/*
Description:   Common Functions/Procedures include file

   Include this file to make coServfli0.p and aclifli0.p available
   everywhere
   We check whether main .ps are running persistently (like the old broker.p) and if not
   we run them. 
   Client one always runs locally , but server one may run remotely on AppServer.

Arguments:
	
Comments:

************************************************************************/

/* 
   Common Functions/Procedures include file
   Include this file to make coServfli0.p and aclifli0.p available
   everywhere
   We check whether main .ps are running persistently (like the old broker.p) and if not
   we run them. 
   Client one always runs locally , but server one may run remotely on AppServer.
*/
/* Ensure this file is only included once */
&IF "{&cocofnmli0-included}" <> "YES" &THEN
&GLOB cocofnmli0-included YES
&IF "{&coCommonFunc-definitionsonly}" <> "YES" &THEN
    {adbgdef0.i}
    DEFINE VARIABLE LhClientFunctionsSuperProcedure AS HANDLE NO-UNDO.
    IF NOT VALID-HANDLE(LhClientFunctionsSuperProcedure) THEN
    DO:
      LhClientFunctionsSuperProcedure = SESSION:FIRST-PROCEDURE.
      DO WHILE VALID-HANDLE(LhClientFunctionsSuperProcedure) AND LhClientFunctionsSuperProcedure:FILE-NAME NE "aclifli0.p":
        LhClientFunctionsSuperProcedure = LhClientFunctionsSuperProcedure:NEXT-SIBLING.
      END.
      IF NOT VALID-HANDLE(LhClientFunctionsSuperProcedure) THEN
         RUN aclifli0.p PERSISTENT SET LhClientFunctionsSuperProcedure.
      THIS-PROCEDURE:ADD-SUPER-PROCEDURE(LhClientFunctionsSuperProcedure,SEARCH-TARGET).
    END.
&ENDIF

/* Prototypes for all functions in coServfli0.p and aclifli0.p */

/* Client */
FUNCTION FcConvDataType RETURNS CHARACTER
  ( INPUT IcFromDataType AS CHAR )
  IN LhClientFunctionsSuperProcedure.
FUNCTION FcString_RemoveNonNumeric
    RETURNS CHARACTER
    (INPUT IcInputString AS CHAR)
    IN LhClientFunctionsSuperProcedure.
FUNCTION FcClearCombo
    RETURNS CHARACTER
    (INPUT Ih AS HANDLE)
    IN LhClientFunctionsSuperProcedure.
FUNCTION FlIsExistingDirectory
    RETURNS LOGICAL (INPUT IcDir AS CHAR)
    IN LhClientFunctionsSuperProcedure.
FUNCTION FcOrderStringList
    RETURNS CHARACTER
    (INPUT IcList       AS CHAR,
     INPUT IcDelimiter  AS CHAR,
     INPUT IlAscending  AS LOGICAL)
    IN LhClientFunctionsSuperProcedure.
FUNCTION FcCalculateStringValue
    RETURNS CHARACTER
    (INPUT IcStringFormula  AS CHARACTER,
     INPUT IcType           AS CHARACTER)
    IN LhClientFunctionsSuperProcedure.
&ENDIF
