/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          hotel            PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME gDialog
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS gDialog 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrdlg.w - ADM2 SmartDialog Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */
     
{def-update-params.i}
DEF INPUT PARAMETER check-out AS LOGICAL.
DEF INPUT PARAMETER init-room-num AS INTEGER.
DEF INPUT PARAMETER init-start-date AS DATE.
DEF INPUT PARAMETER init-end-date AS DATE.
DEF INPUT PARAMETER init-guest-name AS CHAR.

DEF BUFFER xreservation FOR reservation.
DEF BUFFER xstay FOR stay.
DEF BUFFER xguest FOR guest.
DEF BUFFER xservice FOR service.

DEF VAR stay-guest-name AS CHAR INIT "".


CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDialog
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER DIALOG-BOX

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME gDialog
&Scoped-define BROWSE-NAME guests

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES guest service service-type

/* Definitions for BROWSE guests                                        */
&Scoped-define FIELDS-IN-QUERY-guests guest.order ~
guest.first-name + " " + guest.last-name 
&Scoped-define ENABLED-FIELDS-IN-QUERY-guests 
&Scoped-define QUERY-STRING-guests FOR EACH guest NO-LOCK
&Scoped-define OPEN-QUERY-guests OPEN QUERY guests FOR EACH guest NO-LOCK.
&Scoped-define TABLES-IN-QUERY-guests guest
&Scoped-define FIRST-TABLE-IN-QUERY-guests guest


/* Definitions for BROWSE services                                      */
&Scoped-define FIELDS-IN-QUERY-services service-type.description ~
service.service-date service.amount 
&Scoped-define ENABLED-FIELDS-IN-QUERY-services 
&Scoped-define QUERY-STRING-services FOR EACH service NO-LOCK, ~
      EACH service-type OF service NO-LOCK
&Scoped-define OPEN-QUERY-services OPEN QUERY services FOR EACH service NO-LOCK, ~
      EACH service-type OF service NO-LOCK.
&Scoped-define TABLES-IN-QUERY-services service service-type
&Scoped-define FIRST-TABLE-IN-QUERY-services service
&Scoped-define SECOND-TABLE-IN-QUERY-services service-type


/* Definitions for DIALOG-BOX gDialog                                   */

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS roomNumber guests addGuest updateGuest ~
startDate viewGuest endDate endDatePicker deleteGuest services addService ~
deleteService Btn_OK Btn_Cancel startDatePicker roomType reservationDays ~
priceText totalServices totalPrice 
&Scoped-Define DISPLAYED-OBJECTS roomNumber startDate endDate roomType ~
reservationDays priceText totalServices totalPrice 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON addGuest 
     LABEL "Add" 
     SIZE 13 BY 1.14.

DEFINE BUTTON addService 
     LABEL "Add" 
     SIZE 13 BY 1.14.

DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 15 BY 1.14.

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "OK" 
     SIZE 15 BY 1.14.

DEFINE BUTTON deleteGuest 
     LABEL "Delete" 
     SIZE 13 BY 1.14.

DEFINE BUTTON deleteService 
     LABEL "Delete" 
     SIZE 13 BY 1.14.

DEFINE BUTTON endDatePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

DEFINE BUTTON startDatePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

DEFINE BUTTON updateGuest 
     LABEL "Update" 
     SIZE 13 BY 1.14.

DEFINE BUTTON viewGuest 
     LABEL "View" 
     SIZE 13 BY 1.14.

DEFINE VARIABLE roomNumber AS CHARACTER 
     LABEL "Room Number" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     LIST-ITEMS "101","102","203","204" 
     DROP-DOWN
     SIZE 16 BY 1 NO-UNDO.

DEFINE VARIABLE endDate AS DATE FORMAT "99/99/99":U 
     LABEL "Check-out Date" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE priceText AS CHARACTER FORMAT "X(256)":U 
     LABEL "Room Price" 
      VIEW-AS TEXT 
     SIZE 34 BY .62 NO-UNDO.

DEFINE VARIABLE reservationDays AS INTEGER FORMAT ">>>>>9":U INITIAL 0 
     LABEL "Days" 
      VIEW-AS TEXT 
     SIZE 14 BY .62 NO-UNDO.

DEFINE VARIABLE roomType AS CHARACTER FORMAT "X(256)":U 
     LABEL "Room Type" 
      VIEW-AS TEXT 
     SIZE 22.8 BY .62 NO-UNDO.

DEFINE VARIABLE startDate AS DATE FORMAT "99/99/99":U 
     LABEL "Check-in Date" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE totalPrice AS INTEGER FORMAT "$ ->,>>>,>>9.99":U INITIAL 0 
     LABEL "Total Price" 
      VIEW-AS TEXT 
     SIZE 14 BY .62 NO-UNDO.

DEFINE VARIABLE totalServices AS INTEGER FORMAT "$ ->,>>>,>>9.99":U INITIAL 0 
     LABEL "Services Total" 
      VIEW-AS TEXT 
     SIZE 13 BY .62 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY guests FOR 
      guest SCROLLING.

DEFINE QUERY services FOR 
      service, 
      service-type SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE guests
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS guests gDialog _STRUCTURED
  QUERY guests NO-LOCK DISPLAY
      guest.order COLUMN-LABEL "" FORMAT ">9":U
      guest.first-name + " " + guest.last-name COLUMN-LABEL "Guest Name" FORMAT "x(40)":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 44 BY 5.62
         FONT 8 FIT-LAST-COLUMN.

DEFINE BROWSE services
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS services gDialog _STRUCTURED
  QUERY services NO-LOCK DISPLAY
      service-type.description COLUMN-LABEL "Service" FORMAT "x(20)":U
            WIDTH 18.2
      service.service-date FORMAT "99/99/99":U
      service.amount COLUMN-LABEL "Amount" FORMAT "->>,>>9.99":U
            WIDTH 10.6
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 44 BY 4.52
         FONT 8 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME gDialog
     roomNumber AT ROW 1.48 COL 15.2 COLON-ALIGNED WIDGET-ID 4
     guests AT ROW 1.48 COL 52.2 WIDGET-ID 200
     addGuest AT ROW 1.57 COL 98.2 WIDGET-ID 32
     updateGuest AT ROW 3 COL 98.2 WIDGET-ID 34
     startDate AT ROW 4.05 COL 15.2 COLON-ALIGNED WIDGET-ID 18
     viewGuest AT ROW 4.43 COL 98.2 WIDGET-ID 38
     endDate AT ROW 5.52 COL 15.2 COLON-ALIGNED WIDGET-ID 16
     endDatePicker AT ROW 5.43 COL 32.8 WIDGET-ID 14
     deleteGuest AT ROW 5.86 COL 98.2 WIDGET-ID 36
     services AT ROW 8.24 COL 52 WIDGET-ID 300
     addService AT ROW 8.33 COL 98.2 WIDGET-ID 40
     deleteService AT ROW 9.76 COL 98 WIDGET-ID 42
     Btn_OK AT ROW 12.29 COL 3
     Btn_Cancel AT ROW 12.29 COL 20
     startDatePicker AT ROW 3.95 COL 32.8 WIDGET-ID 20
     roomType AT ROW 2.95 COL 15.2 COLON-ALIGNED WIDGET-ID 22
     reservationDays AT ROW 7 COL 15.2 COLON-ALIGNED WIDGET-ID 24
     priceText AT ROW 8.1 COL 4.8 WIDGET-ID 26
     totalServices AT ROW 9.19 COL 2.2 WIDGET-ID 44
     totalPrice AT ROW 10.19 COL 5.6 WIDGET-ID 48
     SPACE(81.79) SKIP(2.80)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         FONT 8
         TITLE "Check-In"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDialog
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: APPSERVER
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB gDialog 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX gDialog
   FRAME-NAME                                                           */
/* BROWSE-TAB guests roomNumber gDialog */
/* BROWSE-TAB services deleteGuest gDialog */
ASSIGN 
       FRAME gDialog:SCROLLABLE       = FALSE
       FRAME gDialog:HIDDEN           = TRUE.

/* SETTINGS FOR FILL-IN priceText IN FRAME gDialog
   ALIGN-L                                                              */
/* SETTINGS FOR FILL-IN totalPrice IN FRAME gDialog
   ALIGN-L                                                              */
/* SETTINGS FOR FILL-IN totalServices IN FRAME gDialog
   ALIGN-L                                                              */
ASSIGN 
       totalServices:READ-ONLY IN FRAME gDialog        = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX gDialog
/* Query rebuild information for DIALOG-BOX gDialog
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX gDialog */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE guests
/* Query rebuild information for BROWSE guests
     _TblList          = "hotel.guest"
     _Options          = "NO-LOCK"
     _FldNameList[1]   > hotel.guest.order
"guest.order" "" ">9" "integer" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   > "_<CALC>"
"guest.first-name + "" "" + guest.last-name" "Guest Name" "x(40)" ? ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _Query            is NOT OPENED
*/  /* BROWSE guests */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE services
/* Query rebuild information for BROWSE services
     _TblList          = "hotel.service,hotel.service-type OF hotel.service"
     _Options          = "NO-LOCK"
     _FldNameList[1]   > hotel.service-type.description
"service-type.description" "Service" ? "character" ? ? ? ? ? ? no ? no no "18.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   = hotel.service.service-date
     _FldNameList[3]   > hotel.service.amount
"service.amount" "Amount" ? "decimal" ? ? ? ? ? ? no ? no no "10.6" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _Query            is NOT OPENED
*/  /* BROWSE services */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL gDialog gDialog
ON WINDOW-CLOSE OF FRAME gDialog /* Check-In */
DO:  
  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME addGuest
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL addGuest gDialog
ON CHOOSE OF addGuest IN FRAME gDialog /* Add */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR createdRid AS ROWID.
  DO TRANSACTION:
     RUN update-guest-dialog.w (INPUT rid, 
                                OUTPUT needRefresh, 
                                OUTPUT createdRid,
                                INPUT stay.stay-id,
                                INPUT FALSE).

      IF needRefresh THEN DO:
         RUN refresh-guests.
         REPOSITION guests TO ROWID createdRid NO-ERROR.
      END.
      ELSE UNDO, LEAVE.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME addService
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL addService gDialog
ON CHOOSE OF addService IN FRAME gDialog /* Add */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR createdRid AS ROWID.
  DO TRANSACTION:
     RUN update-service-dialog.w (INPUT rid, 
                                OUTPUT needRefresh, 
                                OUTPUT createdRid,
                                INPUT stay.stay-id).

      IF needRefresh THEN DO:
         RUN refresh-services.
         REPOSITION services TO ROWID createdRid NO-ERROR.
      END.
      ELSE UNDO, LEAVE.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK gDialog
ON CHOOSE OF Btn_OK IN FRAME gDialog /* OK */
DO:
   IF stay.checked-out THEN DO:
      LEAVE.
   END.
   
   FIND FIRST guest WHERE guest.stay-id = stay.stay-id NO-ERROR.
   IF NOT AVAIL(guest) THEN DO:
      MESSAGE "Add at least one guest!" VIEW-AS ALERT-BOX ERROR TITLE "No guests".
      RETURN NO-APPLY.
   END.

   DEF VAR stay-guest-name AS CHAR.
   stay-guest-name = guest.first-name + " " + guest.last-name.

   {check-date-price.i FALSE}
   
   ASSIGN stay.room-num = roomNumber:INPUT-VALUE 
          stay.start-date = date1
          stay.end-date = date2
          stay.price = price.

   DEF VAR guestNum AS INTEGER.
   guestNum = 0.
   FOR EACH xguest WHERE xguest.stay-id = stay.stay-id NO-LOCK:
      guestNum = guestNum + 1.
   END.
   stay.num-guests = guestNum.

   IF check-out THEN DO:
      stay.checked-out = TRUE.
   END.

   needRefresh = YES.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME deleteGuest
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL deleteGuest gDialog
ON CHOOSE OF deleteGuest IN FRAME gDialog /* Delete */
DO:
  IF NOT AVAIL(guest) THEN DO:
     {no-selected-records.i "guests"}  
  END.

  MESSAGE "Are you sure you want to delete guest " +
     guest.first-name + " " + guest.last-name + "?"
     VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO TITLE "Deletion confirmation"
        UPDATE ret AS LOGICAL.
  IF NOT ret THEN RETURN NO-APPLY.

  DO TRANSACTION:
     FIND CURRENT guest EXCLUSIVE-LOCK.
     DELETE guest.

     DEF VAR i AS INTEGER.
     /* reorder guests */
     i = 1.
     FOR EACH xguest WHERE xguest.stay-id = stay.stay-id:
        xguest.order = i.
        i = i + 1.
     END.
  END.

  RUN refresh-guests.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME deleteService
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL deleteService gDialog
ON CHOOSE OF deleteService IN FRAME gDialog /* Delete */
DO:
  IF NOT AVAIL(service) THEN DO:
     {no-selected-records.i "servies"}  
  END.

  MESSAGE 'Are you sure you want to delete service "' +
     service-type.DESCRIPTION + "' (" + 
        TRIM(string(service.amount, "$ ->,>>>,>>9")) + ")?"
     VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO TITLE "Deletion confirmation"
        UPDATE ret AS LOGICAL.
  IF NOT ret THEN RETURN NO-APPLY.

  DO TRANSACTION:
     FIND CURRENT service EXCLUSIVE-LOCK.
     DELETE service.
  END.

  RUN refresh-services.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME endDate
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL endDate gDialog
ON VALUE-CHANGED OF endDate IN FRAME gDialog /* Check-out Date */
DO:
   RUN refresh-days-price.
   RUN refresh-total-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME endDatePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL endDatePicker gDialog
ON CHOOSE OF endDatePicker IN FRAME gDialog
DO:
  {pick-date.i "Check-out Date" endDate gDialog}
  RUN refresh-days-price.
  RUN refresh-total-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME roomNumber
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL roomNumber gDialog
ON VALUE-CHANGED OF roomNumber IN FRAME gDialog /* Room Number */
DO:
  RUN update-room-type.
  RUN refresh-days-price.
  RUN refresh-total-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME startDate
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL startDate gDialog
ON VALUE-CHANGED OF startDate IN FRAME gDialog /* Check-in Date */
DO:
   RUN refresh-days-price.
   RUN refresh-total-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME startDatePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL startDatePicker gDialog
ON CHOOSE OF startDatePicker IN FRAME gDialog
DO:
  {pick-date.i "Check-in Date" startDate gDialog}
  RUN refresh-days-price.
  RUN refresh-total-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME updateGuest
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL updateGuest gDialog
ON CHOOSE OF updateGuest IN FRAME gDialog /* Update */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR unk AS ROWID.

  IF NOT AVAIL(guest) THEN DO:
     {no-selected-records.i "guests"}
  END.

  DO TRANSACTION:
     rid = ROWID(guest).
     RUN update-guest-dialog.w (INPUT rid, 
                                OUTPUT needRefresh, 
                                OUTPUT unk,
                                INPUT stay.stay-id,
                                INPUT FALSE).

     IF needRefresh THEN DO:
        RUN refresh-guests.
        REPOSITION guests TO ROWID rid NO-ERROR.
     END.
     ELSE UNDO, LEAVE.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME viewGuest
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL viewGuest gDialog
ON CHOOSE OF viewGuest IN FRAME gDialog /* View */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR unk AS ROWID.

  IF NOT AVAIL(guest) THEN DO:
     {no-selected-records.i "guests"}
  END.

  DO TRANSACTION:
     rid = ROWID(guest).
     RUN update-guest-dialog.w (INPUT rid, 
                                OUTPUT needRefresh, 
                                OUTPUT unk,
                                INPUT stay.stay-id,
                                INPUT TRUE).

     IF needRefresh THEN DO:
        RUN refresh-guests.
        REPOSITION guests TO ROWID rid NO-ERROR.
     END.
     ELSE UNDO, LEAVE.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME guests
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK gDialog 


/* ***************************  Main Block  *************************** */

{calc-days.i gDialog}
{calc-price.i gDialog}

{fill-rooms.i}

IF recordRid = ? THEN DO:
   FRAME gDialog:TITLE = "Check-In".
   Btn_OK:LABEL = "Check-In".

   DEF VAR sid AS INTEGER.
   FIND LAST xstay NO-ERROR.
   IF AVAIL(xstay) THEN DO:
      sid = xstay.stay-id + 1.
   END.
   ELSE DO:
      sid = 1.
   END.

   CREATE stay.
   createdRecordRid = ROWID(stay).
   stay.stay-id = sid.

   IF init-room-num <> ? THEN DO:
      roomNumber = string(init-room-num).
      startDate = init-start-date.
      endDate = init-end-date.

      IF init-guest-name <> ? THEN DO:
         CREATE guest.
         guest.stay-id = stay.stay-id.

         DEF VAR pos AS INTEGER.
         pos = INDEX(init-guest-name, " ").
         IF pos = 0 THEN DO:
            guest.first-name = init-guest-name.
            guest.last-name = "".
         END.
         ELSE DO:
            guest.first-name = SUBSTRING(init-guest-name, 1, pos - 1).
            guest.last-name = SUBSTRING(init-guest-name, pos + 1).
         END.
      END.
   END.
   ELSE startDate = TODAY.
END.
ELSE DO:
   FIND stay WHERE ROWID(stay) = recordRid.
   ASSIGN roomNumber = string(stay.room-num)
          startDate = stay.start-date
          endDate = stay.end-date.
   DISPLAY roomNumber startDate endDate WITH FRAME gDialog.
   
   RUN update-room-type.
   RUN refresh-days-price.

   IF stay.checked-out THEN DO:
      FRAME gDialog:TITLE = "Close".
      Btn_OK:LABEL = "Close".
   END.
   ELSE IF check-out THEN DO:
      FRAME gDialog:TITLE = "Check-Out".
      Btn_OK:LABEL = "Check-Out".
   END.
   ELSE DO:
      FRAME gDialog:TITLE = "Update Reservation".
      Btn_OK:LABEL = "Update".
   END.
END.

{src/adm2/dialogmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects gDialog  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI gDialog  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME gDialog.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI gDialog  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY roomNumber startDate endDate roomType reservationDays priceText 
          totalServices totalPrice 
      WITH FRAME gDialog.
  ENABLE roomNumber guests addGuest updateGuest startDate viewGuest endDate 
         endDatePicker deleteGuest services addService deleteService Btn_OK 
         Btn_Cancel startDatePicker roomType reservationDays priceText 
         totalServices totalPrice 
      WITH FRAME gDialog.
  VIEW FRAME gDialog.
  {&OPEN-BROWSERS-IN-QUERY-gDialog}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject gDialog 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */

  RUN SUPER.

  RUN refresh-guests.
  RUN refresh-services.

  IF stay.checked-out THEN DO:
     Btn_Cancel:VISIBLE IN FRAME gDialog = FALSE.
     DISABLE roomNumber startDate endDate 
             addGuest updateGuest deleteGuest
             addService deleteService 
             startDatePicker endDatePicker WITH FRAME gDialog.
  END.

  IF init-room-num <> ? THEN DO:
     RUN update-room-type.
     RUN refresh-days-price.
     RUN refresh-total-price.
  END.

  /* Code placed here will execute AFTER standard behavior.    */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refresh-guests gDialog 
PROCEDURE refresh-guests :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
OPEN QUERY guests FOR EACH guest WHERE guest.stay-id = stay.stay-id NO-LOCK.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refresh-services gDialog 
PROCEDURE refresh-services :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR totalSum AS INTEGER.
totalSum = 0.
FOR EACH xservice WHERE xservice.stay-id = stay.stay-id:
   totalSum = totalSum + xservice.amount.
END.
totalServices = totalSum.
DISPLAY totalServices WITH FRAME gDialog.

RUN refresh-total-price.


OPEN QUERY services FOR EACH service NO-LOCK
   WHERE service.stay-id = stay.stay-id,
      EACH service-type OF service NO-LOCK.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refresh-total-price gDialog 
PROCEDURE refresh-total-price :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR serv AS INTEGER.
serv = totalServices:INPUT-VALUE IN FRAME gDialog.

IF roomPriceVal <> ? AND serv <> ? THEN DO:
   totalPrice = roomPriceVal + serv.
END.
ELSE DO:
   totalPrice = 0.
END.

DISPLAY totalPrice WITH FRAME gDialog.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE update-room-type gDialog 
PROCEDURE update-room-type :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR num AS INTEGER.
DEF VAR i AS INTEGER.
num = roomNumber:INPUT-VALUE IN FRAME gDialog.

FIND FIRST room WHERE room.room-num = num NO-ERROR.
IF NOT AVAIL(room) THEN DO:
   roomType = "Specify Room Number". 
END.
ELSE DO:
   FIND room-type WHERE room-type.room-type = room.room-type.
   roomType = room-type.DESCRIPTION.
END.

DISPLAY roomType WITH FRAME gDialog. 


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

