
    create table guest (
        id int8 not null,
        stay_id int4,
        order_ int4,
        first_name text,
        last_name text,
        guest_id_type int4,
        guest_id_num text,
        phone text,
        birth_date date,
        country text,
        city text,
        address text,
        primary key (id)
    );

    create table guest_id_type (
        id int8 not null,
        id_type int4,
        description text,
        primary key (id)
    );

    create table meta_user (
        id int8 not null,
        userid text not null,
        password text not null,
        user_name text,
        user_misc text,
        user_number int4,
        group_number int4,
        given_name text,
        middle_initial text,
        surname text,
        telephone text,
        email text,
        description text,
        disabled bool,
        create_date_timestamp timestamp,
        create_date_offset int4,
        account_expires_timestamp timestamp,
        account_expires_offset int4,
        pwd_expires_timestamp timestamp,
        pwd_expires_offset int4,
        pwd_duration int4,
        last_login_timestamp timestamp,
        last_login_offset int4,
        logins int4,
        max_logins int4,
        max_tries int4,
        login_failures int4,
        spare1 int4,
        spare2 int4,
        spare3 text,
        spare4 text,
        primary key (id)
    );

    create table meta_user__8 (
        parent__id int8 not null,
        u_misc1 int4,
        u_misc2 text,
        list__index int4 not null,
        primary key (parent__id, list__index)
    );

    create table rate (
        id int8 not null,
        room_type int4,
        start_date date,
        end_date date,
        rate numeric(50,2),
        primary key (id)
    );

    create table reservation (
        id int8 not null,
        room_num int4,
        start_date date,
        end_date date,
        guest text,
        num_guests int4,
        price numeric(50,2),
        primary key (id)
    );

    create table room (
        id int8 not null,
        room_num int4,
        floor int4,
        room_type int4,
        active bool,
        primary key (id)
    );

    create table room_type (
        id int8 not null,
        room_type int4,
        parent_type int4,
        description text,
        image text,
        max_persons int4,
        primary key (id)
    );

    create table service (
        id int8 not null,
        stay_id int4,
        amount numeric(50,2),
        service_date date,
        service_type int4,
        primary key (id)
    );

    create table service_type (
        id int8 not null,
        service_type int4,
        description text,
        default_amount numeric(50,2),
        primary key (id)
    );

    create table stay (
        id int8 not null,
        stay_id int4,
        room_num int4,
        start_date date,
        end_date date,
        checked_out bool,
        num_guests int4,
        price int4,
        primary key (id)
    );

    create index meta_user__8_fkey on meta_user__8 (parent__id);

    alter table meta_user__8 
        add constraint FK67DDD4733D1B017C 
        foreign key (parent__id) 
        references meta_user;
