/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.*;
import com.goldencode.p2j.ui.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in start.p).
 */
public class Start
{
   StartFLogo fLogoFrame = GenericFrame.createFrame(StartFLogo.class, "f-logo");

   StartFLogin fLoginFrame = GenericFrame.createFrame(StartFLogin.class, "f-login");

   character uName = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "u-name", new character(""));

   /**
    * External procedure (converted to Java from the 4GL source code
    * in start.p).
    */
   public void execute()
   {
      handle hSmartWindow = TypeFactory.handle();
      character uname = UndoableFactory.character();
      character upass = UndoableFactory.character();
      character safeName = UndoableFactory.character();
      handle hwindow = UndoableFactory.handle();
      
      externalProcedure(Start.this, new Block((Body) () -> 
      {
         fLoginFrame.openScope();
         DynamicWidgetFactory.createWindow(hwindow);
         hwindow.unwrapWidget().setTitle(new character("Hotel Login"));
         hwindow.unwrapWindow().setResize(new logical(false));
         hwindow.unwrapWindow().setMessageArea(new logical(false));
         hwindow.unwrapWindow().setStatusArea(new logical(true));
         hwindow.unwrapWindow().setMessageArea(new logical(false));
         hwindow.unwrapSizeable().setWidthPixels(new integer(642));
         hwindow.unwrapSizeable().setHeightPixels(new integer(449));
         fLoginFrame.asWidget().setFrameHandle(fLogoFrame.asWidgetHandle());
         fLoginFrame.setY(new integer(240));
         fLoginFrame.setX(new integer(90));
         uName.setUnknown();
         
         registerTrigger(new EventList("RETURN", fLoginFrame.widgetUname()), Start.this, new Trigger((Body) () -> 
         {
            fLoginFrame.widgetUpass().apply("ENTRY");
            returnConsume();
         }));
         
         registerTrigger(new EventList("RETURN", fLoginFrame.widgetUpass()), Start.this, new Trigger((Body) () -> 
         {
            fLoginFrame.apply("GO");
            returnConsume();
         }));
         
         registerTrigger(new EventList("CHOOSE", fLogoFrame.widgetExit()), Start.this, new Trigger((Body) () -> 
         {
            quit();
         }));
         
         OnPhrase[] onPhrase0 = new OnPhrase[]
         {
            new OnPhrase(Condition.ENDKEY, Action.NEXT, "loopLabel0"),
            new OnPhrase(Condition.ERROR, Action.NEXT, "loopLabel0"),
            new OnPhrase(Condition.STOP, Action.NEXT, "loopLabel0")
         };
         
         repeat("loopLabel0", onPhrase0, new Block((Init) () -> 
         {
            fLogoFrame.openScope();
         }, 
         (Body) () -> 
         {
            /* logout */
            if ((hSmartWindow.isValid()).booleanValue())
            {
               apply(hSmartWindow, "CLOSE");
            }
            
            SecurityOps.setUserId("", "");
            uName.setUnknown();
            hwindow.unwrapWidget().setVisible(new logical(true));
            
            fLogoFrame.view(hwindow);
            
            FrameElement[] elementList0 = new FrameElement[]
            {
               new WidgetElement(fLogoFrame.widgetExit())
            };
            
            fLogoFrame.enable(elementList0, hwindow);
            
            FrameElement[] elementList1 = new FrameElement[]
            {
               new Element(uname, fLoginFrame.widgetUname()),
               new Element(upass, fLoginFrame.widgetUpass())
            };
            
            fLoginFrame.update(elementList1, hwindow);
            
            if ((SecurityOps.setUserId(uname, upass)).booleanValue())
            {
               uname.assign("");
               upass.assign("");
               fLoginFrame.clearAll(true);
               uName.assign(SecurityOps.getUserId());
               ControlFlowOps.invokePersistentSet("main-window.w", hSmartWindow);
               ControlFlowOps.invokeIn("initializeObject", hSmartWindow);
               hwindow.unwrapWidget().setVisible(new logical(false));
               
               LogicalTerminal.waitFor(null, new EventList("close", hSmartWindow));
               next("loopLabel0");
            }
            else
            {
               safeName.assign(_isUnknown(uname) ? new character("?") : uname);
               safeName.assign(_isEqual(length(safeName), 0) ? new character("''") : safeName);
               messageBox(concat("Invalid userid (", safeName, new character(") or password.")), ALERT_INFO, BTN_OK, (String) null);
               next("loopLabel0");
            }
         }));
         
         LogicalTerminal.waitFor(null, new EventList("close", hwindow));
      }));
   }
}
