/*------------------------------------------------------------------------
    File        : 
    Purpose     :
    Syntax      :
    Description :
    Author(s)   :
    Created     :
    Notes       :
  ----------------------------------------------------------------------*/

package com.goldencode.hotel.common;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/aclifli0.p).
 */
public class Aclifli0
{
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*
   Description: Defines debug global variables for adbgmsg0.i
   ************************************************************************/   
   character goisDebug = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "goisdebug", true, new character(""));

   handle ghDebugWindowProc = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "ghdebugwindowproc", true, new handle());

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/aclifli0.p).
    */
   public void execute()
   {
      externalProcedure(Aclifli0.this, new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character fcGetKeyValue(final character _icKey_2, final character _icKeyAndValList_2)
   {
      character icKey_2 = TypeFactory.initInput(_icKey_2);
      character icKeyAndValList_2 = TypeFactory.initInput(_icKeyAndValList_2);
      /*------------------------------------------------------------------------------
        Purpose:  Returns the value of an argument
          Notes:  A list of arguments may be passed in.
      ------------------------------------------------------------------------------*/
      integer viPos = TypeFactory.integer();
      character vcString = TypeFactory.character(null);
      
      return function("FcGetKeyValue", character.class, new Block((Body) () -> 
      {
         /* Get where the Key= string starts */
         viPos.assign(indexOf(icKeyAndValList_2, concat(icKey_2, "=")));
         
         if (_isGreaterThan(viPos, 0))
         {
            vcString.assign(substring(icKeyAndValList_2, viPos));
            /* Now get where key=value string ends - either with a CHR(1) OR end of string */
            viPos.assign(indexOf(vcString, chr(1)));
            
            if (_isGreaterThan(viPos, 0))
            {
               vcString.assign(substring(vcString, 1, minus(viPos, 1)));
            }
            
            /* Finally get the value of the argument */
            vcString.assign(substring(vcString, plus(length(icKey_2), 2)));
         }
         
         /* Convert CHR(2)'s back to ? */
         if (_isEqual(vcString, chr(2)))
         {
            vcString.setUnknown();
         }
         
         returnNormal(vcString);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fcSetKeyValue(final character _icKey_2, final character _icValue_1, final character _icKeyAndValList_2)
   {
      character icKey_2 = TypeFactory.initInput(_icKey_2);
      character icValue_1 = TypeFactory.initInput(_icValue_1);
      character icKeyAndValList_2 = TypeFactory.initInput(_icKeyAndValList_2);
      /*------------------------------------------------------------------------------
        Purpose:  Adds a key/value pairing to a key/value list
          Notes:  
      ------------------------------------------------------------------------------*/
      character vcRetKeyAndValList = TypeFactory.character();
      integer viEntry = TypeFactory.integer();
      
      return function("FcSetKeyValue", character.class, new Block((Body) () -> 
      {
         if (_isUnknown(icValue_1))
         {
            icValue_1.assign(chr(2));
         }
         
         vcRetKeyAndValList.assign(icKeyAndValList_2);
         
         loopLabel0:
         for (viEntry.assign(1); _isLessThanOrEqual(viEntry, numEntries(icKeyAndValList_2, chr(1))); viEntry.increment())
         {
            if (_begins(entry(viEntry, vcRetKeyAndValList, chr(1)), concat(icKey_2, "=")))
            {
               vcRetKeyAndValList.replaceEntry(viEntry, chr(1), concat(icKey_2, "=", icValue_1));
               returnNormal(vcRetKeyAndValList);
            }
         }
         
         /* If we are here, then key wasn't already in list */
         if (_isGreaterThan(icKeyAndValList_2, ""))
         {
            vcRetKeyAndValList.assign(concat(vcRetKeyAndValList, chr(1)));
         }
         
         vcRetKeyAndValList.assign(concat(vcRetKeyAndValList, icKey_2, "=", icValue_1));
         returnNormal(vcRetKeyAndValList);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character fcCalculateStringValue(final character _icStringFormula_1, final character _icType_1)
   {
      character icStringFormula_1 = TypeFactory.initInput(_icStringFormula_1);
      character icType_1 = TypeFactory.initInput(_icType_1);
      character vcStringFormula = TypeFactory.character();
      character vcSignList = TypeFactory.character();
      integer viCounter = TypeFactory.integer();
      integer viPosition = TypeFactory.integer();
      character vcValueList = TypeFactory.character();
      integer viValueResult = TypeFactory.integer();
      decimal viValueDecResult = TypeFactory.decimal();
      
      return function("FcCalculateStringValue", character.class, new Block((Body) () -> 
      {
         vcStringFormula.assign(icStringFormula_1);
         
         if (_isEqual(lookup(vcStringFormula, "+,-,/,*"), 0))
         {
            loopLabel1:
            while (_isGreaterThan(length(vcStringFormula), 0))
            {
               viPosition.assign(indexOf(vcStringFormula, "+"));
               
               if (_isEqual(viPosition, 0))
               {
                  viPosition.assign(indexOf(vcStringFormula, "-"));
               }
               
               if (_isEqual(viPosition, 0))
               {
                  viPosition.assign(indexOf(vcStringFormula, "/"));
               }
               
               if (_isEqual(viPosition, 0))
               {
                  viPosition.assign(indexOf(vcStringFormula, "*"));
               }
               
               if (_isGreaterThan(viPosition, 0))
               {
                  if (_isEqual(length(vcSignList), 0))
                  {
                     vcSignList.assign(substring(vcStringFormula, viPosition, 1));
                  }
                  else
                  {
                     vcSignList.assign(concat(vcSignList, ",", substring(vcStringFormula, viPosition, 1)));
                  }
               }
               
               if (_isEqual(length(vcValueList), 0))
               {
                  vcValueList.assign(substring(vcStringFormula, 1, minus(viPosition, 1)));
               }
               else
               {
                  vcValueList.assign(concat(vcValueList, ",", substring(vcStringFormula, 1, (_isEqual(viPosition, 0) ? new int64(length(vcStringFormula)) : minus(viPosition, 1)))));
               }
               
               if (_isGreaterThan(viPosition, 0))
               {
                  vcStringFormula.assign(trim(substring(vcStringFormula, plus(viPosition, 1), length(vcStringFormula))));
               }
               else
               {
                  vcStringFormula.assign("");
               }
            }
         }
         else
         {
            returnNormal(icStringFormula_1);
         }
         
         if (_isEqual(icType_1, "INTEGER"))
         {
            loopLabel2:
            for (viCounter.assign(1); _isLessThanOrEqual(viCounter, numEntries(vcSignList)); viCounter.increment())
            {
               if (_isEqual(entry(viCounter, vcSignList), "+"))
               {
                  if (_isEqual(viValueResult, 0))
                  {
                     viValueResult.assign(plus(new integer(entry(viCounter, vcValueList)), new integer(entry(plus(viCounter, 1), vcValueList))));
                  }
                  else
                  {
                     viValueResult.assign(plus(viValueResult, new integer(entry(plus(viCounter, 1), vcValueList))));
                  }
               }
               
               if (_isEqual(entry(viCounter, vcSignList), "-"))
               {
                  if (_isEqual(viValueResult, 0))
                  {
                     viValueResult.assign(minus(new integer(entry(viCounter, vcValueList)), new integer(entry(plus(viCounter, 1), vcValueList))));
                  }
                  else
                  {
                     viValueResult.assign(minus(viValueResult, new integer(entry(plus(viCounter, 1), vcValueList))));
                  }
               }
               
               if (_isEqual(entry(viCounter, vcSignList), "/"))
               {
                  if (_isEqual(viValueResult, 0))
                  {
                     viValueResult.assign(divide(new integer(entry(viCounter, vcValueList)), new integer(entry(plus(viCounter, 1), vcValueList))));
                  }
                  else
                  {
                     viValueResult.assign(divide(viValueResult, new integer(entry(plus(viCounter, 1), vcValueList))));
                  }
               }
               
               if (_isEqual(entry(viCounter, vcSignList), "*"))
               {
                  if (_isEqual(viValueResult, 0))
                  {
                     viValueResult.assign(multiply(new integer(entry(viCounter, vcValueList)), new integer(entry(plus(viCounter, 1), vcValueList))));
                  }
                  else
                  {
                     viValueResult.assign(multiply(viValueResult, new integer(entry(plus(viCounter, 1), vcValueList))));
                  }
               }
            }
            
            returnNormal(valueOf(viValueResult));
         }
         
         if (_isEqual(icType_1, "DECIMAL"))
         {
            loopLabel3:
            for (viCounter.assign(1); _isLessThanOrEqual(viCounter, numEntries(vcSignList)); viCounter.increment())
            {
               if (_isEqual(entry(viCounter, vcSignList), "+"))
               {
                  if (_isEqual(viValueDecResult, 0))
                  {
                     viValueDecResult.assign(plus(new decimal(entry(viCounter, vcValueList)), new decimal(entry(plus(viCounter, 1), vcValueList))));
                  }
                  else
                  {
                     viValueDecResult.assign(plus(viValueDecResult, new decimal(entry(plus(viCounter, 1), vcValueList))));
                  }
               }
               
               if (_isEqual(entry(viCounter, vcSignList), "-"))
               {
                  if (_isEqual(viValueDecResult, 0))
                  {
                     viValueDecResult.assign(minus(new decimal(entry(viCounter, vcValueList)), new decimal(entry(plus(viCounter, 1), vcValueList))));
                  }
                  else
                  {
                     viValueDecResult.assign(minus(viValueDecResult, new decimal(entry(plus(viCounter, 1), vcValueList))));
                  }
               }
               
               if (_isEqual(entry(viCounter, vcSignList), "/"))
               {
                  if (_isEqual(viValueDecResult, 0))
                  {
                     viValueDecResult.assign(divide(new decimal(entry(viCounter, vcValueList)), new decimal(entry(plus(viCounter, 1), vcValueList))));
                  }
                  else
                  {
                     viValueDecResult.assign(divide(viValueDecResult, new decimal(entry(plus(viCounter, 1), vcValueList))));
                  }
               }
               
               if (_isEqual(entry(viCounter, vcSignList), "*"))
               {
                  if (_isEqual(viValueDecResult, 0))
                  {
                     viValueDecResult.assign(multiply(new decimal(entry(viCounter, vcValueList)), new decimal(entry(plus(viCounter, 1), vcValueList))));
                  }
                  else
                  {
                     viValueDecResult.assign(multiply(viValueDecResult, new decimal(entry(plus(viCounter, 1), vcValueList))));
                  }
               }
            }
            
            returnNormal(valueOf(viValueDecResult));
         }
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fcClearCombo(final handle _ih_1)
   {
      handle ih_1 = TypeFactory.initInput(_ih_1);
      /* Clear a combo - handles LIST-ITEMS or LIST-ITEM-PAIRS */
      character vcTemp = TypeFactory.character();
      
      return function("FcClearCombo", character.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         vcTemp.assign(ih_1.unwrapCommonListWidget().getListItemPairs());
         ErrorManager.silentErrorDisable();
         
         if (_isUnknown(vcTemp))
         {
            ih_1.unwrapCommonListWidget().setListItems(ih_1.unwrapCommonListWidget().getListItems());
         }
         else
         {
            ih_1.unwrapCommonListWidget().setListItemPairs(ih_1.unwrapCommonListWidget().getListItemPairs());
         }
         
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fcConvDataType(final character _icFromDataType_1)
   {
      character icFromDataType_1 = TypeFactory.initInput(_icFromDataType_1);
      
      return function("FcConvDataType", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Convert one char data type to normal Progress one
             Notes:  
         ------------------------------------------------------------------------------*/
         if (_isEqual(icFromDataType_1, "C"))
         {
            returnNormal("CHARACTER");
         }
         else
         {
            if (_isEqual(icFromDataType_1, "I"))
            {
               returnNormal("INTEGER");
            }
            else
            {
               if (_isEqual(icFromDataType_1, "D"))
               {
                  returnNormal("DATE");
               }
               else
               {
                  if (_isEqual(icFromDataType_1, "L"))
                  {
                     returnNormal("LOGICAL");
                  }
                  else
                  {
                     if (_isEqual(icFromDataType_1, "F"))
                     {
                        returnNormal("DECIMAL");
                     }
                     else
                     {
                        messageBox(new Object[]
                        {
                           "FcConvDataType does not recognise data type:",
                           icFromDataType_1
                        }, ALERT_ERROR, BTN_OK, (String) null);
                        returnNormal("DONTKNOW");
                     }
                  }
               }
            }
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fcOrderStringList(final character _icList_1, final character _icDelimiter_1, final logical _ilAscending_1)
   {
      character icList_1 = TypeFactory.initInput(_icList_1);
      character icDelimiter_1 = TypeFactory.initInput(_icDelimiter_1);
      logical ilAscending_1 = TypeFactory.initInput(_ilAscending_1);
      integer viCnt = TypeFactory.integer();
      integer viCnt2 = TypeFactory.integer();
      character vcOrderedList = TypeFactory.character();
      character vcTempList = TypeFactory.character();
      character vcValue = TypeFactory.character();
      character vcCheckValue = TypeFactory.character();
      logical vlAdded = TypeFactory.logical();
      
      return function("FcOrderStringList", character.class, new Block((Body) () -> 
      {
         loopLabel4:
         for (viCnt.assign(1); _isLessThanOrEqual(viCnt, numEntries(icList_1, icDelimiter_1)); viCnt.increment())
         {
            vcValue.assign(entry(viCnt, icList_1, icDelimiter_1));
            
            if (_isEqual(vcOrderedList, ""))
            {
               vcOrderedList.assign(vcValue);
            }
            else
            {
               loopLabel5:
               for (viCnt2.assign(1); _isLessThanOrEqual(viCnt2, numEntries(vcOrderedList, icDelimiter_1)); viCnt2.increment())
               {
                  vcCheckValue.assign(entry(viCnt2, vcOrderedList, icDelimiter_1));
                  
                  if (_and(not(vlAdded), () -> isLessThanOrEqual(vcValue, vcCheckValue)))
                  {
                     vcTempList.assign(concat(vcTempList, vcValue, icDelimiter_1));
                     vlAdded.assign(true);
                  }
                  
                  vcTempList.assign(concat(vcTempList, vcCheckValue, icDelimiter_1));
               }
            }
            
            if (_not(vlAdded))
            {
               vcTempList.assign(concat(vcTempList, vcValue));
            }
            
            vcOrderedList.assign(trim(vcTempList, icDelimiter_1));
            vcTempList.assign("");
            vlAdded.assign(false);
         }
         
         returnNormal(vcOrderedList);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fcStringRemoveNonNumeric(final character _icInputString_1)
   {
      character icInputString_1 = TypeFactory.initInput(_icInputString_1);
      character ocResultString = TypeFactory.character();
      integer viCount = TypeFactory.integer();
      character vcCurrentChar = TypeFactory.character();
      
      return function("FcString_RemoveNonNumeric", character.class, new Block((Body) () -> 
      {
         if (_or(isEqual(icInputString_1, ""), () -> isUnknown(icInputString_1)))
         {
            returnNormal(icInputString_1);
         }
         
         loopLabel6:
         for (viCount.assign(1); _isLessThanOrEqual(viCount, length(icInputString_1)); viCount.increment())
         {
            vcCurrentChar.assign(substring(icInputString_1, viCount, 1));
            
            if (_and(isGreaterThanOrEqual(vcCurrentChar, "0"), () -> isLessThanOrEqual(vcCurrentChar, "9")))
            {
               ocResultString.assign(concat(ocResultString, vcCurrentChar));
            }
         }
         
         returnNormal(ocResultString);
      }));
   }
}
