/* Procedure Description
"Version 9 SmartFolder object"
*/

package com.goldencode.hotel.common;

import com.goldencode.p2j.util.*;
import com.goldencode.hotel.ui.common.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.SelfManager.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/afoldfr0.w).
 */
public class Afoldfr0
{
   Afoldfr0FolderFrm folderFrmFrame = GenericFrame.createFrame(Afoldfr0FolderFrm.class, "folder-frm");

   /* ***************************  Definitions  ************************** */   
   /* Parameters Definitions ---                                           */   
   /*
   Description: V9 global variable definitions
   Arguments:
           
   Comments:
   
   ************************************************************************/   
   logical glUsingAppServer = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "glusingappserver", true, new logical(false));

   character gcCase = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gccase", true, new character("[Case]"));

   /* Local Variable Definitions ---                                       */   
   integer numberOfPages = TypeFactory.integer();

   /*&SCOP ADM-PROPERTY-DLG adm2/support/folderd.w*/   
   /***********************  DEFINITIONS  *************************/   
   /* folder vars */   
   /* No longer used - but keep the variables for the get/set functions */   
   integer lFoldertabside = TypeFactory.integer();

   integer lFoldertabsperpage = TypeFactory.integer();

   logical lFoldermultirow = TypeFactory.logical();

   logical alLockRefresh = TypeFactory.logical(false);

   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW C-Win ASSIGN
            HEIGHT             = 4.15
            WIDTH              = 47.57.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ************************* Included-Libraries *********************** */   
   /*------------------------------------------------------------------------
   Description:    Method Library for Folders
   Comments:       
   ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Definitions for button tabs */   
   handle[] lhTab = TypeFactory.handleExtent(20);

   integer liCurrentTab = TypeFactory.integer();

   handle lhContainer = TypeFactory.handle();

   integer liNumTabs = TypeFactory.integer();

   handle[] lhTabFrame = TypeFactory.handleExtent(5);

   handle lhBottomRowTabFrame = TypeFactory.handle();

   integer liNumTabFrames = TypeFactory.integer();

   handle lhTabBottomFrame = TypeFactory.handle();

   handle lhOverlayButton = TypeFactory.handle();

   handle lhOverlayButtonFrame = TypeFactory.handle();

   handle lhBackgroundFrame = TypeFactory.handle();

   handle lhBackgroundButton = TypeFactory.handle();

   logical llOnTabFrame = TypeFactory.logical();

   logical llClickActive = TypeFactory.logical();

   character[] cTabFrameLabels = TypeFactory.characterExtent(5);

   integer[] iTabFramePadding = TypeFactory.integerExtent(5);

   /* These preprocessors tell at compile time which properties can be
        retrieved directly from the temp-table. */   
   /* This property contains the security for all objects found in the AllFieldHandles Property */    
   /* Include the next property file up the chain (in this case, the top
        of the chain); it starts the property temp-table definition and we
        add our field definitions to it. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver /* quick access to all handles on object, e.g. viewer, whether enabled or not */  /* quick access to all fields on object, e.g. viewer, whether enabled or not */ = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/afoldfr0.w).
    */
   public void execute()
   {
      /* For {get/set} */
      handle ghAdmprops = TypeFactory.handle();
      /* Handle of prop t-t */
      handle ghAdmpropsBuf = TypeFactory.handle();
      /*  and its buffer    */
      logical glAdmloadFromRepos = TypeFactory.logical();
      /* Now include out parent class file for visual objects. */
      /*********************************************************************
      * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
      * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
      * below.  All Rights Reserved.                                       *
      *                                                                    *
      * The Initial Developer of the Original Code is PSC.  The Original   *
      * Code is Progress IDE code released to open source December 1, 2000.*
      *                                                                    *
      * The contents of this file are subject to the Possenet Public       *
      * License Version 1.0 (the "License"); you may not use this file     *
      * except in compliance with the License.  A copy of the License is   *
      * available as of the date of this notice at                         *
      * http://www.possenet.org/license.html                               *
      *                                                                    *
      * Software distributed under the License is distributed on an "AS IS"*
      * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
      * should refer to the License for the specific language governing    *
      * rights and limitations under the License.                          *
      *                                                                    *
      * Contributors:                                                      *
      *                                                                    *
      *********************************************************************/
      /*--------------------------------------------------------------------------
          File        : visual.i
          Purpose     : Defines basic properties and other info for visual objects
      
          Syntax      :
      
          Description :
      
          Modified    : May 19, 1999 Version 9.1A
          Modified    : 11/13/2001      Mark Davies (MIP)
                        Check for valid handle of any gsh... variables
        ------------------------------------------------------------------------*/
      /*          This .i file was created with the Progress UIB.             */
      /*----------------------------------------------------------------------*/
      /* ***************************  Definitions  ************************** */
      /* _UIB-CODE-BLOCK-END */
      /* ********************  Preprocessor Definitions  ******************** */
      /* _UIB-PREPROCESSOR-BLOCK-END */
      /* *********************** Procedure Settings ************************ */
      /* Settings for THIS-PROCEDURE
         Type: Include
         Allow: 
         Frames: 0
         Add Fields to: Neither
         Other Settings: INCLUDE-ONLY
       */
      /* *************************  Create Window  ************************** */
      /* DESIGN Window definition (used by the UIB) 
        CREATE WINDOW Include ASSIGN
               HEIGHT             = 8
               WIDTH              = 60.
      _* END WINDOW DEFINITION *_
                                                                              */
      /* ************************* Included-Libraries *********************** */
      /*********************************************************************
      * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
      * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
      * below.  All Rights Reserved.                                       *
      *                                                                    *
      * The Initial Developer of the Original Code is PSC.  The Original   *
      * Code is Progress IDE code released to open source December 1, 2000.*
      *                                                                    *
      * The contents of this file are subject to the Possenet Public       *
      * License Version 1.0 (the "License"); you may not use this file     *
      * except in compliance with the License.  A copy of the License is   *
      * available as of the date of this notice at                         *
      * http://www.possenet.org/license.html                               *
      *                                                                    *
      * Software distributed under the License is distributed on an "AS IS"*
      * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
      * should refer to the License for the specific language governing    *
      * rights and limitations under the License.                          *
      *                                                                    *
      * Contributors:                                                      *
      *                                                                    *
      *********************************************************************/
      /*--------------------------------------------------------------------------
          Library     : smart.i - NEW V9 version of top-level SmartObject include
      
          Modified    : May 22, 2000 -- Version 9.1B
        ------------------------------------------------------------------------*/
      /*          This .i file was created with the Progress UIB.             */
      /*----------------------------------------------------------------------*/
      /* ***************************  Definitions  ************************** */
      /* If smart.i has already been included, skip everything 
            (matching ENDIF is at the end of the file). */
      /* Define the preprocessor that identifies the basic "class" of the object;
           ADMClass will remain undefined here only if the object uses no sub-class
           include files. */
      /* If this object is of type "smart", i.e., uses no lower class include
           files, then include the property file here. Otherwise this will be
           done in the class include file of the base class of the object. */
      /* Window or Frame handle (not used, but kept for backwards comaptibility) */
      handle ghContainer = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      integer iStart = TypeFactory.integer();
      
      externalProcedure(Afoldfr0.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         /*------------------------------------------------------------------------
           File:        V9 folder - wrapper for Videosoft OCX
         ------------------------------------------------------------------------*/
         /*          This .W file was created with the Progress UIB.             */
         /*----------------------------------------------------------------------*/
         /* Create an unnamed pool to store all the widgets created 
              by this procedure. This is a good default which assures
              that this procedure's triggers and internal procedures 
              will execute in this procedure's storage, and that proper
              cleanup will occur on deletion of the procedure. */
         WidgetPool.create();
         
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: SmartFolder
            Allow: Basic
            Frames: 1
            Add Fields to: NEITHER
            Other Settings: PERSISTENT-ONLY
          */
         /* This procedure should always be RUN PERSISTENT.  Report the error,  */
         /* then cleanup and return.                                            */
         if (_not(thisProcedure().unwrapProcedure().isPersistent()))
         {
            messageBox("common/afoldfr0.w should only be RUN PERSISTENT.", ALERT_ERROR, BTN_OK, (String) null);
            returnNormal();
         }
         
         /* Horrible, horrible code required for Homelessness */
         /* Definitions to allow syntax checking when editing the method library code */
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 14.77
                  WIDTH              = 50.29.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ************************* Included-Libraries *********************** */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         DynamicWidgetFactory.createFrame(lhOverlayButtonFrame);
         lhOverlayButtonFrame.unwrapWidget().setFrameHandle(folderFrmFrame.asWidgetHandle());
         lhOverlayButtonFrame.unwrapBox().setBox(new logical(false));
         lhOverlayButtonFrame.unwrapWidget().setScrollable(new logical(false));
         DynamicWidgetFactory.createButton(lhOverlayButton);
         lhOverlayButton.unwrapWidget() /* FRAME {&FRAME-NAME}:HANDLE */ .setFrameHandle(lhOverlayButtonFrame);
         lhOverlayButton.unwrapWidget().setFont(new integer(10));
         registerTriggerPersistentIn(new EventList("CURSOR-RIGHT", lhOverlayButton), "POverlayBtnEventCursorRight", thisProcedure());
         registerTriggerPersistentIn(new EventList("CURSOR-LEFT", lhOverlayButton), "POverlayBtnEventCursorLeft", thisProcedure());
         
         if (_isEqual(LogicalTerminal.getWindowSystem(), "MS-WIN95"))
         {
            DynamicWidgetFactory.createFrame(lhBackgroundFrame);
            lhBackgroundFrame.unwrapWidget().setFrameHandle(folderFrmFrame.asWidgetHandle());
            lhBackgroundFrame.unwrapBox().setBox(new logical(false));
            lhBackgroundFrame.unwrapWidget().setThreeD(new logical(true));
            lhBackgroundFrame.unwrapWidget().setScrollable(new logical(false));
            DynamicWidgetFactory.createButton(lhBackgroundButton);
            lhBackgroundButton.unwrapWidget().setFrameHandle(lhBackgroundFrame);
         }
         else
         {
            DynamicWidgetFactory.createFrame(lhBackgroundFrame);
            lhBackgroundFrame.unwrapWidget().setFrameHandle(folderFrmFrame.asWidgetHandle());
            lhBackgroundFrame.unwrapWidget().setBgColor(new integer(31));
            lhBackgroundFrame.unwrapBox().setBox(new logical(true));
            lhBackgroundFrame.unwrapWidget().setScrollable(new logical(false));
         }
         
         folderFrmFrame.asWidget().setScrollable(new logical(false));
         folderFrmFrame.setHidden(new logical(true));
         folderFrmFrame.asWidget().setSelectable(new logical(true));
         folderFrmFrame.asWidget().setMovable(new logical(true));
         folderFrmFrame.asWidget().setResizable(new logical(true));
         folderFrmFrame.asWidget().setPrivateData(new character("TAB-FOLDER"));
         
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         /* Note that adm-props-from-repository is intended to be replaced with
              a variable for flexible override, so it cannot be used for conditional 
              compile.  */
         if ((gshRepositoryManager.isValid()).booleanValue())
         {
            if (_not(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode("prepareInstance", gshRepositoryManager, "II", concat(valueOf(thisProcedure()), ",", valueOf(folderFrmFrame.asWidgetHandle())), sourceProcedure()))))
            {
               stop();
            }
            
            ghAdmpropsBuf.assign(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))));
            glAdmloadFromRepos.assign(ghAdmpropsBuf.isValid());
         }
         
         /* VALID-HANDLE(gshRepositoryManager) */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            TempTableBuilder.create(ghAdmprops);
            ghAdmprops.unwrapTempTable().setCanUndo(new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectName"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectVersion"), new character("CHAR"), new integer(0), new character(), new character("ADM2.2"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectType"), new character("CHAR"), new integer(0), new character(), new character("SmartFolder"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerType"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("PropertyDialog"), new character("CHAR"), new integer(0), new character(), new character("xadm/adm2/support/cmfolderd.w"));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryObject"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerHandle"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("InstanceProperties"), new character("CHAR"), new integer(0), new character(), new character("FolderLabels,FolderTabType, HideOnInit,DisableOnInit,ObjectLayout"));
            /* NOTE: Any need to support &User-Supported-Links?? */
            ghAdmprops.unwrapTempTable().addNewField(new character("SupportedLinks"), new character("CHAR"), new integer(0), new character(), new character("Page-Source"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerHidden"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectInitialized"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            /*  "hidden" is a logical concept. */
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectHidden"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("HideOnInit"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("UIBMode"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerSource"), new character("HANDLE"));
            /* Note that datavis adds some events that are only required for updating objects */
            /* isUpdateActive event is needed only for data, datavis and container classes,
                 but we currently define it here.. (this simplifies the logic for datavis, 
                 which may or may not inherit from container)
                 confirmOk and confirmCancel only for container ans datavis */
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("initializeObject,hideObject,viewObject,destroyObject,enableObject,confirmExit,confirmCancel,confirmOk,isUpdateActive"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSource"), new character("HANDLE"));
            /* Note that DataSourceEvents is overidden in data.i since some of these 
                 events are intended for visual targets; queryPosition, fetchDataSet, 
                 assignMaxdataguess and the most resent addition confirmUndo and 
                 confirmCommit. These two are NOT dataSourceEvents for SDOs as the message 
                 should not to be published to objects not affected by the commit/undo. */
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("dataAvailable,queryPosition,updateState,deleteComplete,fetchDataSet,confirmContinue,confirmCommit,confirmUndo,assignMaxGuess,isUpdatePending"));
            ghAdmprops.unwrapTempTable().addNewField(new character("TranslatableProperties"), new character("CHAR"), new integer(0), new character(), new character("FolderLabels"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectPage"), new character("INT"), new integer(0), new character(), new integer(0));
            ghAdmprops.unwrapTempTable().addNewField(new character("DBAware"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("DesignDataObject"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSourceNames"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataTargetEvents"), new character("CHARACTER"), new integer(0), new character(), new character("updateState,rowObjectState,fetchBatch,LinkState"));
            ghAdmprops.unwrapTempTable().addNewField(new character("LogicalObjectName"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PhysicalObjectName"), new character("CHARACTER"), new integer(), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("LogicalVersion"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PhysicalVersion"), new character("CHARACTER"), new integer(), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DynamicObject"), new character("LOGICAL"));
            ghAdmprops.unwrapTempTable().addNewField(new character("RunAttribute"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ChildDataKey"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ParentDataKey"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataLinksEnabled"), new character("LOGICAL"), new integer(), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("InactiveLinks"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("InstanceId"), new character("DECIMAL"));
            /* SuperProcedure management */
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedureMode"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedureHandle"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("LayoutPosition"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ClassName"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("RenderingProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ThinRenderingProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("Label"), new character("CHAR"), new integer(0), new character(), new unknown());
         }
         
         /* _UIB-CODE-BLOCK-END */
         /* else if appserver aware (adecomm/appserv.i) include appserver props */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectLayout"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("LayoutOptions"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectEnabled"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("LayoutVariable"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DefaultLayout"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DisableOnInit"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("EnabledObjFlds"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("EnabledObjHdls"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("FieldSecurity"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("SecuredTokens"), new character("CHARACTER"), new integer(0), new character(), new unknown());
            /* Initial must be unknown. */
            ghAdmprops.unwrapTempTable().addNewField(new character("AllFieldHandles"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("AllFieldNames"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("MinHeight"), new character("DECIMAL"), new integer(0), new character(), new integer(0));
            ghAdmprops.unwrapTempTable().addNewField(new character("MinWidth"), new character("DECIMAL"), new integer(0), new character(), new integer(0));
            ghAdmprops.unwrapTempTable().addNewField(new character("ResizeHorizontal"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ResizeVertical"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectSecured"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectTranslated"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("PopupButtonsInFields"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorInfoBG"), new character("INTEGER"), new integer(0), new character(), new integer(10));
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorInfoFG"), new character("INTEGER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorWarnBG"), new character("INTEGER"), new integer(0), new character(), new integer(3));
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorWarnFG"), new character("INTEGER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorErrorBG"), new character("INTEGER"), new integer(0), new character(), new integer(12));
            ghAdmprops.unwrapTempTable().addNewField(new character("ColorErrorFG"), new character("INTEGER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("BGColor"), new character("INTEGER"), new integer(0), new character(), new integer(12));
            ghAdmprops.unwrapTempTable().addNewField(new character("FGColor"), new character("INTEGER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("FieldPopupMapping"), new character("CHARACTER"), new integer(0), new character(), new character(""));
         }
         
         /* _UIB-CODE-BLOCK-END */
         /* and then we add our folder property defs to that... */
         ghAdmprops.unwrapTempTable().addNewField(new character("FolderLabels"), new character("CHAR"), new integer(0), new character(), new character(""));
         ghAdmprops.unwrapTempTable().addNewField(new character("FolderTabType"), new character("INT"), new integer(0), new character(), new integer(1));
         ghAdmprops.unwrapTempTable().addNewField(new character("PageTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
         ghAdmprops.unwrapTempTable().addNewField(new character("PageTargetEvents"), new character("CHAR"), new integer(0), new character(), new character("changeFolderPage,deleteFolderPage,PEVENTMoveToBottom"));
         ghContainer.assign(folderFrmFrame.asWidgetHandle());
         
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 8.62
                  WIDTH              = 52.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ************************* Included-Libraries *********************** */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/smart.p"));
         }
         
         /* Use the old adm definition */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            /* Now create the one record in this property temp-table, and store its
                   handle in ADM-DATA. The CHR(1) delimiters are to set aside spots
                   for UserProperties and UserLinks. */
            ghAdmprops.unwrapTempTable().tempTablePrepare("ADMProps");
            ghAdmpropsBuf.assign(ghAdmprops.unwrapTempTable().defaultBufferHandle());
            ghAdmpropsBuf.unwrapBuffer().bufferCreate();
            /* ... and save it. This ADM object is now open for business! */
            thisProcedure().unwrapADMData().setADMData(concat(valueOf(ghAdmpropsBuf), chr(1), chr(1)));
            /* from this point  {&ADM-PROPS-DEFINED} is true for all cases */
            cObjectName.assign("FolderLabels,FolderTabType, HideOnInit,DisableOnInit,ObjectLayout");
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceProperties"));
            ghProp.unwrapBufferField().changeValue(cObjectName);
            cObjectName.assign(replaceAll(thisProcedure().unwrapFile().getFileName(), "\\", "/"));
            iStart.assign(plus(lastIndexOf(cObjectName, "/"), 1));
            cObjectName.assign(substring(cObjectName, iStart, minus(lastIndexOf(thisProcedure().unwrapFile().getFileName(), "."), iStart)));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            ghProp.unwrapBufferField().changeValue(cObjectName);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
            ghProp.unwrapBufferField().changeValue(folderFrmFrame.asWidgetHandle());
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
            ghProp.unwrapBufferField().changeValue(new character("SmartFolder"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
            ghProp.unwrapBufferField().changeValue(new character(""));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalVersion"));
            ghProp.unwrapBufferField().changeValue(new character(""));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalObjectName"));
            ghProp.unwrapBufferField().changeValue((_isNotEqual("", "") ? new character("") : thisProcedure().unwrapFile().getFileName()));
         }
         
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/visual.p"));
         }
         
         /* _ADM-CODE-BLOCK-START _CUSTOM _INCLUDED-LIB-CUSTOM CUSTOM */
         /*********************************************************************
         * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
         * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
         * below.  All Rights Reserved.                                       *
         *                                                                    *
         * The Initial Developer of the Original Code is PSC.  The Original   *
         * Code is Progress IDE code released to open source December 1, 2000.*
         *                                                                    *
         * The contents of this file are subject to the Possenet Public       *
         * License Version 1.0 (the "License"); you may not use this file     *
         * except in compliance with the License.  A copy of the License is   *
         * available as of the date of this notice at                         *
         * http://www.possenet.org/license.html                               *
         *                                                                    *
         * Software distributed under the License is distributed on an "AS IS"*
         * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
         * should refer to the License for the specific language governing    *
         * rights and limitations under the License.                          *
         *                                                                    *
         * Contributors:                                                      *
         *                                                                    *
         *********************************************************************/
         /*------------------------------------------------------------------------
             File        : visualcustom.i
             Purpose     : References the start of the custom super procedure.
                           Allows properties initialization.
         
             Syntax      : {src/adm2/custom/visualcustom.i}
         
             Description :
         
             Created     : 06/03/1999
             Notes       : Referenced in {src/adm2/visual.i}
           ----------------------------------------------------------------------*/
         /*          This .W file was created with the Progress AppBuilder.      */
         /*----------------------------------------------------------------------*/
         /* ***************************  Definitions  ************************** */
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Include
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Include ASSIGN
                  HEIGHT             = 15
                  WIDTH              = 60.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Starts here the custom super procedure 
            Uncomment to run it */
         /*RUN start-super-proc ("adm2/custom/visualcustom.p":U).*/
         /* _UIB-CODE-BLOCK-END */
         /* _ADM-CODE-BLOCK-END */
         if ((gshSessionManager.isValid()).booleanValue())
         {
            registerTrigger(new EventList("HELP", folderFrmFrame.asWidget(), true), Afoldfr0.this, new Trigger((Body) () -> 
            {
               ControlFlowOps.invokeInWithMode("contextHelp", gshSessionManager, "II", thisProcedure(), focus());
            }));
         }
         
         registerTrigger(new EventList("CTRL-PAGE-UP", folderFrmFrame.asWidget(), true), Afoldfr0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeInWithMode("processAction", targetProcedure(), "I", new character("CTRL-PAGE-UP"));
         }));
         
         registerTrigger(new EventList("CTRL-PAGE-DOWN", folderFrmFrame.asWidget(), true), Afoldfr0.this, new Trigger((Body) () -> 
         {
            ControlFlowOps.invokeInWithMode("processAction", targetProcedure(), "I", new character("CTRL-PAGE-DOWN"));
         }));
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       NO-ERROR on the button dimension assigns because might not exist.<br>
    *              Easier to read then VALID-HANDLE...
    */
   public void padjustBackgroundFrame()
   {
      integer iClassicAdjustment = TypeFactory.integer();
      /* Variables make the code easier to read */
      integer iTargetFrameHeight = TypeFactory.integer();
      integer iTargetFrameWidth = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_isEqual(LogicalTerminal.getWindowSystem(), "MS-WIN95"))
         {
            iClassicAdjustment.assign(1);
         }
         
         /* Resize/Move the frame */
         /* Vertically */
         iTargetFrameHeight.assign(minus(minus(folderFrmFrame.getHeightPixels(), multiply(minus(22, 4), liNumTabFrames)), 2));
         
         if (_isGreaterThan(lhBackgroundFrame.unwrapSizeable().getHeightPixels(), iTargetFrameHeight) /* Getting smaller */)
         {
            ErrorManager.silentErrorEnable();
            lhBackgroundButton.unwrapSizeable().setHeightPixels(iTargetFrameHeight);
            ErrorManager.silentErrorDisable();
            lhBackgroundFrame.unwrapSizeable().setHeightPixels(iTargetFrameHeight);
         }
         
         lhBackgroundFrame.unwrapXY().setY(new integer(plus(multiply(minus(22, 4), liNumTabFrames), 2)));
         
         if (_isLessThan(lhBackgroundFrame.unwrapSizeable().getHeightPixels(), iTargetFrameHeight) /* Getting bigger */)
         {
            lhBackgroundFrame.unwrapSizeable().setHeightPixels(iTargetFrameHeight);
            ErrorManager.silentErrorEnable();
            lhBackgroundButton.unwrapSizeable().setHeightPixels(iTargetFrameHeight);
            ErrorManager.silentErrorDisable();
         }
         
         /* Horizontally */
         iTargetFrameWidth.assign(minus(folderFrmFrame.getWidthPixels(), minus(2, multiply(2, iClassicAdjustment))));
         
         if (_isGreaterThan(lhBackgroundFrame.unwrapSizeable().getWidthPixels(), iTargetFrameWidth) /* Getting smaller */)
         {
            ErrorManager.silentErrorEnable();
            lhBackgroundButton.unwrapSizeable().setWidthPixels(iTargetFrameWidth);
            ErrorManager.silentErrorDisable();
            lhBackgroundFrame.unwrapSizeable().setWidthPixels(iTargetFrameWidth);
         }
         
         lhBackgroundFrame.unwrapXY().setX(new integer(minus(1, iClassicAdjustment)));
         
         if (_isLessThan(lhBackgroundFrame.unwrapSizeable().getWidthPixels(), iTargetFrameWidth) /* Getting bigger */)
         {
            lhBackgroundFrame.unwrapSizeable().setWidthPixels(iTargetFrameWidth);
            ErrorManager.silentErrorEnable();
            lhBackgroundButton.unwrapSizeable().setWidthPixels(iTargetFrameWidth);
            ErrorManager.silentErrorDisable();
         }
         
         lhOverlayButton.unwrapWidget().moveToTop();
         lhBackgroundFrame.unwrapWidget().moveToTop();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void passignTabsToFrames(final character _icFolderLabels, final integer _iiFrameWidth, final OutputExtentParameter<character> extocFrameLabels, final OutputExtentParameter<integer> extoiFramePadding)
   {
      character icFolderLabels = TypeFactory.initInput(_icFolderLabels);
      integer iiFrameWidth = TypeFactory.initInput(_iiFrameWidth);
      character[] ocFrameLabels = TypeFactory.initOutput(extocFrameLabels, 5);
      integer[] oiFramePadding = TypeFactory.initOutput(extoiFramePadding, 5);
      integer iCount = TypeFactory.integer();
      integer iTabFrameCount = TypeFactory.integer((long) 0);
      integer iNumTabFrames = TypeFactory.integer();
      character cLabel = TypeFactory.character();
      integer iLabels = TypeFactory.integer();
      integer[] iWidthOfTab = TypeFactory.integerExtent(20);
      integer[] iFrameFirstTab = TypeFactory.integerExtent(5);
      integer[] iTabFrameWidth = TypeFactory.integerExtent(5);
      integer[] iNumTabsInFrame = TypeFactory.integerExtent(5);
      logical lShuffled = TypeFactory.logical();
      integer iShuffleFrame = TypeFactory.integer();
      /* 1
                  _* Take last tab off previous frame, and add to this, if the result is less wide then go ahead and swap *_
                  DO WHILE iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1]:
                      lShuffled = TRUE.
                      iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                      iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                      iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                  END.
                  */
      /* 2 whilst the average padding of the previous is still larger then shuffle */
      /*
                  DO WHILE (IiFrameWidth - (iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame] + 1) > (IiFrameWidth - (iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame - 1] - 1):
                      lShuffled = TRUE.
                      
                      iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                      iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                      iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                      iNumTabsInFrame[iShuffleFrame] = iNumTabsInFrame[iShuffleFrame] + 1.
                      iNumTabsInFrame[iShuffleFrame - 1] = iNumTabsInFrame[iShuffleFrame - 1] - 1.
                  END.
                  */
      /*
                  _* or 3 both of the above... *_
                  DO WHILE (IiFrameWidth - (iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame] + 1) > (IiFrameWidth - (iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1])) / (iNumTabsInFrame[iShuffleFrame - 1] - 1)
                      OR iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1]:
                      lShuffled = TRUE.
                      
                      iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                      iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                      iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                      iNumTabsInFrame[iShuffleFrame] = iNumTabsInFrame[iShuffleFrame] + 1.
                      iNumTabsInFrame[iShuffleFrame - 1] = iNumTabsInFrame[iShuffleFrame - 1] - 1.
                  END.
                  */
      /* Do whilst padding is still positive for both, but would be better */
      /*
                  DO WHILE iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < IiFrameWidth
                      AND iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1] < iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame] - 1]
                      :
                      
                      lShuffled = TRUE.
                      iFrameFirstTab[iShuffleFrame] = iFrameFirstTab[iShuffleFrame] - 1.
                      iTabFrameWidth[iShuffleFrame] = iTabFrameWidth[iShuffleFrame] + iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                      iTabFrameWidth[iShuffleFrame - 1] = iTabFrameWidth[iShuffleFrame - 1] - iWidthOfTab[iFrameFirstTab[iShuffleFrame]].
                      iNumTabsInFrame[iShuffleFrame] = iNumTabsInFrame[iShuffleFrame] + 1.
                      iNumTabsInFrame[iShuffleFrame - 1] = iNumTabsInFrame[iShuffleFrame - 1] - 1.
                  END.
                  */
      /* Lowest average padding */
      /* Variables to make easier to read */
      decimal iCurrentShuffleTabPadding = TypeFactory.decimal();
      decimal iCurrentMinusTabPadding = TypeFactory.decimal();
      decimal iNewShuffleTabPadding = TypeFactory.decimal();
      decimal iNewMinusTabPadding = TypeFactory.decimal();
      
      internalProcedure(new Block((Body) () -> 
      {
         iLabels.assign(numEntries(icFolderLabels, "|"));
         
         initialAllocateBlock:
         for (iCount.assign(1); _isLessThanOrEqual(iCount, iLabels); iCount.increment())
         {
            cLabel.assign(entry(iCount, icFolderLabels, "|"));
            assignSingle(iWidthOfTab, iCount, plus(FontTable.getTextWidthPixels(cLabel, 10), 11));
            
            /* Should be 10, but with overlaps, it's easier just to say +9, and add 1 on at the start */
            /* Set the initial frames */
            if (_or(isEqual(iTabFrameCount, 0), () -> isGreaterThan(plus(subscript(iTabFrameWidth, iTabFrameCount), subscript(iWidthOfTab, iCount)), iiFrameWidth)))
            {
               if (_isEqual(iTabFrameCount, 5))
               {
                  messageBox("Maximum number of tab rows has been reached.  Not all tabs can be displayed", ALERT_WARNING, BTN_OK, (String) null);
                  iLabels.assign(minus(iCount, 1));
                  break initialAllocateBlock;
               }
               
               iTabFrameCount.assign(plus(iTabFrameCount, 1));
               assignSingle(iFrameFirstTab, iTabFrameCount, iCount);
               assignSingle(iTabFrameWidth, iTabFrameCount, 1);
            }
            assignSingle(iTabFrameWidth, iTabFrameCount, plus(subscript(iTabFrameWidth, iTabFrameCount), subscript(iWidthOfTab, iCount)));
            assignSingle(iNumTabsInFrame, iTabFrameCount, plus(subscript(iNumTabsInFrame, iTabFrameCount), 1));
         }
         
         iNumTabFrames.assign(iTabFrameCount);
         
         if (_isGreaterThan(iNumTabFrames, 1))
         {
            repeat("shuffleBlock", new Block((Body) () -> 
            {
               lShuffled.assign(false);
               
               loopLabel0:
               for (iShuffleFrame.assign(iNumTabFrames); _isGreaterThanOrEqual(iShuffleFrame, 2); iShuffleFrame.decrement())
               {
                  loopLabel1:
                  while (_isLessThan(plus(subscript(iTabFrameWidth, iShuffleFrame), subscript(iWidthOfTab, minus(subscript(iFrameFirstTab, iShuffleFrame), 1))), iiFrameWidth))
                  {
                     /* basic check */
                     iCurrentShuffleTabPadding.assign(divide(minus(iiFrameWidth, subscript(iTabFrameWidth, iShuffleFrame)), subscript(iNumTabsInFrame, iShuffleFrame)));
                     iCurrentMinusTabPadding.assign(divide(minus(iiFrameWidth, subscript(iTabFrameWidth, minus(iShuffleFrame, 1))), subscript(iNumTabsInFrame, minus(iShuffleFrame, 1))));
                     iNewShuffleTabPadding.assign(divide(minus(iiFrameWidth, plus(subscript(iTabFrameWidth, iShuffleFrame), subscript(iWidthOfTab, minus(subscript(iFrameFirstTab, iShuffleFrame), 1)))), plus(subscript(iNumTabsInFrame, iShuffleFrame), 1)));
                     iNewMinusTabPadding.assign(divide(minus(iiFrameWidth, minus(subscript(iTabFrameWidth, minus(iShuffleFrame, 1)), subscript(iWidthOfTab, minus(subscript(iFrameFirstTab, iShuffleFrame), 1)))), minus(subscript(iNumTabsInFrame, minus(iShuffleFrame, 1)), 1)));
                     
                     if (_isLessThanOrEqual(divide(plus(iNewShuffleTabPadding, iNewMinusTabPadding), 2), divide(plus(iCurrentShuffleTabPadding, iCurrentMinusTabPadding), 2)))
                     {
                        lShuffled.assign(true);
                        assignSingle(iFrameFirstTab, iShuffleFrame, minus(subscript(iFrameFirstTab, iShuffleFrame), 1));
                        assignSingle(iTabFrameWidth, iShuffleFrame, plus(subscript(iTabFrameWidth, iShuffleFrame), subscript(iWidthOfTab, subscript(iFrameFirstTab, iShuffleFrame))));
                        assignSingle(iTabFrameWidth, minus(iShuffleFrame, 1), minus(subscript(iTabFrameWidth, minus(iShuffleFrame, 1)), subscript(iWidthOfTab, subscript(iFrameFirstTab, iShuffleFrame))));
                        assignSingle(iNumTabsInFrame, iShuffleFrame, plus(subscript(iNumTabsInFrame, iShuffleFrame), 1));
                        assignSingle(iNumTabsInFrame, minus(iShuffleFrame, 1), minus(subscript(iNumTabsInFrame, minus(iShuffleFrame, 1)), 1));
                     }
                     else
                     {
                        break loopLabel1;
                     }
                  }
               }
               
               if (_not(lShuffled))
               {
                  leave("shuffleBlock");
               }
            }));
         }
         /* Starting with the highest tab, work down */
         /* Algorithm */
         assignMulti(ocFrameLabels, "");
         iTabFrameCount.assign(0);
         
         loopLabel2:
         for (iCount.assign(1); _isLessThanOrEqual(iCount, iLabels); iCount.increment())
         {
            if (_and(isLessThan(iTabFrameCount, 5), () -> isEqual(subscript(iFrameFirstTab, plus(iTabFrameCount, 1)), iCount)))
            {
               iTabFrameCount.assign(plus(iTabFrameCount, 1));
            }
            
            assignSingle(ocFrameLabels, iTabFrameCount, concat(subscript(ocFrameLabels, iTabFrameCount), "|", entry(iCount, icFolderLabels, "|")));
         }
         
         loopLabel3:
         for (iTabFrameCount.assign(1); _isLessThanOrEqual(iTabFrameCount, iNumTabFrames); iTabFrameCount.increment())
         {
            assignSingle(ocFrameLabels, iTabFrameCount, substring(subscript(ocFrameLabels, iTabFrameCount), 2));
            
            if (_isGreaterThan(iNumTabFrames, 1) /* Only pad out the labels for multi-row */)
            {
               assignSingle(oiFramePadding, iTabFrameCount, minus(iiFrameWidth, subscript(iTabFrameWidth, iTabFrameCount)));
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pbtnEventCursorLeft()
   {
      integer iPos = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         loopLabel4:
         for (iPos.assign(1); _isLessThanOrEqual(iPos, liNumTabs); iPos.increment())
         {
            if (_isEqual(subscript(lhTab, iPos), self()))
            {
               break loopLabel4;
            }
         }
         
         iPos.assign(minus(iPos, 1));
         
         if (_isEqual(iPos, 0))
         {
            iPos.assign(liNumTabs);
         }
         
         apply(subscript(lhTab, iPos), "ENTRY");
         apply(subscript(lhTab, iPos), "MOUSE-SELECT-DOWN");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pbtnEventCursorRight()
   {
      integer iPos = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         loopLabel5:
         for (iPos.assign(1); _isLessThanOrEqual(iPos, liNumTabs); iPos.increment())
         {
            if (_isEqual(subscript(lhTab, iPos), self()))
            {
               break loopLabel5;
            }
         }
         
         iPos.assign(plus(iPos, 1));
         
         if (_isGreaterThan(iPos, liNumTabs))
         {
            iPos.assign(1);
         }
         
         apply(subscript(lhTab, iPos), "ENTRY");
         apply(subscript(lhTab, iPos), "MOUSE-SELECT-DOWN");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Specifically the action of pressing the tab with the mouse<br>
    *              and also hitting Enter on the button (instead of Choose)<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Also used by right and left cursor when focus is on tabs.
    */
   public void pbtnEventMouseSelectDown()
   {
      integer iCount = TypeFactory.integer();
      integer iThisPageNo = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Force any leave trigger to fire, and if focus hasn't moved, then assume leave trigger has been rejected */
         apply(self(), "ENTRY");
         
         if (_isNotEqual(focus(), self()))
         {
            returnNormal();
         }
         
         loopLabel6:
         for (iCount.assign(1); _isLessThanOrEqual(iCount, 20); iCount.increment())
         {
            if (_and(and(subscript(lhTab, iCount).isValid(), () -> isNotEqual(subscript(lhTab, iCount), self())), () -> isNotEqual(subscript(lhTab, iCount).unwrap().getPrivateData(), "DISABLED")))
            {
               subscript(lhTab, iCount).unwrapSensitive().setSensitive(new logical(true));
            }
            
            if (_isEqual(subscript(lhTab, iCount), self()))
            {
               iThisPageNo.assign(iCount);
            }
         }
         
         /* Let this be done by the change page for now 
             _* Update the tab visualisation *_
             RUN PUpdateTabVisualisation(iThisPageNo).
             */
         llClickActive.assign(true);
         ErrorManager.silentErrorEnable();
         /* Select the page */
         ControlFlowOps.invokeInWithMode("SelectPage", lhContainer, "I", iThisPageNo);
         ErrorManager.silentErrorDisable();
         /* Visualisation is actually done by the container telling the tab to change, not here */
         llClickActive.assign(false);
         /* Re-apply ENTRY to SELF - to ensure that the focus is on the tab */
         /* APPLY "ENTRY" TO SELF. - whilst using an overlay button, comment out */
         apply(lhOverlayButton, "ENTRY");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pcreateTabs(final character _icLabels)
   {
      character icLabels = TypeFactory.initInput(_icLabels);
      /* create all tabs */
      integer iCount = TypeFactory.integer();
      character cLabel = TypeFactory.character();
      integer iTotalCount = TypeFactory.integer();
      integer iTabFrame = TypeFactory.integer((long) 0);
      integer iTabFramePositionPixels = TypeFactory.integer((long) 10000);
      integer iNumFrameTabs = TypeFactory.integer();
      integer iButtonPadding = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         loopLabel7:
         for (iCount.assign(1); _isLessThanOrEqual(iCount, 20); iCount.increment())
         {
            if ((subscript(lhTab, iCount).isValid()).booleanValue())
            {
               HandleOps.delete(subscript(lhTab, iCount));
            }
         }
         
         loopLabel8:
         for (iCount.assign(1); _isLessThanOrEqual(iCount, liNumTabFrames); iCount.increment())
         {
            HandleOps.delete(subscript(lhTabFrame, iCount));
         }
         
         ControlFlowOps.invokeWithMode("PAssignTabsToFrames", "IIOO", icLabels, minus(folderFrmFrame.getWidthPixels(), 4), new ExtentExpr0(), new ExtentExpr1());
         
         loopLabel9:
         for (iTabFrame.assign(1); _isLessThanOrEqual(iTabFrame, 5); iTabFrame.increment())
         {
            if (_isEqual(subscript(cTabFrameLabels, iTabFrame), ""))
            {
               break loopLabel9;
            }
            
            liNumTabFrames.assign(iTabFrame);
            /* Just increment until it is set */
            DynamicWidgetFactory.createFrame(subscript(lhTabFrame, iTabFrame));
            subscript(lhTabFrame, iTabFrame).unwrapWidget().setFrameHandle(folderFrmFrame.asWidgetHandle());
            subscript(lhTabFrame, iTabFrame).unwrapWidget().setFont(new integer(10));
            subscript(lhTabFrame, iTabFrame).unwrapWidget().setBgColor(((llOnTabFrame).booleanValue() ? new integer(31) : new integer()));
            subscript(lhTabFrame, iTabFrame).unwrapWidget().setThreeD(new logical(true));
            subscript(lhTabFrame, iTabFrame).unwrapSizeable().setWidthPixels(new integer(minus(folderFrmFrame.getWidthPixels(), 2)));
            subscript(lhTabFrame, iTabFrame).unwrapSizeable().setHeightPixels(new integer(22));
            subscript(lhTabFrame, iTabFrame).unwrapXY().setX(new integer(2));
            subscript(lhTabFrame, iTabFrame).unwrapXY().setY(new integer(plus(2, multiply(minus(22, 4), minus(iTabFrame, 1)))));
            subscript(lhTabFrame, iTabFrame).unwrapBox().setBox(new logical(false));
            /* VISIBLE = TRUE */
            subscript(lhTabFrame, iTabFrame).unwrapWidget().setHidden(new logical(false));
            iTabFramePositionPixels.assign(0);
            iNumFrameTabs.assign(numEntries(subscript(cTabFrameLabels, iTabFrame), "|"));
            
            loopLabel10:
            for (iCount.assign(1); _isLessThanOrEqual(iCount, iNumFrameTabs); iCount.increment())
            {
               iTotalCount.assign(plus(iTotalCount, 1));
               /* + INTEGER(ROUND(iCount * iTabFramePadding[iCount] / iNumFrameTabs,0) - ROUND((iCount - 1) * iTabFramePadding[iCount] / iNumFrameTabs,0)) */
               cLabel.assign(entry(iCount, subscript(cTabFrameLabels, iTabFrame), "|"));
               /* For readability/debugging */
               iButtonPadding.assign(minus(round(divide(multiply(iCount, subscript(iTabFramePadding, iTabFrame)), iNumFrameTabs), 0), round(divide(multiply(minus(iCount, 1), subscript(iTabFramePadding, iTabFrame)), iNumFrameTabs), 0)));
               DynamicWidgetFactory.createButton(subscript(lhTab, iTotalCount));
               subscript(lhTab, iTotalCount).unwrapCommonField().setLabel(cLabel);
               subscript(lhTab, iTotalCount).unwrap().setPrivateData(valueOf(iTotalCount));
               subscript(lhTab, iTotalCount).unwrapSizeable().setWidthPixels(new integer(plus(plus(FontTable.getTextWidthPixels(cLabel, 10), 12), iButtonPadding)));
               subscript(lhTab, iTotalCount).unwrapSizeable().setHeightPixels(new integer(minus(22, 1)));
               subscript(lhTab, iTotalCount).unwrapWidget().setFrameHandle(subscript(lhTabFrame, iTabFrame));
               subscript(lhTab, iTotalCount).unwrapXY().setX(iTabFramePositionPixels);
               subscript(lhTab, iTotalCount).unwrapXY().setY(new integer(0));
               subscript(lhTab, iTotalCount).unwrapWidget().setVisible(new logical(true));
               subscript(lhTab, iTotalCount).unwrapSensitive().setSensitive(new logical(true));
               subscript(lhTab, iTotalCount).unwrapWidget().setTabStop(new logical(false /* Whilst using overlay button */));
               registerTriggerPersistentIn(new EventList("CURSOR-RIGHT", subscript(lhTab, iTotalCount)), "PBtnEventCursorRight", thisProcedure());
               registerTriggerPersistentIn(new EventList("CURSOR-LEFT", subscript(lhTab, iTotalCount)), "PBtnEventCursorLeft", thisProcedure());
               registerTriggerPersistentIn(new EventList("RETURN", subscript(lhTab, iTotalCount)), "PBtnEventMouseSelectDown", thisProcedure());
               registerTriggerPersistentIn(new EventList("MOUSE-SELECT-DOWN", subscript(lhTab, iTotalCount)), "PBtnEventMouseSelectDown", thisProcedure());
               iTabFramePositionPixels.assign(minus(plus(iTabFramePositionPixels, subscript(lhTab, iTotalCount).unwrapSizeable().getWidthPixels()), 1));
            }
         }
         
         liNumTabs.assign(iTotalCount);
         
         /* LhOverlayButton:MOVE-TO-TOP(). */
         /* Nice to have - create tab-bottom frame - which covers top of frame-A - looks like tab! */
         if (_not(lhTabBottomFrame.isValid()))
         {
            if ((subscript(lhTab, 1).isValid()).booleanValue())
            {
               DynamicWidgetFactory.createFrame(lhTabBottomFrame);
               lhTabBottomFrame.unwrapWidget().setFrameHandle(folderFrmFrame.asWidgetHandle());
               lhTabBottomFrame.unwrapSizeable().setWidthPixels(new integer(minus(subscript(lhTab, 1).unwrapSizeable().getWidthPixels(), 3)));
               lhTabBottomFrame.unwrapSizeable().setHeightPixels(new integer(20));
               lhTabBottomFrame.unwrapWidget().setThreeD(new logical(true));
               /* BGCOLOR = FRAME FRAME-A:BGCOLOR */
               /* THREE-D = FRAME FRAME-A:THREE-D */
               lhTabBottomFrame.unwrapWidget().setBgColor(lhBackgroundFrame.unwrapWidget().getBgColor());
               lhTabBottomFrame.unwrapBox().setBox(new logical(false));
               lhTabBottomFrame.unwrapWidget().setVisible(new logical(true));
               lhTabBottomFrame.unwrapWidget().setScrollable(new logical(false));
               lhTabBottomFrame.unwrapXY().setX(new integer(3));
               lhTabBottomFrame.unwrapXY().setY(new integer(plus(multiply(minus(22, 4), liNumTabFrames), 1)));
            }
         }
         else
         {
            lhTabBottomFrame.unwrapXY().setY(new integer(plus(multiply(minus(22, 4), liNumTabFrames), 1)));
         }
         
         if ((lhTabBottomFrame.isValid()).booleanValue())
         {
            lhTabBottomFrame.unwrapWidget().moveToTop();
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Moves the specified tab frame to the "front" - which is the bottom<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pmoveSelectedTabFrameToBottomRow(final handle _ihTabFrame)
   {
      handle ihTabFrame = TypeFactory.initInput(_ihTabFrame);
      integer iCount = TypeFactory.integer();
      integer iFrameIndex = TypeFactory.integer();
      integer iFrame = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* IF LiNumTabFrames > 1 _* Do nothing if only one tab frame *_ */
         if (_isNotEqual(ihTabFrame, lhBottomRowTabFrame))
         {
            loopLabel11:
            for (iCount.assign(1); _isLessThanOrEqual(iCount, liNumTabFrames); iCount.increment())
            {
               if (_isEqual(ihTabFrame, subscript(lhTabFrame, iCount)))
               {
                  iFrameIndex.assign(iCount);
               }
            }
            
            loopLabel12:
            for (iCount.assign(1); _isLessThanOrEqual(iCount, liNumTabFrames); iCount.increment())
            {
               /* Which frame? */
               iFrame.assign(plus(modulo(minus(plus(iCount, iFrameIndex), 2), liNumTabFrames), 1));
               /* Do an example to work it out! */
               /* LhTabFrame[iFrame]:Y = (20 * ((LiNumTabFrames - iCount) + 1)) - 19. _* Need to put the front screen at the bottom *_ */
               subscript(lhTabFrame, iFrame).unwrapXY().setY(new integer(minus(multiply(18, plus(minus(liNumTabFrames, iCount), 1)), 15)));
               /* Need to put the front screen at the bottom */
               subscript(lhTabFrame, iFrame).unwrapWidget().moveToBottom();
            }
            
            lhBottomRowTabFrame.assign(ihTabFrame);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void poverlayBtnEventCursorLeft()
   {
      internalProcedure(new Block((Body) () -> 
      {
         apply(subscript(lhTab, new integer(self().unwrap().getPrivateData())), "CURSOR-LEFT");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void poverlayBtnEventCursorRight()
   {
      internalProcedure(new Block((Body) () -> 
      {
         apply(subscript(lhTab, new integer(self().unwrap().getPrivateData())), "CURSOR-RIGHT");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void psetTabSensitivity(final integer _iiPageNumber, final logical _iiSensitive)
   {
      integer iiPageNumber = TypeFactory.initInput(_iiPageNumber);
      logical iiSensitive = TypeFactory.initInput(_iiSensitive);
      
      internalProcedure(new Block((Body) () -> 
      {
         /* main body */
         if ((subscript(lhTab, iiPageNumber).isValid()).booleanValue())
         {
            subscript(lhTab, iiPageNumber).unwrapSensitive().setSensitive(iiSensitive);
            subscript(lhTab, iiPageNumber).unwrap().setPrivateData(trim(valueOf(iiSensitive, "ENABLED/DISABLED")));
         }
         
         if (_isEqual(liCurrentTab, iiPageNumber))
         {
            lhOverlayButton.unwrapSensitive().setSensitive(iiSensitive);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Only changes the tab visualisation<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void pupdateTabVisualisation(final integer _iiTab)
   {
      integer iiTab = TypeFactory.initInput(_iiTab);
      integer iClassicAdjustment = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* !!! Switch off this feature for now - looks better without it !!!
             _* Disable this one *_
             LhTab[IiTab]:SENSITIVE = FALSE.
             */
         /* Windows is slow to respond, and displays scroll bars on the tab frame unless you hide it first - a "feature" of Progress on Windows
             even though the frame is not scrollable.  Tried lots of things - including setting to careful paint, but none seemed to work, so resorted to hiding
             before moving - like with the tab bottom frame.
             This then requires a background frame MOVE-TO-TOP() statement later */
         if (_isNotEqual(iiTab, liCurrentTab))
         {
            lhOverlayButtonFrame.unwrapWidget().setHidden(new logical(true));
         }
         
         /* Reorder the tab frames (if necessary) */
         ControlFlowOps.invokeInWithMode("PMoveSelectedTabFrameToBottomRow", thisProcedure(), "I", subscript(lhTab, iiTab).unwrapWidget().getFrameHandle());
         lhOverlayButton.unwrapSizeable().setHeightPixels(subscript(lhTab, iiTab).unwrapSizeable().getHeightPixels());
         lhOverlayButtonFrame.unwrapSizeable().setHeightPixels(subscript(lhTab, iiTab).unwrapSizeable().getHeightPixels());
         
         if (_isGreaterThan(lhOverlayButton.unwrapSizeable().getWidthPixels(), plus(subscript(lhTab, iiTab).unwrapSizeable().getWidthPixels(), 4)))
         {
            lhOverlayButton.unwrapSizeable().setWidthPixels(new integer(plus(subscript(lhTab, iiTab).unwrapSizeable().getWidthPixels(), 4)));
            lhOverlayButtonFrame.unwrapSizeable().setWidthPixels(lhOverlayButton.unwrapSizeable().getWidthPixels());
         }
         
         lhOverlayButtonFrame.unwrapXY().setX(subscript(lhTab, iiTab).unwrapXY().getX());
         lhOverlayButtonFrame.unwrapXY().setY(new integer(minus(multiply(18, liNumTabFrames), 17)));
          /* Need to put the front screen at the bottom */lhOverlayButton.unwrapCommonField().setLabel(concat(subscript(lhTab, iiTab).unwrapCommonField().getLabel(), " "));
         lhOverlayButton.unwrapSensitive().setSensitive(subscript(lhTab, iiTab).unwrapSensitive().isSensitive());
         lhOverlayButton.unwrap().setPrivateData(valueOf(iiTab));
         
         if (_isLessThan(lhOverlayButton.unwrapSizeable().getWidthPixels(), plus(subscript(lhTab, iiTab).unwrapSizeable().getWidthPixels(), 4)))
         {
            lhOverlayButtonFrame.unwrapSizeable().setWidthPixels(new integer(plus(subscript(lhTab, iiTab).unwrapSizeable().getWidthPixels(), 4)));
            lhOverlayButton.unwrapSizeable().setWidthPixels(lhOverlayButtonFrame.unwrapSizeable().getWidthPixels());
         }
         
         if (_isNotEqual(iiTab, liCurrentTab))
         {
            lhOverlayButtonFrame.unwrapWidget().setVisible(new logical(true));
         }
         
         /* Re-show if necessary */
         /* When necessary, grey the "bottom" of current selected tab */
         if ((lhTabBottomFrame.isValid()).booleanValue())
         {
            if (_isEqual(LogicalTerminal.getWindowSystem(), "MS-WIN95"))
            {
               iClassicAdjustment.assign(1);
            }
            
            /* Only do anything if necessary - to prevent flashing */
            /* + iClassicAdjustment */
            if (_or(isNotEqual(lhTabBottomFrame.unwrapSizeable().getWidthPixels(), subscript(lhTab, iiTab).unwrapSizeable().getWidthPixels()), () /* + iClassicAdjustment */ -> isNotEqual(lhTabBottomFrame.unwrapXY().getX(), minus(plus(subscript(lhTab, iiTab).unwrapXY().getX(), 2), iClassicAdjustment))))
            {
               lhTabBottomFrame.unwrapWidget().setVisible(new logical(false));
               
               /* Hide, because occassionally you see the windows frame resizing bars */
               if (_isGreaterThan(lhTabBottomFrame.unwrapSizeable().getWidthPixels(), subscript(lhTab, iiTab).unwrapSizeable().getWidthPixels()) /* + iClassicAdjustment */  /* Getting smaller */)
               {
                  /* Shrink first, then move */
                  lhTabBottomFrame.unwrapSizeable().setWidthPixels(subscript(lhTab, iiTab).unwrapSizeable().getWidthPixels());
                  lhTabBottomFrame.unwrapXY().setX(new integer(minus(plus(subscript(lhTab, iiTab).unwrapXY().getX(), 2), iClassicAdjustment)));
               }
               else
               {
                  /* Move first, then enlarge */
                  lhTabBottomFrame.unwrapXY().setX(new integer(minus(plus(subscript(lhTab, iiTab).unwrapXY().getX(), 2), iClassicAdjustment)));
                  lhTabBottomFrame.unwrapSizeable().setWidthPixels(subscript(lhTab, iiTab).unwrapSizeable().getWidthPixels());
               }
               
               lhTabBottomFrame.unwrapWidget().setHidden(new logical(false));
            }
            lhBackgroundFrame.unwrapWidget().moveToTop();
            /* Hiding and viewing the overlay tab frame makes this necessary */
            lhTabBottomFrame.unwrapWidget().moveToTop();
         }
         liCurrentTab.assign(iiTab);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
         cType.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorDisable();
         returnNormal(cType);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    *    Purpose:  Clone the current adm property temp-table<br>
    * Parameters: <br>
    *      Notes:  This is used to clone the dynamic property record for static <br>
    *              objects that does not call deleteProperties from destroyObject<br>
    *              in the target-procedure. This way the properties are kept alive <br>
    *              until destroyObject is completed without creating a memory leak,<br>
    *              since this TT is created in the object's widget-pool.
    */
   public void admCloneProps()
   {
      handle hReposBuffer = TypeFactory.handle();
      handle hPropTable = TypeFactory.handle();
      handle hBuffer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hReposBuffer.assign(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))));
         
         if (_and(hReposBuffer.isValid(), () -> isNotEqual(hReposBuffer.unwrap().name(), "ADMProps")))
         {
            ErrorManager.silentErrorEnable();
            hReposBuffer.unwrapBuffer().findFirst(concat("WHERE Target = WIDGET-H(\"", valueOf(thisProcedure()), "\")"));
            ErrorManager.silentErrorDisable();
            
            if ((hReposBuffer.unwrapBuffer().available()).booleanValue())
            {
               TempTableBuilder.create(hPropTable);
               hPropTable.unwrapTempTable().createTableLike(hReposBuffer);
               hPropTable.unwrapTempTable().tempTablePrepare("ADMProps");
               hBuffer.assign(hPropTable.unwrapTempTable().defaultBufferHandle());
               hBuffer.unwrapBuffer().bufferCreate();
               hBuffer.unwrapBuffer().bufferCopy(hReposBuffer);
               /* delete the dynamic's property record */
               /* {fn <func-name> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionIn(logical.class, "deleteProperties", targetProcedure());
               /* ... and save it. This ADM object is now open for business! */
               thisProcedure().unwrapADMData().setADMData(concat(valueOf(hBuffer), chr(1), chr(1)));
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Procedure to start a super proc if it's not already running, <br>
    *              and to add it as a super proc in any case.<br>
    * Parameters:  Procedure name to make super.<br>
    * Notes:       NOTE: This presumes that we want only one copy of an ADM<br>
    *              super procedure running per session, meaning that they are <br>
    *              stateless and "multi-threaded". This is intended to be the case<br>
    *              for ours, but may not be true for all super procs.<br>
    *           -  The LAST-SUPER-PROCEDURE-PROP preprocessor allows classes<br>
    *              to specify a property of char or handle that stores<br>
    *              super-procedures that need to be kept at the bottom of the list <br>
    *              (defined by data.i and sbo.i if they are extended by other classes)
    */
   public void startSuperProc(final character _pcProcName)
   {
      character pcProcName = TypeFactory.initInput(_pcProcName);
      handle hProc = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hProc.assign(ProcedureManager.firstProcedure());
         
         loopLabel13:
         while (_and(hProc.isValid(), () -> isNotEqual(hProc.unwrapFile().getFileName(), pcProcName)))
         {
            hProc.assign(hProc.unwrap().getNextSibling());
         }
         
         if (_not(hProc.isValid()))
         {
            ControlFlowOps.invokePersistentSet((pcProcName).toStringMessage(), hProc);
         }
         
         thisProcedure().unwrapCommonProcedure().addSuperProcedure(hProc, ProcedureManager.SEARCH_TARGET);
         returnNormal();
      }));
   }

   /**
    * *********************  Internal Procedures **********************
    */
   public void admCreateObjects()
   {
      internalProcedure(new Block());
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void changeFolderPage()
   {
      integer pageNumber = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         if ((lhContainer.isValid()).booleanValue())
         {
            /* {get Prop var [handle]} */
            pageNumber.assign(ControlFlowOps.invokeDynamicFunctionIn(integer.class, "getCurrentPage", lhContainer));
         }
         else
         {
            pageNumber.assign(1);
         }
         
         /* For design mode. */
         if (_and(and(isGreaterThan(pageNumber, 0), () -> isLessThanOrEqual(pageNumber, 20)), () -> subscript(lhTab, pageNumber).isValid()))
         {
            ControlFlowOps.invokeWithMode("PUpdateTabVisualisation", "I", pageNumber);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Defines an image for a single tab and sets its label.<br>
    * Parameters:  INPUT page number, label<br>
    * Notes:       Doesn't do anything, don't think is used in ADM2.
    */
   public void createFolderLabel(final integer _pPageNumber, final character _pPageLabel)
   {
      integer pPageNumber = TypeFactory.initInput(_pPageNumber);
      character pPageLabel = TypeFactory.initInput(_pPageLabel);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Create a new tab label after initialization.<br>
    * Parameters:  INPUT new page number, new tab label<br>
    * Notes:       Doesn't do anything, don't think is used in ADM2
    */
   public void createFolderPage(final integer _pPageNumber, final character _pNewLabel)
   {
      integer pPageNumber = TypeFactory.initInput(_pPageNumber);
      character pNewLabel = TypeFactory.initInput(_pNewLabel);
      
      internalProcedure(new Block());
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Remove the tab for a page<br>
    * Parameters:  INPUT page number to delete<br>
    * Notes:
    */
   public void deleteFolderPage(final integer _pPageNumber)
   {
      integer pPageNumber = TypeFactory.initInput(_pPageNumber);
      integer i_3 = TypeFactory.integer();
      integer pos1 = TypeFactory.integer((long) 0);
      integer pos2 = TypeFactory.integer();
      character labels = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FolderLabels"));
         labels.assign(ghProp.unwrapBufferField().value());
         
         loopLabel14:
         for (i_3.assign(1); _isLessThanOrEqual(i_3, minus(pPageNumber, 1)); i_3.increment())
         {
            pos1.assign(indexOf(labels, "|", plus(pos1, 1)));
         }
         
         pos2.assign(indexOf(labels, "|", plus(pos1, 1)));
         labels.assign(_isNotEqual(pos2, 0) ? concat(substring(labels, 1, pos1, "CHARACTER"), substring(labels, pos2, -1, "CHARACTER")) : substring(labels, 1, minus(pos1, 1), "CHARACTER"));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FolderLabels"));
         ghProp.unwrapBufferField().changeValue(labels);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Disable and gray out the tab for a page<br>
    * Parameters:  INPUT page number to disable<br>
    * Notes:
    */
   public void disableFolderPage(final integer _pPageNumber)
   {
      integer pPageNumber = TypeFactory.initInput(_pPageNumber);
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("PSetTabSensitivity", thisProcedure(), "II", pPageNumber, new logical(false));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void disableUi()
   {
      internalProcedure(new Block((Body) () -> 
      {
         if ((thisProcedure().unwrapProcedure().isPersistent()).booleanValue())
         {
            HandleOps.delete(thisProcedure());
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Enable the tab for a page<br>
    * Parameters:  INPUT page number to enable<br>
    * Notes:
    */
   public void enableFolderPage(final integer _pPageNumber)
   {
      integer pPageNumber = TypeFactory.initInput(_pPageNumber);
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("PSetTabSensitivity", thisProcedure(), "II", pPageNumber, new logical(true));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Creates the dynamic images for a tab or notebook<br>
    *              folder.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Run automatically as part of folder startup.
    */
   public void initializeFolder()
   {
      character folderLabels = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FolderLabels"));
         folderLabels.assign(ghProp.unwrapBufferField().value());
         /*
             {get FolderTabType tab-type}.
             number-of-pages =   NUM-ENTRIES(folder-labels,'|':U).
             
             _* RUN resizeObject (FRAME {&FRAME-NAME}:HEIGHT, FRAME {&FRAME-NAME}:WIDTH). *_
             _* set side of folder on which tabs go, tabs per page and multi-row flag *_
             DEFINE VARIABLE iTabPosition AS INT NO-UNDO.
             CASE    l-foldertabside:
                     WHEN    1   THEN    ASSIGN  iTabPosition = 0.    _* top *_
                     WHEN    2   THEN    ASSIGN  iTabPosition = 3.    _* right *_
                     WHEN    3   THEN    ASSIGN  iTabPosition = 2.    _* bottom *_
                     WHEN    4   THEN    ASSIGN  iTabPosition = 1.    _* left *_
             END     CASE.
             */
         ControlFlowOps.invokeWithMode("PCreateTabs", "I", folderLabels);
         ControlFlowOps.invoke("PAdjustBackgroundFrame");
         ControlFlowOps.invoke("changeFolderPage");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Local version of the initialize method which starts up<br>
    *              the folder object. This runs initializeFolder with<br>
    *              the folder attributes.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       The folder initialization is suppressed in character mode.
    */
   public void initializeObject()
   {
      character cInstanceProperties = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.runSuper("initializeObject");
         ErrorManager.silentErrorEnable();
         /* Get the folder's CONTAINER for triggers.
                Note that in design mode the CONTAINER may not be specified;
                the code takes this into account. Also the broker will not
                be available in design mode. */
         lhContainer.assign(handle.fromString(ControlFlowOps.invokeDynamicFunctionWithMode(character.class, "linkHandles", "I", "Container-Source")));
         ErrorManager.silentErrorDisable();
         ControlFlowOps.invoke("initializeFolder");
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceProperties"));
         cInstanceProperties.assign(ghProp.unwrapBufferField().value());
         cInstanceProperties.assign(concat(cInstanceProperties, ",FolderTabSide,FolderTabsPerPage,FolderMultiRow"));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceProperties"));
         ghProp.unwrapBufferField().changeValue(cInstanceProperties);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Move frame to bottom to sort out Z Order problem with the<br>
    *              tab folder object, which seems to put itself on top of the<br>
    *              Z order when the parent frame is hidden then viewed again.<br>
    *              <br>
    *              Run from container (actually from container super procedure).
    */
   public void peventmoveToBottom()
   {
      internalProcedure(new Block((Body) () -> 
      {
         folderFrmFrame.asWidget().moveToBottom();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Sets the size of the rectangles which make up the folder<br>
    *              "image" whenever it is resized.<br>
    * Parameters:  INPUT height and width.<br>
    * Notes:       Run automatically when the folder is initialized or resized.
    */
   public void resizeObject(final decimal _pHeight, final decimal _pWidth)
   {
      decimal pHeight = TypeFactory.initInput(_pHeight);
      decimal pWidth = TypeFactory.initInput(_pWidth);
      
      internalProcedure(new Block((Body) () -> 
      {
         folderFrmFrame.asWidget().setScrollable(new logical(true));
         folderFrmFrame.asWidget().setVirtHeightPixels(new integer(1500));
         folderFrmFrame.asWidget().setVirtWidthPixels(new integer(1500));
         folderFrmFrame.setHeightChars(pHeight);
         folderFrmFrame.setWidthChars(pWidth);
         
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getObjectInitialized", targetProcedure()))).booleanValue())
         {
            ControlFlowOps.invoke("initializeFolder");
         }
         
         folderFrmFrame.asWidget().setVirtHeightPixels(folderFrmFrame.getHeightPixels());
         folderFrmFrame.asWidget().setVirtWidthPixels(folderFrmFrame.getWidthPixels());
         folderFrmFrame.asWidget().setScrollable(new logical(false));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Shows the tab for "current" folder page<br>
    * Parameters:  page# - (INTEGER) The current page.<br>
    * Notes:
    */
   public void showCurrentPage(final integer _pageNumber)
   {
      integer pageNumber = TypeFactory.initInput(_pageNumber);
      
      internalProcedure(new Block((Body) () -> 
      {
         if ((subscript(lhTab, pageNumber).isValid()).booleanValue())
         {
            apply(subscript(lhTab, pageNumber), "MOUSE-SELECT-DOWN");
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public integer getAiNumberOfPages()
   {
      return function("getAiNumberOfPages", integer.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  This attribute is the number of pages in the folder
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(numberOfPages);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getClickActive()
   {
      return function("getClickActive", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(valueOf(llClickActive, "yes/no"));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getFolderLabels()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the folder labels property.
          Notes:  
      ------------------------------------------------------------------------------*/
      character cLabels = TypeFactory.character();
      
      return function("getFolderLabels", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FolderLabels"));
         cLabels.assign(ghProp.unwrapBufferField().value());
         returnNormal(cLabels);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getFolderMultiRow()
   {
      return function("GetFolderMultiRow", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         /*     RUN initPages("1"). */
         returnNormal(valueOf(lFoldermultirow, "Yes/No"));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getFolderTabSide()
   {
      return function("GetFolderTabSide", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(valueOf(lFoldertabside));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getFolderTabsPerPage()
   {
      return function("GetFolderTabsPerPage", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(valueOf(lFoldertabsperpage));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public integer getFolderTabType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the folder tab type, 1 or 2
          Notes:  
      ------------------------------------------------------------------------------*/
      integer iType = TypeFactory.integer();
      
      return function("getFolderTabType", integer.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FolderTabType"));
         iType.assign(ghProp.unwrapBufferField().value());
         returnNormal(iType);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPageTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the handle of the folder's "PageTarget", normally its container.
          Notes:  
      ------------------------------------------------------------------------------*/
      character cTarget = TypeFactory.character();
      
      return function("getPageTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTarget);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPageTargetEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a list of the events the folder expects to receive from
                  its PageTarget (normally its container).
          Notes:  
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getPageTargetEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageTargetEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setAlLockRefresh(final logical _il_1)
   {
      logical il_1 = TypeFactory.initInput(_il_1);
      
      return function("setAlLockRefresh", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Lock refreshing of folder while we add labels
             Notes:  
         ------------------------------------------------------------------------------*/
         alLockRefresh.assign(il_1);
         
         /* If unlocking then refresh the folder display as we've probably added tabs */
         if (_isEqual(il_1, false))
         {
            ControlFlowOps.invoke("initializeFolder");
         }
         
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setFolderLabels(final character _pcLabels_1)
   {
      character pcLabels_1 = TypeFactory.initInput(_pcLabels_1);
      
      return function("setFolderLabels", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Sets folder labels.
             Notes:  Basic folder property.
         ------------------------------------------------------------------------------*/
         /* Ensure [Case] is replaced in the folder labels string. This is so
              we can parameterise the word used for Case=Call=Task=Issue etc
           */
         pcLabels_1.assign(replaceAll(pcLabels_1, "[Case]", gcCase));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FolderLabels"));
         ghProp.unwrapBufferField().changeValue(pcLabels_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setFolderMultiRow(final character _i_3)
   {
      character i_3 = TypeFactory.initInput(_i_3);
      
      return function("SetFolderMultiRow", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         lFoldermultirow.assign(or(isEqual(i_3, "YES"), () -> isEqual(i_3, "TRUE")));
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setFolderTabSide(final character _i_3)
   {
      character i_3 = TypeFactory.initInput(_i_3);
      
      return function("SetFolderTabSide", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         lFoldertabside.assign(new integer(i_3));
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character setFolderTabsPerPage(final character _i_3)
   {
      character i_3 = TypeFactory.initInput(_i_3);
      
      return function("SetFolderTabsPerPage", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         lFoldertabsperpage.assign(new integer(i_3));
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setFolderTabType(final integer _piTabType_1)
   {
      integer piTabType_1 = TypeFactory.initInput(_piTabType_1);
      
      return function("setFolderTabType", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Sets the folder tab type to 1 or 2
             Notes:  
         ------------------------------------------------------------------------------*/
         if (_and(isNotEqual(piTabType_1, 1), () -> isNotEqual(piTabType_1, 2)))
         {
            returnNormal(false);
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FolderTabType"));
            ghProp.unwrapBufferField().changeValue(piTabType_1);
            returnNormal(true);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPageTarget(final character _pcTarget_1)
   {
      character pcTarget_1 = TypeFactory.initInput(_pcTarget_1);
      
      return function("setPageTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageTarget"));
         ghProp.unwrapBufferField().changeValue(pcTarget_1);
         returnNormal(true);
      }));
   }

   private class ExtentExpr0
   extends OutputExtentParameter<character>
   {
      public character[] getVariable()
      {
         return cTabFrameLabels;
      }

      public void setVariable(final character[] newRef)
      {
         cTabFrameLabels = newRef;
      }
   }

   private class ExtentExpr1
   extends OutputExtentParameter<integer>
   {
      public integer[] getVariable()
      {
         return iTabFramePadding;
      }

      public void setVariable(final integer[] newRef)
      {
         iTabFramePadding = newRef;
      }
   }
}
