/*
Description: Smart Container Super Procedure
    Sits before containr.p in the super-procedure stack for each container
    Copy of CMS cocontsup0.p
    
Arguments:
        
Comments:

************************************************************************/

package com.goldencode.hotel.common;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/ascnsup0.p).
 */
public class Ascnsup0
{
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*
   Description: Defines debug global variables for adbgmsg0.i
   ************************************************************************/   
   character goisDebug = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "goisdebug", true, new character(""));

   handle ghDebugWindowProc = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "ghdebugwindowproc", true, new handle());

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/ascnsup0.p).
    */
   public void execute()
   {
      externalProcedure(Ascnsup0.this, new Block());
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     Copy of the version from smart.p<br>
    *              This version applies entry to the container handle if no enabled<br>
    *              widgets have been found<br>
    *              <br>
    *              <br>
    *              Applies "ENTRY" to the first enabled and visible object <br>
    *              in the default frame (unless pcField is specified), <br>
    *              or in the first child which is a Frame.<br>
    * Parameters:  pcField AS CHARACTER  optional fieldname; if specified,<br>
    *              the frame field of that name will be positioned to.
    */
   public void applyEntry(final character _pcField)
   {
      character pcField = TypeFactory.initInput(_pcField);
      handle hContainer = TypeFactory.handle();
      handle hWidget = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_isUnknown(pcField))
         {
            pcField.assign("");
         }
         
         /* {get Prop var [handle]} */ 
         hContainer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getContainerHandle", targetProcedure()));
         
         if ((hContainer.isValid()).booleanValue())
         {
            loopLabel0:
            while (_isEqual(hContainer.unwrapType().getResourceType(), "WINDOW"))
            {
               hContainer.assign(hContainer.unwrapTree().firstChild());
            }
            
            hWidget.assign(hContainer.unwrapIterableResource().currentIteration());
            hWidget.assign(hWidget.unwrapWidget().getFirstTabItem());
            
            loopLabel1:
            while ((hWidget.isValid()).booleanValue())
            {
               if (_and(and(hWidget.unwrapSensitive().isSensitive(), () -> hWidget.unwrapWidget().isVisible()), () -> or(isEqual(pcField, ""), () -> isEqual(hWidget.unwrap().name(), pcField))))
               {
                  loopLabel2:
                  while (_and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "WINDOW")))
                  {
                     hContainer.assign(hContainer.unwrapWidget().getParentHandle());
                  }
                  
                  if (_isEqual(hContainer.unwrapType().getResourceType(), "WINDOW"))
                  {
                     setCurrentWindow(hContainer);
                     /* OIS - Added this to make smart.p version work! */
                     apply(currentWindow(), "ENTRY");
                  }
                  
                  apply(hWidget, "ENTRY");
                  returnNormal();
               }
               else
               {
                  hWidget.assign(hWidget.unwrapWidget().getNextTabItem());
               }
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:   if the container is a window then set it to be the current window
    */
   public void pchildClosingPre()
   {
      handle vhContainerHandle = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         vhContainerHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getContainerHandle", targetProcedure()));
         
         if (_isEqual(vhContainerHandle.unwrapType().getResourceType(), "WINDOW"))
         {
            setCurrentWindow(vhContainerHandle);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     For this container, look for all folders and do a MOVE-TO-BOTTOM<br>
    *              on the frame handle of each folder.<br>
    *              This publish works because the folder has PEVENTMoveToBottom<br>
    *              included as a pageTargetEvent, so the folder will subscribe to<br>
    *              PEVENTMoveToBottom in its page target (its container).<br>
    *              Also does same for splitter(s) inside the container.
    */
   public void pfixFolderZorder()
   {
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("PEVENTMoveToBottom", targetProcedure());
         /* Splitter must be on the bottom, even below folders */
         NamedEventManager.publish("PEVENTMoveToBottomSplitter", targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Find all SDOs on page and if they are data target of an SDO off<br>
    *              the page, reopen the query<br>
    *              <br>
    *             * NOT CURRENTLY USED*<br>
    *              <br>
    *              This was originally designed to fix the problem I found in 9.1A<br>
    *              where, when NOT using AppServer, the 'hidden SDO doesnt open the<br>
    *              query' problem arose. More specifically, the query was opening<br>
    *              but the browse was missing out it's top record!<br>
    *              <br>
    *              This routine was designed to run from selectPage, but it cause new<br>
    *              problems itself so I tried to find a alternate fix.<br>
    *              <br>
    *              I finally fixed the problem by opening the query even when hidden,<br>
    *              and I had to put a fix into dataAvailable in the browse to ensure<br>
    *              all the records were being shown when the query opens and the<br>
    *              browse is hidden.
    */
   public void popenSdoqueriesOnPage(final integer _piPageNum)
   {
      integer piPageNum = TypeFactory.initInput(_piPageNum);
      /* Find all SmartObjects on this page */
      character cPageN = TypeFactory.character();
      integer iObj = TypeFactory.integer();
      character cTargets = TypeFactory.character("");
      character cEntry = TypeFactory.character();
      /* Got all SO's on page - now work through and check each one */
      handle vhCurObj = TypeFactory.handle();
      integer viCount = TypeFactory.integer();
      /* Check if its data-target of another SDO */
      handle vhCurObjDataSource = TypeFactory.handle();
      /* Check that SDO query is already open - if so it needs a refresh */
      logical vlQueryOpen = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cPageN.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getPageNTarget", targetProcedure()));
         
         loopLabel3:
         for (iObj.assign(1); _isLessThanOrEqual(iObj, numEntries(cPageN)); iObj.increment())
         {
            cEntry.assign(entry(iObj, cPageN));
            
            if (_isEqual(new integer(entry(2, cEntry, "|")), piPageNum))
            {
               cTargets.assign(concat(cTargets, (_isEqual(cTargets, "") ? new character("") : new character(",")), entry(1, cEntry, "|")));
            }
         }
         
         if (_isGreaterThan(cTargets, ""))
         {
            IntegerExpression resExpr0 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cTargets);
               }
            };
            ToClause toClause0 = new ToClause(viCount, 1, resExpr0);
            
            doTo("loopLabel4", toClause0, new Block((Body) () -> 
            {
               vhCurObj.assign(handle.fromString(entry(viCount, cTargets)));
               
               blockLabel0:
               {
                  /* Debug Include {adbgmsg0.i} */
                  if (_isEqual(goisDebug, "YES"))
                  {
                     if (_and(ghDebugWindowProc.isValid(), () -> isGreaterThan(lookup("PReceiveDebugMessage", ghDebugWindowProc.unwrapProcedure().internalEntries()), 0)))
                     {
                        ControlFlowOps.invokeInWithMode("PReceiveDebugMessage", ghDebugWindowProc, "I", concat(EnvironmentOps.getSourceName(1), chr(1), "POpenSDOQueriesOnPage IS checking OBJECT:", chr(1), "TARGET-PROCEDURE:FILE-NAME = ", (_notUnknown(targetProcedure().unwrapFile().getFileName()) ? valueOf(targetProcedure().unwrapFile().getFileName()) : new character("?")), chr(1), "VhCurObj:FILE-NAME = ", (_notUnknown(vhCurObj.unwrapFile().getFileName()) ? valueOf(vhCurObj.unwrapFile().getFileName()) : new character("?")), chr(1)));
                     }
                     else
                     {
                        messageBox(new Object[]
                        {
                           EnvironmentOps.getSourceName(new integer(1)),
                           new SkipEntity(1),
                           "POpenSDOQueriesOnPage IS checking OBJECT:",
                           new SkipEntity(true),
                           "TARGET-PROCEDURE:FILE-NAME",
                           targetProcedure().unwrapFile().getFileName(),
                           new SkipEntity(true),
                           "VhCurObj:FILE-NAME",
                           vhCurObj.unwrapFile().getFileName(),
                           new SkipEntity(true)
                        }, ALERT_INFO, BTN_OK, (String) null);
                     }
                  }
               }
               
               /* {get Prop var [handle]} */
               vhCurObjDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getdataSource", vhCurObj));
               
               if (_not(vhCurObjDataSource.isValid()))
               {
                  next("loopLabel4");
               }
               
               /* Is the data source of this SDO on the same page as it?
                      If it's in the list of objects on the current page then both are on the
                      same page so don't need to worry about it */
               if (_isGreaterThan(lookup(valueOf(vhCurObjDataSource), cTargets), 0))
               {
                  next("loopLabel4");
               }
               
               blockLabel1:
               {
                  /* Debug Include {adbgmsg0.i} */
                  if (_isEqual(goisDebug, "YES"))
                  {
                     if (_and(ghDebugWindowProc.isValid(), () -> isGreaterThan(lookup("PReceiveDebugMessage", ghDebugWindowProc.unwrapProcedure().internalEntries()), 0)))
                     {
                        ControlFlowOps.invokeInWithMode("PReceiveDebugMessage", ghDebugWindowProc, "I", concat(EnvironmentOps.getSourceName(1), chr(1), "OBJECT IS ON different PAGE FROM data SOURCE:", chr(1), "TARGET-PROCEDURE:FILE-NAME = ", (_notUnknown(targetProcedure().unwrapFile().getFileName()) ? valueOf(targetProcedure().unwrapFile().getFileName()) : new character("?")), chr(1), "VhCurObj:FILE-NAME = ", (_notUnknown(vhCurObj.unwrapFile().getFileName()) ? valueOf(vhCurObj.unwrapFile().getFileName()) : new character("?")), chr(1), "VhCurObjDataSource:FILE-NAME = ", (_notUnknown(vhCurObjDataSource.unwrapFile().getFileName()) ? valueOf(vhCurObjDataSource.unwrapFile().getFileName()) : new character("?")), chr(1)));
                     }
                     else
                     {
                        messageBox(new Object[]
                        {
                           EnvironmentOps.getSourceName(new integer(1)),
                           new SkipEntity(1),
                           "OBJECT IS ON different PAGE FROM data SOURCE:",
                           new SkipEntity(true),
                           "TARGET-PROCEDURE:FILE-NAME",
                           targetProcedure().unwrapFile().getFileName(),
                           new SkipEntity(true),
                           "VhCurObj:FILE-NAME",
                           vhCurObj.unwrapFile().getFileName(),
                           new SkipEntity(true),
                           "VhCurObjDataSource:FILE-NAME",
                           vhCurObjDataSource.unwrapFile().getFileName(),
                           new SkipEntity(true)
                        }, ALERT_INFO, BTN_OK, (String) null);
                     }
                  }
               }
               
               /* OK we do need to reopen the query? 
                      Check if it's an SDO here? I've left this for now as other SO's may be
                      data-targets and may need query refreshing
                   */
               if (_isEqual( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectType", vhCurObj), "SmartDataObject"))
               {
                  /* {get Prop var [handle]} */
                  vlQueryOpen.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", vhCurObj));
                  
                  if (_not(vlQueryOpen))
                  {
                     blockLabel2:
                     {
                        /* Debug Include {adbgmsg0.i} */
                        if (_isEqual(goisDebug, "YES"))
                        {
                           if (_and(ghDebugWindowProc.isValid(), () -> isGreaterThan(lookup("PReceiveDebugMessage", ghDebugWindowProc.unwrapProcedure().internalEntries()), 0)))
                           {
                              ControlFlowOps.invokeInWithMode("PReceiveDebugMessage", ghDebugWindowProc, "I", concat(EnvironmentOps.getSourceName(1), chr(1), "rejecting AS QUERY NOT OPEN", chr(1)));
                           }
                           else
                           {
                              messageBox(new Object[]
                              {
                                 EnvironmentOps.getSourceName(new integer(1)),
                                 new SkipEntity(1),
                                 "rejecting AS QUERY NOT OPEN",
                                 new SkipEntity(true)
                              }, ALERT_INFO, BTN_OK, (String) null);
                           }
                        }
                     }
                     
                     next("loopLabel4");
                  }
                  
                  blockLabel3:
                  {
                     /* Debug Include {adbgmsg0.i} */
                     if (_isEqual(goisDebug, "YES"))
                     {
                        if (_and(ghDebugWindowProc.isValid(), () -> isGreaterThan(lookup("PReceiveDebugMessage", ghDebugWindowProc.unwrapProcedure().internalEntries()), 0)))
                        {
                           ControlFlowOps.invokeInWithMode("PReceiveDebugMessage", ghDebugWindowProc, "I", concat(EnvironmentOps.getSourceName(1), chr(1), "POpenSDOQueriesOnPage IS opening QUERY FOR OBJECT:", chr(1), "TARGET-PROCEDURE:FILE-NAME = ", (_notUnknown(targetProcedure().unwrapFile().getFileName()) ? valueOf(targetProcedure().unwrapFile().getFileName()) : new character("?")), chr(1), "VhCurObj:FILE-NAME = ", (_notUnknown(vhCurObj.unwrapFile().getFileName()) ? valueOf(vhCurObj.unwrapFile().getFileName()) : new character("?")), chr(1)));
                        }
                        else
                        {
                           messageBox(new Object[]
                           {
                              EnvironmentOps.getSourceName(new integer(1)),
                              new SkipEntity(1),
                              "POpenSDOQueriesOnPage IS opening QUERY FOR OBJECT:",
                              new SkipEntity(true),
                              "TARGET-PROCEDURE:FILE-NAME",
                              targetProcedure().unwrapFile().getFileName(),
                              new SkipEntity(true),
                              "VhCurObj:FILE-NAME",
                              vhCurObj.unwrapFile().getFileName(),
                              new SkipEntity(true)
                           }, ALERT_INFO, BTN_OK, (String) null);
                        }
                     }
                  }
                  
                  ControlFlowOps.invokeInWithMode("dataavailable", vhCurObj, "I", new character("DIFFERENT"));
                  ControlFlowOps.invokeIn("fetchFirst", vhCurObj);
               }
            }));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Check the window is on the screen, and if its not move it so its <br>
    *              hard up to the edge of the screen
    */
   public void pwindowCheckOnScreen()
   {
      handle vhContainerHandle = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         vhContainerHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getContainerHandle", targetProcedure()));
         
         if (_isNotEqual(vhContainerHandle.unwrapType().getResourceType(), "WINDOW"))
         {
            messageBox(new Object[]
            {
               "PWindowCheckOnScreen only works for Windows.",
               new SkipEntity(true),
               "This object is not a window:",
               targetProcedure().unwrapFile().getFileName()
            }, ALERT_ERROR, BTN_OK, (String) null);
            returnNormal();
         }
         
         /* Note: We could use the API to find the real total height of the window - this 25
                is just a decent guess */
         if (_isGreaterThan(plus(vhContainerHandle.unwrapXY().getX(), (vhContainerHandle.unwrapSizeable().getWidthPixels())), LogicalTerminal.getWorkAreaWidthPixels()))
         {
            vhContainerHandle.unwrapXY().setX(new integer(minus(LogicalTerminal.getWorkAreaWidthPixels(), (vhContainerHandle.unwrapSizeable().getWidthPixels()))));
         }
         
         if (_isGreaterThan(plus(vhContainerHandle.unwrapXY().getY(), plus(vhContainerHandle.unwrapSizeable().getHeightPixels(), 25)), LogicalTerminal.getWorkAreaHeightPixels()))
         {
            vhContainerHandle.unwrapXY().setY(new integer(minus(LogicalTerminal.getWorkAreaHeightPixels(), plus(vhContainerHandle.unwrapSizeable().getHeightPixels(), 25))));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Override to fix folder problem
    */
   public void viewObject()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.runSuper("viewObject");
         ControlFlowOps.invokeIn("PFixFolderZOrder", targetProcedure());
      }));
   }
}
