/*--------------------------------------------------------------------------
    File        : Dataextcols.java
    Purpose     : Support procedure for data class.  This is an extension
                  of data.p.  The extension is necessary to avoid an overflow
                  of the action segment. This extension file contains
                  all column related functions (assignColumn* and column*)
                  as well as the col*values* functions
                  These functions will be rolled back into data.p when segment 
                  size increases.
                  
    Syntax      : adm2/dataextcols.p

    Modified    : Jan 30, 2001 Version 9.1C
  ------------------------------------------------------------------------*/

package com.goldencode.hotel.common.adm2;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.util.*;
import com.goldencode.p2j.ui.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/adm2/dataextcols.p).
 */
public class Dataextcols
{
   /* tmp row num for add */   
   /* Include the file which defines AppServerConnect procedures. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /* adecomm/appserv.i checks to see if the persistent procedure adecomm/as-utils.w
                        has been started up, and if not, it starts it and then makes
                        is a SUPER procedure of the calling procedure.
                        
      Created: 11/26/97 by Ross Hunter
                                                                                    */   
   handle appSrvUtils = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "appsrvutils", true, new handle());

   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 4.57
            WIDTH              = 42.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* Preprocessors to define properties that can be retrieved
       directly from the property temp-table. */   
   /* if appserver aware add appserver properties */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : appsprop.i
       Purpose     : Defines basic properties.
       Syntax      : {src/adm2/appsprop.i}
   
       Description :
   
       Modified    : 01/24/2001
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Custom instance definition file */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : appserverdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/appserverdefscustom.i}
   
       Modified    : 01/24/2001
       
       Notes       : Referenced in {src/adm2/appsprop.i}
     ------------------------------------------------------------------------*/   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 7.86
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
      procedure's entry points. 
      And skip including the prototypes if we are *any* super procedure. */   
   /* These preprocessors tell at compile time which properties can
        be retrieved directly from the temp-table */   
   /* include properties from smart */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/adm2/dataextcols.p).
    */
   public void execute()
   {
      externalProcedure(Dataextcols.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         if (_not(appSrvUtils.isValid()))
         {
            ControlFlowOps.invokePersistentSet("adecomm/as-utils.w", appSrvUtils);
         }
         
         thisProcedure().unwrapCommonProcedure().addSuperProcedure(appSrvUtils);
         
         /* _UIB-CODE-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 14.86
                  WIDTH              = 57.2.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Include the file which defines prototypes for all of the super
              procedure's entry points. Also, start or attach to the super procedure.
              Skip start-super-proc if we *are* the super procedure. 
              And skip including the prototypes if we are *any* super procedure. */
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         cType.assign("SUPER");
         returnNormal(cType);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public logical assignColumnColumnLabel(final character _pcColumn_27, final character _pcLabel_2)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      character pcLabel_2 = TypeFactory.initInput(_pcLabel_2);
      /*------------------------------------------------------------------------------
        Purpose:     Sets the Progress Column Label text of a specified column.
      
        Parameters: 
          INPUT pcColumn - Unqualified column name of the RowObject field.
                         - Column name qualified with "RowObject".  
                         - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
          INPUT pcLabel  - The new Column Label text
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("assignColumnColumnLabel", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_notUnknown(hCol))
         {
            hCol.unwrapCommonField().setColumnLabel(pcLabel_2);
         }
         
         returnNormal(_isUnknown(hCol) ? new logical(false) : new logical(true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignColumnFormat(final character _pcColumn_27, final character _pcFormat_1)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      character pcFormat_1 = TypeFactory.initInput(_pcFormat_1);
      /*------------------------------------------------------------------------------
        Purpose:     Sets the Progress Format text of a specified column.
        Parameters:  
          INPUT pcColumn  - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
          INPUT pcFormat - The new format string
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("assignColumnFormat", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_notUnknown(hCol))
         {
            hCol.unwrapCommonField().setFormat(pcFormat_1);
         }
         
         returnNormal(_isUnknown(hCol) ? new logical(false) : new logical(true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignColumnHelp(final character _pcColumn_27, final character _pcHelp_1)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      character pcHelp_1 = TypeFactory.initInput(_pcHelp_1);
      /*------------------------------------------------------------------------------
        Purpose:     Sets the Progress Help text of a specified column.
      
        Parameters:  
          INPUT pcColumn  - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
          INPUT pcHelp   - The new help text
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("assignColumnHelp", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_notUnknown(hCol))
         {
            hCol.unwrapWidget().setHelp(pcHelp_1);
         }
         
         returnNormal(_isUnknown(hCol) ? new logical(false) : new logical(true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignColumnInitial(final character _pcColumn_27, final character _pcInitial_1)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      character pcInitial_1 = TypeFactory.initInput(_pcInitial_1);
      /*------------------------------------------------------------------------------
        Purpose:     Sets the Progress Format text of a specified column.
        Parameters:  
          INPUT pcColumn  - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
          INPUT pcInitial - The new initial value
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("assignColumnInitial", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_notUnknown(hCol))
         {
            hCol.unwrap().readOnlyError("INITIAL");
         }
         
         returnNormal(_isUnknown(hCol) ? new logical(false) : new logical(true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignColumnLabel(final character _pcColumn_27, final character _pcLabel_2)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      character pcLabel_2 = TypeFactory.initInput(_pcLabel_2);
      /*------------------------------------------------------------------------------
        Purpose:     Sets the Progress Label text of a specified column.
      
        Parameters:  
          INPUT pcColumn  - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
           INPUT pcLabel  - The new Label text
       -----------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("assignColumnLabel", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_notUnknown(hCol))
         {
            hCol.unwrapCommonField().setLabel(pcLabel_2);
         }
         
         returnNormal(_isUnknown(hCol) ? new logical(false) : new logical(true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignColumnPrivateData(final character _pcColumn_27, final character _pcData_1)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      character pcData_1 = TypeFactory.initInput(_pcData_1);
      /*------------------------------------------------------------------------------
        Purpose:     Sets the Progress Private-data attribute of a specified column.
      
        Parameters:  
          INPUT pcColumn  - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
          INPUT pcData   - The new Private-data string
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("assignColumnPrivateData", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_notUnknown(hCol))
         {
            hCol.unwrap().setPrivateData(pcData_1);
         }
         
         returnNormal(_isUnknown(hCol) ? new logical(false) : new logical(true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignColumnValExp(final character _pcColumn_27, final character _pcValExp_1)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      character pcValExp_1 = TypeFactory.initInput(_pcValExp_1);
      /*------------------------------------------------------------------------------
        Purpose:     Sets the Progress Validation Expression of a specified column.
        Parameters:  
          INPUT pcColumn  - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
        
          INPUT pcValExp - The new Validation Expression.
          
        Notes:       This will not actually change the column's validation which
                     gets irrevocably set at compile time.  However, it can be 
                     retrieved by an object and then used to generate validation 
                     code for the column.
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("assignColumnValExp", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_isUnknown(hCol))
         {
            returnNormal(false);
         }
         else
         {
            hCol.unwrapBufferField().changeValidateExpression(pcValExp_1);
            returnNormal(true);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignColumnValMsg(final character _pcColumn_27, final character _pcValMsg_1)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      character pcValMsg_1 = TypeFactory.initInput(_pcValMsg_1);
      /*------------------------------------------------------------------------------
        Purpose:     Sets the Progress Validation Message text of a specified column.
      
        Parameters:  
         INPUT pcColumn  - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
          INPUT pcValMsg - The new Validation Message text.
          
        Notes:       This will not actually change the column's message which
                     gets irrevocably set at compile time.  However, it can be 
                     retrieved by an object and then used to generate a
                     message on some sort of dynamic validation.
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("assignColumnValMsg", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_isUnknown(hCol))
         {
            returnNormal(false);
         }
         else
         {
            hCol.unwrapBufferField().changeValidateMessage(pcValMsg_1);
            returnNormal(true);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character colStringValues(final character _pcColumnList_2, final character _pcFormatOption_2, final character _pcDelimiter_2)
   {
      character pcColumnList_2 = TypeFactory.initInput(_pcColumnList_2);
      character pcFormatOption_2 = TypeFactory.initInput(_pcFormatOption_2);
      character pcDelimiter_2 = TypeFactory.initInput(_pcDelimiter_2);
      
      return function("colStringValues", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:     Returns a delimited list of values for the requested
                        columns of the current row of the RowObject.
           Parameters:
             INPUT pcColumnList   - Comma delimited list of RowObject column names
             INPUT pcFormatOption - Format of returned values
                                   - Blank or ? 
                                     No formatting, just buffer values 
                                   - 'Formatted' 
                                     Formatted according to the columnFormat with right 
                                     justified numeric values.
                                   - 'TrimNumeric' 
                                     Formatted according to the columnFormat with LEFT 
                                     justified numeric values.
                                      
             INPUT pcDelimiter  - optional delimiter (default CHR(1)).   
           Notes:       This function is different from colValues in that it does NOT 
                        return rowidents as the first entry and does not look in the 
                        dataSource.
         ------------------------------------------------------------------------------*/
         returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colStringValuesAnyRow", targetProcedure(), "IIII", new unknown(), pcColumnList_2, pcFormatOption_2, pcDelimiter_2));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character colStringValuesAnyRow(final handle _phRowObject_1, final character _pcColumnList_2, final character _pcFormatOption_2, final character _pcDelimiter_2)
   {
      handle phRowObject_1 = TypeFactory.initInput(_phRowObject_1);
      character pcColumnList_2 = TypeFactory.initInput(_pcColumnList_2);
      character pcFormatOption_2 = TypeFactory.initInput(_pcFormatOption_2);
      character pcDelimiter_2 = TypeFactory.initInput(_pcDelimiter_2);
      /*------------------------------------------------------------------------------
        Purpose:     Returns a delimited list of values for the requested
                     columns of the requested RowObject record. Intented for internal
                     use only as the structure or implementation details of the RowObject
                     Temp Table is subject to change.
        Parameters:
          INPUT phRowObject    - RowObject buffer. If ? we use current RowObject.
          INPUT pcColumnList   - Comma delimited list of RowObject column names
          INPUT pcFormatOption - Format of returned values
                                - Blank or ? 
                                  No formatting, just buffer values 
                                - 'Formatted' 
                                  Formatted according to the columnFormat with right 
                                  justified numeric values.
                                - 'TrimNumeric' 
                                  Formatted according to the columnFormat with LEFT 
                                  justified numeric values.
                                   
          INPUT pcDelimiter  - optional delimiter (default CHR(1)).   
        Notes:       This function is different from colValues in that it does NOT 
                     return rowidents as the first entry and does not look in the 
                     dataSource.
      ------------------------------------------------------------------------------*/
      character cColValues = TypeFactory.character();
      integer iCol = TypeFactory.integer();
      handle hColumn = TypeFactory.handle();
      character cValue = TypeFactory.character();
      character cColumn = TypeFactory.character();
      
      return function("colStringValuesAnyRow", character.class, new Block((Body) () -> 
      {
         if (_isUnknown(phRowObject_1))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
            phRowObject_1.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         /* use current RowObject record */
         if (_and(phRowObject_1.isValid(), () -> phRowObject_1.unwrapBuffer().available()))
         {
            if (_isUnknown(pcDelimiter_2))
            {
               pcDelimiter_2.assign(chr(1));
            }
            
            loopLabel0:
            for (iCol.assign(1); _isLessThanOrEqual(iCol, numEntries(pcColumnList_2)); iCol.increment())
            {
               cColumn.assign(entry(iCol, pcColumnList_2));
               
               /* If column is formatted with the SDO name in front, strip it out */
               if (_isGreaterThan(indexOf(cColumn, "."), 0))
               {
                  cColumn.assign(entry(2, cColumn, "."));
               }
               
               ErrorManager.silentErrorEnable();
               hColumn.assign(phRowObject_1.unwrapBuffer().bufferField(cColumn));
               ErrorManager.silentErrorDisable();
               
               if (_not(hColumn.isValid()))
               {
                  cValue.assign("?");
               }
               else
               {
                  if (_isEqual(cColumn, "Rowident"))
                  {
                     hColumn.unwrapCommonField().setFormat(concat("x(", valueOf(int64.maximum(new int64(1), DynamicOps.length(new character(hColumn.unwrapBufferField().value())))), ")"));
                  }
                  
                  switch (StringHelper.safeTrimTrailing((pcFormatOption_2).toStringMessage()).toUpperCase())
                  {
                     case "FORMATTED":
                        {
                           cValue.assign(rightTrim(hColumn.unwrapBufferField().stringValue(), " "));
                        }
                        break;
                     case "TRIMNUMERIC":
                        {
                           cValue.assign(_isGreaterThan(lookup(hColumn.unwrapCommonField().getDataType(), "Decimal,Integer"), 0) ? leftTrim(hColumn.unwrapBufferField().stringValue(), " ") : rightTrim(hColumn.unwrapBufferField().stringValue(), " "));
                        }
                        break;
                     case "NOTRIM":
                        {
                           cValue.assign(hColumn.unwrapBufferField().stringValue());
                        }
                        break;
                     default:
                        {
                           cValue.assign(hColumn.unwrapBufferField().value());
                        }
                        break;
                  }
               }
               /* END ELSE DO if hColumn found locally */
               cColValues.assign(concat(cColValues, (_isGreaterThan(iCol, 1) ? _isNotEqual(pcDelimiter_2, "") ? pcDelimiter_2 : new character(" ") : new character("")), cValue));
            }
            
            /* END iCol */
            returnNormal(cColValues);
         }
         /* valid and avail rowObject*/
         returnNormal(new character());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnColumnLabel(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns the Progress Column Label of a specified column.
        Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnColumnLabel", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_not(hCol.isValid()))
         {
            returnNormal(new character());
         }
         
         returnNormal(_isUnknown(hCol.unwrapCommonField().getColumnLabel()) ? ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnLabel", targetProcedure(), "I", pcColumn_27) : hCol.unwrapCommonField().getColumnLabel());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnDataType(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns the Progress datatype of a specified column.
        
        Parameters:
          INPUT pcColumn - a column name, either a RowObject fieldname or a
                           qualified DB fieldname of a table in the DB query.
        
        Note:        columnDataType recognizes that pcColumn is a qualified DB
                     fieldname based on the presence of a period (".").
                     If pcColumn is a qualified DB fieldname and columnDataType is
                     called on the client side of the SmartDataObject, an attempt is 
                     made to resolve this on the client. First by using the mapped 
                     SmartDataObject name in a recursive call to columnDataType.  If
                     this fails, and there is a ForeignFields property, the 
                     corresponding data source field is queried via this function.
                     
            !!!      As a last resort columnDataType is called on the Server side.
                     This is done in order to support queries with fields that are
                     not mapped to the SDO.  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      character cAsdivision = TypeFactory.character();
      handle hAppServer = TypeFactory.handle();
      character cDataColumn = TypeFactory.character();
      character cDataType = TypeFactory.character();
      
      return function("columnDataType", character.class, new Block((Body) () -> 
      {
         if (_begins(pcColumn_27, "RowObject."))
         {
            pcColumn_27.assign(entry(2, pcColumn_27, "."));
         }
         
         /* If not Qualified check the RowObject */
         if (_isEqual(indexOf(pcColumn_27, "."), 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
            hRowObject.assign(ghProp.unwrapBufferField().value());
            ErrorManager.silentErrorEnable();
            hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
            ErrorManager.silentErrorDisable();
            returnNormal(_isUnknown(hCol) ? new character() : hCol.unwrapCommonField().getDataType());
         }
         else
         {
            /* {get Prop var [handle]} */ 
            cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
            
            if (_isEqual(cAsdivision, "Client"))
            {
               cDataType.setUnknown();
               /* get the mapped RowObject column */
               cDataColumn /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "dbColumnDataName", targetProcedure(), "I", pcColumn_27));
               
               if (_isNotEqual(cDataColumn, ""))
               {
                  cDataType /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnDataType", targetProcedure(), "I", cDataColumn));
               }
               
               /* The database field was not defined in the sdo so we will try to get the
                        datatype from other sources */
               if (_isUnknown(cDataType))
               {
                  /* {get Prop var [handle]} */ 
                  hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
                  cDataType /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnDataType", hAppServer, "I", pcColumn_27));
                  /* unbind if this call did the bind (getASHandle) */
                  ControlFlowOps.invokeInWithMode("unbindServer", targetProcedure(), "I", new unknown());
               }
               
               /* END DO cDatatype = ? */
               returnNormal(cDataType);
            }
            else
            {
               returnNormal((character) ControlFlowOps.runSuper("columnDataType", pcColumn_27));
            }
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnDbname(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*-----------------------------------------------------------------------------
        Purpose:     Returns the database name of the column mapped to a
                     SmartDataObjects RowObject column.               
        Parameters: INPUT pcColumn 
                    - column name of the RowObject field being queried or a 
                      qualified database column.                   
      ------------------------------------------------------------------------------*/
      character cTable = TypeFactory.character();
      character cTables = TypeFactory.character();
      character cDbnames = TypeFactory.character();
      
      return function("columnDBName", character.class, new Block((Body) () -> 
      {
         cTable /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnTable", targetProcedure(), "I", pcColumn_27));
         
         if (_isGreaterThan(numEntries(cTable, "."), 1))
         {
            returnNormal(entry(1, cTable, "."));
         }
         else
         {
            if (_isGreaterThan(cTable, ""))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("Tables"));
               cTables.assign(ghProp.unwrapBufferField().value());
               /* {get Prop var [handle]} */ 
               cDbnames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDBNames", targetProcedure()));
               returnNormal(entry(lookup(cTable, cTables), cDbnames));
            }
         }
         returnNormal(new character());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public integer columnExtent(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns the Progress extent of a specified column.
        Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnExtent", integer.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new integer() : hCol.unwrapBufferField().extent());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnFormat(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:    Returns the Progress format of a specified column.  
        Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnFormat", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new character() : hCol.unwrapCommonField().getFormat());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle columnHandle(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:    Returns the handle of a RowObject column.  
        Parameters: INPUT pcColumn 
                     - Unqualified column name of the RowObject field.
                     - Column name qualified with "RowObject".   
                     - qualified database field name. 
                       (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hRowObject = TypeFactory.handle();
      handle hColumn = TypeFactory.handle();
      
      return function("columnHandle", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hRowObject.isValid()))
         {
            returnNormal(new handle());
         }
         
         if (_isGreaterThan(numEntries(pcColumn_27, "."), 1))
         {
            if (_begins(pcColumn_27, "RowObject."))
            {
               pcColumn_27.assign(entry(2, pcColumn_27, "."));
            }
            else
            {
               pcColumn_27 /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "dbColumnDataName", targetProcedure(), "I", pcColumn_27));
            }
         }
         ErrorManager.silentErrorEnable();
         hColumn.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         returnNormal(hColumn);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnHelp(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:    Returns the Progress help text for a specified column.  
        Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnHelp", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new character() : hCol.unwrapWidget().getHelp());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnInitial(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns the initial value for a specified field as a character
                     string with the field FORMAT applied.
        
        Parameters:
          INPUT pcColumn - column name of the RowObject field being queried.
        
        Notes:       Example: If the value of a numeric field is 123456789 and the
                              format is "999-99-9999", columnInitial would return
                              a character string containing "123-45-6789".
      -----------------------------------------------------------------------------*/
      handle hColumn = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnInitial", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hColumn.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         if ((hColumn.isValid()).booleanValue())
         {
            if (_isUnknown(hColumn.unwrapBufferField().initial()))
            {
               returnNormal("");
            }
            else
            {
               if (_and(isEqual(hColumn.unwrapCommonField().getDataType(), "DATE"), () -> isEqual(hColumn.unwrapBufferField().initial(), "TODAY")))
               {
                  returnNormal(valueOf(date.today()));
               }
               else
               {
                  returnNormal(hColumn.unwrapBufferField().initial());
               }
            }
         }
         /* valid-handle(hcolumn) */
         returnNormal(new character());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnLabel(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns the Progress Label of a specified column.
        Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
        Note:       If no label have been specified, then the column name is return.
                    Use ColumnColumnLabel to get the COLUMN-LABEL (for browsers) 
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnLabel", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         if (_not(hCol.isValid()))
         {
            returnNormal(new character());
         }
         
         returnNormal(_isUnknown(hCol.unwrapCommonField().getLabel()) ? hCol.unwrap().name() : hCol.unwrapCommonField().getLabel());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical columnModified(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns true if a specified column has been modified in the 
                     RowObject record.
        
        Parameters:  
          INPUT pcColumn - column name of the RowObject field being queried.
        
        Notes:       NOTE: The only way to do this is to see if the row has been
                     modified and then compare the changed and unchanged copies; 
                     there's no MODIFIED attribute on the BUFFER-FIELD.
      ------------------------------------------------------------------------------*/
      handle hRowObject = TypeFactory.handle();
      handle hRowObjUpd = TypeFactory.handle();
      logical lColModified = TypeFactory.logical();
      
      return function("columnModified", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_or(not(hRowObject.isValid()), () -> not(hRowObject.unwrapBuffer().available())))
         {
            returnNormal(false);
         }
         
         if (_isEqual(hRowObject.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value(), "U"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
            hRowObjUpd.assign(ghProp.unwrapBufferField().value());
            RecordBuffer.create(hRowObjUpd, hRowObjUpd);
            
            if ((hRowObjUpd.isValid()).booleanValue())
            {
               ErrorManager.silentErrorEnable();
               hRowObjUpd.unwrapBuffer().findFirst(concat("WHERE ", hRowObjUpd.unwrap().name(), ".RowNum = ", hRowObject.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value(), " AND  ", hRowObjUpd.unwrap().name(), ".RowMod = \"\""));
               ErrorManager.silentErrorDisable();
               lColModified.assign(and(hRowObjUpd.unwrapBuffer().available(), () -> isNotEqual(hRowObjUpd.unwrapBuffer().bufferField(pcColumn_27).unwrapBufferField().value(), hRowObject.unwrapBuffer().bufferField(pcColumn_27).unwrapBufferField().value())));
            }
            
            ErrorManager.silentErrorEnable();
            HandleOps.delete(hRowObjUpd);
            ErrorManager.silentErrorDisable();
         }
         /* if hColumn:BUFFER-VALUE = "U" */
         returnNormal(lColModified);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnPrivateData(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
         Purpose: Returns the Progress Private-Data attribute of a specified column.
      Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnPrivateData", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we resolved all cases 
              by a call to columnHandle, as below, but column functions are used 
              extensively and repeatedly and we don't want to let the normal call with 
              just a column name have to pay the performance overhead of an additional 
              function call, just to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new character() : hCol.unwrap().getPrivateData());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnQuerySelection(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      
      return function("columnQuerySelection", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
          Purpose:      Returns a CHR(1) separated string with ALL operators and values 
                        that has been added to the Query for this column using the 
                        assignQuerySelection method. 
                        
                        Example: If the query contains 'custnum > 5 and custnum < 9' 
                                 this function will return (chr(1) is shown as '|'): 
                                 '>|5|<|9'    
                                       
           Parameters:
            INPUT pcColumn - A column in the RowObject. 
                             - unqualifed or qualified with RowObject.                       
                             Qualified field names will be passed directly to the
                             super procedure:   
                             - TBL.FLDNM or DB.TBL.FLDNM (only if qualified with db),
          
           Notes:       This override is needed to take a rowobject column as input and 
                        pass the mapped database column to the super procedure in query.p   
                        The data returned reflects the QueryString/QueryColumns properties, 
                        which is maintained by the assignQuerySelection. These values
                        may not have been used in an openQuery yet.               
         ------------------------------------------------------------------------------*/
         if (_begins(pcColumn_27, "RowObject."))
         {
            pcColumn_27.assign(entry(2, pcColumn_27, "."));
         }
         
         /* Find the mapped database column */
         if (_isEqual(indexOf(pcColumn_27, "."), 0))
         {
            pcColumn_27 /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnDBColumn", targetProcedure(), "I", pcColumn_27));
         }
         
         /* Call the query version */
         returnNormal((character) ControlFlowOps.runSuper("columnQuerySelection", pcColumn_27));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical columnReadOnly(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns TRUE if a specified column is READ-ONLY in the 
                     SmartDataObject, that is, if it is not in the list of Updatable
                     Columns.  Returns unknown if non-existing in the SDO
        Parameters:
          INPUT pcColumn - column name of the RowObject temp-table that is being
                           queried.
        
        Notes:       A visualization may use this dynamically to determine whether 
                     the field should be updatable on the screen.  Even still, there
                     may be circumstances where it is desirable to have it updatable
                     on the screen but if it is READ-ONLY in the SmartDataObject any
                     changes sent back to the SmartDataObject will not be made in
                     the RowObject temp-table and, therefore, in the database.
      ------------------------------------------------------------------------------*/
      character cUpdatable = TypeFactory.character();
      character cColumns = TypeFactory.character();
      
      return function("columnReadOnly", logical.class, new Block((Body) () -> 
      {
         if (_begins(pcColumn_27, "RowObject."))
         {
            pcColumn_27.assign(entry(2, pcColumn_27, "."));
         }
         
         if (_isGreaterThan(numEntries(pcColumn_27, "."), 1))
         {
            pcColumn_27 /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "dbColumnDataName", targetProcedure(), "I", pcColumn_27));
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
         cColumns.assign(ghProp.unwrapBufferField().value());
         
         if ((matchesList(cColumns, pcColumn_27)).booleanValue())
         {
            /* {get Prop var [handle]} */ 
            cUpdatable.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdatableColumns", targetProcedure()));
            returnNormal(not(matchesList(cUpdatable, pcColumn_27)));
         }
         else
         {
            returnNormal(new logical());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnStringValue(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns the STRING-VALUE of a specified column in the 
                     SmartDataObject RowObject buffer.  The STRING-VALUE is the value
                     of a field expressed as a character string formatted according
                     to the columns FORMAT expression.
       Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnStringValue", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_or(not(hRowObject.isValid()), () -> not(hRowObject.unwrapBuffer().available())))
         {
            returnNormal(new character());
         }
         
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new character() : hCol.unwrapBufferField().stringValue());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnTable(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*-----------------------------------------------------------------------------
        Purpose:     Returns the database table name of the column mapped to a
                     SmartDataObjects RowObject column or the correct .               
        Parameters: INPUT pcColumn 
                    - column name of the RowObject field being queried or a 
                      qualified database column.                   
            Notes: The table is returned according to the queries db qualification.
                   Returns unknown if ambiguous, blank if not found.    
                -  The columnTable is called on the server as last resort for 
                   qualified columns in order to support queries on unmapped fields!                          
      ------------------------------------------------------------------------------*/
      character cTable = TypeFactory.character();
      character cDbcolumn = TypeFactory.character();
      /* else do (ie: qualified references)  */
      /* Query methods support querying fields that are not mapped to the 
           SDO, so the final check is done against the actual database table. 
           This require a call to the server.  */
      /*********************************************************************
      * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
      * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
      * below.  All Rights Reserved.                                       *
      *                                                                    *
      * The Initial Developer of the Original Code is PSC.  The Original   *
      * Code is Progress IDE code released to open source December 1, 2000.*
      *                                                                    *
      * The contents of this file are subject to the Possenet Public       *
      * License Version 1.0 (the "License"); you may not use this file     *
      * except in compliance with the License.  A copy of the License is   *
      * available as of the date of this notice at                         *
      * http://www.possenet.org/license.html                               *
      *                                                                    *
      * Software distributed under the License is distributed on an "AS IS"*
      * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
      * should refer to the License for the specific language governing    *
      * rights and limitations under the License.                          *
      *                                                                    *
      * Contributors:                                                      *
      *                                                                    *
      *********************************************************************/
      /*------------------------------------------------------------------------
          File        : adm2/cltorsvr.i
          Purpose     : This include file is used many times in data.p to send
                        a request (in the form of a function) to the
                        appServer if the ASDivision is "Client" or to send the
                        request up the Super Procedure stack or just execute
                        the code for the function if we are local.
      
          Syntax      : {src/adm2/cltorsvr.i FnctName RetType "param(s)" Super}
                           Where FnctName is the name of the Function to call
                                 ReType is the return type of the function
                                        (either Log, Char, Int, Dec, Dat, or Row)
                                        (actually either "Log" or anything else)
                                 param() is an argument list to the function.
                                 Super is an optional argument (normally omitted)
                                   which if specified and NO will just fall out
                                   of the include file to execute that code in
                                   the function locally instead of doing SUPER().
      
          Modified    : December 27, 1999
        ----------------------------------------------------------------------*/
      handle hAppServer = TypeFactory.handle();
      character cAsdivision = TypeFactory.character();
      
      return function("columnTable", character.class, new Block((Body) () -> 
      {
         if (_begins(pcColumn_27, "RowObject."))
         {
            pcColumn_27.assign(entry(2, pcColumn_27, "."));
         }
         
         if (_isEqual(numEntries(pcColumn_27, "."), 1))
         {
            cDbcolumn /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnDbColumn", targetProcedure(), "I", pcColumn_27));
            
            if (_isNotEqual(cDbcolumn, ""))
            {
               /* Remove the field part */
               cDbcolumn.replaceEntry(numEntries(cDbcolumn, "."), ".", "");
               returnNormal(rightTrim(cDbcolumn, "."));
            }
            else
            {
               returnNormal("");
            }
         }
         else
         {
            /* If the column is in the data object find the table part of pcColumn. */
            if (_isNotEqual( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "dbColumnDataName", targetProcedure(), "I", pcColumn_27), ""))
            {
               cTable.assign(pcColumn_27);
               cTable.replaceEntry(numEntries(cTable, "."), ".", "");
               cTable.assign(rightTrim(cTable, "."));
               cTable /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "resolveBuffer", targetProcedure(), "I", cTable));
               
               /* if not blank, we have a resolution, a table name or ? (ambiguous) */
               if (_isNotEqual(cTable, ""))
               {
                  returnNormal(cTable);
               }
            }
         }
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         
         if (_isEqual(cAsdivision, "Client"))
         {
            /* If we're just the client then tell the AppServer to adjust the
                     where clause. */
            /* {get Prop var [handle]} */ 
            hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
            
            if (_and(hAppServer.isValid(), () -> isNotEqual(hAppServer, targetProcedure())))
            {
               returnNormal((ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnTable", hAppServer, "I", pcColumn_27)));
            }
            else
            {
               returnNormal(new character());
            }
         }
         else
         {
            returnNormal((character) ControlFlowOps.runSuper("columnTable", pcColumn_27));
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnValExp(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:   Returns the Progress Validation expression for a specified column
       Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnValExp", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new character() : hCol.unwrapBufferField().validateExpression());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnValMsg(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns the Progress Validation message for a specified column
                     of the SmartDataObjects RowObject temp-table.
       Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnValMsg", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new character() : hCol.unwrapBufferField().validateMessage());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnValue(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:   Returns the UNFORMATTED character value of a specified column 
                   in the SmartDataObject RowObject buffer.  
       Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
           Note:     This is different from columnStringValue which returns the 
                     formatted value.
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnValue", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_or(not(hRowObject.isValid()), () -> not(hRowObject.unwrapBuffer().available())))
         {
            returnNormal(new character());
         }
         
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new character() : valueOf(hCol.unwrapBufferField().value()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public decimal columnWidth(final character _pcColumn_27)
   {
      character pcColumn_27 = TypeFactory.initInput(_pcColumn_27);
      /*------------------------------------------------------------------------------
        Purpose:     Returns the width (in character units) of a specified column in
                     the SmartDataObjects RowObject temp-table.
        
       Parameters: INPUT pcColumn 
                          - Unqualified column name of the RowObject field.
                          - Column name qualified with "RowObject".   
                          - qualified database field name. 
                            (This requires that the field is mapped to the SDO).  
        
        Notes:       The width is setable inside of the column editor when editing
                     the fields of the SmartDataObject.  However, its default is
                     based on the numbers of characters needed to satisfy the
                     FORMAT expression assigned to the field.
                     The width may be used as a reference by the visualization, but
                     the visualization doesn't necessarily use the same width.
      ------------------------------------------------------------------------------*/
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      
      return function("columnWidth", decimal.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         hCol.assign(hRowObject.unwrapBuffer().bufferField(pcColumn_27));
         ErrorManager.silentErrorDisable();
         
         /* The code would certainly look more elegant if we skipped the code above
              and resolved all cases by a call to columnHandle, as below, but column 
              functions are used extensively and we don't want to let the normal call 
              with just a column name have to pay the performance overhead of an 
              additional function call, in order to support the odd case with qualifiers. */
         if (_and(isUnknown(hCol), () -> isGreaterThan(numEntries(pcColumn_27, "."), 1)))
         {
            hCol /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnHandle", targetProcedure(), "I", pcColumn_27));
         }
         
         returnNormal(_isUnknown(hCol) ? new decimal() : hCol.unwrapSizeable().getWidthChars());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character colValues(final character _pcViewColList_1)
   {
      character pcViewColList_1 = TypeFactory.initInput(_pcViewColList_1);
      /*------------------------------------------------------------------------------
        Purpose:     Returns a CHR(1) delimited list of values for the requested
                     columns (in pcViewColList) of the current row of the RowObject.
                     The first value is the RowObect ROWID and RowIdent separated 
                     with a comma.     
        Parameters:
          INPUT pcViewColList - Comma delimited list of RowObject column names
        
        Notes:       The form of the first value is:
                       <RowObject ROWID>,<DB Buffer1 ROWID>,<DB Buffer2 ROWID>,...
                     This is used as a key to uniquely identify the row and its
                     origins in the optimistic locking system.
      ------------------------------------------------------------------------------*/
      character cColValues = TypeFactory.character();
      integer iCol = TypeFactory.integer();
      handle hColumn = TypeFactory.handle();
      integer iColCount = TypeFactory.integer();
      handle hRowObject = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      character cValue = TypeFactory.character();
      
      return function("colValues", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hRowObject.isValid(), () -> hRowObject.unwrapBuffer().available()))
         {
            /* If pcViewColList is formatted with the SDO name in front, strip it out */
            if (_isGreaterThan(indexOf(pcViewColList_1, "."), 0))
            {
               pcViewColList_1.assign(entry(2, pcViewColList_1, "."));
            }
            
            cColValues.assign(concat(valueOf(hRowObject.unwrapBuffer().rowID()), ","));
            hColumn.assign(hRowObject.unwrapBuffer().bufferField("RowIdent"));
            cColValues.assign(concat(cColValues, hColumn.unwrapBufferField().value(), chr(1)));
            iColCount.assign(numEntries(pcViewColList_1));
            
            ToClause toClause0 = new ToClause(iCol, 1, iColCount);
            
            doTo("loopLabel1", toClause0, new Block((Body) () -> 
            {
               ErrorManager.silentErrorEnable();
               hColumn.assign(hRowObject.unwrapBuffer().bufferField(entry(iCol, pcViewColList_1)));
               ErrorManager.silentErrorDisable();
               
               if (_not(hColumn.isValid()))
               {
                  /* If this is a <calc> field, make put a constant in so that the
                              browser does not fail during displayFields */
                  if (_isGreaterThan(indexOf(entry(iCol, pcViewColList_1), "<calc>"), 0))
                  {
                     cColValues.assign(concat(cColValues, chr(4), "<calc>", chr(4)));
                  }
                  else
                  {
                     /* If the column was not found in this object, look to see
                                   if this object has a parent that can supply it. */
                     /* {get Prop var [handle]} */ 
                     hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
                     
                     if ((hDataSource.isValid()).booleanValue())
                     {
                        cValue.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", hDataSource, "I", entry(iCol, pcViewColList_1)));
                        
                        if (_notUnknown(cValue))
                        {
                           cColValues.assign(concat(cColValues, entry(2, cValue, chr(1))));
                        }
                        else
                        {
                           returnNormal(new character());
                        }
                     }
                     else
                     {
                        returnNormal(new character());
                     }
                  }
               }
               else
               {
                  cColValues.assign(concat(cColValues, _isUnknown(hColumn.unwrapBufferField().value()) ? new character("?") : rightTrim(valueOf(hColumn.unwrapBufferField().value()))));
               }
               
               /* END ELSE DO if hColumn found locally */
               if (_isNotEqual(iCol, iColCount))
               {
                  cColValues.assign(concat(cColValues, chr(1)));
               }
            }));
            
            /* END iCol */
            returnNormal(cColValues);
         }
         /* valid and avail rowObject*/
         returnNormal(new character());
      }));
   }
}
