package com.goldencode.hotel.dmo._meta;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>_meta.meta_file</code> (previously
 * <code>_meta._file</code>).
 */
public interface MetaFile
extends DataModelObject
{
   /**
    * Getter: newName
    * 
    * @return  newName
    */
   public character getNewName();

   /**
    * Setter: newName
    * 
    * @param   newName
    *          newName
    */
   public void setNewName(Text newName);

   /**
    * Getter: File-Name
    * 
    * @return  File-Name
    */
   public character getFileName();

   /**
    * Setter: File-Name
    * 
    * @param   fileName
    *          File-Name
    */
   public void setFileName(Text fileName);

   /**
    * Getter: Prime-Index
    * 
    * @return  Prime-Index
    */
   public recid getPrimeIndex();

   /**
    * Setter: Prime-Index
    * 
    * @param   primeIndex
    *          Prime-Index
    */
   public void setPrimeIndex(NumberType primeIndex);

   /**
    * Getter: File-Number
    * 
    * @return  File-Number
    */
   public integer getFileNumber();

   /**
    * Setter: File-Number
    * 
    * @param   fileNumber
    *          File-Number
    */
   public void setFileNumber(NumberType fileNumber);

   /**
    * Getter: dftPk
    * 
    * @return  dftPk
    */
   public logical isDftPk();

   /**
    * Setter: dftPk
    * 
    * @param   dftPk
    *          dftPk
    */
   public void setDftPk(logical dftPk);

   /**
    * Getter: numkey
    * 
    * @return  numkey
    */
   public integer getNumkey();

   /**
    * Setter: numkey
    * 
    * @param   numkey
    *          numkey
    */
   public void setNumkey(NumberType numkey);

   /**
    * Getter: numkfld
    * 
    * @return  numkfld
    */
   public integer getNumkfld();

   /**
    * Setter: numkfld
    * 
    * @param   numkfld
    *          numkfld
    */
   public void setNumkfld(NumberType numkfld);

   /**
    * Getter: numkcomp
    * 
    * @return  numkcomp
    */
   public integer getNumkcomp();

   /**
    * Setter: numkcomp
    * 
    * @param   numkcomp
    *          numkcomp
    */
   public void setNumkcomp(NumberType numkcomp);

   /**
    * Getter: template
    * 
    * @return  template
    */
   public recid getTemplate();

   /**
    * Setter: template
    * 
    * @param   template
    *          template
    */
   public void setTemplate(NumberType template);

   /**
    * Getter: numfld
    * 
    * @return  numfld
    */
   public integer getNumfld();

   /**
    * Setter: numfld
    * 
    * @param   numfld
    *          numfld
    */
   public void setNumfld(NumberType numfld);

   /**
    * Getter: Can-Create
    * 
    * @return  Can-Create
    */
   public character getCanCreate();

   /**
    * Setter: Can-Create
    * 
    * @param   canCreate
    *          Can-Create
    */
   public void setCanCreate(Text canCreate);

   /**
    * Getter: Can-Read
    * 
    * @return  Can-Read
    */
   public character getCanRead();

   /**
    * Setter: Can-Read
    * 
    * @param   canRead
    *          Can-Read
    */
   public void setCanRead(Text canRead);

   /**
    * Getter: Can-Write
    * 
    * @return  Can-Write
    */
   public character getCanWrite();

   /**
    * Setter: Can-Write
    * 
    * @param   canWrite
    *          Can-Write
    */
   public void setCanWrite(Text canWrite);

   /**
    * Getter: Can-Delete
    * 
    * @return  Can-Delete
    */
   public character getCanDelete();

   /**
    * Setter: Can-Delete
    * 
    * @param   canDelete
    *          Can-Delete
    */
   public void setCanDelete(Text canDelete);

   /**
    * Getter: Desc
    * 
    * @return  Desc
    */
   public character getDesc();

   /**
    * Setter: Desc
    * 
    * @param   desc
    *          Desc
    */
   public void setDesc(Text desc);

   /**
    * Getter: Db-recid
    * 
    * @return  Db-recid
    */
   public recid getDbRecid();

   /**
    * Setter: Db-recid
    * 
    * @param   dbRecid
    *          Db-recid
    */
   public void setDbRecid(NumberType dbRecid);

   /**
    * Getter: Valexp
    * 
    * @return  Valexp
    */
   public character getValexp();

   /**
    * Setter: Valexp
    * 
    * @param   valexp
    *          Valexp
    */
   public void setValexp(Text valexp);

   /**
    * Getter: Valmsg
    * 
    * @return  Valmsg
    */
   public character getValmsg();

   /**
    * Setter: Valmsg
    * 
    * @param   valmsg
    *          Valmsg
    */
   public void setValmsg(Text valmsg);

   /**
    * Indexed Getter: filMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  filMisc1
    */
   public integer getFilMisc1(int index);

   /**
    * Indexed Setter: filMisc1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          filMisc1
    */
   public void setFilMisc1(int index, NumberType element);

   /**
    * Indexed Getter: filMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  filMisc2
    */
   public character getFilMisc2(int index);

   /**
    * Indexed Setter: filMisc2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          filMisc2
    */
   public void setFilMisc2(int index, Text element);

   /**
    * Getter: lastChange
    * 
    * @return  lastChange
    */
   public integer getLastChange();

   /**
    * Setter: lastChange
    * 
    * @param   lastChange
    *          lastChange
    */
   public void setLastChange(NumberType lastChange);

   /**
    * Getter: dbLang
    * 
    * @return  dbLang
    */
   public integer getDbLang();

   /**
    * Setter: dbLang
    * 
    * @param   dbLang
    *          dbLang
    */
   public void setDbLang(NumberType dbLang);

   /**
    * Getter: hidden
    * 
    * @return  hidden
    */
   public logical isHidden();

   /**
    * Setter: hidden
    * 
    * @param   hidden
    *          hidden
    */
   public void setHidden(logical hidden);

   /**
    * Getter: Frozen
    * 
    * @return  Frozen
    */
   public logical isFrozen();

   /**
    * Setter: Frozen
    * 
    * @param   frozen
    *          Frozen
    */
   public void setFrozen(logical frozen);

   /**
    * Getter: Dump-name
    * 
    * @return  Dump-name
    */
   public character getDumpName();

   /**
    * Setter: Dump-name
    * 
    * @param   dumpName
    *          Dump-name
    */
   public void setDumpName(Text dumpName);

   /**
    * Getter: CRC
    * 
    * @return  CRC
    */
   public integer getCrc();

   /**
    * Setter: CRC
    * 
    * @param   crc
    *          CRC
    */
   public void setCrc(NumberType crc);

   /**
    * Indexed Getter: filRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  filRes1
    */
   public integer getFilRes1(int index);

   /**
    * Indexed Setter: filRes1
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          filRes1
    */
   public void setFilRes1(int index, NumberType element);

   /**
    * Indexed Getter: filRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * 
    * @return  filRes2
    */
   public character getFilRes2(int index);

   /**
    * Indexed Setter: filRes2
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
    * @param   element
    *          filRes2
    */
   public void setFilRes2(int index, Text element);

   /**
    * Getter: cache
    * 
    * @return  cache
    */
   public raw getCache();

   /**
    * Setter: cache
    * 
    * @param   cache
    *          cache
    */
   public void setCache(BinaryData cache);

   /**
    * Getter: forSize
    * 
    * @return  forSize
    */
   public integer getForSize();

   /**
    * Setter: forSize
    * 
    * @param   forSize
    *          forSize
    */
   public void setForSize(NumberType forSize);

   /**
    * Getter: forFlag
    * 
    * @return  forFlag
    */
   public integer getForFlag();

   /**
    * Setter: forFlag
    * 
    * @param   forFlag
    *          forFlag
    */
   public void setForFlag(NumberType forFlag);

   /**
    * Getter: forCnt1
    * 
    * @return  forCnt1
    */
   public integer getForCnt1();

   /**
    * Setter: forCnt1
    * 
    * @param   forCnt1
    *          forCnt1
    */
   public void setForCnt1(NumberType forCnt1);

   /**
    * Getter: forCnt2
    * 
    * @return  forCnt2
    */
   public integer getForCnt2();

   /**
    * Setter: forCnt2
    * 
    * @param   forCnt2
    *          forCnt2
    */
   public void setForCnt2(NumberType forCnt2);

   /**
    * Getter: forName
    * 
    * @return  forName
    */
   public character getForName();

   /**
    * Setter: forName
    * 
    * @param   forName
    *          forName
    */
   public void setForName(Text forName);

   /**
    * Getter: forOwner
    * 
    * @return  forOwner
    */
   public character getForOwner();

   /**
    * Setter: forOwner
    * 
    * @param   forOwner
    *          forOwner
    */
   public void setForOwner(Text forOwner);

   /**
    * Getter: forFormat
    * 
    * @return  forFormat
    */
   public character getForFormat();

   /**
    * Setter: forFormat
    * 
    * @param   forFormat
    *          forFormat
    */
   public void setForFormat(Text forFormat);

   /**
    * Getter: forInfo
    * 
    * @return  forInfo
    */
   public character getForInfo();

   /**
    * Setter: forInfo
    * 
    * @param   forInfo
    *          forInfo
    */
   public void setForInfo(Text forInfo);

   /**
    * Getter: forType
    * 
    * @return  forType
    */
   public character getForType();

   /**
    * Setter: forType
    * 
    * @param   forType
    *          forType
    */
   public void setForType(Text forType);

   /**
    * Getter: forId
    * 
    * @return  forId
    */
   public integer getForId();

   /**
    * Setter: forId
    * 
    * @param   forId
    *          forId
    */
   public void setForId(NumberType forId);

   /**
    * Getter: forNumber
    * 
    * @return  forNumber
    */
   public integer getForNumber();

   /**
    * Setter: forNumber
    * 
    * @param   forNumber
    *          forNumber
    */
   public void setForNumber(NumberType forNumber);

   /**
    * Getter: File-Label
    * 
    * @return  File-Label
    */
   public character getFileLabel();

   /**
    * Setter: File-Label
    * 
    * @param   fileLabel
    *          File-Label
    */
   public void setFileLabel(Text fileLabel);

   /**
    * Getter: Can-Dump
    * 
    * @return  Can-Dump
    */
   public character getCanDump();

   /**
    * Setter: Can-Dump
    * 
    * @param   canDump
    *          Can-Dump
    */
   public void setCanDump(Text canDump);

   /**
    * Getter: Can-Load
    * 
    * @return  Can-Load
    */
   public character getCanLoad();

   /**
    * Setter: Can-Load
    * 
    * @param   canLoad
    *          Can-Load
    */
   public void setCanLoad(Text canLoad);

   /**
    * Getter: Valmsg-SA
    * 
    * @return  Valmsg-SA
    */
   public character getValmsgSa();

   /**
    * Setter: Valmsg-SA
    * 
    * @param   valmsgSa
    *          Valmsg-SA
    */
   public void setValmsgSa(Text valmsgSa);

   /**
    * Getter: File-Label-SA
    * 
    * @return  File-Label-SA
    */
   public character getFileLabelSa();

   /**
    * Setter: File-Label-SA
    * 
    * @param   fileLabelSa
    *          File-Label-SA
    */
   public void setFileLabelSa(Text fileLabelSa);

   /**
    * Getter: ianum
    * 
    * @return  ianum
    */
   public integer getIanum();

   /**
    * Setter: ianum
    * 
    * @param   ianum
    *          ianum
    */
   public void setIanum(NumberType ianum);

   /**
    * Getter: version
    * 
    * @return  version
    */
   public integer getVersion();

   /**
    * Setter: version
    * 
    * @param   version
    *          version
    */
   public void setVersion(NumberType version);

   /**
    * Getter: fieldMap
    * 
    * @return  fieldMap
    */
   public raw getFieldMap();

   /**
    * Setter: fieldMap
    * 
    * @param   fieldMap
    *          fieldMap
    */
   public void setFieldMap(BinaryData fieldMap);

   /**
    * Getter: Creator
    * 
    * @return  Creator
    */
   public character getCreator();

   /**
    * Setter: Creator
    * 
    * @param   creator
    *          Creator
    */
   public void setCreator(Text creator);

   /**
    * Getter: hasCcnstrs
    * 
    * @return  hasCcnstrs
    */
   public character getHasCcnstrs();

   /**
    * Setter: hasCcnstrs
    * 
    * @param   hasCcnstrs
    *          hasCcnstrs
    */
   public void setHasCcnstrs(Text hasCcnstrs);

   /**
    * Getter: hasFcnstrs
    * 
    * @return  hasFcnstrs
    */
   public character getHasFcnstrs();

   /**
    * Setter: hasFcnstrs
    * 
    * @param   hasFcnstrs
    *          hasFcnstrs
    */
   public void setHasFcnstrs(Text hasFcnstrs);

   /**
    * Getter: hasPcnstrs
    * 
    * @return  hasPcnstrs
    */
   public character getHasPcnstrs();

   /**
    * Setter: hasPcnstrs
    * 
    * @param   hasPcnstrs
    *          hasPcnstrs
    */
   public void setHasPcnstrs(Text hasPcnstrs);

   /**
    * Getter: hasUcnstrs
    * 
    * @return  hasUcnstrs
    */
   public character getHasUcnstrs();

   /**
    * Setter: hasUcnstrs
    * 
    * @param   hasUcnstrs
    *          hasUcnstrs
    */
   public void setHasUcnstrs(Text hasUcnstrs);

   /**
    * Getter: Owner
    * 
    * @return  Owner
    */
   public character getOwner();

   /**
    * Setter: Owner
    * 
    * @param   owner
    *          Owner
    */
   public void setOwner(Text owner);

   /**
    * Getter: rssid
    * 
    * @return  rssid
    */
   public integer getRssid();

   /**
    * Setter: rssid
    * 
    * @param   rssid
    *          rssid
    */
   public void setRssid(NumberType rssid);

   /**
    * Getter: tblStatus
    * 
    * @return  tblStatus
    */
   public character getTblStatus();

   /**
    * Setter: tblStatus
    * 
    * @param   tblStatus
    *          tblStatus
    */
   public void setTblStatus(Text tblStatus);

   /**
    * Getter: Tbl-Type
    * 
    * @return  Tbl-Type
    */
   public character getTblType();

   /**
    * Setter: Tbl-Type
    * 
    * @param   tblType
    *          Tbl-Type
    */
   public void setTblType(Text tblType);

   /**
    * Getter: User-Misc
    * 
    * @return  User-Misc
    */
   public character getUserMisc();

   /**
    * Setter: User-Misc
    * 
    * @param   userMisc
    *          User-Misc
    */
   public void setUserMisc(Text userMisc);

   /**
    * Getter: lastModified
    * 
    * @return  lastModified
    */
   public datetimetz getLastModified();

   /**
    * Setter: lastModified
    * 
    * @param   lastModified
    *          lastModified
    */
   public void setLastModified(date lastModified);

   /**
    * Getter: modSequence
    * 
    * @return  modSequence
    */
   public integer getModSequence();

   /**
    * Setter: modSequence
    * 
    * @param   modSequence
    *          modSequence
    */
   public void setModSequence(NumberType modSequence);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends MetaFile, Buffer
   {
      /**
       * Getter: filMisc1
       * 
       * @return  filMisc1
       */
      public integer[] getFilMisc1();

      /**
       * Indexed Getter: filMisc1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  filMisc1
       */
      public integer getFilMisc1(NumberType index);

      /**
       * Indexed Setter: filMisc1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          filMisc1
       */
      public void setFilMisc1(NumberType index, NumberType element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: filMisc1
       * 
       * @param   element
       *          Scalar value to which to set all elements of: filMisc1
       */
      public void setFilMisc1(NumberType element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: filMisc1
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: filMisc1
       */
      public void setFilMisc1(NumberType[] elements);

      /**
       * Getter: filMisc2
       * 
       * @return  filMisc2
       */
      public character[] getFilMisc2();

      /**
       * Indexed Getter: filMisc2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  filMisc2
       */
      public character getFilMisc2(NumberType index);

      /**
       * Indexed Setter: filMisc2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          filMisc2
       */
      public void setFilMisc2(NumberType index, Text element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: filMisc2
       * 
       * @param   element
       *          Scalar value to which to set all elements of: filMisc2
       */
      public void setFilMisc2(Text element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: filMisc2
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: filMisc2
       */
      public void setFilMisc2(Text[] elements);

      /**
       * Getter: filRes1
       * 
       * @return  filRes1
       */
      public integer[] getFilRes1();

      /**
       * Indexed Getter: filRes1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  filRes1
       */
      public integer getFilRes1(NumberType index);

      /**
       * Indexed Setter: filRes1
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          filRes1
       */
      public void setFilRes1(NumberType index, NumberType element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: filRes1
       * 
       * @param   element
       *          Scalar value to which to set all elements of: filRes1
       */
      public void setFilRes1(NumberType element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: filRes1
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: filRes1
       */
      public void setFilRes1(NumberType[] elements);

      /**
       * Getter: filRes2
       * 
       * @return  filRes2
       */
      public character[] getFilRes2();

      /**
       * Indexed Getter: filRes2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * 
       * @return  filRes2
       */
      public character getFilRes2(NumberType index);

      /**
       * Indexed Setter: filRes2
       * 
       * @param   index
       *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 8</code>).
       * @param   element
       *          filRes2
       */
      public void setFilRes2(NumberType index, Text element);

      /**
       * Set all elements of the target list property to the given scalar value. Modifies the
       * contents of: filRes2
       * 
       * @param   element
       *          Scalar value to which to set all elements of: filRes2
       */
      public void setFilRes2(Text element);

      /**
       * Set as many elements of the target list property as are provided in the given array of
       * scalar values. Modifies the contents of: filRes2
       * <p>
       * If the given array is larger than the target list, any additional elements in the given
       * array are ignored. If the target array is smaller than the target list, only those
       * elements whose array indices match are updated.
       * 
       * @param   elements
       *          Array of scalar values to which to set the corresponding elements of: filRes2
       */
      public void setFilRes2(Text[] elements);

   }
}
