package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "admlink", table = "tt5")
public class Admlink_1_1Impl
implements Serializable,
           Persistable,
           Admlink_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "linksource", initial = "?")
   private final handle linksource;

   /** Data member */
   @LegacyField(fieldId = 2, name = "linktarget", initial = "?")
   private final handle linktarget;

   /** Data member */
   @LegacyField(fieldId = 3, name = "linktype")
   private final character linktype;

   /**
    * Default constructor.
    */
   public Admlink_1_1Impl()
   {
      linksource = new handle();
      linktarget = new handle();
      linktype = new character("");
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Admlink_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Admlink_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Admlink_1_1Impl from = (Admlink_1_1Impl) old;
      setId(from.id);
      setLinksource(from.linksource);
      setLinktarget(from.linktarget);
      setLinktype(from.linktype);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: linksource
    * 
    * @return  linksource
    */
   public handle getLinksource()
   {
      return (new handle(linksource));
   }

   /**
    * Setter: linksource
    * 
    * @param   linksource
    *          linksource
    */
   public void setLinksource(handle linksource)
   {
      this.linksource.assign(linksource, true);
   }

   /**
    * Getter: linktarget
    * 
    * @return  linktarget
    */
   public handle getLinktarget()
   {
      return (new handle(linktarget));
   }

   /**
    * Setter: linktarget
    * 
    * @param   linktarget
    *          linktarget
    */
   public void setLinktarget(handle linktarget)
   {
      this.linktarget.assign(linktarget, true);
   }

   /**
    * Getter: linktype
    * 
    * @return  linktype
    */
   public character getLinktype()
   {
      return (new character(linktype));
   }

   /**
    * Setter: linktype
    * 
    * @param   linktype
    *          linktype
    */
   public void setLinktype(Text linktype)
   {
      this.linktype.assign(linktype, true);
   }
}
