package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "ttcombodata", table = "tt6")
@LegacyIndexes(
{
   @LegacyIndex(name = "keyIndex", converted = "tt6_key_index", primary = true, components = 
   {
      @LegacyIndexComponent(fieldName = "hwidget")
   }),
   @LegacyIndex(name = "key2", converted = "tt6_key2", components = 
   {
      @LegacyIndexComponent(fieldName = "cwidgetname")
   })
})
public class Ttcombodata_1_1Impl
implements Serializable,
           Persistable,
           Ttcombodata_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "hwidget", initial = "?")
   private final handle hwidget;

   /** Data member */
   @LegacyField(fieldId = 2, name = "cwidgetname")
   private final character cwidgetname;

   /** Data member */
   @LegacyField(fieldId = 3, name = "cwidgettype")
   private final character cwidgettype;

   /** Data member */
   @LegacyField(fieldId = 4, name = "cforeach")
   private final character cforeach;

   /** Data member */
   @LegacyField(fieldId = 5, name = "cbufferlist")
   private final character cbufferlist;

   /** Data member */
   @LegacyField(fieldId = 6, name = "ckeyfieldname")
   private final character ckeyfieldname;

   /** Data member */
   @LegacyField(fieldId = 7, name = "cdescfieldnames")
   private final character cdescfieldnames;

   /** Data member */
   @LegacyField(fieldId = 8, name = "cdescsubstitute")
   private final character cdescsubstitute;

   /** Data member */
   @LegacyField(fieldId = 9, name = "cflag")
   private final character cflag;

   /** Data member */
   @LegacyField(fieldId = 10, name = "ccurrentkeyvalue")
   private final character ccurrentkeyvalue;

   /** Data member */
   @LegacyField(fieldId = 11, name = "clistitemdelimiter")
   private final character clistitemdelimiter;

   /** Data member */
   @LegacyField(fieldId = 12, name = "clistitempairs")
   private final character clistitempairs;

   /** Data member */
   @LegacyField(fieldId = 13, name = "ccurrentdescvalue")
   private final character ccurrentdescvalue;

   /**
    * Default constructor.
    */
   public Ttcombodata_1_1Impl()
   {
      hwidget = new handle();
      cwidgetname = new character("");
      cwidgettype = new character("");
      cforeach = new character("");
      cbufferlist = new character("");
      ckeyfieldname = new character("");
      cdescfieldnames = new character("");
      cdescsubstitute = new character("");
      cflag = new character("");
      ccurrentkeyvalue = new character("");
      clistitemdelimiter = new character("");
      clistitempairs = new character("");
      ccurrentdescvalue = new character("");
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Ttcombodata_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Ttcombodata_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Ttcombodata_1_1Impl from = (Ttcombodata_1_1Impl) old;
      setId(from.id);
      setHwidget(from.hwidget);
      setCwidgetname(from.cwidgetname);
      setCwidgettype(from.cwidgettype);
      setCforeach(from.cforeach);
      setCbufferlist(from.cbufferlist);
      setCkeyfieldname(from.ckeyfieldname);
      setCdescfieldnames(from.cdescfieldnames);
      setCdescsubstitute(from.cdescsubstitute);
      setCflag(from.cflag);
      setCcurrentkeyvalue(from.ccurrentkeyvalue);
      setClistitemdelimiter(from.clistitemdelimiter);
      setClistitempairs(from.clistitempairs);
      setCcurrentdescvalue(from.ccurrentdescvalue);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: hwidget
    * 
    * @return  hwidget
    */
   public handle getHwidget()
   {
      return (new handle(hwidget));
   }

   /**
    * Setter: hwidget
    * 
    * @param   hwidget
    *          hwidget
    */
   public void setHwidget(handle hwidget)
   {
      this.hwidget.assign(hwidget, true);
   }

   /**
    * Getter: cwidgetname
    * 
    * @return  cwidgetname
    */
   public character getCwidgetname()
   {
      return (new character(cwidgetname));
   }

   /**
    * Setter: cwidgetname
    * 
    * @param   cwidgetname
    *          cwidgetname
    */
   public void setCwidgetname(Text cwidgetname)
   {
      this.cwidgetname.assign(cwidgetname, true);
   }

   /**
    * Getter: cwidgettype
    * 
    * @return  cwidgettype
    */
   public character getCwidgettype()
   {
      return (new character(cwidgettype));
   }

   /**
    * Setter: cwidgettype
    * 
    * @param   cwidgettype
    *          cwidgettype
    */
   public void setCwidgettype(Text cwidgettype)
   {
      this.cwidgettype.assign(cwidgettype, true);
   }

   /**
    * Getter: cforeach
    * 
    * @return  cforeach
    */
   public character getCforeach()
   {
      return (new character(cforeach));
   }

   /**
    * Setter: cforeach
    * 
    * @param   cforeach
    *          cforeach
    */
   public void setCforeach(Text cforeach)
   {
      this.cforeach.assign(cforeach, true);
   }

   /**
    * Getter: cbufferlist
    * 
    * @return  cbufferlist
    */
   public character getCbufferlist()
   {
      return (new character(cbufferlist));
   }

   /**
    * Setter: cbufferlist
    * 
    * @param   cbufferlist
    *          cbufferlist
    */
   public void setCbufferlist(Text cbufferlist)
   {
      this.cbufferlist.assign(cbufferlist, true);
   }

   /**
    * Getter: ckeyfieldname
    * 
    * @return  ckeyfieldname
    */
   public character getCkeyfieldname()
   {
      return (new character(ckeyfieldname));
   }

   /**
    * Setter: ckeyfieldname
    * 
    * @param   ckeyfieldname
    *          ckeyfieldname
    */
   public void setCkeyfieldname(Text ckeyfieldname)
   {
      this.ckeyfieldname.assign(ckeyfieldname, true);
   }

   /**
    * Getter: cdescfieldnames
    * 
    * @return  cdescfieldnames
    */
   public character getCdescfieldnames()
   {
      return (new character(cdescfieldnames));
   }

   /**
    * Setter: cdescfieldnames
    * 
    * @param   cdescfieldnames
    *          cdescfieldnames
    */
   public void setCdescfieldnames(Text cdescfieldnames)
   {
      this.cdescfieldnames.assign(cdescfieldnames, true);
   }

   /**
    * Getter: cdescsubstitute
    * 
    * @return  cdescsubstitute
    */
   public character getCdescsubstitute()
   {
      return (new character(cdescsubstitute));
   }

   /**
    * Setter: cdescsubstitute
    * 
    * @param   cdescsubstitute
    *          cdescsubstitute
    */
   public void setCdescsubstitute(Text cdescsubstitute)
   {
      this.cdescsubstitute.assign(cdescsubstitute, true);
   }

   /**
    * Getter: cflag
    * 
    * @return  cflag
    */
   public character getCflag()
   {
      return (new character(cflag));
   }

   /**
    * Setter: cflag
    * 
    * @param   cflag
    *          cflag
    */
   public void setCflag(Text cflag)
   {
      this.cflag.assign(cflag, true);
   }

   /**
    * Getter: ccurrentkeyvalue
    * 
    * @return  ccurrentkeyvalue
    */
   public character getCcurrentkeyvalue()
   {
      return (new character(ccurrentkeyvalue));
   }

   /**
    * Setter: ccurrentkeyvalue
    * 
    * @param   ccurrentkeyvalue
    *          ccurrentkeyvalue
    */
   public void setCcurrentkeyvalue(Text ccurrentkeyvalue)
   {
      this.ccurrentkeyvalue.assign(ccurrentkeyvalue, true);
   }

   /**
    * Getter: clistitemdelimiter
    * 
    * @return  clistitemdelimiter
    */
   public character getClistitemdelimiter()
   {
      return (new character(clistitemdelimiter));
   }

   /**
    * Setter: clistitemdelimiter
    * 
    * @param   clistitemdelimiter
    *          clistitemdelimiter
    */
   public void setClistitemdelimiter(Text clistitemdelimiter)
   {
      this.clistitemdelimiter.assign(clistitemdelimiter, true);
   }

   /**
    * Getter: clistitempairs
    * 
    * @return  clistitempairs
    */
   public character getClistitempairs()
   {
      return (new character(clistitempairs));
   }

   /**
    * Setter: clistitempairs
    * 
    * @param   clistitempairs
    *          clistitempairs
    */
   public void setClistitempairs(Text clistitempairs)
   {
      this.clistitempairs.assign(clistitempairs, true);
   }

   /**
    * Getter: ccurrentdescvalue
    * 
    * @return  ccurrentdescvalue
    */
   public character getCcurrentdescvalue()
   {
      return (new character(ccurrentdescvalue));
   }

   /**
    * Setter: ccurrentdescvalue
    * 
    * @param   ccurrentdescvalue
    *          ccurrentdescvalue
    */
   public void setCcurrentdescvalue(Text ccurrentdescvalue)
   {
      this.ccurrentdescvalue.assign(ccurrentdescvalue, true);
   }
}
