package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "ttdcombocopy", table = "tt10")
@LegacyIndexes(
{
   @LegacyIndex(name = "keyIndex", converted = "tt10_key_index", primary = true, components = 
   {
      @LegacyIndexComponent(fieldName = "hwidget")
   }),
   @LegacyIndex(name = "keyCont", converted = "tt10_key_cont", components = 
   {
      @LegacyIndexComponent(fieldName = "hviewer")
   }),
   @LegacyIndex(name = "key2", converted = "tt10_key2", components = 
   {
      @LegacyIndexComponent(fieldName = "cwidgetname")
   })
})
public class Ttdcombocopy_1_1Impl
implements Serializable,
           Persistable,
           Ttdcombocopy_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "hwidget", initial = "?")
   private final handle hwidget;

   /** Data member */
   @LegacyField(fieldId = 2, name = "hviewer", initial = "?")
   private final handle hviewer;

   /** Data member */
   @LegacyField(fieldId = 3, name = "cwidgetname")
   private final character cwidgetname;

   /** Data member */
   @LegacyField(fieldId = 4, name = "cwidgettype")
   private final character cwidgettype;

   /** Data member */
   @LegacyField(fieldId = 5, name = "cforeach")
   private final character cforeach;

   /** Data member */
   @LegacyField(fieldId = 6, name = "cbufferlist")
   private final character cbufferlist;

   /** Data member */
   @LegacyField(fieldId = 7, name = "cphysicaltablenames")
   private final character cphysicaltablenames;

   /** Data member */
   @LegacyField(fieldId = 8, name = "ctemptablenames")
   private final character ctemptablenames;

   /** Data member */
   @LegacyField(fieldId = 9, name = "ckeyfieldname")
   private final character ckeyfieldname;

   /** Data member */
   @LegacyField(fieldId = 10, name = "ckeyformat")
   private final character ckeyformat;

   /** Data member */
   @LegacyField(fieldId = 11, name = "cdescfieldnames")
   private final character cdescfieldnames;

   /** Data member */
   @LegacyField(fieldId = 12, name = "cdescsubstitute")
   private final character cdescsubstitute;

   /** Data member */
   @LegacyField(fieldId = 13, name = "cflag")
   private final character cflag;

   /** Data member */
   @LegacyField(fieldId = 14, name = "cflagvalue")
   private final character cflagvalue;

   /** Data member */
   @LegacyField(fieldId = 15, name = "ccurrentkeyvalue")
   private final character ccurrentkeyvalue;

   /** Data member */
   @LegacyField(fieldId = 16, name = "clistitemdelimiter")
   private final character clistitemdelimiter;

   /** Data member */
   @LegacyField(fieldId = 17, name = "clistitempairs")
   private final character clistitempairs;

   /** Data member */
   @LegacyField(fieldId = 18, name = "ccurrentdescvalue")
   private final character ccurrentdescvalue;

   /** Data member */
   @LegacyField(fieldId = 19, name = "ckeyvalues")
   private final character ckeyvalues;

   /** Data member */
   @LegacyField(fieldId = 20, name = "cdescriptionvalues")
   private final character cdescriptionvalues;

   /** Data member */
   @LegacyField(fieldId = 21, name = "cparentfield")
   private final character cparentfield;

   /** Data member */
   @LegacyField(fieldId = 22, name = "cparentfilterquery")
   private final character cparentfilterquery;

   /** Data member */
   @LegacyField(fieldId = 23, name = "ibuildsequence", initial = "0")
   private final integer ibuildsequence;

   /** Data member */
   @LegacyField(fieldId = 24, name = "lusecache", initial = "false")
   private final logical lusecache;

   /**
    * Default constructor.
    */
   public Ttdcombocopy_1_1Impl()
   {
      hwidget = new handle();
      hviewer = new handle();
      cwidgetname = new character("");
      cwidgettype = new character("");
      cforeach = new character("");
      cbufferlist = new character("");
      cphysicaltablenames = new character("");
      ctemptablenames = new character("");
      ckeyfieldname = new character("");
      ckeyformat = new character("");
      cdescfieldnames = new character("");
      cdescsubstitute = new character("");
      cflag = new character("");
      cflagvalue = new character("");
      ccurrentkeyvalue = new character("");
      clistitemdelimiter = new character("");
      clistitempairs = new character("");
      ccurrentdescvalue = new character("");
      ckeyvalues = new character("");
      cdescriptionvalues = new character("");
      cparentfield = new character("");
      cparentfilterquery = new character("");
      ibuildsequence = new integer(0);
      lusecache = new logical(false);
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Ttdcombocopy_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Ttdcombocopy_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Ttdcombocopy_1_1Impl from = (Ttdcombocopy_1_1Impl) old;
      setId(from.id);
      setHwidget(from.hwidget);
      setHviewer(from.hviewer);
      setCwidgetname(from.cwidgetname);
      setCwidgettype(from.cwidgettype);
      setCforeach(from.cforeach);
      setCbufferlist(from.cbufferlist);
      setCphysicaltablenames(from.cphysicaltablenames);
      setCtemptablenames(from.ctemptablenames);
      setCkeyfieldname(from.ckeyfieldname);
      setCkeyformat(from.ckeyformat);
      setCdescfieldnames(from.cdescfieldnames);
      setCdescsubstitute(from.cdescsubstitute);
      setCflag(from.cflag);
      setCflagvalue(from.cflagvalue);
      setCcurrentkeyvalue(from.ccurrentkeyvalue);
      setClistitemdelimiter(from.clistitemdelimiter);
      setClistitempairs(from.clistitempairs);
      setCcurrentdescvalue(from.ccurrentdescvalue);
      setCkeyvalues(from.ckeyvalues);
      setCdescriptionvalues(from.cdescriptionvalues);
      setCparentfield(from.cparentfield);
      setCparentfilterquery(from.cparentfilterquery);
      setIbuildsequence(from.ibuildsequence);
      setLusecache(from.lusecache);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: hwidget
    * 
    * @return  hwidget
    */
   public handle getHwidget()
   {
      return (new handle(hwidget));
   }

   /**
    * Setter: hwidget
    * 
    * @param   hwidget
    *          hwidget
    */
   public void setHwidget(handle hwidget)
   {
      this.hwidget.assign(hwidget, true);
   }

   /**
    * Getter: hviewer
    * 
    * @return  hviewer
    */
   public handle getHviewer()
   {
      return (new handle(hviewer));
   }

   /**
    * Setter: hviewer
    * 
    * @param   hviewer
    *          hviewer
    */
   public void setHviewer(handle hviewer)
   {
      this.hviewer.assign(hviewer, true);
   }

   /**
    * Getter: cwidgetname
    * 
    * @return  cwidgetname
    */
   public character getCwidgetname()
   {
      return (new character(cwidgetname));
   }

   /**
    * Setter: cwidgetname
    * 
    * @param   cwidgetname
    *          cwidgetname
    */
   public void setCwidgetname(Text cwidgetname)
   {
      this.cwidgetname.assign(cwidgetname, true);
   }

   /**
    * Getter: cwidgettype
    * 
    * @return  cwidgettype
    */
   public character getCwidgettype()
   {
      return (new character(cwidgettype));
   }

   /**
    * Setter: cwidgettype
    * 
    * @param   cwidgettype
    *          cwidgettype
    */
   public void setCwidgettype(Text cwidgettype)
   {
      this.cwidgettype.assign(cwidgettype, true);
   }

   /**
    * Getter: cforeach
    * 
    * @return  cforeach
    */
   public character getCforeach()
   {
      return (new character(cforeach));
   }

   /**
    * Setter: cforeach
    * 
    * @param   cforeach
    *          cforeach
    */
   public void setCforeach(Text cforeach)
   {
      this.cforeach.assign(cforeach, true);
   }

   /**
    * Getter: cbufferlist
    * 
    * @return  cbufferlist
    */
   public character getCbufferlist()
   {
      return (new character(cbufferlist));
   }

   /**
    * Setter: cbufferlist
    * 
    * @param   cbufferlist
    *          cbufferlist
    */
   public void setCbufferlist(Text cbufferlist)
   {
      this.cbufferlist.assign(cbufferlist, true);
   }

   /**
    * Getter: cphysicaltablenames
    * 
    * @return  cphysicaltablenames
    */
   public character getCphysicaltablenames()
   {
      return (new character(cphysicaltablenames));
   }

   /**
    * Setter: cphysicaltablenames
    * 
    * @param   cphysicaltablenames
    *          cphysicaltablenames
    */
   public void setCphysicaltablenames(Text cphysicaltablenames)
   {
      this.cphysicaltablenames.assign(cphysicaltablenames, true);
   }

   /**
    * Getter: ctemptablenames
    * 
    * @return  ctemptablenames
    */
   public character getCtemptablenames()
   {
      return (new character(ctemptablenames));
   }

   /**
    * Setter: ctemptablenames
    * 
    * @param   ctemptablenames
    *          ctemptablenames
    */
   public void setCtemptablenames(Text ctemptablenames)
   {
      this.ctemptablenames.assign(ctemptablenames, true);
   }

   /**
    * Getter: ckeyfieldname
    * 
    * @return  ckeyfieldname
    */
   public character getCkeyfieldname()
   {
      return (new character(ckeyfieldname));
   }

   /**
    * Setter: ckeyfieldname
    * 
    * @param   ckeyfieldname
    *          ckeyfieldname
    */
   public void setCkeyfieldname(Text ckeyfieldname)
   {
      this.ckeyfieldname.assign(ckeyfieldname, true);
   }

   /**
    * Getter: ckeyformat
    * 
    * @return  ckeyformat
    */
   public character getCkeyformat()
   {
      return (new character(ckeyformat));
   }

   /**
    * Setter: ckeyformat
    * 
    * @param   ckeyformat
    *          ckeyformat
    */
   public void setCkeyformat(Text ckeyformat)
   {
      this.ckeyformat.assign(ckeyformat, true);
   }

   /**
    * Getter: cdescfieldnames
    * 
    * @return  cdescfieldnames
    */
   public character getCdescfieldnames()
   {
      return (new character(cdescfieldnames));
   }

   /**
    * Setter: cdescfieldnames
    * 
    * @param   cdescfieldnames
    *          cdescfieldnames
    */
   public void setCdescfieldnames(Text cdescfieldnames)
   {
      this.cdescfieldnames.assign(cdescfieldnames, true);
   }

   /**
    * Getter: cdescsubstitute
    * 
    * @return  cdescsubstitute
    */
   public character getCdescsubstitute()
   {
      return (new character(cdescsubstitute));
   }

   /**
    * Setter: cdescsubstitute
    * 
    * @param   cdescsubstitute
    *          cdescsubstitute
    */
   public void setCdescsubstitute(Text cdescsubstitute)
   {
      this.cdescsubstitute.assign(cdescsubstitute, true);
   }

   /**
    * Getter: cflag
    * 
    * @return  cflag
    */
   public character getCflag()
   {
      return (new character(cflag));
   }

   /**
    * Setter: cflag
    * 
    * @param   cflag
    *          cflag
    */
   public void setCflag(Text cflag)
   {
      this.cflag.assign(cflag, true);
   }

   /**
    * Getter: cflagvalue
    * 
    * @return  cflagvalue
    */
   public character getCflagvalue()
   {
      return (new character(cflagvalue));
   }

   /**
    * Setter: cflagvalue
    * 
    * @param   cflagvalue
    *          cflagvalue
    */
   public void setCflagvalue(Text cflagvalue)
   {
      this.cflagvalue.assign(cflagvalue, true);
   }

   /**
    * Getter: ccurrentkeyvalue
    * 
    * @return  ccurrentkeyvalue
    */
   public character getCcurrentkeyvalue()
   {
      return (new character(ccurrentkeyvalue));
   }

   /**
    * Setter: ccurrentkeyvalue
    * 
    * @param   ccurrentkeyvalue
    *          ccurrentkeyvalue
    */
   public void setCcurrentkeyvalue(Text ccurrentkeyvalue)
   {
      this.ccurrentkeyvalue.assign(ccurrentkeyvalue, true);
   }

   /**
    * Getter: clistitemdelimiter
    * 
    * @return  clistitemdelimiter
    */
   public character getClistitemdelimiter()
   {
      return (new character(clistitemdelimiter));
   }

   /**
    * Setter: clistitemdelimiter
    * 
    * @param   clistitemdelimiter
    *          clistitemdelimiter
    */
   public void setClistitemdelimiter(Text clistitemdelimiter)
   {
      this.clistitemdelimiter.assign(clistitemdelimiter, true);
   }

   /**
    * Getter: clistitempairs
    * 
    * @return  clistitempairs
    */
   public character getClistitempairs()
   {
      return (new character(clistitempairs));
   }

   /**
    * Setter: clistitempairs
    * 
    * @param   clistitempairs
    *          clistitempairs
    */
   public void setClistitempairs(Text clistitempairs)
   {
      this.clistitempairs.assign(clistitempairs, true);
   }

   /**
    * Getter: ccurrentdescvalue
    * 
    * @return  ccurrentdescvalue
    */
   public character getCcurrentdescvalue()
   {
      return (new character(ccurrentdescvalue));
   }

   /**
    * Setter: ccurrentdescvalue
    * 
    * @param   ccurrentdescvalue
    *          ccurrentdescvalue
    */
   public void setCcurrentdescvalue(Text ccurrentdescvalue)
   {
      this.ccurrentdescvalue.assign(ccurrentdescvalue, true);
   }

   /**
    * Getter: ckeyvalues
    * 
    * @return  ckeyvalues
    */
   public character getCkeyvalues()
   {
      return (new character(ckeyvalues));
   }

   /**
    * Setter: ckeyvalues
    * 
    * @param   ckeyvalues
    *          ckeyvalues
    */
   public void setCkeyvalues(Text ckeyvalues)
   {
      this.ckeyvalues.assign(ckeyvalues, true);
   }

   /**
    * Getter: cdescriptionvalues
    * 
    * @return  cdescriptionvalues
    */
   public character getCdescriptionvalues()
   {
      return (new character(cdescriptionvalues));
   }

   /**
    * Setter: cdescriptionvalues
    * 
    * @param   cdescriptionvalues
    *          cdescriptionvalues
    */
   public void setCdescriptionvalues(Text cdescriptionvalues)
   {
      this.cdescriptionvalues.assign(cdescriptionvalues, true);
   }

   /**
    * Getter: cparentfield
    * 
    * @return  cparentfield
    */
   public character getCparentfield()
   {
      return (new character(cparentfield));
   }

   /**
    * Setter: cparentfield
    * 
    * @param   cparentfield
    *          cparentfield
    */
   public void setCparentfield(Text cparentfield)
   {
      this.cparentfield.assign(cparentfield, true);
   }

   /**
    * Getter: cparentfilterquery
    * 
    * @return  cparentfilterquery
    */
   public character getCparentfilterquery()
   {
      return (new character(cparentfilterquery));
   }

   /**
    * Setter: cparentfilterquery
    * 
    * @param   cparentfilterquery
    *          cparentfilterquery
    */
   public void setCparentfilterquery(Text cparentfilterquery)
   {
      this.cparentfilterquery.assign(cparentfilterquery, true);
   }

   /**
    * Getter: ibuildsequence
    * 
    * @return  ibuildsequence
    */
   public integer getIbuildsequence()
   {
      return (new integer(ibuildsequence));
   }

   /**
    * Setter: ibuildsequence
    * 
    * @param   ibuildsequence
    *          ibuildsequence
    */
   public void setIbuildsequence(NumberType ibuildsequence)
   {
      this.ibuildsequence.assign(ibuildsequence, true);
   }

   /**
    * Getter: lusecache
    * 
    * @return  lusecache
    */
   public logical isLusecache()
   {
      return (new logical(lusecache));
   }

   /**
    * Setter: lusecache
    * 
    * @param   lusecache
    *          lusecache
    */
   public void setLusecache(logical lusecache)
   {
      this.lusecache.assign(lusecache, true);
   }
}
