package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "ttschema", table = "tt3")
@LegacyIndexes(
{
   @LegacyIndex(name = "primidx", converted = "tt3_primidx", primary = true, unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "sdo_name"),
      @LegacyIndexComponent(fieldName = "column_sequence")
   }),
   @LegacyIndex(name = "key2", converted = "tt3_key2", components = 
   {
      @LegacyIndexComponent(fieldName = "column_sequence")
   }),
   @LegacyIndex(name = "key3", converted = "tt3_key3", components = 
   {
      @LegacyIndexComponent(fieldName = "column_name")
   }),
   @LegacyIndex(name = "key4", converted = "tt3_key4", components = 
   {
      @LegacyIndexComponent(fieldName = "calculated_field")
   }),
   @LegacyIndex(name = "idx_handle", converted = "tt3_idx_handle", components = 
   {
      @LegacyIndexComponent(fieldName = "sdo_handle")
   })
})
public class Ttschema_1_1Impl
implements Serializable,
           Persistable,
           Ttschema_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "sdo_name")
   private final character sdoName;

   /** Data member */
   @LegacyField(fieldId = 2, name = "column_sequence", initial = "0")
   private final integer columnSequence;

   /** Data member */
   @LegacyField(fieldId = 3, name = "column_name")
   private final character columnName;

   /** Data member */
   @LegacyField(fieldId = 4, name = "database_name")
   private final character databaseName;

   /** Data member */
   @LegacyField(fieldId = 5, name = "table_name")
   private final character tableName;

   /** Data member */
   @LegacyField(fieldId = 6, name = "table_sequence", initial = "0")
   private final integer tableSequence;

   /** Data member */
   @LegacyField(fieldId = 7, name = "table_label")
   private final character tableLabel;

   /** Data member */
   @LegacyField(fieldId = 8, name = "field_name")
   private final character fieldName;

   /** Data member */
   @LegacyField(fieldId = 9, name = "column_datatype")
   private final character columnDatatype;

   /** Data member */
   @LegacyField(fieldId = 10, name = "column_updatable", initial = "false")
   private final logical columnUpdatable;

   /** Data member */
   @LegacyField(fieldId = 11, name = "column_indexed", initial = "false")
   private final logical columnIndexed;

   /** Data member */
   @LegacyField(fieldId = 12, name = "column_case_sensitive", initial = "false")
   private final logical columnCaseSensitive;

   /** Data member */
   @LegacyField(fieldId = 13, name = "column_format")
   private final character columnFormat;

   /** Data member */
   @LegacyField(fieldId = 14, name = "column_label")
   private final character columnLabel;

   /** Data member */
   @LegacyField(fieldId = 15, name = "column_mandatory", initial = "false")
   private final logical columnMandatory;

   /** Data member */
   @LegacyField(fieldId = 16, name = "column_width_chars", initial = "0")
   private final decimal columnWidthChars;

   /** Data member */
   @LegacyField(fieldId = 17, name = "index_position")
   private final character indexPosition;

   /** Data member */
   @LegacyField(fieldId = 18, name = "adm_column", initial = "false")
   private final logical admColumn;

   /** Data member */
   @LegacyField(fieldId = 19, name = "word_index", initial = "false")
   private final logical wordIndex;

   /** Data member */
   @LegacyField(fieldId = 20, name = "search_from")
   private final character searchFrom;

   /** Data member */
   @LegacyField(fieldId = 21, name = "search_to")
   private final character searchTo;

   /** Data member */
   @LegacyField(fieldId = 22, name = "search_contains")
   private final character searchContains;

   /** Data member */
   @LegacyField(fieldId = 23, name = "search_matches")
   private final character searchMatches;

   /** Data member */
   @LegacyField(fieldId = 24, name = "calculated_field", initial = "false")
   private final logical calculatedField;

   /** Data member */
   @LegacyField(fieldId = 25, name = "sdo_handle", initial = "?")
   private final handle sdoHandle;

   /** Data member */
   @LegacyField(fieldId = 26, name = "sdo_order", initial = "0")
   private final integer sdoOrder;

   /**
    * Default constructor.
    */
   public Ttschema_1_1Impl()
   {
      sdoName = new character("");
      columnSequence = new integer(0);
      columnName = new character("");
      databaseName = new character("");
      tableName = new character("");
      tableSequence = new integer(0);
      tableLabel = new character("");
      fieldName = new character("");
      columnDatatype = new character("");
      columnUpdatable = new logical(false);
      columnIndexed = new logical(false);
      columnCaseSensitive = new logical(false);
      columnFormat = new character("");
      columnLabel = new character("");
      columnMandatory = new logical(false);
      columnWidthChars = new decimal(0);
      indexPosition = new character("");
      admColumn = new logical(false);
      wordIndex = new logical(false);
      searchFrom = new character("");
      searchTo = new character("");
      searchContains = new character("");
      searchMatches = new character("");
      calculatedField = new logical(false);
      sdoHandle = new handle();
      sdoOrder = new integer(0);
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Ttschema_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Ttschema_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Ttschema_1_1Impl from = (Ttschema_1_1Impl) old;
      setId(from.id);
      setSdoName(from.sdoName);
      setColumnSequence(from.columnSequence);
      setColumnName(from.columnName);
      setDatabaseName(from.databaseName);
      setTableName(from.tableName);
      setTableSequence(from.tableSequence);
      setTableLabel(from.tableLabel);
      setFieldName(from.fieldName);
      setColumnDatatype(from.columnDatatype);
      setColumnUpdatable(from.columnUpdatable);
      setColumnIndexed(from.columnIndexed);
      setColumnCaseSensitive(from.columnCaseSensitive);
      setColumnFormat(from.columnFormat);
      setColumnLabel(from.columnLabel);
      setColumnMandatory(from.columnMandatory);
      setColumnWidthChars(from.columnWidthChars);
      setIndexPosition(from.indexPosition);
      setAdmColumn(from.admColumn);
      setWordIndex(from.wordIndex);
      setSearchFrom(from.searchFrom);
      setSearchTo(from.searchTo);
      setSearchContains(from.searchContains);
      setSearchMatches(from.searchMatches);
      setCalculatedField(from.calculatedField);
      setSdoHandle(from.sdoHandle);
      setSdoOrder(from.sdoOrder);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: sdoName
    * 
    * @return  sdoName
    */
   public character getSdoName()
   {
      return (new character(sdoName));
   }

   /**
    * Setter: sdoName
    * 
    * @param   sdoName
    *          sdoName
    */
   public void setSdoName(Text sdoName)
   {
      this.sdoName.assign(sdoName, true);
   }

   /**
    * Getter: columnSequence
    * 
    * @return  columnSequence
    */
   public integer getColumnSequence()
   {
      return (new integer(columnSequence));
   }

   /**
    * Setter: columnSequence
    * 
    * @param   columnSequence
    *          columnSequence
    */
   public void setColumnSequence(NumberType columnSequence)
   {
      this.columnSequence.assign(columnSequence, true);
   }

   /**
    * Getter: columnName
    * 
    * @return  columnName
    */
   public character getColumnName()
   {
      return (new character(columnName));
   }

   /**
    * Setter: columnName
    * 
    * @param   columnName
    *          columnName
    */
   public void setColumnName(Text columnName)
   {
      this.columnName.assign(columnName, true);
   }

   /**
    * Getter: databaseName
    * 
    * @return  databaseName
    */
   public character getDatabaseName()
   {
      return (new character(databaseName));
   }

   /**
    * Setter: databaseName
    * 
    * @param   databaseName
    *          databaseName
    */
   public void setDatabaseName(Text databaseName)
   {
      this.databaseName.assign(databaseName, true);
   }

   /**
    * Getter: tableName
    * 
    * @return  tableName
    */
   public character getTableName()
   {
      return (new character(tableName));
   }

   /**
    * Setter: tableName
    * 
    * @param   tableName
    *          tableName
    */
   public void setTableName(Text tableName)
   {
      this.tableName.assign(tableName, true);
   }

   /**
    * Getter: tableSequence
    * 
    * @return  tableSequence
    */
   public integer getTableSequence()
   {
      return (new integer(tableSequence));
   }

   /**
    * Setter: tableSequence
    * 
    * @param   tableSequence
    *          tableSequence
    */
   public void setTableSequence(NumberType tableSequence)
   {
      this.tableSequence.assign(tableSequence, true);
   }

   /**
    * Getter: tableLabel
    * 
    * @return  tableLabel
    */
   public character getTableLabel()
   {
      return (new character(tableLabel));
   }

   /**
    * Setter: tableLabel
    * 
    * @param   tableLabel
    *          tableLabel
    */
   public void setTableLabel(Text tableLabel)
   {
      this.tableLabel.assign(tableLabel, true);
   }

   /**
    * Getter: fieldName
    * 
    * @return  fieldName
    */
   public character getFieldName()
   {
      return (new character(fieldName));
   }

   /**
    * Setter: fieldName
    * 
    * @param   fieldName
    *          fieldName
    */
   public void setFieldName(Text fieldName)
   {
      this.fieldName.assign(fieldName, true);
   }

   /**
    * Getter: columnDatatype
    * 
    * @return  columnDatatype
    */
   public character getColumnDatatype()
   {
      return (new character(columnDatatype));
   }

   /**
    * Setter: columnDatatype
    * 
    * @param   columnDatatype
    *          columnDatatype
    */
   public void setColumnDatatype(Text columnDatatype)
   {
      this.columnDatatype.assign(columnDatatype, true);
   }

   /**
    * Getter: columnUpdatable
    * 
    * @return  columnUpdatable
    */
   public logical isColumnUpdatable()
   {
      return (new logical(columnUpdatable));
   }

   /**
    * Setter: columnUpdatable
    * 
    * @param   columnUpdatable
    *          columnUpdatable
    */
   public void setColumnUpdatable(logical columnUpdatable)
   {
      this.columnUpdatable.assign(columnUpdatable, true);
   }

   /**
    * Getter: columnIndexed
    * 
    * @return  columnIndexed
    */
   public logical isColumnIndexed()
   {
      return (new logical(columnIndexed));
   }

   /**
    * Setter: columnIndexed
    * 
    * @param   columnIndexed
    *          columnIndexed
    */
   public void setColumnIndexed(logical columnIndexed)
   {
      this.columnIndexed.assign(columnIndexed, true);
   }

   /**
    * Getter: columnCaseSensitive
    * 
    * @return  columnCaseSensitive
    */
   public logical isColumnCaseSensitive()
   {
      return (new logical(columnCaseSensitive));
   }

   /**
    * Setter: columnCaseSensitive
    * 
    * @param   columnCaseSensitive
    *          columnCaseSensitive
    */
   public void setColumnCaseSensitive(logical columnCaseSensitive)
   {
      this.columnCaseSensitive.assign(columnCaseSensitive, true);
   }

   /**
    * Getter: columnFormat
    * 
    * @return  columnFormat
    */
   public character getColumnFormat()
   {
      return (new character(columnFormat));
   }

   /**
    * Setter: columnFormat
    * 
    * @param   columnFormat
    *          columnFormat
    */
   public void setColumnFormat(Text columnFormat)
   {
      this.columnFormat.assign(columnFormat, true);
   }

   /**
    * Getter: columnLabel
    * 
    * @return  columnLabel
    */
   public character getColumnLabel()
   {
      return (new character(columnLabel));
   }

   /**
    * Setter: columnLabel
    * 
    * @param   columnLabel
    *          columnLabel
    */
   public void setColumnLabel(Text columnLabel)
   {
      this.columnLabel.assign(columnLabel, true);
   }

   /**
    * Getter: columnMandatory
    * 
    * @return  columnMandatory
    */
   public logical isColumnMandatory()
   {
      return (new logical(columnMandatory));
   }

   /**
    * Setter: columnMandatory
    * 
    * @param   columnMandatory
    *          columnMandatory
    */
   public void setColumnMandatory(logical columnMandatory)
   {
      this.columnMandatory.assign(columnMandatory, true);
   }

   /**
    * Getter: columnWidthChars
    * 
    * @return  columnWidthChars
    */
   public decimal getColumnWidthChars()
   {
      return (new decimal(columnWidthChars));
   }

   /**
    * Setter: columnWidthChars
    * 
    * @param   columnWidthChars
    *          columnWidthChars
    */
   public void setColumnWidthChars(NumberType columnWidthChars)
   {
      this.columnWidthChars.assign(columnWidthChars, true);
   }

   /**
    * Getter: indexPosition
    * 
    * @return  indexPosition
    */
   public character getIndexPosition()
   {
      return (new character(indexPosition));
   }

   /**
    * Setter: indexPosition
    * 
    * @param   indexPosition
    *          indexPosition
    */
   public void setIndexPosition(Text indexPosition)
   {
      this.indexPosition.assign(indexPosition, true);
   }

   /**
    * Getter: admColumn
    * 
    * @return  admColumn
    */
   public logical isAdmColumn()
   {
      return (new logical(admColumn));
   }

   /**
    * Setter: admColumn
    * 
    * @param   admColumn
    *          admColumn
    */
   public void setAdmColumn(logical admColumn)
   {
      this.admColumn.assign(admColumn, true);
   }

   /**
    * Getter: wordIndex
    * 
    * @return  wordIndex
    */
   public logical isWordIndex()
   {
      return (new logical(wordIndex));
   }

   /**
    * Setter: wordIndex
    * 
    * @param   wordIndex
    *          wordIndex
    */
   public void setWordIndex(logical wordIndex)
   {
      this.wordIndex.assign(wordIndex, true);
   }

   /**
    * Getter: searchFrom
    * 
    * @return  searchFrom
    */
   public character getSearchFrom()
   {
      return (new character(searchFrom));
   }

   /**
    * Setter: searchFrom
    * 
    * @param   searchFrom
    *          searchFrom
    */
   public void setSearchFrom(Text searchFrom)
   {
      this.searchFrom.assign(searchFrom, true);
   }

   /**
    * Getter: searchTo
    * 
    * @return  searchTo
    */
   public character getSearchTo()
   {
      return (new character(searchTo));
   }

   /**
    * Setter: searchTo
    * 
    * @param   searchTo
    *          searchTo
    */
   public void setSearchTo(Text searchTo)
   {
      this.searchTo.assign(searchTo, true);
   }

   /**
    * Getter: searchContains
    * 
    * @return  searchContains
    */
   public character getSearchContains()
   {
      return (new character(searchContains));
   }

   /**
    * Setter: searchContains
    * 
    * @param   searchContains
    *          searchContains
    */
   public void setSearchContains(Text searchContains)
   {
      this.searchContains.assign(searchContains, true);
   }

   /**
    * Getter: searchMatches
    * 
    * @return  searchMatches
    */
   public character getSearchMatches()
   {
      return (new character(searchMatches));
   }

   /**
    * Setter: searchMatches
    * 
    * @param   searchMatches
    *          searchMatches
    */
   public void setSearchMatches(Text searchMatches)
   {
      this.searchMatches.assign(searchMatches, true);
   }

   /**
    * Getter: calculatedField
    * 
    * @return  calculatedField
    */
   public logical isCalculatedField()
   {
      return (new logical(calculatedField));
   }

   /**
    * Setter: calculatedField
    * 
    * @param   calculatedField
    *          calculatedField
    */
   public void setCalculatedField(logical calculatedField)
   {
      this.calculatedField.assign(calculatedField, true);
   }

   /**
    * Getter: sdoHandle
    * 
    * @return  sdoHandle
    */
   public handle getSdoHandle()
   {
      return (new handle(sdoHandle));
   }

   /**
    * Setter: sdoHandle
    * 
    * @param   sdoHandle
    *          sdoHandle
    */
   public void setSdoHandle(handle sdoHandle)
   {
      this.sdoHandle.assign(sdoHandle, true);
   }

   /**
    * Getter: sdoOrder
    * 
    * @return  sdoOrder
    */
   public integer getSdoOrder()
   {
      return (new integer(sdoOrder));
   }

   /**
    * Setter: sdoOrder
    * 
    * @param   sdoOrder
    *          sdoOrder
    */
   public void setSdoOrder(NumberType sdoOrder)
   {
      this.sdoOrder.assign(sdoOrder, true);
   }
}
