package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "tttable", table = "tt4")
@LegacyIndexes(
{
   @LegacyIndex(name = "mainidx", converted = "tt4_mainidx", primary = true, unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "irow"),
      @LegacyIndexComponent(fieldName = "icol")
   })
})
public class Tttable_1_1Impl
implements Serializable,
           Persistable,
           Tttable_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "irow", initial = "0")
   private final integer irow;

   /** Data member */
   @LegacyField(fieldId = 2, name = "icol", initial = "0")
   private final integer icol;

   /** Data member */
   @LegacyField(fieldId = 3, name = "ccell")
   private final character ccell;

   /**
    * Default constructor.
    */
   public Tttable_1_1Impl()
   {
      irow = new integer(0);
      icol = new integer(0);
      ccell = new character("");
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Tttable_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Tttable_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Tttable_1_1Impl from = (Tttable_1_1Impl) old;
      setId(from.id);
      setIrow(from.irow);
      setIcol(from.icol);
      setCcell(from.ccell);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: irow
    * 
    * @return  irow
    */
   public integer getIrow()
   {
      return (new integer(irow));
   }

   /**
    * Setter: irow
    * 
    * @param   irow
    *          irow
    */
   public void setIrow(NumberType irow)
   {
      this.irow.assign(irow, true);
   }

   /**
    * Getter: icol
    * 
    * @return  icol
    */
   public integer getIcol()
   {
      return (new integer(icol));
   }

   /**
    * Setter: icol
    * 
    * @param   icol
    *          icol
    */
   public void setIcol(NumberType icol)
   {
      this.icol.assign(icol, true);
   }

   /**
    * Getter: ccell
    * 
    * @return  ccell
    */
   public character getCcell()
   {
      return (new character(ccell));
   }

   /**
    * Setter: ccell
    * 
    * @param   ccell
    *          ccell
    */
   public void setCcell(Text ccell)
   {
      this.ccell.assign(ccell, true);
   }
}
