package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.service_type</code> (previously
 * <code>hotel.service-type</code>).
 * <p>
 * Additional service types
 */
public interface ServiceType
extends DataModelObject
{
   /**
    * Getter: Service Type
    * 
    * @return  Service Type
    */
   public integer getServiceType();

   /**
    * Setter: Service Type
    * 
    * @param   serviceType
    *          Service Type
    */
   public void setServiceType(NumberType serviceType);

   /**
    * Getter: Description
    * 
    * @return  Description
    */
   public character getDescription();

   /**
    * Setter: Description
    * 
    * @param   description
    *          Description
    */
   public void setDescription(Text description);

   /**
    * Getter: Default Charge Amount
    * 
    * @return  Default Charge Amount
    */
   public decimal getDefaultAmount();

   /**
    * Setter: Default Charge Amount
    * 
    * @param   defaultAmount
    *          Default Charge Amount
    */
   public void setDefaultAmount(NumberType defaultAmount);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends ServiceType, Buffer
   {
   }
}
