/*--------------------------------------------------------------------------
    File        : Datavis.java
    Purpose     : Super procedure for PDO Data Visualization objects

    Syntax      : adm2/datavis.p

    Modified    : July 21, 2000 -- Version 9.1B
  ------------------------------------------------------------------------*/

package com.goldencode.hotel.common.adm2;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.util.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/adm2/datavis.p).
 */
public class Datavis
{
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Tell dvisattr.i that this is the Super procedure. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : datavisexclcustom.i
       Purpose     : Defines EXCLUDE-xxx preprocessor variables to exclude
                     functions or internal procedures in the super procedure
                     where it is referenced.
       Syntax      : {src/adm2/custom/datavisexclcustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in src/adm2/datavis.p
     ------------------------------------------------------------------------*/   
   /* This variable is needed at least temporarily in 9.1B so that a called
      fn can tell who the actual source was. */   
   handle ghTargetProcedure = TypeFactory.handle();

   /* _UIB-CODE-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Procedure
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: CODE-ONLY COMPILE
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Procedure ASSIGN
            HEIGHT             = 19.52
            WIDTH              = 56.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ************************* Included-Libraries *********************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : dvisprop.i
       Purpose     : Property Include file for Data Visualization Objects 
   
       Syntax      : src\adm2\dvisprop.i
   
       Description :
   
       Modified    : May 26, 2000 -- Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : datavisdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/datavisdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/dvisprop.i}
     ------------------------------------------------------------------------*/   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 8
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* These preprocessors tell at compile time which properties can be
        retrieved directly from the property temp-table. */   
   /* Include the next property file up the chain; we will add our field
        definitions to its list. As of 9.1A, if this visual object is also
        a SmartContainer, we include container properties as well. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : visprop.i
       Purpose     : Starts Super procedure visual.p and defines basic properties
                     for visual SmartObjects in V9
       Syntax      : {src/adm2/visprop.i}
   
       Description :
   
       Modified    : May 19, 1999 Version 9.1A
       Modified    : 10/23/2001          Mark Davies (MIP)
                     Added two new fields for ResizeHorizontal and ResizeVertical
       Modified    : 11/02/2001          Mark Davies (MIP)
                     Replaced properties for FrameMinHeightChars and FrameMinWidthChars with MinHeight and MinWidth
       Modified    : 11/14/2001          Mark Davies (MIP)
                     Renamed property 'DisplayFieldsSecurity' to 'FieldSecurity'
       Modified    : 02/27/2003          Neil Bell (MIP)
                     Added property 'SecuredTokens'                  
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : visualdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/visualdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/visprop.i}
     ------------------------------------------------------------------------*/   
   /* This is the procedure to execute to set InstanceProperties at design time. */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 8
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* These preprocessors tell at compile time which properties can be
        retrieved directly from the temp-table. */   
   /* This property contains the security for all objects found in the AllFieldHandles Property */    
   /* Include the next property file up the chain (in this case, the top
        of the chain); it starts the property temp-table definition and we
        add our field definitions to it. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver /* quick access to all handles on object, e.g. viewer, whether enabled or not */  /* quick access to all fields on object, e.g. viewer, whether enabled or not */ = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/adm2/datavis.p).
    */
   public void execute()
   {
      externalProcedure(Datavis.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         /* _UIB-CODE-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 14.86
                  WIDTH              = 57.2.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Include the file which defines prototypes for all of the super
              procedure's entry points. Also, start or attach to the super procedure.
              Skip start-super-proc if we *are* the super procedure. 
              And skip including the prototypes if we are *any* super procedure. */
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         /* else if appserver aware (adecomm/appserv.i) include appserver props */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         cType.assign("SUPER");
         returnNormal(cType);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     General code for Add operation.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Invoked when the Add button is pressed on an Update SmartPanel<br>
    *              or a SmartToolbar.<br>
    *              No Add operation can be done while there are updates in <br>
    *              progress, if so the user receives a message that current values<br>
    *              must be saved or cancelled before Add.<br>
    *              Sets NewRecord property to 'Add'.<br>
    *              PUBLISHes updateState 'Update' to tell Tableio source and <br>
    *              Update target that update is in progress.
    */
   public void addRecord()
   {
      character cTarget = TypeFactory.character();
      handle hGroupSource = TypeFactory.handle();
      logical lMod = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         hGroupSource.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         
         if (_and(isEqual(cTarget, ""), () -> isUnknown(hGroupSource)))
         {
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 62));
            returnNormal("ADM-ERROR");
         }
         
         /* Reject the Add attempt if the current values have been modified
              and not saved. */
         /* {get Prop var [handle]} */ 
         lMod.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
         
         if ((lMod).booleanValue())
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", "2");
            /* "Current values must be saved or cancelled before Add or Copy." */
            returnNormal("ADM-ERROR");
         }
         
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setNewRecord", targetProcedure(), "I", "Add");
         /* If for some reason this object's fields have not been enabled from
              outside, then do it here. */
         ControlFlowOps.invokeIn("enableFields", targetProcedure());
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose: Passes an cancel request to its container    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:  The convention is that the standard routine always<br>
    *         passes an cancel,ok or exit request to its CONTAINER-SOURCE. <br>
    *         The container that is actually able to initiate the cancel <br>
    *         should override this andnot* call SUPER.
    */
   public void cancelObject()
   {
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("cancelObject", targetProcedure());
         /* NOTE: MUST go to Container-Source */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     General code to cancel the update or add of the current row.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Invoked when the Cancel button is pressed on an Update SmartPanel<br>
    *              or on a SmartToolbar.<br>
    *              Invokes cancelRow() in the Update target.
    */
   public void cancelRecord()
   {
      handle hGroupSource = TypeFactory.handle();
      character cErrors = TypeFactory.character();
      handle hUpdateTarget = TypeFactory.handle();
      character cNew = TypeFactory.character();
      character cState = TypeFactory.character();
      logical lModified = TypeFactory.logical();
      character cRowIdent = TypeFactory.character();
      character cTarget = TypeFactory.character();
      logical lFound = TypeFactory.logical();
      logical lSaveSource = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         hGroupSource.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cNew.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", targetProcedure()));
         hUpdateTarget.assign(handle.fromString(cTarget));
         
         /* Ensure the rowobject record in the SDO is pointing at the correct one, 
              before we start cancelling */
         if ((hUpdateTarget.isValid()).booleanValue())
         {
            /* {get Prop var [handle]} */ 
            cRowIdent.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", targetProcedure()));
            lFound /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "repositionRowObject", hUpdateTarget, "I", cRowIdent));
            
            if (_not(isEqual(lFound, true)))
            {
               returnError(ControlFlowOps.getReturnValue());
            }
         }
         
         /* Note that for a GroupAssign-Target the UpdateTarget will not be
              present, so we will skip this step; it's done only in the Source. */
         if ((hUpdateTarget.isValid()).booleanValue())
         {
            ghTargetProcedure.assign(targetProcedure());
            cErrors.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "cancelRow", hUpdateTarget));
            ghTargetProcedure.setUnknown();
         }
         else
         {
            if (_isUnknown(hGroupSource))
            {
               cErrors.assign("No UpdateTarget present for Cancel operation.");
            }
         }
         /* END ELSE DO (No Update Target) */
         /* DataAvailable avoids display when newRecord <> 'no', so we set it to 'no'
              AFTER the call to the UpdateTarget that publishes DataAvailable 
              and always display here instead  */
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setNewRecord", targetProcedure(), "I", "No");
         /* Note: this is character 'no', not logical*/
         ControlFlowOps.invokeIn("displayRecord", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
         lSaveSource.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(lSaveSource, false))
         {
            ControlFlowOps.invokeInWithMode("updateMode", targetProcedure(), "I", new character("updateEnd"));
         }
         
         /* Ensure that GroupAssign-targets Modified flag is set to FALSE 
              BEFORE setDataModified as it publishes UpdateActive up the container 
              link, and each container checks all targets before republishing  */
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignLinkProperty", targetProcedure(), "III", "GroupAssign-Target", "DataModified", "no");
         /* NOTE: set DataModifed/updateState must happen AFTER cancelRow() because 
              at the end of the events (depending of the toolbar mode) updatestate may 
              fire back from the toolbar to disable and if this is a viewer the focus 
              will be set to the browse and if 'add' or 'copy' the previous record will 
              become available. When this was done BEFORE cancelRow the 'add' or 'copy'
              would not be undone and these rowObject records would cause error messages
              with the next save */
         /* {get Prop var [handle]} */ 
         lModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
         
         if (_not(lModified))
         {
            NamedEventManager.publish("updateState", targetProcedure(), "I", new Object[]
            {
               "updateComplete"
            });
         }
         else
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataModified", targetProcedure(), "I", false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RecordState"));
         cState.assign(ghProp.unwrapBufferField().value());
         
         if (_and(isEqual(cState, "NoRecordAvailable"), () -> isNotEqual(cNew, "No")))
         {
 /* Could be Add or Copy or No */
            ControlFlowOps.invokeInWithMode("disableFields", targetProcedure(), "I", new character("All"));
         }
         
         if ((hUpdateTarget.isValid()).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("applyEntry", targetProcedure(), "I", new unknown());
         }
         
         /* NOTE: Disabling only create fields is not yet supported
              RUN disableFields IN TARGET-PROCEDURE ("Create":U).
            */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Collects changed field values.<br>
    *              Executed and PUBLISHed from updateRecord to collect up changed <br>
    *              field values from GroupAssign targets.<br>
    * Parameters:  INPUT-OUTPUT pcChanges  delimited list of<br>
    *                fieldName CHR(1) newValue CHR(1) ...;<br>
    *              INPUT-OUTPUT pcInfo  delimited list of information<br>
    *                for the caller to use to determine where the changes came from<br>
    *                and how to direct error messages. Each object which adds<br>
    *                any changes to the Changes list adds three comma-separated<br>
    *                items to the Info list: the number of fields changed in<br>
    *                this object, its page number, and its handle.
    */
   public void collectChanges(final character pcChanges, final character pcInfo)
   {
      character cChange = TypeFactory.character();
      character cFieldHandles = TypeFactory.character();
      character cFieldNames = TypeFactory.character();
      integer iCnt = TypeFactory.integer();
      integer iChanges = TypeFactory.integer((long) 0);
      handle hFrameField = TypeFactory.handle();
      integer iPage = TypeFactory.integer();
      logical lMod = TypeFactory.logical();
      character cNew = TypeFactory.character();
      character cEnabledFields = TypeFactory.character();
      character cField = TypeFactory.character();
      character cValue = TypeFactory.character();
      handle hUpdateTarget = TypeFactory.handle();
      character cUpdateNames = TypeFactory.character();
      logical lError = TypeFactory.logical();
      character cMessage = TypeFactory.character();
      character cObjectType = TypeFactory.character();
      character cModifyFields = TypeFactory.character();
      character cCheckFields = TypeFactory.character();
      character cUpdatable = TypeFactory.character();
      /* Used to check field security on editors */
      character cAllFieldHandles = TypeFactory.character();
      character cFieldSecurity = TypeFactory.character();
      integer iFieldPos = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FieldHandles"));
         cFieldHandles.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedFields"));
         cFieldNames.assign(ghProp.unwrapBufferField().value());
         /* In an add or copy situation, we assume that all enabled fields have been 
              changed, regardless of their modified status, to ensure they have a valid 
              value, and that any errors from validation procedures can return back to 
              the field in error. */
         /* {get Prop var [handle]} */ 
         cNew.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("EnabledFields"));
         cEnabledFields.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
         cObjectType.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ModifyFields"));
         cModifyFields.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTargetNames"));
         cUpdateNames.assign(ghProp.unwrapBufferField().value());
         
         /* CollectChanges according to ModifyFields */
         if (_isEqual(cModifyFields, "(Updatable)"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
            hUpdateTarget.assign(ghProp.unwrapBufferField().value());
            
            if ((hUpdateTarget.isValid()).booleanValue())
            {
               /* {get Prop var [handle]} */
               cUpdatable.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdatableColumns", hUpdateTarget));
            }
         }
         else
         {
            if (_and(isNotEqual(cModifyFields, "(All)"), () -> isNotEqual(cModifyFields, "(EnabledFields)")))
            {
               cCheckFields.assign(cModifyFields);
            }
         }
         
         IntegerExpression resExpr0 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cFieldHandles);
            }
         };
         ToClause toClause0 = new ToClause(iCnt, 1, resExpr0);
         
         doTo("loopLabel0", toClause0, new Block((Body) () -> 
         {
            hFrameField.assign(handle.fromString(entry(iCnt, cFieldHandles)));
            cField.assign(entry(iCnt, cFieldNames));
            
            /* set above if ModifyFields specifies a field list */
            if (_and(isGreaterThan(cCheckFields, ""), () -> isEqual(lookup(cField, cCheckFields), 0)))
            {
               next("loopLabel0");
            }
            
            /* Qualify the fields if not qualified AND UpdateTargetNames has exacly */
            /* one entry. The reason is that if it had more entries then the viewer */
            /* has been created against a SBO, so the fields should be already qualified. */
            /* On the other hand, if UpdateTargetNames is empty then our DataTarget */
            /* is NOT an SBO, so no qualification is needed */
            if (_isNotEqual(cObjectType, "SmartDataBrowser"))
            {
 /* older dyn browsers may have set this property */
               if (_and(isEqual(numEntries(cField, "."), 1), () -> isEqual(numEntries(cUpdateNames), 1)))
               {
                  cField.assign(concat(cUpdateNames, ".", cField));
               }
            }
            
            /* set above if ModifyFields is '(updatable)' */
            if (_and(isGreaterThan(cUpdatable, ""), () -> isEqual(lookup(cField, cUpdatable), 0)))
            {
               next("loopLabel0");
            }
            
            /* The MODIFIED attribute of EDITOR widgets is NOT set when their 
                   SCREEN-VALUE is modified thru the 4GL, so we need to do more work. 
                   Note that we could always commit EDITORs that are in the EnabledFields 
                   list but.. I think it's cleaner to check first.. */
            if (_and(and(isEqual(hFrameField.unwrapType().getResourceType(), "EDITOR"), () -> isEqual(hFrameField.unwrapWidget().isModified(), false)), () -> matchesList(cEnabledFields, cField)))
            thenBlk:
            {
               /* If this editor has been disabled by field security, its SCREEN-VALUE won't have been set.     *
                      * If this is the case, we don't want to set its MODIFIED property to YES, because we don't want *
                      * to assign a blank SCREEN-VALUE back to the database.                                          */
               if (_isEqual(cAllFieldHandles, ""))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("allFieldHandles"));
                  cAllFieldHandles.assign(ghProp.unwrapBufferField().value());
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("fieldSecurity"));
                  cFieldSecurity.assign(ghProp.unwrapBufferField().value());
               }
               
               ErrorManager.silentErrorEnable();
               iFieldPos.assign(lookup(valueOf(hFrameField), cAllFieldHandles));
               ErrorManager.silentErrorDisable();
               
               if (_and(and(and(isNotEqual(iFieldPos, 0), () -> notUnknown(iFieldPos)), () -> isGreaterThanOrEqual(numEntries(cFieldSecurity), iFieldPos)), () -> isEqual(entry(iFieldPos, cFieldSecurity), "HIDDEN")))
               {
                  break thenBlk;
               }
               
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
               hUpdateTarget.assign(ghProp.unwrapBufferField().value());
               
               if ((hUpdateTarget.isValid()).booleanValue())
               {
                  if (_isNotEqual( /* {fnarg <func-name> <arg> [handle] */ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValue", hUpdateTarget, "I", hFrameField.unwrap().name()), hFrameField.unwrapWidget().getScreenValue()))
                  {
                     hFrameField.unwrapWidget().setModified(new logical(true));
                  }
               }
            }
            
            /* The "Frame Field" may be a procedure handle for a SmartDataField object */
            if (_isEqual(hFrameField.unwrapType().getResourceType(), "PROCEDURE"))
            {
               ErrorManager.silentErrorEnable();
               lMod.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", hFrameField));
               ErrorManager.silentErrorDisable();
               
               /* if in an add/copy then set modified flag if field is enabled */
               if (_and(isEqual(lMod, false), () -> isNotEqual(cNew, "no")))
               {
                  ErrorManager.silentErrorEnable();
                  lMod.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getFieldEnabled", hFrameField));
                  ErrorManager.silentErrorDisable();
               }
               
               if ((lMod).booleanValue())
               {
                  /* Store field value in variable and deal with nulls 
                             coming back from an SDF - to avoid pcchanges being set to null*/
                  cValue.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataValue", hFrameField));
                  
                  if (_isUnknown(cValue))
                  {
                     cValue.assign("?");
                  }
                  
                  iChanges.assign(plus(iChanges, 1));
                  pcChanges.assign(concat(pcChanges, (_isEqual(pcChanges, "") ? new character("") : chr(1)), cField, chr(1), cValue));
               }
            }
            else
            {
               if (_or(hFrameField.unwrapWidget().isModified(), () -> and(isNotEqual(cNew, "no"), () -> matchesList(cEnabledFields, hFrameField.unwrap().name()))) /* Always if in add/copy */)
               {
                  ErrorManager.silentErrorEnable();
                  /* Need to try to assign the INPUT-VALUE to see if there is an 
                           error with the INPUT-VALUE, for example an invalid date was
                           entered by the user, if there is we add a message for this
                           field */
                  cChange.assign(hFrameField.unwrapWidget().inputValue());
                  ErrorManager.silentErrorDisable();
                  
                  if (_isNotEqual(ErrorManager.getErrorText(1), ""))
                  {
                     cMessage.assign(ErrorManager.getErrorText(1));
                     
                     /* Ignore the format error if this is a blank field that does
                                not match the format (It is possible to set screen-value to 
                                blank for a field where the format does not allow blanks, but a 
                                reference to input-value will give an error) */
                     if ((new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "widgetIsBlank", targetProcedure(), "I", cField))).booleanValue())
                     {
                        cChange.assign("");
                     }
                     else
                     {
                        lError.assign(true);
                        ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", cMessage, hFrameField.unwrap().name(), new unknown());
                     }
                  }
                  
                  /* if error with INPUT-VALUE */
                  if (_not(lError))
                  {
                     iChanges.assign(plus(iChanges, 1));
                     pcChanges.assign(concat(pcChanges, (_isEqual(pcChanges, "") ? new character("") : chr(1)), cField, chr(1), _isUnknown(cChange) ? new character("?") : cChange));
                  }
               }
            }
         }));
         
         /* END DO iCnt */
         if (_isGreaterThan(iChanges, 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
            iPage.assign(ghProp.unwrapBufferField().value());
            pcInfo.assign(concat(pcInfo, (_isNotEqual(pcInfo, "") ? new character(",") : new character("")), valueOf(iChanges), ",", valueOf(iPage), ",", valueOf(targetProcedure())));
         }
         
         /* END DO iChanges */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Make sure there are unsaved changes is cancelled and uncommitted<br>
    *              changes are undone before allowing its container to initiate a <br>
    *              "destroy" operation.<br>
    * Parameters:  INPUT-OUTPUT plError - <br>
    *              If this is returned TRUE the destroyObject will be cancelled.<br>
    *      Notes:  The name confirm is used as it is in family with the other <br>
    *              confirm methods, but this does not ask any questions
    */
   public void confirmCancel(final logical plError)
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plError))
         {
            ControlFlowOps.invokeInWithMode("okToContinueProcedure", targetProcedure(), "IO", new character("Cancel"), plError);
            plError.assign(not(plError));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Checks to make sure there are no unsaved changes before allowing <br>
    *              its data-source to start a "commitTransaction" operation.<br>
    * Parameters:  INPUT-OUTPUT plCancel - <br>
    *                If this is returned TRUE the transaction will be committed.
    */
   public void confirmCommit(final logical plCancel)
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plCancel))
         {
            ControlFlowOps.invokeInWithMode("okToContinueProcedure", targetProcedure(), "IO", new character("Commit"), plCancel);
            plCancel.assign(not(plCancel));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Checks to make sure there are no unsaved changes <br>
    *              or uncommitted data before allowing its data-source <br>
    *              to start an "Apply filter" operation.<br>
    * Parameters:  INPUT-OUTPUT plCancel - <br>
    *                If this is returned TRUE new filter data will be applied.
    */
   public void confirmContinue(final logical plCancel)
   {
      internalProcedure(new Block((Body) () -> 
      {
         /*IF NOT plCancel THEN
             plCancel = NOT {fnarg okToContinue 'openQuery':U}. */
         if (_not(plCancel))
         {
            ControlFlowOps.invokeInWithMode("okToContinueProcedure", targetProcedure(), "IO", new character("openQuery"), plCancel);
            plCancel.assign(not(plCancel));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Deleterecord hook to ask a question before record is<br>
    *              deleted, giving the option to abort the deletion.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void confirmDelete(final logical plAnswer)
   {
      character cMessage = TypeFactory.character();
      character cAnswer = TypeFactory.character();
      character cButtonPressed = TypeFactory.character();
      handle hUpdateTarget = TypeFactory.handle();
      character cTarget = TypeFactory.character();
      character cDisplayColumns = TypeFactory.character();
      integer iLoop = TypeFactory.integer();
      handle hContainer = TypeFactory.handle();
      character cAllFieldNames = TypeFactory.character();
      character cSecuredFields = TypeFactory.character();
      character cHiddenFields = TypeFactory.character();
      character cFieldName = TypeFactory.character();
      character cUpdateTargetNames = TypeFactory.character();
      handle hSdo = TypeFactory.handle();
      logical lAll = TypeFactory.logical();
      character cObjectType = TypeFactory.character();
      character cOneToOneList = TypeFactory.character();
      integer iCount = TypeFactory.integer();
      integer iCount2 = TypeFactory.integer();
      character cValue = TypeFactory.character();
      character cLabel = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         plAnswer.assign(false);
         cMessage /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 34));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
         cObjectType.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FieldSecurity"));
         cSecuredFields.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         hUpdateTarget.assign(handle.fromString(cTarget));
         
         if (_isEqual( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectType", hUpdateTarget), "SmartBusinessObject"))
         {
            /* {get Prop var [handle]} */ 
            cUpdateTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", targetProcedure()));
            hSdo /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", hUpdateTarget, "I", entry(1, cUpdateTargetNames)));
            cOneToOneList /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "getUpdateSiblings", hUpdateTarget, "I", hSdo));
            
            IntegerExpression resExpr1 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cOneToOneList);
               }
            };
            ToClause toClause1 = new ToClause(iCount, 1, resExpr1);
            
            doTo("loopLabel1", toClause1, new Block((Body) () -> 
            {
               hSdo /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", hUpdateTarget, "I", entry(iCount, cOneToOneList)));
               /* {get Prop var [handle]} */
               cAnswer.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getPromptColumns", hSdo));
               
               if (_or(or(isEqual(cAnswer, "(NONE)"), () -> isEqual(cAnswer, "")), () -> isUnknown(cAnswer)))
               {
                  cAnswer.assign("");
               }
               else
               {
                  if (_isEqual(cAnswer, "(ALL)"))
                  {
                     cAnswer /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataColumns", hSdo));
                  }
               }
               
               loopLabel2:
               for (iCount2.assign(1); _isLessThanOrEqual(iCount2, numEntries(cAnswer)); iCount2.increment())
               {
                  cAnswer.replaceEntry(iCount2, concat(entry(iCount, cOneToOneList), ".", entry(iCount2, cAnswer)));
               }
               
               cDisplayColumns.assign(concat(cDisplayColumns, (_isEqual(cDisplayColumns, "") ? new character("") : new character(",")), cAnswer));
            }));
            
            cAnswer.assign("");
         }
         else
         {
            /* {get Prop var [handle]} */
            cDisplayColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getPromptColumns", hUpdateTarget));
            
            if (_or(or(isEqual(cDisplayColumns, "(NONE)"), () -> isEqual(cDisplayColumns, "")), () -> isUnknown(cDisplayColumns)))
            {
               cDisplayColumns.assign("");
            }
            else
            {
               if (_isEqual(cDisplayColumns, "(ALL)"))
               {
                  lAll.assign(true);
                  /* get list of data columns in the SDO */
                  cDisplayColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataColumns", hUpdateTarget));
               }
            }
         }
         
         if (_isEqual(cObjectType, "smartDataBrowser"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("displayedFields"));
            cAllFieldNames.assign(ghProp.unwrapBufferField().value());
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("AllFieldNames"));
            cAllFieldNames.assign(ghProp.unwrapBufferField().value());
         }
         
         loopLabel3:
         for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cSecuredFields)); iLoop.increment())
         {
            if (_isEqual(entry(iLoop, cSecuredFields), "Hidden"))
            {
               cHiddenFields.assign(concat(cHiddenFields, ",", entry(iLoop, cAllFieldNames)));
            }
         }
         
         IntegerExpression resExpr2 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cDisplayColumns);
            }
         };
         ToClause toClause2 = new ToClause(iLoop, 1, resExpr2);
         
         doTo("loopLabel4", toClause2, new Block((Body) () -> 
         {
            cFieldName.assign(entry(iLoop, cDisplayColumns));
            
            if (_isEqual(numEntries(cFieldName, "."), 2))
            {
               hSdo /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", hUpdateTarget, "I", entry(1, cFieldName, ".")));
               cFieldName.assign(entry(2, cFieldName, "."));
            }
            else
            {
               hSdo.assign(hUpdateTarget);
            }
            
            /* Skip _obj for the all option */
            if (_and(not(matchesList(cHiddenFields, cFieldName)), () -> or(not(lAll), () -> not(matches(cFieldName, ".*_obj")))))
            {
               cValue.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnStringValue", hSdo, "I", cFieldName));
               cLabel.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnLabel", hSdo, "I", cFieldName));
               
               /* If we don't have a label and the value is unknown then
                        do not include this field */
               if (_and(isUnknown(cLabel), () -> isUnknown(cValue)))
               {
                  next("loopLabel4");
               }
               
               if (_isUnknown(cValue))
               {
                  cValue.assign("?");
               }
               
               if (_isUnknown(cLabel))
               {
                  cLabel.assign("");
               }
               
               cAnswer.assign(concat(chr(10), cLabel, " : ", cValue));
               /* -- This is the number of characters we can add --- */
               cMessage.assign(concat(cMessage, substring(cAnswer, 1, int64.maximum(new int64(0) /* -- This is the number of characters we can add --- */, int64.minimum(minus(15000, length(cMessage)), length(cAnswer))))));
               cAnswer.assign("");
            }
         }));
         
         if (_and(and(not(new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "IsDialogBoxParent", targetProcedure(), "I", hContainer))), () -> not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFunctionInCallStack", targetProcedure())))), () -> gshSessionManager.isValid()))
         {
            ErrorManager.silentErrorEnable();
            ControlFlowOps.invokeInWithMode("askQuestion", gshSessionManager, "IIIIIIIUO", cMessage, new character("Yes,No"), new character("YES"), new character("NO"), new character("Record Deletion"), new character(""), new character(""), cAnswer, cButtonPressed /* pcButtonPressed   */);
            ErrorManager.silentErrorDisable();
            
            switch (StringHelper.safeTrimTrailing((cButtonPressed).toStringMessage()).toUpperCase())
            {
               case "YES":
                  {
                     plAnswer.assign(true);
                  }
                  break;
               case "NO":
                  {
                     plAnswer.assign(false);
                  }
                  break;
            }
         }
         else
         {
            messageBox(cMessage, false, new AccessorWrapper(plAnswer), ALERT_QUESTION, BTN_YES_NO, (String) null);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Checks to make sure there are no unsaved changes <br>
    *              or uncommitted data before allowing its container <br>
    *              to initiate a "destroy" operation.<br>
    * Parameters:  INPUT-OUTPUT plCancel - <br>
    *                If this is returned TRUE the destroyObject will be cancelled.
    */
   public void confirmExit(final logical plCancel)
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plCancel))
         {
            ControlFlowOps.invokeInWithMode("okToContinueProcedure", targetProcedure(), "IO", new character("Exit"), plCancel);
            plCancel.assign(not(plCancel));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Make sure unsaved changes are saved and uncommitted data is committed<br>
    *              before allowing its container to initiate a "destroy" operation.<br>
    * Parameters:  INPUT-OUTPUT plError - <br>
    *              If this is returned TRUE the destroyObject will be cancelled.<br>
    *      Notes:  The name confirm is used as it is in family with the other <br>
    *              confirm methods, but this does not ask any questions
    */
   public void confirmOk(final logical plError)
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plError))
         {
            ControlFlowOps.invokeInWithMode("okToContinueProcedure", targetProcedure(), "IO", new character("Ok"), plError);
            plError.assign(not(plError));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Checks to make sure there are no unsaved changes before allowing <br>
    *              its data-source to start an "undoTransaction" operation.<br>
    * Parameters:  INPUT-OUTPUT plCancel - <br>
    *                If this is returned TRUE the changes will be undone.
    */
   public void confirmUndo(final logical plCancel)
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plCancel))
         {
            ControlFlowOps.invokeInWithMode("okToContinueProcedure", targetProcedure(), "IO", new character("Undo"), plCancel);
            plCancel.assign(not(plCancel));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     General code for Copy operation.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Invoked when the Copy button is pressed on an Update SmartPanel<br>
    *              or on a SmartToolbar.<br>
    *              No Copy operation can be done while there are updates in <br>
    *              progress, if so, the user receives a message that current values<br>
    *              must be saved or cancelled before Copy.<br>
    *              Sets NewRecord property to 'Copy'.<br>
    *              PUBLISHes updateState 'Update' to tell Tableio source and <br>
    *              Update target that update is in progress.
    */
   public void copyRecord()
   {
      character cTarget = TypeFactory.character();
      handle hGroupSource = TypeFactory.handle();
      logical lMod = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         hGroupSource.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         lMod.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
         
         if (_and(isEqual(cTarget, ""), () -> isUnknown(hGroupSource)))
         {
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 63));
            returnNormal("ADM-ERROR");
         }
         
         /* Reject the Copy attempt if the current values have been modified
               and not saved. */
         if ((lMod).booleanValue())
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", "2");
            /*  "Current values must be saved or cancelled before Add or Copy." */
            returnNormal("ADM-ERROR");
         }
         
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setNewRecord", targetProcedure(), "I", "Copy");
         /* If for some reason this object's fields have not been enabled from
               outside, then do it here. */
         ControlFlowOps.invokeIn("enableFields", targetProcedure());
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     This is invoked whenever the Data source has a new row. <br>
    *              Requests the data columns to be displayed in the Data source <br>
    *              for that row and displays them.<br>
    * Parameters:  pcRelative AS CHARACTER  record state<br>
    *              Possible values are:<br>
    *              ?                - To check if there is a record pending<br>
    *              FIRST            - First record <br>
    *              PREV             - Prev record<br>
    *              NEXT             - Next record <br>
    *              LAST             - Last record<br>
    *              SAME             - Same record <br>
    *              DIFFERENT        - Different record<br>
    * Notes:       Parallel to row-available for V8 SmartViewers.<br>
    *              This version of dataAvailable doesn't care of the value<br>
    *              of the input parameter received.<br>
    *              AddRecord and CopyRecord does its own display so we only <br>
    *              display if NewRecord = 'NO' in ourselves or GroupAssignSource.
    */
   public void dataAvailable(final character _pcRelative)
   {
      character pcRelative = TypeFactory.initInput(_pcRelative);
      handle hAddSource = TypeFactory.handle();
      character cNewRecord = TypeFactory.character();
      logical lInitialized = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lInitialized))
         {
            returnNormal();
         }
         
         /* The NewRecord is only set at the tableioTarget yet, 
             so check through a potential GroupAssignSource link chain. */
         hAddSource.assign(targetProcedure());
         
         LogicalOp whileClause0 = () -> hAddSource.isValid();
         
         doWhile("loopLabel5", whileClause0, new Block((Body) () -> 
         {
            /* {get Prop var [handle]} */
            cNewRecord.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", hAddSource));
            ghProp.assign(handle.fromString(entry(1, hAddSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
            hAddSource.assign(ghProp.unwrapBufferField().value());
         }));
         
         if (_isEqual(cNewRecord, "NO"))
         {
            ControlFlowOps.invokeIn("displayRecord", targetProcedure());
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     General code for Delete operation.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Invoked when the Delete button is pressed on an Update SmartPanel<br>
    *              or a SmartToolbar.<br>
    *              Invokes deleteRow() in the Update target.
    */
   public void deleteRecord()
   {
      handle hUpdateTarget = TypeFactory.handle();
      character cTarget = TypeFactory.character();
      logical lSuccess = TypeFactory.logical();
      character cRowIdent = TypeFactory.character();
      character cDummy = TypeFactory.character();
      logical lConfirmDelete = TypeFactory.logical();
      character cUpdateTargetNames = TypeFactory.character();
      handle hSdo = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         hUpdateTarget.assign(handle.fromString(cTarget));
         
         /* NOTE: Make sure there's just 1? */
         if ((hUpdateTarget.isValid()).booleanValue())
         {
            if (_isEqual( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectType", hUpdateTarget), "SmartBusinessObject"))
            {
               /* {get Prop var [handle]} */ 
               cUpdateTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", targetProcedure()));
               hSdo /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", hUpdateTarget, "I", entry(1, cUpdateTargetNames)));
               /* {get Prop var [handle]} */
               lConfirmDelete.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getPromptOnDelete", hSdo));
            }
            else
            {
               /* {get Prop var [handle]} */
               lConfirmDelete.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getPromptOnDelete", hUpdateTarget));
            }
            
            if ((lConfirmDelete).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("confirmDelete", targetProcedure(), "U", lConfirmDelete);
            }
            else
            {
               lConfirmDelete.assign(true);
            }
            
            if ((lConfirmDelete).booleanValue())
            {
               /* {get Prop var [handle]} */ 
               cRowIdent.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", targetProcedure()));
               lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "deleteRow", hUpdateTarget, "I", cRowIdent));
            }
         }
         else
         {
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III",  /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 64), new unknown(), new unknown());
            lSuccess.assign(false);
         }
         
         /* END ELSE DO (NOT VALID-HANDLE) */
         if (_isEqual(lSuccess, false))
         {
            /* {fn showDataMessages}. */
            ControlFlowOps.invokeInWithMode("showDataMessagesProcedure", targetProcedure(), "O", cDummy);
            returnNormal("ADM-ERROR");
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  override to unregister from object Mapping in an sbo (if necessary)    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void destroyObject()
   {
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("unRegisterObject", targetProcedure());
         /* iz 996*/
         ControlFlowOps.runSuper("destroyObject");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:   set ObjectMode    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:    Viewer and browser class has complete override for disabling.       <br>
    *        -  The ObjectMode is also set in updateMode, but users may call this<br>
    *           directly.
    */
   public void disableFields(final character _pcFieldType)
   {
      character pcFieldType = TypeFactory.initInput(_pcFieldType);
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
         ghProp.unwrapBufferField().changeValue(new character("View"));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    Display the current datasource's rows <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void displayRecord()
   {
      character cColumns = TypeFactory.character();
      character cDisplayed = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      character cSourceNames = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if ((hSource.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedFields"));
            cDisplayed.assign(ghProp.unwrapBufferField().value());
            
            /* If the fields are unqualified, we check if we run against an SBO and
                  qualify so the SBO can know which SDO to direct the call to.  
                  This is both for speed and is also required for data integrity as the SBO 
                  does return values on a first found basis. The SBOs addDataTarget will not 
                  allow any ambiguity when generating DataSourceNames, but trusts the object
                  to qualify correctly if DataSourceNames is set already at start up. */
            if (_isEqual(indexOf(cDisplayed, "."), 0))
            {
               ErrorManager.silentErrorEnable();
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
               cSourceNames.assign(ghProp.unwrapBufferField().value());
               ErrorManager.silentErrorDisable();
               
               /* The SBOs colValues needs only one qualifer to direct the call to 
                        that SDO */
               if (_isEqual(numEntries(cSourceNames), 1))
               {
                  cDisplayed.assign(concat(cSourceNames, ".", cDisplayed));
               }
            }
            ErrorManager.silentErrorEnable();
            /* no qualifiers */
            cColumns.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", hSource, "I", cDisplayed));
            ErrorManager.silentErrorDisable();
            
            /* error 7351 indicates that a buffer-field is missing */
            if (_and(isUnknown(cColumns), () -> isEqual(ErrorManager.getErrorNumber(1), 7351)))
            {
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 19), entry(2, ErrorManager.getErrorText(1), " "), targetProcedure().unwrapFile().getFileName()));
            }
            else
            {
               ControlFlowOps.invokeInWithMode("displayFields", targetProcedure(), "I", cColumns);
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:   set ObjectMode    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:    Viewer and browser class has complete override for enabling.       <br>
    *           The ObjectMode is also set in updateMode, but users may call this<br>
    *           directly.
    */
   public void enableFields()
   {
      character cObjectMode = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
         cObjectMode.assign(ghProp.unwrapBufferField().value());
         
         if (_isNotEqual(cObjectMode, "Update"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
            ghProp.unwrapBufferField().changeValue(new character("Modify"));
         }
         /* {set Prop value [handle]} */ 
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Data visualization (Viewers and Browsers) version of <br>
    *              initializeObject.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Invokes displayObjects to display values of non database fields.<br>
    *              Sets the value of the SaveSource property which indicates the <br>
    *              'PanelType'of the SmartPanel Update or SmartToolbar, if any, <br>
    *              we are connected to. (c.f. PanelType 'Update' or 'Save').
    */
   public void initializeObject()
   {
      handle hSource = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      character cPanelType = TypeFactory.character();
      character cState = TypeFactory.character();
      character cTarget = TypeFactory.character();
      character cUibmode = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* if the datasource is inactive then activate it before the object is 
              initialized as we don't want viewObject -> (data.p)linkState 
              -> LinkstateHandler to run dataAvailable, since it also is run at the end 
              of initialization in viewer and browser. 
              (This is kind of a workaround for the fact that ObjectInitialized is set 
               to true in smart.p initializeObject, somewhat early .. ) */
         /* {get Prop var [handle]} */ 
         hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if ((hDataSource.isValid()).booleanValue())
         {
            if ((new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", targetProcedure(), "II", "DataSource", hDataSource))).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("linkStateHandler", targetProcedure(), "III", new character("active"), hDataSource, new character("DataSource"));
            }
         }
         ControlFlowOps.runSuper("initializeObject");
         
         /* Invoke the standard behavior first. */
         if (_isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
         {
            returnNormal("ADM-ERROR");
         }
         
         /* The sbo subscribes to this event in order to update ObjectMapping.*/
         NamedEventManager.publish("registerObject", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("TableIOSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         
         /* If there's a TableIO-Source but no Update-Target, this is invalid,
              so setEditable to false in order to disable the update panel. 
              Actions are either checking editable or canNavigate */
         if ((hSource.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
            cTarget.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(cTarget, ""))
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setEditable", targetProcedure(), "I", false);
            }
            else
            {
               ErrorManager.silentErrorEnable();
               /* Check save/update mode in the toolbar */
               cPanelType /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn("getTableioType", hSource));
               ErrorManager.silentErrorDisable();
               
               /* Check save/update mode in the panel (different property) */
               if (_isUnknown(cPanelType))
               {
                  ErrorManager.silentErrorEnable();
                  cPanelType /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn("getPanelType", hSource));
                  ErrorManager.silentErrorDisable();
               }
               
               if (_isEqual(cPanelType, "Save"))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
                  ghProp.unwrapBufferField().changeValue(new logical(true));
               }
               else
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
                  ghProp.unwrapBufferField().changeValue(new logical(false));
               }
               /* {set Prop value [handle]} */ 
               /* {set Prop value [handle]} */ 
            }
         }
 /* If no TIO-Source then leave SaveSource '?' */         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
            cUibmode.assign(ghProp.unwrapBufferField().value());
            
            if (_begins(cUibmode, "design"))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
               ghProp.unwrapBufferField().changeValue(new logical(false));
            }
            /* {set Prop value [handle]} */ 
         }
         /* The DataSource may have published queryPosition before we got created
              and queryPosition also RETURNs when not initialized so retrieve the 
              QueryPosition from the DataSource and pass it to ourselves to ensure 
              correct state and field enabling. */
         /* {get Prop var [handle]} */ 
         hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if ((hDataSource.isValid()).booleanValue())
         {
            ghTargetProcedure.assign(targetProcedure());
            /* {get Prop var [handle]} */
            cState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", hDataSource));
            ghTargetProcedure.setUnknown();
            
            /* An uninitialized SDO/SBO may return blank.. */
            if (_isEqual(cState, ""))
            {
               cState.assign("NoRecordAvailable");
            }
            
            ControlFlowOps.invokeInWithMode("queryPosition", targetProcedure(), "I", cState);
         }
         ErrorManager.silentErrorEnable();
         ControlFlowOps.invokeIn("displayObjects", targetProcedure());
         ErrorManager.silentErrorDisable();
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Received from container source to check if contained objects have <br>
    *          unsaved or uncommitted changes, including addMode.           <br>
    *   Notes: This is published thru the container link and are used for <br>
    *          close logic ( ok, cancel, exit).<br>
    *         (It is very similar to canNavigate -&gt; isUpdatePending which is <br>
    *          published thru the data link)   <br>
    *        - This can be called directly, but canExit() is the intended API.<br>
    *          canExit() is used to check an actual container from the toolbar.
    */
   public void isUpdateActive(final logical plActive)
   {
      logical lModified = TypeFactory.logical();
      character cNewRecord = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plActive))
         {
            /* {get Prop var [handle]} */ 
            lModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cNewRecord.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", targetProcedure()));
            plActive.assign(or(lModified, () -> isNotEqual(cNewRecord, "NO")));
            
            /* call super with no-error in case this is a container  */
            if (_not(plActive))
            {
               ErrorManager.silentErrorEnable();
               ControlFlowOps.runSuper("isUpdateActive", plActive);
               ErrorManager.silentErrorDisable();
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    Returns true if this object is in update mode <br>
    * Parameters:  I-O plUpdate - Is update pending<br>
    *              if it is input as true then some other subscriber has a pending <br>
    *              update and we must just leave it as is. <br>
    * Notes:    -  DataSources publishes this from canNavigate to check if targets<br>
    *              have pending updates and return false to indicate that the object<br>
    *              cannot be navigated if the publish returns true.<br>
    *           -  It is also called directly from canNavigate in this class.
    */
   public void isUpdatePending(final logical plUpdate)
   {
      character cMode = TypeFactory.character();
      logical lModified = TypeFactory.logical();
      character cNew = TypeFactory.character("no");
      handle hGaSource = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         hGaSource.assign(ghProp.unwrapBufferField().value());
         
         if ((hGaSource.isValid()).booleanValue())
         {
            returnNormal();
         }
         
         /* Keep update was found somewhere else */
         if (_isEqual(plUpdate, false))
         {
            /* {get Prop var [handle]} */ 
            lModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cNew.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
            cMode.assign(ghProp.unwrapBufferField().value());
            plUpdate.assign(or(or(lModified, () -> isNotEqual(cNew, "NO")), () -> isEqual(cMode, "Update")));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters: pcstate -<br>
    *               add,remove,inactive,active<br>
    *             phObject - object to link to <br>
    *             pcLink   - Linkname (data-source)  <br>
    * Notes:      if you think you get this... think again... <br>
    *             Or more precisely ensure you realize that there is an override <br>
    *             in viewer.p that runs this in all its GroupAssignTargets while the<br>
    *             SDO's linkState only runs this in the GroupAssignSource.
    */
   public void linkStateHandler(final character _pcState, final handle _phObject_2, final character _pcLink)
   {
      character pcState = TypeFactory.initInput(_pcState);
      handle phObject_2 = TypeFactory.initInput(_phObject_2);
      character pcLink = TypeFactory.initInput(_pcLink);
      logical lDataInactive = TypeFactory.logical();
      logical lInitialized = TypeFactory.logical();
      logical lQueryObject = TypeFactory.logical();
      character cQueryPosition = TypeFactory.character();
      handle hUpdateTarget = TypeFactory.handle();
      character cMyRowident = TypeFactory.character();
      character cSourceRowident = TypeFactory.character();
      logical lSameRecord = TypeFactory.logical();
      handle hGaSource = TypeFactory.handle();
      handle hUpdateSource = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      handle hToolbarSource = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_and(isEqual(pcLink, "ToolbarSource"), () -> isEqual(pcState, "Add")))
         {
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            if ((hDataSource.isValid()).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
               lQueryObject.assign(ghProp.unwrapBufferField().value());
               
               if ((lQueryObject).booleanValue())
               {
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchHasAudit", hDataSource, "I", true);
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchHasComment", hDataSource, "I", true);
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchAutoComment", hDataSource, "I", true);
               }
            }
         }
         else
         {
            if (_and(isEqual(pcLink, "DataSource"), () -> isEqual(pcState, "Add")))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ToolbarSource"));
               hToolbarSource.assign(ghProp.unwrapBufferField().value());
               
               if ((hToolbarSource.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, phObject_2.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQueryObject.assign(ghProp.unwrapBufferField().value());
                  
                  if ((lQueryObject).booleanValue())
                  {
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchHasAudit", phObject_2, "I", true);
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchHasComment", phObject_2, "I", true);
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchAutoComment", phObject_2, "I", true);
                  }
               }
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         
         if (_and(and(lInitialized, () -> isEqual(pcState, "active")), () -> isEqual(pcLink, "DataSource")))
         {
            /* if the source is inactive then just wait for the dataavailable
                   that it will publish when it becomes active */
            if (_not(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", phObject_2, "II", "DataSource", new unknown()))))
            {
               lDataInactive.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", targetProcedure(), "II", "DataSource", phObject_2));
            }
         }
         ControlFlowOps.runSuper("linkStateHandler", pcState, phObject_2, pcLink);
         
         if ((lDataInactive).booleanValue())
         {
            /* (note that we only get here when 'active' 'DataSource' )
                   We want to avoid redisplay if we are on the same record, but we are a 
                   bit paranoid so we ensure that we're the updateSource, so that it is 
                   very unlikely that anything have changed in the source while we were 
                   unconscious.. (to find the updatetarget we must find the top in the 
                   GA link) */
            hGaSource.assign(targetProcedure());
            
            loopLabel6:
            while ((hGaSource.isValid()).booleanValue())
            {
               hUpdateSource.assign(hGaSource);
               ghProp.assign(handle.fromString(entry(1, hUpdateSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
               hGaSource.assign(ghProp.unwrapBufferField().value());
            }
            
            ghProp.assign(handle.fromString(entry(1, hUpdateSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
            hUpdateTarget.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(hUpdateTarget, phObject_2))
            {
               /* {get Prop var [handle]} */ 
               cMyRowident.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowident", targetProcedure()));
                              /* check if we are on the same record (? is not avail or new 
                               on ANY parent... so make sure that is not seen as the same ) */cSourceRowident.assign(entry(1, ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", phObject_2, "I", ""), chr(1)));
               lSameRecord.assign(and(notUnknown(cMyRowident), () -> isEqual(cMyRowident, cSourceRowident)));
            }
            
            if (_not(lSameRecord))
            {
               /* {get Prop var [handle]} */
               cQueryPosition.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", phObject_2));
               ControlFlowOps.invokeInWithMode("queryPosition", targetProcedure(), "I", cQueryPosition);
               ControlFlowOps.invokeInWithMode("dataAvailable", targetProcedure(), "I", new character("different"));
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Locates a widget and retuns its handle and the handle of its<br>
    *              TARGET-PROCEDURE<br>
    * Parameters:  pcWidget AS CHARACTER<br>
    *              phWidget AS HANDLE<br>
    *              phTarget AS HANDLE<br>
    * Notes:       Supports self and no qualifiers<br>
    *              A field may be qualified in its field name with an SDO name <br>
    *              if the viewer was built against an SBO.  This is first treated <br>
    *              as no qualifier before treating it as an instance name qualifier.
    */
   public void locateWidget(final character _pcWidget, final handle phWidget, final handle phTarget)
   {
      character pcWidget = TypeFactory.initInput(_pcWidget);
      character cDataTargets = TypeFactory.character();
      character cField = TypeFactory.character();
      character cObjectType = TypeFactory.character();
      handle hDataSource = TypeFactory.handle();
      handle hDataTarget = TypeFactory.handle();
      integer iDataTargets = TypeFactory.integer();
      logical lQueryObject = TypeFactory.logical();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(phWidget);
         TypeFactory.initOutput(phTarget);
      }, 
      (Body) () -> 
      {
         /* Support for Self qualifier */
         if (_and(isGreaterThan(numEntries(pcWidget, "."), 1), () -> isEqual(entry(1, pcWidget, "."), "Self")))
         {
            ErrorManager.silentErrorEnable();
            cField.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "deleteEntry", targetProcedure(), "III", 1, pcWidget, "."));
            phWidget.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "internalWidgetHandle", targetProcedure(), "II", cField, "ALL"));
            phTarget.assign(targetProcedure());
            ErrorManager.silentErrorDisable();
            
            if (_notUnknown(phWidget))
            {
               returnNormal();
            }
         }
         
         /* if qualifier is self */
         /* Support for searching this object with no qualifier 
              (or qualifier of SDO name for field of viewer built against SBO)
              
              If the number of entries is less than or equal to 2 then the field has
              no qualifier or only has one qualifier which could be an SDO name for a
              field of a viewer built with an SBO, check for a widget in this object 
              first with the passed name.  */
         if (_isLessThanOrEqual(numEntries(pcWidget, "."), 2))
         {
            ErrorManager.silentErrorEnable();
            phWidget.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "internalWidgetHandle", targetProcedure(), "II", pcWidget, "ALL"));
            phTarget.assign(targetProcedure());
            ErrorManager.silentErrorDisable();
            
            if (_notUnknown(phWidget))
            {
               returnNormal();
            }
         }
         
         /* no qualifier or one qualifier */
         /* Support for searching sibling objects with no qualifier 
              (or qualifier of SDO name for field of viewer built against SBO)
              
              If the widget was not found in this object and there is no qualifier
              or only one qualifier which could be an SDO name for a field of a 
              viewer built with an SBO, check for the widget in objects with the 
              same data source. */
         if (_isLessThanOrEqual(numEntries(pcWidget, "."), 2))
         {
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            if ((hDataSource.isValid()).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
               cDataTargets.assign(ghProp.unwrapBufferField().value());
               
               IntegerExpression resExpr3 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cDataTargets);
                  }
               };
               ToClause toClause3 = new ToClause(iDataTargets, 1, resExpr3);
               
               doTo("loopLabel7", toClause3, new Block((Body) () -> 
               {
                  ErrorManager.silentErrorEnable();
                  hDataTarget.assign(handle.fromString(entry(iDataTargets, cDataTargets)));
                  ErrorManager.silentErrorDisable();
                  ghProp.assign(handle.fromString(entry(1, hDataTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQueryObject.assign(ghProp.unwrapBufferField().value());
                  ghProp.assign(handle.fromString(entry(1, hDataTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
                  cObjectType.assign(ghProp.unwrapBufferField().value());
                  
                  /* Only sibling viewer objects are searched when there is no 
                             qualifier */
                  if (_and(and(and(hDataTarget.isValid(), () -> isNotEqual(hDataTarget, targetProcedure())), not(lQueryObject)), () -> isNotEqual(cObjectType, "SmartDataBrowser")))
                  {
                     ErrorManager.silentErrorEnable();
                     phWidget.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "internalWidgetHandle", hDataTarget, "II", pcWidget, "DATA"));
                     phTarget.assign(hDataTarget);
                     ErrorManager.silentErrorDisable();
                     
                     if (_notUnknown(phWidget))
                     {
                        returnNormal();
                     }
                  }
               }));
            }
         }
         
         /* if no qualifier */
         /* If there is a qualifier other than self then run SUPER to locate widget
              by datasource or instance name qualifiers */
         if (_and(isGreaterThan(numEntries(pcWidget, "."), 1), () -> isNotEqual(entry(1, pcWidget, "."), "Self")))
         {
            ControlFlowOps.runSuper("locateWidget", pcWidget, phWidget, phTarget);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose: Passes an ok request to its container    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:  The convention is that the standard routine always<br>
    *         passes an cancel,ok or exit request to its CONTAINER-SOURCE. <br>
    *         The container that is actually able to initiate the ok <br>
    *         should override this andnot* call SUPER.
    */
   public void okObject()
   {
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("okObject", targetProcedure());
         /* NOTE: MUST go to Container-Source */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *  Purpose:  Check if the visual object have modified screen data or <br>
    *            if its data-source has uncommitted changes.<br>
    *            If any of these conditions are true we issue Yes-No-Cancel <br>
    *            questions offering the user to answer <br>
    *              YES     to save/commit and continue the action.  TRUE<br>
    *              NO      to cancel/undo and continue the action.  TRUE<br>
    *              CANCEL  to NOT continue the action.              FALSE<br>
    * Parameters: pcAction (char) - Used to retrieve correct message. <br>
    *                     - exit   - Exit/close of application window.<br>
    *                     - blank  - Continue  <br>
    *                     - Commit - Commit (yes,no cancel unsaved changes)<br>
    *                     - Undo   - Undo   (Don't offer save as an option)<br>
    *                     - Ok     - No question (Save and commit) <br>
    *                     - Cancel - No question (cancel and undo)<br>
    *    Notes:   -  confirmExit and confirmOpenQuery uses this function.<br>
    *            This is copied from okToContinue function in datavis.p for use<br>
    *            with Astra 2.
    */
   public void okToContinueProcedure(final character _pcAction_1, final logical plAnswer)
   {
      character pcAction_1 = TypeFactory.initInput(_pcAction_1);
      logical lModified = TypeFactory.logical();
      logical lAnswer = TypeFactory.logical();
      handle hDataSource = TypeFactory.handle();
      character cRowObjectState = TypeFactory.character();
      character cOperation = TypeFactory.character();
      handle hGasource = TypeFactory.handle();
      character cNewRecord = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(plAnswer);
      }, 
      (Body) () -> 
      {
         cOperation.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", _isEqual(pcAction_1, "Exit") ? new integer(21) /* Exit */ : _isEqual(pcAction_1, "Commit") ? new integer(31) : new integer( /* Commit */22)));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         hGasource.assign(ghProp.unwrapBufferField().value());
         
         /* We trust that all checks will be performed against the GA Source */
         if ((hGasource.isValid()).booleanValue())
         {
            plAnswer.assign(true);
            returnNormal();
         }
         
         /* If lModified ask the user what to do. */
         /* {get Prop var [handle]} */ 
         lModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
         /* {get Prop var [handle]} */ 
         cNewRecord.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", targetProcedure()));
         
         if (_or(lModified, () -> and(isNotEqual(cNewRecord, "NO"), () -> isNotEqual(pcAction_1, "Exit"))))
         {
            switch (StringHelper.safeTrimTrailing((pcAction_1).toStringMessage()).toUpperCase())
            {
               case "OK":
                  {
                     lAnswer.assign(true);
                  }
                  break;
               case "CANCEL":
                  {
                     lAnswer.assign(false);
                  }
                  break;
               case "UNDO":
                  {
                     ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", concat("32,", cOperation, ",OkCancel"), lAnswer);
                     
                     if ((lAnswer).booleanValue())
                     {
                        lAnswer.setUnknown();
                     }
                  }
                  break;
               default:
                  {
                     ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", concat("3,", cOperation, ",YesNoCancel"), lAnswer);
                  }
                  break;
            }
            
            /* Yes to save changes */
            if ((lAnswer).booleanValue())
            {
               ControlFlowOps.invokeIn("updateRecord", targetProcedure());
               
               /* Do not continue if error */
               if (_isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
               {
                  plAnswer.assign(false);
                  returnNormal();
               }
            }
            else
            {
               if (_not(lAnswer))
               {
                  ControlFlowOps.invokeIn("cancelRecord", targetProcedure());
                  
                  /* Do not continue if error */
                  if (_isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
                  {
                     plAnswer.assign(false);
                     returnNormal();
                  }
               }
               else
               {
                  plAnswer.assign(false);
                  returnNormal();
               }
 /* lAnswer = ? */;
            }
         }
         else
         {
            if (_and(isNotEqual(cNewRecord, "NO"), () -> isEqual(pcAction_1, "EXIT")))
            {
               ControlFlowOps.invokeIn("cancelRecord", targetProcedure());
            }
         }
         
         /* Check if there are any uncommited changes in the data-source. 
               Avoid this for undo and commit of course... */
         if (_not(matchesList("Undo,Commit", pcAction_1)))
         {
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            if ((hDataSource.isValid()).booleanValue())
            {
               ErrorManager.silentErrorEnable();
               /* use no-error in case of db query */
               cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", hDataSource));
               ErrorManager.silentErrorDisable();
               
               if (_isEqual(cRowObjectState, "RowUpdated"))
               {
                  switch (StringHelper.safeTrimTrailing((pcAction_1).toStringMessage()).toUpperCase())
                  {
                     case "OK":
                        {
                           lAnswer.assign(true);
                        }
                        break;
                     case "CANCEL":
                        {
                           lAnswer.assign(false);
                        }
                        break;
                     default:
                        {
                           ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", concat("20,", cOperation, ",YesNoCancel"), lAnswer);
                        }
                        break;
                  }
                  
                  if ((lAnswer).booleanValue())
                  {
                     ControlFlowOps.invokeIn("commitTransaction", hDataSource);
                     
                     /* Do not continue if error */
                     if (_isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
                     {
                        plAnswer.assign(false);
                        returnNormal();
                     }
                  }
                  else
                  {
                     if (_not(lAnswer))
                     {
                        ControlFlowOps.invokeIn("undoTransaction", hDataSource);
                     }
                     else
                     {
                        /* lAnswer = ? so don't continue */
                        plAnswer.assign(false);
                        returnNormal();
                     }
                  }
               }
            }
         }
         /* pcAction <> undo,commit*/
         plAnswer.assign(true);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Captures 'state' events for the associated Query in the object's<br>
    *              Data source. <br>
    * Parameters:  pcState AS CHARACTER  queryPosition State<br>
    *              Possible values are:<br>
    *              FirstRecord              - First record<br>
    *              NotFirstOrLast           - Not the first or last record<br>
    *              LastRecord               - Last record<br>
    *              NoRecordAvailable        - No record<br>
    *              OnlyRecord               - Only one<br>
    * Notes:       Any state that begins "NoRecordAvail" means disable; all others<br>
    *              (FirstRecord, etc.) mean enable if we're in 'Save' mode <br>
    *              (SaveSource property is set to yes).<br>
    *              Sets the RecordState property to 'NoRecordAvailable' when the<br>
    *              state is equivalent to that for any other state, sets the value<br>
    *              to 'RecordAvilable'.
    */
   public void queryPosition(final character _pcState)
   {
      character pcState = TypeFactory.initInput(_pcState);
      character cRecordState = TypeFactory.character();
      logical lEnabled = TypeFactory.logical();
      logical lSaveSource = TypeFactory.logical();
      handle hGasource = TypeFactory.handle();
      logical lInitialized = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lInitialized))
         {
            returnNormal();
         }
         
         /* Save a [No]RecordAvailable flag for others to query. */
         cRecordState.assign(_begins(pcState, "NoRecordAvail") ? pcState : new character("RecordAvailable"));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RecordState"));
         ghProp.unwrapBufferField().changeValue(cRecordState);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FieldsEnabled"));
         lEnabled.assign(ghProp.unwrapBufferField().value());
         
         if (_begins(pcState, "NoRecordAvail"))
         {
            if ((lEnabled).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("disableFields", targetProcedure(), "I", new character("All"));
            }
         }
         else
         {
 /* one of the "record-available" states */
            if (_not(lEnabled))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
               hGasource.assign(ghProp.unwrapBufferField().value());
               
               if ((hGasource.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hGasource.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
                  lSaveSource.assign(ghProp.unwrapBufferField().value());
               }
               else
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
                  lSaveSource.assign(ghProp.unwrapBufferField().value());
               }
               /* {get Prop var [handle]} */ 
               /* {get Prop var [handle]} */ 
               
               /* The SaveSource is used to check whether to enable at start up 
                      The only way to NOT make this happen is with an tableio-target 
                      with UPDATE mode (lSaveSource = false).  
                      We check NOT (lSaveSource = false) to ensure that we run enableFields 
                      also when unknown value and no tableio source. 
                      THIS IS INTENTIONAL from 9.1B ! but has been overridden in viewer.i for 
                      backwards compatibility ...  
                      The updateMode toggles SaveSource on/off to ensure that we don't enable 
                      if the user have explicitly set it to view. (This also includes the 
                      inititial Containermode = 'view', which the container publishes from 
                      its toolbars)  */
               if (_not(isEqual(lSaveSource, false)))
               {
                  ControlFlowOps.invokeInWithMode("updateMode", targetProcedure(), "I", new character("modify"));
               }
            }
         }
         /*  NOT lEnabled */
         /* re-send the event to other objects (such as an Update Panel) */
         NamedEventManager.publish("queryPosition", targetProcedure(), "I", new Object[]
         {
            pcState
         });
         NamedEventManager.publish("resetToolbar", targetProcedure());
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     General code for reset operation.<br>
    *              Redisplays the original field values retrieved from the <br>
    *              SmartDataObject by invoking the colValues() function for the<br>
    *              fields that are displayed.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Invoked when the Reset button is pressed on an Update SmartPanel<br>
    *              or a SmartToolbar.<br>
    *              PUBLISHEs 'resetRecord' in case of GroupAssign.<br>
    *              Sets DataModified property to ?.
    */
   public void resetRecord()
   {
      handle hUpdateTarget = TypeFactory.handle();
      character cRowIdent = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         hUpdateTarget.assign(ghProp.unwrapBufferField().value());
         
         if ((hUpdateTarget.isValid()).booleanValue())
         {
            /* {get Prop var [handle]} */ 
            cRowIdent.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowident", targetProcedure()));
            /* {fnarg <func-name> <arg> [handle] */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "resetRow", hUpdateTarget, "I", cRowIdent);
         }
         
         /* In case GroupAssign. This is done before set DataModified to ensure
              that the GATargets are unmodified before updateActive is published
              up the ContainerSources  */
         NamedEventManager.publish("resetRecord", targetProcedure());
         /* Normally setting DataModified to 'no' also publishes updateComplete,
              but we want a Reset (to avoid browse rows becoming enabled
              when changing rows after a Reset), so pass special signal of unknown to 
              tell setDataModified to set the property off and pass 'reset' instead of
              'UpdateComplete'.  This will also trigger the dataObject to roll back 
              and delete a potential rowObjUpd record , so display afterwards */
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataModified", targetProcedure(), "I", new unknown());
         ControlFlowOps.invokeIn("displayRecord", targetProcedure());
         ControlFlowOps.invokeInWithMode("applyEntry", targetProcedure(), "I", new unknown());
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     New Astra 2 procedure to replace showDataMessages function and to<br>
    *              use Astra 2 message handling routines.<br>
    *              Returns the name of the field (if any) from the first<br>
    *              error message, to allow the caller to use it to position the <br>
    *              cursor.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Invokes fetchMessages() to retrieve all Data-related messages<br>
    *              (normally database update-related error messages), and<br>
    *              displays them in a alert-box of type error.<br>
    *              This function expects to receive back a single string <br>
    *              from fetchMessages with one or more messages delimited by CHR(3),<br>
    *              and within each message the message text, Fieldname (or blank) +<br>
    *              a Tablename (or blank), delimited by CHR(4) if present.
    */
   public void showDataMessagesProcedure(final character pcReturn)
   {
      character cMessages = TypeFactory.character();
      integer iMsg = TypeFactory.integer();
      integer iMsgCnt = TypeFactory.integer();
      character cMessage = TypeFactory.character();
      character cFirstField = TypeFactory.character();
      character cField = TypeFactory.character();
      character cTable = TypeFactory.character();
      character cText = TypeFactory.character("");
      handle hContainerSource = TypeFactory.handle();
      handle hContainer = TypeFactory.handle();
      character cIgnore = TypeFactory.character();
      logical lIgnore = TypeFactory.logical();
      character cSummary = TypeFactory.character();
      character cParentType = TypeFactory.character();
      character cFocusType = TypeFactory.character();
      character cButtonPressed = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initOutput(pcReturn);
      }, 
      (Body) () -> 
      {
         cMessages.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
         
         /* Issue 6945 - we need to detect if a browse cell is involved */
         if ((focus().isValid()).booleanValue())
         {
            cParentType.assign(focus().unwrapWidget().getParentHandle().unwrapType().getResourceType());
            cFocusType.assign(focus().unwrapType().getResourceType());
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         /* If we're running Dynamics, and a dialog is not involved, and there is
              no function in the call stack, and we're not in an updatable field in a 
              browser we can just send the message to the session manager to display.
              We want to avoid calling afmessagep in the session manager in this scenario,
              as each call to it will result in an Appserver hit, and showMessages is
              going to run afmessagep anyway. */
         /* 6945 */
         if (_and(and(and(and(isNotEqual(cMessages, ""), () -> not(new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "IsDialogBoxParent", targetProcedure(), "I", hContainer)))), () -> not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFunctionInCallStack", targetProcedure())))), () -> not(and(isEqual(cFocusType, "FILL-IN"), () -> begins(cParentType, "BROWSE")))), () -> gshSessionManager.isValid()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainerSource.assign(ghProp.unwrapBufferField().value());
            /* Dynamics showMessages handles message list in raw form */
            ControlFlowOps.invokeInWithMode("showMessages", gshSessionManager, "IIIIIIIIO", cMessages, new character("ERR"), new character("OK"), new character("OK"), new character(""), new character("ADM2Message"), new logical(true), hContainerSource, cButtonPressed /* pcButtonPressed */);
            cMessage.assign(entry(1, cMessages, chr(3)));
            cFirstField.assign(_isGreaterThan(numEntries(cMessage, chr(4)), 1) ? entry(2, cMessage, chr(4)) : new character(""));
         }
         else
         {
            iMsgCnt.assign(numEntries(cMessages, chr(3)));
            
            ToClause toClause4 = new ToClause(iMsg, 1, iMsgCnt);
            
            doTo("msgCntBlk", toClause4, new Block((Body) () -> 
            {
               cMessage.assign(entry(iMsg, cMessages, chr(3)));
               cField.assign(_isGreaterThan(numEntries(cMessage, chr(4)), 1) ? entry(2, cMessage, chr(4)) : new character(""));
               cTable.assign(_isGreaterThan(numEntries(cMessage, chr(4)), 2) ? entry(3, cMessage, chr(4)) : new character(""));
               
               /* Is Dynamics running? If so then run the messages through the standard message routine.
                          * This will ensure that the messages are translated and correctly formatted.           */
               if ((gshSessionManager.isValid()).booleanValue())
               {
                  /* We are only interested in getting the summary message here. Ignore all other 
                                 * parameters.                                                                  */
                  ControlFlowOps.invokeInWithMode("afmessagep", gshSessionManager, "IIIOOOOOO", cMessage, new character(""), new character(""), cSummary, cIgnore, cIgnore, cIgnore, lIgnore, lIgnore);
                  cText.assign(concat(cText, (_isNotEqual(cField, "") ? ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 10) : new character("")), cField, "   ", (_isNotEqual(cTable, "") ? ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 11) : new character("")), cTable, (_or(isNotEqual(cField, ""), () -> isNotEqual(cTable, "")) ? new character("\n") : new character("")), "  ", cSummary, "\n"));
               }
               else
               {
                  cText.assign(concat(cText, (_isNotEqual(cField, "") ? ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 10) : new character("")), cField, "   ", (_isNotEqual(cTable, "") ? ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 11) : new character("")), cTable, (_or(isNotEqual(cField, ""), () -> isNotEqual(cTable, "")) ? new character("\n") : new character("")), "  ", entry(1, cMessage, chr(4)), "\n"));
               }
               
               /* since we are displaying in a resizable dialog we can afford a blank line between fields */
               if (_isNotEqual(trim(cText), ""))
               {
                  cText.assign(concat(cText, "\n"));
               }
               
               /* Return the field name from the first error message so the caller can
                          use it to position the cursor. */
               if (_isEqual(iMsg, 1))
               {
                  cFirstField.assign(cField);
               }
            }));
            
            /* END DO iMsg */
            /* Either Dynamics is not connected, or we couldn't use the standard Dynamics message window.
                     Either way, display the message using the standard 4GL MESSAGE statement. */
            if (_and(isNotEqual(cText, ""), () -> isNotEqual(cMessages, "")))
            {
               messageBox(cText, ALERT_ERROR, BTN_OK, "Data Error");
            }
         }
         pcReturn.assign(cFirstField);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Procedure to handle datavisual toolbar actions.<br>
    * Parameters:  pcValue AS CHARACTER - action<br>
    * Notes:
    */
   public void toolbar(final character _pcValue)
   {
      character pcValue = TypeFactory.initInput(_pcValue);
      character cDataSourceNames = TypeFactory.character();
      character cFields = TypeFactory.character();
      character cProcedureType = TypeFactory.character();
      character cStoreFieldName = TypeFactory.character();
      character cUpdateTargetNames = TypeFactory.character();
      handle hBrowse = TypeFactory.handle();
      handle hColumn = TypeFactory.handle();
      handle hContainerSource = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      handle hFilterWindow = TypeFactory.handle();
      handle hNewObject = TypeFactory.handle();
      handle hSdodataSource = TypeFactory.handle();
      handle hWindowHandle = TypeFactory.handle();
      integer iBrowsePosition = TypeFactory.integer();
      integer iFieldsPosition = TypeFactory.integer();
      logical lSbo = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         /* If we are linked to an SBO then retrieve the SDO handle, try to get
              the only datasourcename first then the only updatetargetname.  Otherwise
              we can't invoke the functionality. */
         if (_and(hDataSource.isValid(), () -> new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "instanceOf", hDataSource, "I", "SBO"))))
         {
            lSbo.assign(true);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
            cDataSourceNames.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(numEntries(cDataSourceNames), 1))
            {
               hSdodataSource /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", hDataSource, "I", cDataSourceNames));
            }
            else
            {
               /* {get Prop var [handle]} */ 
               cUpdateTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", targetProcedure()));
               
               if (_isEqual(numEntries(cUpdateTargetNames), 1))
               {
                  hSdodataSource /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", hDataSource, "I", cUpdateTargetNames));
               }
            }
         }
         else
         {
            hSdodataSource.assign(hDataSource);
         }
         /* {fnarg <func-name> <arg> [handle] */
         
         switch (StringHelper.safeTrimTrailing((pcValue).toStringMessage()).toUpperCase())
         {
            case "COMMENTS":
               {
                  if ((hSdodataSource.isValid()).booleanValue())
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                     hContainerSource.assign(ghProp.unwrapBufferField().value());
                     ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
                     hWindowHandle.assign(ghProp.unwrapBufferField().value());
                     
                     if ((gshSessionManager.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeInWithMode("launchContainer", gshSessionManager, "IIIIIIIIIIIOO", new character("gsmcmobjcw"), new character(""), new character(""), new logical(true), new character(""), new character(""), valueOf(hSdodataSource), new character(""), hWindowHandle, hContainerSource, hContainerSource, hNewObject, cProcedureType);
                     }
                  }
               }
               break;
 /* pcProcedureType        */            case "EXPORT":
               {
                  if (_not(lSbo))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedFields"));
                     cFields.assign(ghProp.unwrapBufferField().value());
                     
                     if ((hSdodataSource.isValid()).booleanValue())
                     {
                        ErrorManager.silentErrorEnable();
                        /* If this is a browser, we already have all the browser field names,
                                     but we may have them in the wrong order.  
                                     The user may have moved columns, so make sure they're ordered 
                                     correctly. */
                        hBrowse.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getBrowseHandle", targetProcedure()));
                        ErrorManager.silentErrorDisable();
                        
                        if ((hBrowse.isValid()).booleanValue())
                        {
                           doBlk:
                           for (iBrowsePosition.assign(1); _isLessThanOrEqual(iBrowsePosition, hBrowse.unwrapWidget().getNumColumns()); iBrowsePosition.increment())
                           {
                              ErrorManager.silentErrorEnable();
                              hColumn.assign(hBrowse.unwrapBrowse().getBrowseColumn(iBrowsePosition));
                              iFieldsPosition.assign(lookup(hColumn.unwrapBrowseColumn().bufferField().unwrap().name(), cFields));
                              ErrorManager.silentErrorDisable();
                              
                              if (_or(or(ErrorManager.isError(), () -> isEqual(iFieldsPosition, 0)), () -> isUnknown(iFieldsPosition)))
                              {
                                 continue doBlk;
                              }
                              
                              /* If the field is out of place, swap it with the field currently in its place */
                              if (_isNotEqual(iBrowsePosition, iFieldsPosition))
                              {
                                 cStoreFieldName.assign(entry(iBrowsePosition, cFields));
                                 cFields.replaceEntry(iBrowsePosition, hColumn.unwrapBrowseColumn().bufferField().unwrap().name());
                                 cFields.replaceEntry(iFieldsPosition, cStoreFieldName);
                              }
                           }
                        }
                        /* DO-BLK */
                        ControlFlowOps.invokeInWithMode("transferToExcel", hSdodataSource, "IIII", cFields, new logical(false), new logical(true), new unknown());
                     }
                  }
 /* export not supported for SBOs */;
               }
               break;
            case "PREVIEW":
               {
                  if (_not(lSbo))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedFields"));
                     cFields.assign(ghProp.unwrapBufferField().value());
                     ControlFlowOps.invokeInWithMode("printToCrystal", hSdodataSource, "III", cFields, new logical(false), new unknown());
                  }
 /* preview not supported for SBOs */;
               }
               break;
            case "FILTER":
            case "FIND":
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                  hContainerSource.assign(ghProp.unwrapBufferField().value());
                  ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
                  hWindowHandle.assign(ghProp.unwrapBufferField().value());
                  
                  if ((hDataSource.isValid()).booleanValue())
                  {
                     if ((gshSessionManager.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeInWithMode("launchContainer", gshSessionManager, "IIIIIIIIIIIOO", new character(""), new character("af/sup2/afsdofiltw.w"), new character(""), new logical(true), new character(""), new character(""), new character(""), new character(""), hWindowHandle, hContainerSource, new unknown(), hFilterWindow, cProcedureType /* pcProcedureType      */);
                     }
                     
                     if ((hFilterWindow.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeIn("initializeObject", hFilterWindow);
                        ControlFlowOps.invokeInWithMode("setDataSourceHandle", hFilterWindow, "III", pcValue, hDataSource, targetProcedure());
                     }
                  }
               }
               break;
            case "AUDIT":
               {
                  if ((hSdodataSource.isValid()).booleanValue())
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                     hContainerSource.assign(ghProp.unwrapBufferField().value());
                     ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
                     hWindowHandle.assign(ghProp.unwrapBufferField().value());
                     
                     if ((gshSessionManager.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeInWithMode("launchContainer", gshSessionManager, "IIIIIIIIIIIOO", new character("gstadobjcw"), new character(""), new character(""), new logical(true), new character(""), new character(""), valueOf(hSdodataSource), new character(""), hWindowHandle, hContainerSource, hContainerSource, hNewObject, cProcedureType /* pcProcedureType        */);
                     }
                  }
               }
               break;
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Serves to enable/disable fields when the data visualization <br>
    *              object is linked to an Update SmartPanel for which the type is<br>
    *              'Update'.<br>
    * Parameters:  pcMode AS CHARACTER  update mode<br>
    *              Possible values are:<br>
    *              updateBegin      - Signals that the user has pressed<br>
    *                                 the update button. This is a modal update that<br>
    *                                 only cancel or save can end with UpdateEnd.  <br>
    *              updateEnd        - Signals that the user has pressed the save<br>
    *                                 or cancel button <br>
    *              view             - Signals that the user has pressed the view<br>
    *                                 button.                    <br>
    *              Modify           - Signals that the user has pressed the modify<br>
    *                                 button. This is less modal than Update and<br>
    *                                 and is not included in canNavigate                     <br>
    * Notes:       'updateBegin' signals that the Update button has been pressed <br>
    *              in an Update SmartPanel in Update mode. Enable fields for data <br>
    *              entry. 'updateEnd' signals that Save has completed; disable <br>
    *              fields. 'update-begin' was a state msg in V8. updateEnd <br>
    *              corresponds to the save button dispatching disable-fields in V8.<br>
    *           -
    */
   public void updateMode(final character _pcMode_1)
   {
      character pcMode_1 = TypeFactory.initInput(_pcMode_1);
      character cLogicalObjectName = TypeFactory.character();
      character cRunAttribute = TypeFactory.character();
      character cSecuredTokens = TypeFactory.character();
      handle hTableIosource = TypeFactory.handle();
      logical lSaveSource = TypeFactory.logical();
      handle hGasource = TypeFactory.handle();
      character cTableioType = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("TableIOSource"));
         hTableIosource.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
         lSaveSource.assign(ghProp.unwrapBufferField().value());
         
         /* We change SaveSource to keep track of explicit 'view' and 'modify' requests to be able 
              to avoid the automatic enabling in queryPosition when a record becomes 
              available if the user explicitly pressed view previously. (This also 
              includes the initial ContainerMode 'view' setting, which the dynamic 
              container publishes from its toolbars). 
              queryPosition used to avoid enabling when ContainerMode = view, but the
              ContainerMode now reflects the 'Main' viewer's mode, so it was never enabled 
              again if it was set in view mode automatically when no records existed 
              (i.e due to filter criteria) */
         if (_isEqual(sourceProcedure(), hTableIosource))
         {
            if (_isEqual(pcMode_1, "view"))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
               ghProp.unwrapBufferField().changeValue(new logical(false));
            }
            else
            {
               if (_and(isEqual(lSaveSource, false), () -> isEqual(pcMode_1, "Modify")))
               {
                  /* {get Prop var [handle]} */
                  cTableioType.assign(ControlFlowOps.invokeDynamicFunctionIn("getTableIOType", hTableIosource));
                  
                  if (_isEqual(cTableioType, "Save"))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
                     ghProp.unwrapBufferField().changeValue(new logical(true));
                  }
                  /* {set Prop value [handle]} */ 
               }
            }
            /* {set Prop value [handle]} */ 
         }
         
         /* For modes Modify, Enable and UpdateEnd, we check if security has been set for 'Modify'. 
              If it has, we're going into view mode, end of story. :)  */
         if (_and(gshSecurityManager.isValid(), () -> matchesList("Modify,Enable,UpdateEnd", pcMode_1)))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("containerSource"));
            hContainer.assign(ghProp.unwrapBufferField().value());
            
            if ((hContainer.isValid()).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, hContainer.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
               cLogicalObjectName.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, hContainer.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("runAttribute"));
               cRunAttribute.assign(ghProp.unwrapBufferField().value());
               ControlFlowOps.invokeInWithMode("tokenSecurityGet", gshSecurityManager, "IIIO", hContainer, cLogicalObjectName, cRunAttribute, cSecuredTokens);
               cSecuredTokens.assign(replaceAll(cSecuredTokens, "&", ""));
            }
            
            /* We're going to set the mode to view and make sure the TableIO type is set to update */
            if (_isGreaterThan(lookup("Modify", cSecuredTokens), 0))
            {
               pcMode_1.assign("view");
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
               ghProp.unwrapBufferField().changeValue(new logical(false));
               
               if ((hTableIosource.isValid()).booleanValue())
               {
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode("setTableIOType", hTableIosource, "I", "Update");
               }
            }
         }
         
         /* Set the mode */
         switch (StringHelper.safeTrimTrailing((pcMode_1).toStringMessage()).toUpperCase())
         {
            case "ENABLE":
            case "MODIFY":
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
                  ghProp.unwrapBufferField().changeValue(new character("Modify"));
                  ControlFlowOps.invokeIn("enableFields", targetProcedure());
                  NamedEventManager.publish("resetTableio", targetProcedure());
               }
               break;
            case "VIEW":
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
                  ghProp.unwrapBufferField().changeValue(new character("View"));
                  ControlFlowOps.invokeInWithMode("disableFields", targetProcedure(), "I", new character("All"));
                  NamedEventManager.publish("resetTableio", targetProcedure());
               }
               break;
            case "UPDATEBEGIN":
               {
                  ControlFlowOps.invokeIn("enableFields", targetProcedure());
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
                  ghProp.unwrapBufferField().changeValue(new character("Update"));
                  NamedEventManager.publish("updateState", targetProcedure(), "I", new Object[]
                  {
                     "update"
                  });
               }
               break;
            case "UPDATEEND":
               {
                  /* only disable if SaveSource=no (TablioType=Update) */
                  if (_isEqual(lSaveSource, false))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
                     hGasource.assign(ghProp.unwrapBufferField().value());
                     
                     /* GroupAssignTargets does not have correct SaveSource and 
                                are also disabled and enabled from the source */
                     if (_not(hGasource.isValid()))
                     {
                        ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
                        ghProp.unwrapBufferField().changeValue(new character("View"));
                        ControlFlowOps.invokeInWithMode("disableFields", targetProcedure(), "I", new character("All"));
                     }
                  }
               }
               break;
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     General code to start the save operation.<br>
    *              Procedure to receive a "Save" message from a TableIO source <br>
    *              and send the changed values back to the SmartDataObject.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Invoked when the Save button is pressed on an Update SmartPanel<br>
    *              or a SmartToolbar.<br>
    *              PUBLISHes 'collectChanges' to gather changes made eventually<br>
    *              in any GroupAssign target.<br>
    *              Invokes submitRow() in the Data source that actually applies the<br>
    *              changes to the database.<br>
    *              If any validations failed or errors occured during the save <br>
    *              operation for a field, it brings up the page where the field<br>
    *              is, if necessary and reposition to it.
    */
   public void updateRecord()
   {
      character cValues = TypeFactory.character("");
      character cChangeInfo = TypeFactory.character("");
      logical lSuccess = TypeFactory.logical();
      handle hUpdateTarget = TypeFactory.handle();
      character cTarget = TypeFactory.character();
      character cErrorField = TypeFactory.character();
      integer iErrorField = TypeFactory.integer();
      integer iFields = TypeFactory.integer((long) 0);
      integer iPos = TypeFactory.integer();
      integer iCurrentPage = TypeFactory.integer();
      integer iErrorPage = TypeFactory.integer();
      handle hErrorObject = TypeFactory.handle();
      integer iEntries = TypeFactory.integer();
      character cRowIdent = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      character cNoValidFlds = TypeFactory.character();
      character cNewRecord = TypeFactory.character();
      logical lModified = TypeFactory.logical();
      character cDummy = TypeFactory.character();
      logical lFound = TypeFactory.logical();
      logical lSaveSource = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cRowIdent.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         hUpdateTarget.assign(handle.fromString(cTarget));
         
         if ((hUpdateTarget.isValid()).booleanValue())
         {
            lFound /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "repositionRowObject", hUpdateTarget, "I", cRowIdent));
            
            if (_not(isEqual(lFound, true)))
            {
               returnError(ControlFlowOps.getReturnValue());
            }
         }
         /* Validate the fields */
         ControlFlowOps.invokeInWithMode("validateFields", targetProcedure(), "U", cNoValidFlds);
         
         /* If all the fields are valid go ahead and submit changes */
         if (_isEqual(cNoValidFlds, ""))
         {
            /* First get any changed fields from the current object. */
            ControlFlowOps.invokeInWithMode("collectChanges", targetProcedure(), "UU", cValues, cChangeInfo);
            /* If there are GroupAssign-Targets for this object, get their changed 
                   values and append them to this object's. Using an INPUT-OUTPUT parameter 
                   on the PUBLISH allows each target to add its values to the list. */
            NamedEventManager.publish("collectChanges", targetProcedure(), "UU", new Object[]
            {
               cValues,
               cChangeInfo
            });
            /* {get Prop var [handle]} */ 
            cNewRecord.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", targetProcedure()));
            /* Log Add/Copy flag in case of error */
            /* DataAvailable checks this to avoid redisplay on add, so set it to 'no'
                   in case it was 'add' or' copy' before we call the datasource that 
                   publishes DataAvailable  */
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setNewRecord", targetProcedure(), "I", "No");
            
            /* Note: this is character 'no', not logical*/
            if ((hUpdateTarget.isValid()).booleanValue())
            {
               ghTargetProcedure.assign(targetProcedure());
               lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "submitRow", hUpdateTarget, "II", cRowIdent, cValues));
               ghTargetProcedure.setUnknown();
            }
            else
            {
               ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III",  /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 65), new unknown(), new unknown());
               lSuccess.assign(false);
            }
            
            /* END ELSE DO */
            /* If there are no errors set flags */
            if ((lSuccess).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
               lSaveSource.assign(ghProp.unwrapBufferField().value());
               
               if (_isEqual(lSaveSource, false))
               {
                  ControlFlowOps.invokeInWithMode("updateMode", targetProcedure(), "I", new character("updateEnd"));
               }
               
               /* Ensure that GroupAssign-targets Modified flag is set to FALSE 
                        BEFORE setDataModified as it publishes UpdateActive up the container 
                        link, and each container checks all targets before republishing  */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignLinkProperty", targetProcedure(), "III", "GroupAssign-Target", "DataModified", "no");
               /* setDatamodifed currently publishes 'updateState' only if the modified 
                        property was changed, so check if we need to publish directly */
               /* {get Prop var [handle]} */ 
               lModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
               
               if (_not(lModified))
               {
                  NamedEventManager.publish("updateState", targetProcedure(), "I", new Object[]
                  {
                     "updateComplete"
                  });
               }
               else
               {
                  /* {set Prop value [handle]} */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataModified", targetProcedure(), "I", false);
               }
            }
            else
            {
               /* Display error messages */
               /*
                     cErrorField = {fn showDataMessages}.  _* Get the first field in error. *_
                     */
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setNewRecord", targetProcedure(), "I", cNewRecord);
               
               /* Keep Add/Copy as it was before submit*/
               /* Make sure the toolbar also gets it (SBOs may publish while newRecored is NO) */
               if (_isNotEqual(cNewRecord, "NO"))
               {
                  NamedEventManager.publish("resetTableio", targetProcedure());
                  NamedEventManager.publish("updateState", targetProcedure(), "I", new Object[]
                  {
                     "update"
                  });
               }
               
               if (_notUnknown(lSuccess))
               {
                  ControlFlowOps.invokeInWithMode("showDataMessagesProcedure", targetProcedure(), "O", cErrorField);
               }
               else
               {
                  returnNormal();
               }
               
               /* issue with lSuccess = ? and no errors with appserver partition maintenance */
               if (_or(isEqual(cErrorField, ""), () -> isUnknown(cErrorField)))
               {
                  returnNormal("ADM-ERROR");
               }
               
               iErrorField.assign(divide(plus(lookup(cErrorField, cValues, chr(1)), 1), 2));
               iEntries.assign(numEntries(cChangeInfo));
               iPos.assign(1);
               
               loopLabel8:
               for (iPos.assign(1); _and(_isLessThanOrEqual(iPos, iEntries), isLessThan(iFields, iErrorField)); iPos.assign(plus(iPos, 3)))
               {
                  iFields.assign(plus(iFields, new integer(entry(iPos, cChangeInfo))));
               }
               
               /* END DO iPos */
               /* Deal with case where error field is not in list of changed fields, or 
                        there are no changed fields (could happen in add/copy) */
               if (_and(isGreaterThan(iPos, 0), () -> isGreaterThanOrEqual(numEntries(cChangeInfo), 3)))
               {
                  iPos.assign(minus(iPos, 3));
                   /* DO has incremented iPos, move to prev group */iErrorPage.assign(new integer(entry(plus(iPos, 1), cChangeInfo)));
                  hErrorObject.assign(handle.fromString(entry(plus(iPos, 2), cChangeInfo)));
               }
               else
               {
                  iPos.assign(1);
                  iErrorPage.assign(0);
                  hErrorObject.setUnknown();
               }
            }
         }
         else
         {
            /* add the update cancelled message */
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III",  /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 15), new unknown(), new unknown());
            /*{fn showDataMessages}.    */
            ControlFlowOps.invokeInWithMode("showDataMessagesProcedure", targetProcedure(), "O", cDummy);
            ErrorManager.silentErrorEnable();
            iErrorField.assign(1);
             /* we just pick the first field in the error list*/cErrorField.assign(entry(iErrorField, cNoValidFlds));
            iErrorPage.assign(new integer(entry(plus(iErrorField, 1), cNoValidFlds)));
            hErrorObject.assign(handle.fromString(entry(plus(iErrorField, 2), cNoValidFlds)));
            ErrorManager.silentErrorDisable();
            
            if ((ErrorManager.isError()).booleanValue())
            {
               returnNormal("ADM-ERROR");
            }
         }
         
         /* Validate failed */
         if (_or(hErrorObject.isValid(), () -> isGreaterThan(iErrorPage, 0)))
         {
            iCurrentPage.assign(new integer(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "linkProperty", targetProcedure(), "II", "Container-Source", "CurrentPage")));
            
            /**If validation error or submit error set focus to the error field */
            if (_and(isNotEqual(iErrorPage, 0), () -> isNotEqual(iErrorPage, iCurrentPage)))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hSource.assign(ghProp.unwrapBufferField().value());
               ControlFlowOps.invokeInWithMode("selectPage", hSource, "I", iErrorPage);
            }
            
            ErrorManager.silentErrorEnable();
            /* END DO iErrorPage */
            ControlFlowOps.invokeInWithMode("applyEntry", hErrorObject, "I", cErrorField);
            ErrorManager.silentErrorDisable();
            returnNormal("ADM-ERROR");
         }
         /* if cErrorfield <> '' */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *   Purpose:     Receives the updateState event from DataSources (or GATargets)<br>
    *   Parameters:  pcState AS CHARACTER  update state               <br>
    *                Possible values are:<br>
    *                <br>
    *                update           - Signals that update is in progress<br>
    *                updateComplete   - Signals that update is terminated<br>
    *                <br>
    *       Notes: The updateState has a somewhat ambivalent behavior, since it is <br>
    *              bidirectional, i.e. a visual DataTarget publishes 'updateState', <br>
    *              which is subscribed by tableioSource and DataSource, but it also<br>
    *              subribes to this event from its DataSource. This means that an <br>
    *              'updateState' received form its DataSource actually may originate<br>
    *              from the object.  The republishing is conditional so this never <br>
    *              caused an endless loop, and the main issue was that the toolbar <br>
    *              would receive the event twice on this occasion.                             <br>
    *             <br>
    *             Since some of the attempts to clean this up has had some undesired <br>
    *             effects, the history is kept here for reference: <br>
    *              Group Assign Targets   <br>
    *              - 9.1B GaTargets caused the SDO to receive the event three times. <br>
    *                1. Published from GaSource (addRecord, copyRecord ..) <br>
    *                2. Published from the same method in GaTarget<br>
    *                3. Published from the GASource when received from GaTarget.<br>
    *              - 9.1C always goes through setDataModified, which only <br>
    *                publishes when a change has happened. <br>
    *              <br>
    *              9.1B setdataModified, however did run 'updateState' in GaSource <br>
    *              probably to avoid this.<br>
    *              <br>
    *              In 9.1C this was changed back to a publish (although we might<br>
    *              as well have just setDataModifed directly in the GAsource),<br>
    *              but we certainly did not want to have the run, because we need to <br>
    *              identify the GaTargets as explained above, so we can treat their<br>
    *              events as outbound events and treat the events from dataSources <br>
    *              as inbound pass-thru events.  <br>
    *              'Ricochet' history <br>
    *             How a 'ricochet' was avoided in 9.1B :                    <br>
    *              - The browser always subscribed this from DataSource to be able <br>
    *                to disable/enable, but it never republished.  <br>
    *                It did actually get 'ricochets' when publishing, but avoided <br>
    *                problems by a RETURN when modifed or New in browser.p's override. <br>
    *                This logic is still there, but probably not required.   <br>
    *              - The viewer never subscribed to this from DataSource until a late<br>
    *                9.1B patch.                          <br>
    *              How this was dealt with in 9.1C (FCS).<br>
    *              - Filter out the events received from GATargets and always <br>
    *                pass them through setDataModifed. <br>
    *              - Don't republish otherwise, but publish 'resetTablio', which <br>
    *                only goes to the tableioSource.<br>
    *              - In addition data.p unsubscribed updateState from objects that <br>
    *                were DataTargets AND had 'updateState' as DataSourceEvents before<br>
    *                it republished and subscribed it back after to completely avoid <br>
    *                the that the event got published back to us.<br>
    *              Problems:  <br>
    *                The removal of the 'ricochet' revealed that there were dependencies<br>
    *                on the second updateState, as the toolbar state logic depended on<br>
    *                receiving the event AFTER the visual object's DataSource.<br>
    *                These timing dependencies were removed and in all cases the <br>
    *                result were much 'healthier' code with better encapsulation.<br>
    *                However, at least one customer were actually relying on <br>
    *                updateState being fired back to the originating object.      <br>
    *              Current solution (9.1C patch) <br>
    *                The main change was that the 'ricochet' was reintroduced by <br>
    *                getting rid of the unsubscribe/unsubscribe, which actually was a<br>
    *                relief... instead the DataSource sets a new property <br>
    *                CurrentUpdateSource to the handle of the originating object. <br>
    *                This is checked here to avoid resetTablieo if we are the <br>
    *                originator. The browser's override does the same check and <br>
    *                returns immediately.  <br>
    * Note date: 2002/02/11
    */
   public void updateState(final character _pcState)
   {
      character pcState = TypeFactory.initInput(_pcState);
      handle hCurrSource = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      character cGatarget = TypeFactory.character();
      logical lModified = TypeFactory.logical();
      handle hRequester = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_and(isNotEqual(pcState, "Update"), () -> isNotEqual(pcState, "UpdateComplete")))
         {
            returnNormal("ADM-ERROR");
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTarget"));
         cGatarget.assign(ghProp.unwrapBufferField().value());
         
         /* If this is this an internal change of data, publish to everyone */
         if ((matchesList(cGatarget, valueOf(sourceProcedure()))).booleanValue())
         {
            lModified.assign(isEqual(pcState, "Update"));
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataModified", targetProcedure(), "I", lModified);
         }
         else
         {
            /* Received from a dataSource just tell the toolbar, unless we are 
                   the publisher's currentUpdateSource, which means that we actually are 
                   the original publisher of this event, which then have or will reach the
                   toolbar */
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            /* SBOs does run  so SOURCE is incorrect, so unless we know the 
                   SOURCE is the dataSource check the special trick property   */
            if (_isNotEqual(hDataSource, sourceProcedure()))
            {
               ErrorManager.silentErrorEnable();
               hRequester /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure()));
               ErrorManager.silentErrorDisable();
            }
            else
            {
               hRequester.assign(sourceProcedure());
            }
            
            ErrorManager.silentErrorEnable();
            /* {get Prop var [handle]} */
            hCurrSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getCurrentUpdateSource", hRequester));
            ErrorManager.silentErrorDisable();
            
            if (_isNotEqual(targetProcedure(), hCurrSource))
            {
               NamedEventManager.publish("resetTableio", targetProcedure());
            }
         }
         /* Tableio is only reset for the tablio source linked to this object. 
              Toolbar source needs to be reset when state is updated from 
              objects launched from the toolbar source.   */
         NamedEventManager.publish("resetToolbar", targetProcedure());
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Update window title at end of update - to get rid of - new<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void updateTitle()
   {
      handle hSource = TypeFactory.handle();
      character cWindowTitleField_1 = TypeFactory.character();
      character cWindowTitleColumn = TypeFactory.character();
      character cWindowTitleValue = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      character cWindowName = TypeFactory.character();
      character cWindowTitle = TypeFactory.character();
      handle hContainerSource = TypeFactory.handle();
      handle hContainerHandle = TypeFactory.handle();
      character cContainerMode = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowTitleField"));
         cWindowTitleField_1.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hSource.isValid(), () -> isNotEqual(cWindowTitleField_1, "")))
         {
            cWindowTitleColumn.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", hSource, "I", cWindowTitleField_1));
            
            if (_isEqual(numEntries(cWindowTitleColumn, chr(1)), 2))
            {
               cWindowTitleValue.assign(entry(2, cWindowTitleColumn, chr(1)));
               
               if (_notUnknown(cWindowTitleValue))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                  hContainerSource.assign(ghProp.unwrapBufferField().value());
                  
                  if ((hContainerSource.isValid()).booleanValue())
                  {
                     ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
                     cObjectName.assign(ghProp.unwrapBufferField().value());
                     /* {get Prop var [handle]} */
                     cWindowName.assign(ControlFlowOps.invokeDynamicFunctionIn("getWindowName", hContainerSource));
                     ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
                     hContainerHandle.assign(ghProp.unwrapBufferField().value());
                     /* {get Prop var [handle]} */
                     cContainerMode.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getContainerMode", hContainerSource));
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setwindowTitleViewer", hContainerSource, "I", targetProcedure());
                  }
                  
                  if (_isEqual(indexOf(cWindowName, " - "), 0))
                  {
                     cWindowTitle.assign(cWindowName);
                  }
                  else
                  {
                     cWindowTitle.assign(substring(cWindowName, 1, minus(indexOf(cWindowName, " - "), 1)));
                  }
                  
                  cWindowTitle.assign(concat(cWindowTitle, " - ", _or(isEqual(cContainerMode, "add"), () -> isEqual(cContainerMode, "copy")) ? new character("New") : cWindowTitleValue));
                  
                  if ((hContainerSource.isValid()).booleanValue())
                  {
                     ErrorManager.silentErrorEnable();
                     /* Try to run the manual override. If it fails then we use the setWindowName function. */
                     ControlFlowOps.invokeInWithMode("updateTitleOverride", hContainerSource, "I", cWindowTitle);
                     ErrorManager.silentErrorDisable();
                     
                     if ((ErrorManager.isError()).booleanValue())
                     {
                        /* {set Prop value [handle]} */
                        ControlFlowOps.invokeDynamicFunctionInWithMode("setWindowName", hContainerSource, "I", cWindowTitle);
                     }
                  }
               }
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Validate field of a visual object.     <br>
    * Parameters:  INPUT-OUTPUT pcNotValidFields (char)<br>
    *               - Blank if valid data<br>
    *               - If not valid data comma-separated list of the fieldname, <br>
    *                 Objecthandle and page separated with comma. <br>
    *                 updateRecord will use this to set focus  <br>
    * Notes:     - Called from updateRecord to ensure that data can be saved.<br>
    *              Field validation on leave cannot be trusted because save can be <br>
    *              triggered by accellerators and no-focus buttons (toolbar).<br>
    *            - currently only one error is returned, because validate() <br>
    *              on hidden objects does not give any message we we return <br>
    *              immediately for any error. (We could probably find the validation <br>
    *              message in the visual RowObject handle? )<br>
    *                  <br>
    *            - The validation will always check unmodifed fields, which is <br>
    *              useful for add/copy, but maybe not so useful otherwise as <br>
    *              those fields will not be saved anyway.
    */
   public void validateFields(final character pcNotValidFields)
   {
      logical lOk = TypeFactory.logical();
      integer iPage = TypeFactory.integer();
      handle hContainer = TypeFactory.handle();
      handle hBrowse = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      handle hFld = TypeFactory.handle();
      character cMsg = TypeFactory.character();
      character cType = TypeFactory.character();
      character cTargets = TypeFactory.character();
      integer i = TypeFactory.integer();
      handle hField = TypeFactory.handle();
      character cField = TypeFactory.character();
      character cNewRecord = TypeFactory.character();
      logical lModified = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Currently we handle only ONE error, so return if other subscribers 
              have already found non-valid data. */
         if (_isNotEqual(pcNotValidFields, ""))
         {
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            ErrorManager.silentErrorEnable();
            /* Check if this is a browse. For now at least we don't bother about 
                   overriding this for this simple check) */
            hBrowse.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getBrowseHandle", targetProcedure()));
            ErrorManager.silentErrorDisable();
            
            if ((hBrowse.isValid()).booleanValue())
            {
               hFld.assign(hBrowse.unwrapBrowse().getFirstColumn());
            }
            else
            {
               hFld.assign(hContainer.unwrapTree().firstChild());
                /* skip the fieldgroup */hFld.assign(hFld.unwrapTree().firstChild());
            }
            
            LogicalOp whileClause1 = () -> hFld.isValid();
            
            doWhile("loopLabel9", whileClause1, new Block((Body) () -> 
            {
               if ((HandleOps.canQuery(hFld, "validate")).booleanValue())
               {
                  ErrorManager.silentErrorEnable();
                  lOk.assign(hFld.unwrapWidget().validateFields("ENABLED-FIELDS"));
                  ErrorManager.silentErrorDisable();
                  
                  if (_not(lOk))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
                     iPage.assign(ghProp.unwrapBufferField().value());
                     pcNotValidFields.assign(concat(pcNotValidFields, (_isEqual(pcNotValidFields, "") ? new character("") : new character(",")), hFld.unwrap().name(), ",", valueOf(iPage), ",", valueOf(targetProcedure())));
                     ErrorManager.silentErrorEnable();
                     /* Hidden fields does not validate and subsequently the frame compiled
                                  message is not available in the error-status.              
                                  The validation is inherited from the SDO so we must retrieve 
                                  the validation message from there.  
                                  We check for a local version first, mostly for db based queries,
                                  (but thids allows other objects to have the messages as locales)*/
                     cMsg /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValMsg", targetProcedure(), "I", hFld.unwrap().name()));
                     ErrorManager.silentErrorDisable();
                     
                     if (_isUnknown(cMsg))
                     {
                        /* {get Prop var [handle]} */ 
                        hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
                        ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
                        cType.assign(ghProp.unwrapBufferField().value());
                        cMsg.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValMsg", hDataSource, "I", _and(isEqual(cType, "VIRTUAL"), () -> isNotEqual(hFld.unwrapDatabaseInfo().getTable(), "RowObject")) ? concat(hFld.unwrapDatabaseInfo().getTable(), ".", hFld.unwrap().name()) : hFld.unwrap().name()));
                     }
                     
                     /* if cMsg */
                     ControlFlowOps.invokeInWithMode("AddMessage", targetProcedure(), "III", cMsg, hFld.unwrap().name(), new unknown());
                  }
               }
               
               /* can-query(hfl,validate)*/
               if ((hBrowse.isValid()).booleanValue())
               {
                  hFld.assign(hFld.unwrapBrowseColumn().getNextColumn());
               }
               else
               {
                  hFld.assign(hFld.unwrap().getNextSibling());
               }
            }));
            
            /* do while valid hfld */
            /* {get Prop var [handle]} */ 
            cNewRecord.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", targetProcedure()));
            ErrorManager.silentErrorEnable();
            /* Validate SmartDataFields */
            /* {get Prop var [handle]} */ 
            cTargets.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getContainerTarget", targetProcedure()));
            ErrorManager.silentErrorDisable();
            
            IntegerExpression resExpr4 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cTargets);
               }
            };
            ToClause toClause5 = new ToClause(i, 1, resExpr4);
            
            doTo("loopLabel10", toClause5, new Block((Body) () -> 
            {
               hField.assign(handle.fromString(entry(i, cTargets)));
               lModified.assign(false);
               lOk.assign(true);
               
               if (_isEqual(cNewRecord, "NO"))
               {
                  ErrorManager.silentErrorEnable();
                  /* {get Prop var [handle]} */
                  lModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", hField));
                  ErrorManager.silentErrorDisable();
               }
               
               if (_or(isNotEqual(cNewRecord, "NO"), lModified))
               {
                  ErrorManager.silentErrorEnable();
                  lOk /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn("validateField", hField));
                  ErrorManager.silentErrorDisable();
               }
               
               if (_not(lOk))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
                  iPage.assign(ghProp.unwrapBufferField().value());
                  cField /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getFieldName", hField));
                  pcNotValidFields.assign(concat(pcNotValidFields, (_isEqual(pcNotValidFields, "") ? new character("") : new character(",")), ",", valueOf(iPage), ",", valueOf(hField)));
                  cMsg /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn("validateMessage", hField));
                  ControlFlowOps.invokeInWithMode("AddMessage", targetProcedure(), "III", cMsg, cField, new unknown());
               }
            }));
         }
         /* Check GroupAssignTargets  */
         NamedEventManager.publish("validateFields", targetProcedure(), "U", new Object[]
         {
            pcNotValidFields
         });
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public logical canLaunchDetailWindow()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cFolderWindow = TypeFactory.character();
      
      return function("canLaunchDetailWindow", logical.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         /* {get Prop var [handle]} */ 
         cFolderWindow.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getFolderWindowToLaunch", targetProcedure()));
         ErrorManager.silentErrorDisable();
         returnNormal(isGreaterThan(cFolderWindow, ""));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical canNavigate()
   {
      /*------------------------------------------------------------------------------
        Purpose: Check if the object can allow a navigation 
          Notes: An object cannot navigate if there are uncommited or unsaved
                 changes in the updateTarget or unsaved changes in any of the 
                 Datatargets of the updatetarget. 
               - The check is used as rule for enabling of toolbar actions. This 
                 includes delete and add/copy as navigation is an implicit result 
                 of these actions on the client. 
               - See details in the data.p canNavigate        
      ------------------------------------------------------------------------------*/
      handle hDataObject = TypeFactory.handle();
      logical lNavigate = TypeFactory.logical();
      logical lPending = TypeFactory.logical();
      
      return function("canNavigate", logical.class, new Block((Body) () -> 
      {
         /* we call our own isUpdatePending first. 
             (It will be reached from our UpdateTarget also as part of the check of 
              all targets in canNavigate) */
         ControlFlowOps.invokeInWithMode("IsUpdatePending", targetProcedure(), "U", lPending);
         
         if ((lPending).booleanValue())
         {
            returnNormal(false);
         }
         
         lNavigate.setUnknown();
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         hDataObject.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hDataObject.isValid()))
         {
            /* {get Prop var [handle]} */ 
            hDataObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         }
         
         if ((hDataObject.isValid()).booleanValue())
         {
            ghTargetProcedure.assign(targetProcedure());
            ErrorManager.silentErrorEnable();
            lNavigate /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "canNavigate", hDataObject));
            ErrorManager.silentErrorDisable();
            ghTargetProcedure.setUnknown();
         }
         
         /* if valid data object */
         /* Return false only for active denials. */
         returnNormal(_isEqual(lNavigate, false) ? new logical(false) : new logical(true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getAuditEnabled()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Get the audit enabled for the data source
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hDataSource = TypeFactory.handle();
      logical lAuditEnabled = TypeFactory.logical();
      
      return function("getAuditEnabled", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         ghTargetProcedure.assign(targetProcedure());
         /* {get Prop var [handle]} */
         lAuditEnabled.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAuditEnabled", hDataSource));
         ghTargetProcedure.setUnknown();
         returnNormal(lAuditEnabled);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getCreateHandles()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value (in a list form, comma-separated) of the 
                  handles of the fields in the data visualization object which should 
                  be enabled for an Add or Copy operation.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cHandles = TypeFactory.character();
      
      return function("getCreateHandles", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CreateHandles"));
         cHandles.assign(ghProp.unwrapBufferField().value());
         returnNormal(cHandles);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getDataModified()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a logical value which indicates whether the current 
                  SCREEN-VALUES have been modified but not saved.
         Params:  <none>
          Notes:  This property is set when the user modifies some data on
                  the screen. 
      ------------------------------------------------------------------------------*/
      logical lModified = TypeFactory.logical();
      
      return function("getDataModified", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataModified"));
         lModified.assign(ghProp.unwrapBufferField().value());
         returnNormal(lModified);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDisplayedFields()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value (in a list form, comma-separated) of the 
                  columns displayed by the visualization object.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cFields = TypeFactory.character();
      
      return function("getDisplayedFields", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedFields"));
         cFields.assign(ghProp.unwrapBufferField().value());
         returnNormal(cFields);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDisplayedTables()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the list of SDO table names used by the visualization.
                  May be just "RowObject" or if the object was built against an
                  SBO, will be the list of SDO ObjectNames whose fields are used.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cTables = TypeFactory.character();
      
      return function("getDisplayedTables", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedTables"));
         cTables.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTables);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getEditable()
   {
      /*------------------------------------------------------------------------------
        Purpose: Indicates whether this object can be edited (add/copy/save/update) 
          Notes: This defaults to true if any enabled fields is defined here or in 
                 any GroupAssingTarget.     
                 Used by the toolbar to indicate whether actions like add/copy etc
                 should be enabled. 
        ------------------------------------------------------------------------------*/
      logical lEditable = TypeFactory.logical();
      character cTargets = TypeFactory.character();
      integer iTarget = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      character cEnabledFields = TypeFactory.character();
      
      return function("getEditable", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Editable"));
         lEditable.assign(ghProp.unwrapBufferField().value());
         
         /* If undefined, we check for Enabled fields here and if no found we
              call the same function in all GroupAssignTarget, which then will do
              the same check in it self an all its GroupAssignTargets */
         if (_isUnknown(lEditable))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("EnabledFields"));
            cEnabledFields.assign(ghProp.unwrapBufferField().value());
            lEditable.assign(isNotEqual(cEnabledFields, ""));
            
            if (_not(isEqual(lEditable, true)))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTarget"));
               cTargets.assign(ghProp.unwrapBufferField().value());
               
               IntegerExpression resExpr5 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cTargets);
                  }
               };
               ToClause toClause6 = new ToClause(iTarget, 1, resExpr5);
               
               doTo("loopLabel11", toClause6, new Block((Body) () -> 
               {
                  hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
                  /* {get Prop var [handle]} */
                  lEditable.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getEditable", hTarget));
                  
                  /* We don't need to look further if an editable target was found */
                  if ((lEditable).booleanValue())
                  {
                     leave("loopLabel11");
                  }
               }));
            }
            /* Store the property so we don't need to perform this loop again */
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setEditable", targetProcedure(), "I", lEditable);
         }
         /* lEditable = ? (Property not defined yet) */
         returnNormal(lEditable);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getEnabledFields()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value (in a list form, comma-separated) of the 
                  enabled fields (name) in this object which map to fields in the 
                  SmartDataObject (&ENABLED-FIELDS).
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cFields = TypeFactory.character();
      
      return function("getEnabledFields", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("EnabledFields"));
         cFields.assign(ghProp.unwrapBufferField().value());
         returnNormal(cFields);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getEnabledHandles()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value (in a list form, comma-separared) of the 
                  handles of the enabled fields in the visualization object.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cHandles = TypeFactory.character();
      
      return function("getEnabledHandles", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("EnabledHandles"));
         cHandles.assign(ghProp.unwrapBufferField().value());
         returnNormal(cHandles);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getEnabledObjFldsToDisable()
   {
      /*------------------------------------------------------------------------------
        Purpose: This property decides whether non-db objects should be disabled
                 when the fields are disabled.
                 - (None)  - EnabledObjFlds remain enabled when the fields are 
                             disabled.  
                 - (All)   - EnabledObjFlds should be disabled in view mode
                 - Comma separated list of object names that will be disabled in view
                   mode.               
          Notes:  
      ------------------------------------------------------------------------------*/
      character cDisable = TypeFactory.character();
      logical lUseRepository = TypeFactory.logical();
      character cDataSourceFields = TypeFactory.character();
      handle hTableioSource = TypeFactory.handle();
      character cUibmode = TypeFactory.character();
      handle hGaSource = TypeFactory.handle();
      handle hTableioTarget = TypeFactory.handle();
      
      return function("getEnabledObjFldsToDisable", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("EnabledObjFldsToDisable"));
         cDisable.assign(ghProp.unwrapBufferField().value());
         
         /* ? or blank means use default */
         if (_or(isUnknown(cDisable), () -> isEqual(cDisable, "")))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
            cUibmode.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(cUibmode, "Design"))
            {
               returnNormal(cDisable);
            }
            
            /* Default is (none) for adm2 and (all) for dynamics in order to 
                  be backward compatible with both. */
            /* {get Prop var [handle]} */ 
            lUseRepository.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUseRepository", targetProcedure()));
            
            if ((lUseRepository).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedFields"));
               cDataSourceFields.assign(ghProp.unwrapBufferField().value());
               
               if (_isEqual(cDataSourceFields, ""))
               {
                  cDisable.assign("(None)");
               }
               else
               {
                  /* Check if the top most GASource is a tableioTarget */
                  hTableioTarget.assign(targetProcedure());
                  
                  loopLabel12:
                  while (true)
                  {
                     ghProp.assign(handle.fromString(entry(1, hTableioTarget.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
                     hGaSource.assign(ghProp.unwrapBufferField().value());
                     
                     if (_not(hGaSource.isValid()))
                     {
                        break loopLabel12;
                     }
                     else
                     {
                        hTableioTarget.assign(hGaSource);
                     }
                  }
                  
                  ghProp.assign(handle.fromString(entry(1, hTableioTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("TableioSource"));
                  hTableioSource.assign(ghProp.unwrapBufferField().value());
                  
                  if ((hTableioSource.isValid()).booleanValue())
                  {
                     cDisable.assign("(All)");
                  }
                  else
                  {
                     cDisable.assign("(None)");
                  }
               }
            }
            else
            {
               cDisable.assign("(None)");
            }
            /* store it for the next time */
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setEnabledObjFldsToDisable", targetProcedure(), "I", cDisable);
         }
         /* NOTE: If Design mode the prop was returned as-is above */
         returnNormal(cDisable);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getFieldHandles()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value  (in a list form, comma-separated) of the 
                  handles of the Data Fields in the visualization object.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cHandles = TypeFactory.character();
      
      return function("getFieldHandles", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FieldHandles"));
         cHandles.assign(ghProp.unwrapBufferField().value());
         returnNormal(cHandles);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getFieldsEnabled()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a logical value indicating whether the fields in this 
                  visualization object are enabled or not.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      logical lEnabled = TypeFactory.logical();
      
      return function("getFieldsEnabled", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FieldsEnabled"));
         lEnabled.assign(ghProp.unwrapBufferField().value());
         returnNormal(lEnabled);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getFilterActive()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns whether the dataSource has a logical filter 
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hSource = TypeFactory.handle();
      logical lActive = TypeFactory.logical();
      
      return function("getFilterActive", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if ((hSource.isValid()).booleanValue())
         {
            ghTargetProcedure.assign(targetProcedure());
            /* {get Prop var [handle]} */
            lActive.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getFilterActive", hSource));
            ghTargetProcedure.setUnknown();
         }
         
         returnNormal(lActive);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getGroupAssignHidden()
   {
      /*------------------------------------------------------------------------------
        Purpose: Check if the object is hidden and will remain hidden including 
                 ALL GroupAssignTargets
          Notes: Used by the data.p LinkState to check if it can deactivate the link
                 and how to republish the message.
                 Returns false as soon as any visible object is found.
               - Checks pendingPage in order to return NO if it is becoming visible.             
      ------------------------------------------------------------------------------*/
      character cTargets = TypeFactory.character();
      integer iTarget = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      logical lHidden = TypeFactory.logical();
      integer iObjectPage = TypeFactory.integer();
      handle hContainer = TypeFactory.handle();
      integer iPendingPage = TypeFactory.integer();
      handle hTableio = TypeFactory.handle();
      logical lToolbarDisabled = TypeFactory.logical();
      character cInactiveLinks = TypeFactory.character();
      
      return function("getGroupAssignHidden", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lHidden.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getObjectHidden", targetProcedure()));
         
         if (_not(lHidden))
         {
            returnNormal(false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
         iObjectPage.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */
         iPendingPage.assign(ControlFlowOps.invokeDynamicFunctionIn(integer.class, "getPendingPage", hContainer));
         
         if (_isEqual(iPendingPage, iObjectPage))
         {
            returnNormal(false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InactiveLinks"));
         cInactiveLinks.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(lookup("TableioSource", cInactiveLinks), 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("TableioSource"));
            hTableio.assign(ghProp.unwrapBufferField().value());
            
            if ((hTableio.isValid()).booleanValue())
            {
               /* {get Prop var [handle]} */
               cTargets.assign(ControlFlowOps.invokeDynamicFunctionIn("getTableioTarget", hTableio));
               
               if (_isEqual(cTargets, valueOf(targetProcedure())))
               {
                  /* {get Prop var [handle]} */
                  lToolbarDisabled.assign(ControlFlowOps.invokeDynamicFunctionIn("getDeactivateTargetOnHide", hTableio));
                  ghProp.assign(handle.fromString(entry(1, hTableio.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
                  iObjectPage.assign(ghProp.unwrapBufferField().value());
                  
                  /* page 0 and we're the only target. */
                  if (_and(isEqual(iObjectPage, 0), not(lToolbarDisabled)))
                  {
                     returnNormal(false);
                  }
               }
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr6 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargets);
            }
         };
         ToClause toClause7 = new ToClause(iTarget, 1, resExpr6);
         
         doTo("loopLabel13", toClause7, new Block((Body) () -> 
         {
            hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
            /* {get Prop var [handle]} */
            lHidden.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getGroupAssignHidden", hTarget));
            
            if (_not(lHidden))
            {
               returnNormal(false);
            }
         }));
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getGroupAssignSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a handle value representing the handle of the 
                  object's GroupAssign source.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hSource = TypeFactory.handle();
      
      return function("getGroupAssignSource", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(hSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getGroupAssignSourceEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value (in a list form, comma-separated) of the 
                  events this object wants to subscribe to in its GroupAssign source.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getGroupAssignSourceEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSourceEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getGroupAssignTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value of the handle of the 
                  object's GroupAssign target.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cTarget = TypeFactory.character();
      
      return function("getGroupAssignTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTarget);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getGroupAssignTargetEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value (in a list form, comma-separated) of the 
                  events this object wants to subscribe to in its GroupAssign target.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getGroupAssignTargetEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTargetEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getLabel()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns the LABEL defined for the DataSource object 
      ------------------------------------------------------------------------------*/
      character cLabel = TypeFactory.character();
      handle hDataSource = TypeFactory.handle();
      character cSourceNames = TypeFactory.character();
      character cDataSourceName = TypeFactory.character();
      
      return function("getLabel", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Label"));
         cLabel.assign(ghProp.unwrapBufferField().value());
         
         if (_isUnknown(cLabel))
         {
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
            cSourceNames.assign(ghProp.unwrapBufferField().value());
            
            if ((hDataSource.isValid()).booleanValue())
            {
               /* The SBO Label is really useless, so if SourceNames is defined we need 
                        to get the handle of the actual Source */
               if (_isGreaterThan(cSourceNames, ""))
               {
                  if (_isGreaterThan(numEntries(cSourceNames), 1))
                  {
                     cSourceNames.assign(entry(1, cSourceNames));
                  }
                  else
                  {
                     ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
                     cDataSourceName.assign(ghProp.unwrapBufferField().value());
                  }
                  /* {get Prop var [handle]} */ 
                  
                  if (_isNotEqual(cSourceNames, cDataSourceName))
                  {
                     hDataSource /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", hDataSource, "I", cSourceNames));
                  }
               }
               /* {get Prop var [handle]} */
               cLabel.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getLABEL", hDataSource));
            }
            
            if (_or(isUnknown(cLabel), () -> isEqual(cLabel, "")))
            {
               cLabel.assign(((character) ControlFlowOps.runSuper("getLabel")));
            }
            
            if (_and(notUnknown(cLabel), () -> isNotEqual(cLabel, "")))
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setLABEL", targetProcedure(), "I", cLabel);
            }
         }
         returnNormal(cLabel);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getModifyFields()
   {
      /*------------------------------------------------------------------------------
        Purpose: This property decides which enabled fields that should set 
                 DataModified when the fields are changed.
                 - (All)   - All EnabledObjects should set DataModified
                 - (EnabledFields) - Only EnabledFields (Fields from the DataSource) 
                                     should set DataModified
                 - (Updatable) - Only EnabledFields that are updatable in the 
                                 DataSource should set DataModified 
                 - (None)  - No EnabledObjects should set DataModified
                 - Comma separated list of object names that will set DataModified 
          Notes:  
      ------------------------------------------------------------------------------*/
      character cModifyFields = TypeFactory.character();
      
      return function("getModifyFields", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ModifyFields"));
         cModifyFields.assign(ghProp.unwrapBufferField().value());
         returnNormal(cModifyFields);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getNewRecord()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value that indicates whether the current record 
                  in the visualization object is newly created or not.
                  Possible values are: Add, Copy, No          
          Notes:   
      ------------------------------------------------------------------------------*/
      character cNew = TypeFactory.character();
      
      return function("getNewRecord", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NewRecord"));
         cNew.assign(ghProp.unwrapBufferField().value());
         returnNormal(cNew);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getObjectMode()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns the mode of the object 
                 - modify (This is a non-modal mode that can be turned off with view
                 - update (This is a modal mode that is turned off with save or cancel)
                 - view   (not editable) 
          Notes:  
      ------------------------------------------------------------------------------*/
      character cObjectMode = TypeFactory.character();
      
      return function("getObjectMode", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
         cObjectMode.assign(ghProp.unwrapBufferField().value());
         returnNormal(cObjectMode);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getObjectParent()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a handle value of the Progress parent container handle 
                  for the current visualization object.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("getObjectParent", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            if ((hContainer.unwrapWidget().getFrameHandle().isValid()).booleanValue())
            {
               returnNormal(hContainer.unwrapWidget().getFrameHandle());
            }
            else
            {
               if ((hContainer.unwrapWidget().getParentHandle().isValid()).booleanValue())
               {
                  returnNormal(hContainer.unwrapWidget().getParentHandle());
               }
               else
               {
                  returnNormal(new handle());
               }
            }
         }
         else
         {
            returnNormal(new handle());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getPrintPreviewActive()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns true if the print preview functionality is active
          Notes: Ensure check is only done once in session, then use value of
                 property from then on.
      ------------------------------------------------------------------------------*/
      logical lPreviewActive_1 = TypeFactory.logical();
      
      return function("getPrintPreviewActive", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PrintPreviewActive"));
         lPreviewActive_1.assign(ghProp.unwrapBufferField().value());
         
         /* not checked yet */
         if (_isUnknown(lPreviewActive_1))
         {
         }
         
         returnNormal(lPreviewActive_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getRecordState()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value indicating if a record is available or not.
                  Possible values are: RecordAvailable, NoRecorAvailable
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cState = TypeFactory.character();
      
      return function("getRecordState", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RecordState"));
         cState.assign(ghProp.unwrapBufferField().value());
         returnNormal(cState);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getRowIdent()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value representing the RowIdent of the current 
                  row in the visualization.
        Params:   <none>
        Notes:    The DB rowids may be stored as the second entry of the list, if the 
                  updateTarget is an SDO.         
        SBO:      When connected to an SBO the rowids returned are a semi-colon 
                  separated list corresponding to the SBOs DataObjectNames, 
                  if the SBO is a valid UpdateTarget the rowids are for the 
                  UpdateTargetNames, otherwise the DataSourceNames are used.      
                - We want to return only the rowids that uniquely identifies this 
                  objects connection to the dataSource/updateTarget and remove 
                  unnecessary rowids so the property can be used directly as input 
                  to update methods in the SBO. 
                  The assumption is of course that all tables that only are displayed 
                  in the visual object are on the 'one' side of a one-to-many or 
                  many-to-one relation of the table that is updated, so that they are
                  uniquely identified through the updateable table and their rowids 
                  are not part of this object 'Ident'.  
                  We do however return more than one rowid for the case were more
                  than one SDO is updated as one-to-one in the SBO. 
      ------------------------------------------------------------------------------*/
      handle hSbo = TypeFactory.handle();
      character cRowIdent = TypeFactory.character();
      character cDataObjectNames = TypeFactory.character();
      character cVisualNames = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      character cGatargets = TypeFactory.character();
      handle hGatarget = TypeFactory.handle();
      integer iGa = TypeFactory.integer();
      character cGarowident = TypeFactory.character();
      integer iRowident = TypeFactory.integer();
      character cRowid = TypeFactory.character();
      character cGarowid = TypeFactory.character();
      
      return function("getRowIdent", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowIdent"));
         cRowIdent.assign(ghProp.unwrapBufferField().value());
         
         /* If we update an SBO with more than one SDO, the property are '' delimited.*/
         if (_isGreaterThan(numEntries(cRowIdent, ";"), 1))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
            hSbo.assign(ghProp.unwrapBufferField().value());
            
            /* If update link, we use UpdateTargetNames. */
            if ((hSbo.isValid()).booleanValue())
            {
               /* {get Prop var [handle]} */ 
               cVisualNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", targetProcedure()));
            }
            else
            {
               /* {get Prop var [handle]} */ 
               hSbo.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
               cVisualNames.assign(ghProp.unwrapBufferField().value());
            }
            
            if (_not(hSbo.isValid()))
            {
               returnNormal("");
            }
            
            /* Don't return ? as this means current record in the 
                                  update methids */
            /* {get Prop var [handle]} */
            cDataObjectNames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", hSbo));
            
            loopLabel14:
            for (iObject.assign(1); _isLessThanOrEqual(iObject, numEntries(cDataObjectNames)); iObject.increment())
            {
               cObjectName.assign(entry(iObject, cDataObjectNames));
               
               if (_not(matchesList(cVisualNames, cObjectName)))
               {
                  cRowIdent.replaceEntry(iObject, ";", "");
               }
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTarget"));
            cGatargets.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr7 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cGatargets);
               }
            };
            ToClause toClause8 = new ToClause(iGa, 1, resExpr7);
            
            doTo("loopLabel15", toClause8, new Block((Body) () -> 
            {
               hGatarget.assign(handle.fromString(entry(iGa, cGatargets)));
               /* {get Prop var [handle]} */
               cGarowident.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", hGatarget));
               
               if (_notUnknown(cGarowident))
               {
                  loopLabel16:
                  for (iRowident.assign(1); _isLessThanOrEqual(iRowident, numEntries(cRowIdent, ";")); iRowident.increment())
                  {
                     cRowid.assign(entry(iRowident, cRowIdent, ";"));
                     
                     /* if we have ? unavail or nothing check the GA's rowid */
                     if (_or(isEqual(cRowid, "?"), () -> isEqual(cRowid, "")))
                     {
                        /* if the GA's is neither unavail or nothing then use it. */
                        cGarowid.assign(entry(iRowident, cGarowident, ";"));
                        
                        if (_or(isNotEqual(cGarowid, "?"), () -> isNotEqual(cGarowid, "")))
                        {
                           cRowIdent.replaceEntry(iRowident, ";", cGarowid);
                        }
                     }
                  }
               }
            }));
         }
         else
         {
            /* If rowid was set from rowobject:rowid, which is common for the browse,
                    ensure that it is returned in the SBO format if required, in this case 
                    the dataSourcename and updatetargetname is the same so we just check
                    dataSourcenames */
            /* {get Prop var [handle]} */ 
            hSbo.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            if ((hSbo.isValid()).booleanValue())
            {
               ErrorManager.silentErrorEnable();
               /* {get Prop var [handle]} */
               cDataObjectNames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", hSbo));
               ErrorManager.silentErrorDisable();
               
               if (_isGreaterThan(numEntries(cDataObjectNames), 1))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
                  cVisualNames.assign(ghProp.unwrapBufferField().value());
                  cRowid.assign(cRowIdent);
                  cRowIdent.assign(fill(";", minus(numEntries(cDataObjectNames), 1)));
                  cRowIdent.replaceEntry(lookup(cVisualNames, cDataObjectNames), ";", cRowid);
               }
            }
         }
         returnNormal(cRowIdent);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getSaveSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns true if the tableiosource is a Save and false if 'Update' 
                  ( modal update )
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lSaveSource = TypeFactory.logical();
      
      return function("getSaveSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
         lSaveSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(lSaveSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getTableIosource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a handle value representing the handle of the 
                  object's TableIO Source.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hSource = TypeFactory.handle();
      
      return function("getTableIOSource", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("TableIOSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(hSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getTableIosourceEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value (in a list form, comma-separated) of the 
                  events this object wants to subscribe to in its Tableio source.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getTableIOSourceEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("TableIOSourceEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getTargetProcedure()
   {
      return function("getTargetProcedure", handle.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Temporary fn to return the source-procedure's target-procedure
                     to a function such as addRow in an SBO who needs to know who
                     the *real* caller object is.
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(ghTargetProcedure);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getToolbarSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the handle(s) of the object's toolbar-source.
         Params:  <none>
          Notes:   
      ------------------------------------------------------------------------------*/
      character cSource = TypeFactory.character();
      
      return function("getToolbarSource", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ToolbarSource"));
         cSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(cSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getToolbarSourceEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the list of events to be subscribed to in the
                  Toolbar-Source.  
         Params:  <none>
          Notes:             
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getToolbarSourceEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ToolbarSourceEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getUpdateTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a character value of the handle of the 
                  object's Update Target.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cTarget = TypeFactory.character();
      
      return function("getUpdateTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTarget);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getUpdateTargetNames()
   {
      /*------------------------------------------------------------------------------
       Purpose:  Returns the ObjectName of the Data Object to be updated by this
                 visual object. This would be set if the Update-Target is an SBO
                 or other Container with DataObjects.
        Params:  <none>
         Notes: Currently used when visual objects designed against an SDO with 
                RowObject is linked to an SBO.  
      ------------------------------------------------------------------------------*/
      character cTargetNames = TypeFactory.character();
      character cGaTargetNames = TypeFactory.character();
      character cGaTargets = TypeFactory.character();
      integer iGa = TypeFactory.integer();
      handle hGatarget = TypeFactory.handle();
      integer iGaNames = TypeFactory.integer();
      character cGaName = TypeFactory.character();
      
      return function("getUpdateTargetNames", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTargetNames"));
         cTargetNames.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTarget"));
         cGaTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr8 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cGaTargets);
            }
         };
         ToClause toClause9 = new ToClause(iGa, 1, resExpr8);
         
         doTo("loopLabel17", toClause9, new Block((Body) () -> 
         {
            hGatarget.assign(handle.fromString(entry(iGa, cGaTargets)));
            /* {get Prop var [handle]} */
            cGaTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", hGatarget));
            
            if (_and(notUnknown(cGaTargetNames), () -> isNotEqual(cGaTargetNames, "")))
            {
               loopLabel18:
               for (iGaNames.assign(1); _isLessThanOrEqual(iGaNames, numEntries(cGaTargetNames)); iGaNames.increment())
               {
                  cGaName.assign(entry(iGaNames, cGaTargetNames));
                  
                  if (_isEqual(lookup(cGaName, cTargetNames), 0))
                  {
                     cTargetNames.assign(concat(cTargetNames, (_isEqual(cTargetNames, "") ? new character("") : new character(",")), cGaName));
                  }
               }
            }
         }));
         
         /* loop thru GATargets */
         returnNormal(cTargetNames);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getWindowTitleField()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cWindowTitleField_1 = UndoableFactory.character();
      
      return function("getWindowTitleField", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowTitleField"));
         cWindowTitleField_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cWindowTitleField_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasActiveAudit()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hSource = TypeFactory.handle();
      
      return function("hasActiveAudit", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if ((hSource.isValid()).booleanValue())
         {
            ghTargetProcedure.assign(targetProcedure());
            returnNormal( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasActiveAudit", hSource));
         }
         
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasActiveComments()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hSource = TypeFactory.handle();
      
      return function("hasActiveComments", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if ((hSource.isValid()).booleanValue())
         {
            ghTargetProcedure.assign(targetProcedure());
            returnNormal( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasActiveComments", hSource));
         }
         
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle internalWidgetHandle(final character _pcField_1, final character _pcSearchMode_1)
   {
      character pcField_1 = TypeFactory.initInput(_pcField_1);
      character pcSearchMode_1 = TypeFactory.initInput(_pcSearchMode_1);
      /*------------------------------------------------------------------------------
        Purpose:  Return handle of named widget within this object  
          Notes:  This version is for datavisual objects and uses search mode
                  to determine whether to search for datafields or invoke 
                  the SUPER version to search for local fields as well.
                  Valid values are:
                  ALL - searches datafields and local fields (if it doesn't find 
                                                              datafield)
                  DATA - searches datafields only
                  LOCAL - searches local field only
      ------------------------------------------------------------------------------*/
      character cFieldNames = TypeFactory.character();
      character cFieldHandles = TypeFactory.character();
      integer iFieldPos = TypeFactory.integer();
      handle hField = TypeFactory.handle();
      
      return function("internalWidgetHandle", handle.class, new Block((Body) () -> 
      {
         if (_isGreaterThan(lookup(pcSearchMode_1, "ALL,DATA"), 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedFields"));
            cFieldNames.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FieldHandles"));
            cFieldHandles.assign(ghProp.unwrapBufferField().value());
            iFieldPos.assign(lookup(pcField_1, cFieldNames));
            
            if (_and(isNotEqual(iFieldPos, 0), () -> isGreaterThanOrEqual(numEntries(cFieldHandles), iFieldPos)))
            {
               hField.assign(handle.fromString(entry(iFieldPos, cFieldHandles)));
            }
         }
         
         /* if mode is all or data */
         if ((hField.isValid()).booleanValue())
         {
            returnNormal(hField);
         }
         else
         {
            if (_isGreaterThan(lookup(pcSearchMode_1, "ALL,LOCAL"), 0))
            {
               returnNormal((handle) ControlFlowOps.runSuper("internalWidgetHandle", pcField_1, pcSearchMode_1));
            }
            else
            {
               returnNormal(new handle());
            }
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical okToContinue(final character _pcAction_1)
   {
      character pcAction_1 = TypeFactory.initInput(_pcAction_1);
      /*------------------------------------------------------------------------------
        Purpose:  Check if the visual object have modified screen data or 
                  if its data-source has uncommitted changes.
                  If any of these conditions are true we issue Yes-No-Cancel 
                  questions offering the user to answer 
                    YES     to save/commit and continue the action.  TRUE
                    NO      to cancel/undo and continue the action.  TRUE
                    CANCEL  to NOT continue the action.              FALSE
       Parameters: pcAction (char) - Used to retrieve correct message. 
                           - exit   - Exit/close of application window.
                           - blank  - Continue  
                           - Commit - Commit 
                           - Undo   - Undo (Don't offer save as an option) 
          Notes:   -  confirmExit and confirmOpenQuery uses this function.
      ------------------------------------------------------------------------------*/
      logical lModified = TypeFactory.logical();
      logical lAnswer = TypeFactory.logical();
      handle hDataSource = TypeFactory.handle();
      character cRowObjectState = TypeFactory.character();
      character cOperation = TypeFactory.character();
      handle hGasource = TypeFactory.handle();
      character cNewRecord = TypeFactory.character();
      
      return function("okToContinue", logical.class, new Block((Body) () -> 
      {
         cOperation.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", _isEqual(pcAction_1, "Exit") ? new integer(21) /* Exit */ : _isEqual(pcAction_1, "Commit") ? new integer(31) : new integer( /* Commit */22)));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         hGasource.assign(ghProp.unwrapBufferField().value());
         
         /* We trust that all checks will be performed against the GA Source */
         if ((hGasource.isValid()).booleanValue())
         {
            returnNormal(true);
         }
         
         /* If lModified ask the user what to do. */
         /* {get Prop var [handle]} */ 
         lModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
         /* {get Prop var [handle]} */ 
         cNewRecord.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", targetProcedure()));
         
         if (_or(lModified, () -> and(isNotEqual(cNewRecord, "NO"), () -> isNotEqual(pcAction_1, "Exit"))))
         {
            if (_isNotEqual(pcAction_1, "Undo"))
            {
               lAnswer.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", concat("3,", cOperation, ",YesNoCancel")));
            }
            else
            {
               lAnswer.assign(not(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", "32,OkCancel"))));
               
               if ((lAnswer).booleanValue())
               {
                  lAnswer.setUnknown();
               }
            }
            
            /* Yes to save changes */
            if ((lAnswer).booleanValue())
            {
               ControlFlowOps.invokeIn("updateRecord", targetProcedure());
               
               /* Do not continue if error */
               if (_isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
               {
                  returnNormal(false);
               }
            }
            else
            {
               if (_not(lAnswer))
               {
                  ControlFlowOps.invokeIn("cancelRecord", targetProcedure());
               }
               else
               {
 /* lAnswer = ? */
                  returnNormal(false);
               }
            }
         }
         else
         {
            if (_and(isNotEqual(cNewRecord, "NO"), () -> isEqual(pcAction_1, "EXIT")))
            {
               ControlFlowOps.invokeIn("cancelRecord", targetProcedure());
            }
         }
         
         /* Check if there are any uncommited changes in the data-source. 
               Avoid this for undo and commit of course... */
         if (_not(matchesList("Undo,Commit", pcAction_1)))
         {
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            if ((hDataSource.isValid()).booleanValue())
            {
               ErrorManager.silentErrorEnable();
               /* use no-error in case of db query */
               cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", hDataSource));
               ErrorManager.silentErrorDisable();
               
               if (_isEqual(cRowObjectState, "RowUpdated"))
               {
                  lAnswer.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", concat("20,", cOperation, ",YesNoCancel")));
                  
                  if ((lAnswer).booleanValue())
                  {
                     ControlFlowOps.invokeIn("commitTransaction", hDataSource);
                     
                     /* Do not continue if error */
                     if (_isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
                     {
                        returnNormal(false);
                     }
                  }
                  else
                  {
                     if (_not(lAnswer))
                     {
                        ControlFlowOps.invokeIn("undoTransaction", hDataSource);
                     }
                     else
                     {
 /* lAnswer = ? so don't continue */
                        returnNormal(false);
                     }
                  }
               }
            }
         }
         /* pcAction <> undo,commit*/
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDataModified(final logical _plModified_1)
   {
      logical plModified_1 = TypeFactory.initInput(_plModified_1);
      /*------------------------------------------------------------------------------
        Purpose:  Assigns a logical value to the DataModified property indicating 
                  that there are unsaved changes in a data visualization object.
         Params:  lModified AS LOGICAL -- TRUE or FALSE 
          Notes:  Also PUBLISHEes the UpdateState event to tell other objects
                  unless the special value of Unknown is passed, which means
                  to set DataModified to no without doing UpdateComplete, but Reset
                  which will ensure that the toolbar/panel does not publish 
                  updateMode('UpdateEnd')    
      ------------------------------------------------------------------------------*/
      character cState = TypeFactory.character();
      handle hGasource = TypeFactory.handle();
      logical lChanged = TypeFactory.logical();
      logical lDataModified = TypeFactory.logical();
      logical lNewModified = TypeFactory.logical();
      
      return function("setDataModified", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataModified"));
         lDataModified.assign(ghProp.unwrapBufferField().value());
         lChanged.assign(or(isNotEqual(plModified_1, lDataModified), () -> isUnknown(plModified_1)));
         lNewModified.assign(_isUnknown(plModified_1) ? new logical(false) : plModified_1);
         cState.assign(_isUnknown(plModified_1) ? new character("Reset") : _isEqual(plModified_1, true) ? new character("Update") : new character("UpdateComplete"));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataModified"));
         ghProp.unwrapBufferField().changeValue(lNewModified);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         hGasource.assign(ghProp.unwrapBufferField().value());
         
         if ((hGasource.isValid()).booleanValue())
         {
            if (_isEqual(cState, "Update"))
            {
               NamedEventManager.publish("UpdateState", targetProcedure(), "I", new Object[]
               {
                  cState
               });
            }
         }
         else
         {
            if ((lChanged).booleanValue())
            {
               /* up the dataSource chain */
               NamedEventManager.publish("UpdateState", targetProcedure(), "I", new Object[]
               {
                  cState
               });
               /* Up the containerSource chain */
               NamedEventManager.publish("UpdateActive", targetProcedure(), "I", new Object[]
               {
                  _isUnknown(plModified_1) ? new logical(false) : plModified_1
               });
            }
         }
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDisplayedFields(final character _pcFieldList_2)
   {
      character pcFieldList_2 = TypeFactory.initInput(_pcFieldList_2);
      
      return function("setDisplayedFields", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DisplayedFields"));
         ghProp.unwrapBufferField().changeValue(pcFieldList_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setEditable(final logical _plEditable_1)
   {
      logical plEditable_1 = TypeFactory.initInput(_plEditable_1);
      
      return function("setEditable", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Editable"));
         ghProp.unwrapBufferField().changeValue(plEditable_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setEnabledFields(final character _pcFieldList_2)
   {
      character pcFieldList_2 = TypeFactory.initInput(_pcFieldList_2);
      
      return function("setEnabledFields", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("EnabledFields"));
         ghProp.unwrapBufferField().changeValue(pcFieldList_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setEnabledHandles(final character _pcHandles_2)
   {
      character pcHandles_2 = TypeFactory.initInput(_pcHandles_2);
      
      return function("setEnabledHandles", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("EnabledHandles"));
         ghProp.unwrapBufferField().changeValue(pcHandles_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setEnabledObjFldsToDisable(final character _pcEnabledObjFldsToDisable_1)
   {
      character pcEnabledObjFldsToDisable_1 = TypeFactory.initInput(_pcEnabledObjFldsToDisable_1);
      
      return function("setEnabledObjFldsToDisable", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("EnabledObjFldsToDisable"));
         ghProp.unwrapBufferField().changeValue(pcEnabledObjFldsToDisable_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setFieldHandles(final character _pcHandles_2)
   {
      character pcHandles_2 = TypeFactory.initInput(_pcHandles_2);
      
      return function("setFieldHandles", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FieldHandles"));
         ghProp.unwrapBufferField().changeValue(pcHandles_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setGroupAssignSource(final handle _phObject_2)
   {
      handle phObject_2 = TypeFactory.initInput(_phObject_2);
      
      return function("setGroupAssignSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSource"));
         ghProp.unwrapBufferField().changeValue(phObject_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setGroupAssignSourceEvents(final character _pcEvents_4)
   {
      character pcEvents_4 = TypeFactory.initInput(_pcEvents_4);
      
      return function("setGroupAssignSourceEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignSourceEvents"));
         ghProp.unwrapBufferField().changeValue(pcEvents_4);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setGroupAssignTarget(final character _pcObject_2)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      
      return function("setGroupAssignTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTarget"));
         ghProp.unwrapBufferField().changeValue(pcObject_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setGroupAssignTargetEvents(final character _pcEvents_4)
   {
      character pcEvents_4 = TypeFactory.initInput(_pcEvents_4);
      
      return function("setGroupAssignTargetEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("GroupAssignTargetEvents"));
         ghProp.unwrapBufferField().changeValue(pcEvents_4);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setLogicalObjectName(final character _pcLogicalObjectName_1)
   {
      character pcLogicalObjectName_1 = TypeFactory.initInput(_pcLogicalObjectName_1);
      /*------------------------------------------------------------------------------
        Purpose:  
         Params:  
      ------------------------------------------------------------------------------*/
      logical lObjectInitialized = UndoableFactory.logical();
      
      return function("setLogicalObjectName", logical.class, new Block((Body) () -> 
      {
         ControlFlowOps.runSuper("setLogicalObjectName", pcLogicalObjectName_1);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lObjectInitialized.assign(ghProp.unwrapBufferField().value());
         
         if ((lObjectInitialized).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
            ghProp.unwrapBufferField().changeValue(new logical(false));
            ControlFlowOps.invokeIn("initializeObject", targetProcedure());
         }
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setModifyFields(final character _pcModifyFields_1)
   {
      character pcModifyFields_1 = TypeFactory.initInput(_pcModifyFields_1);
      
      return function("setModifyFields", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ModifyFields"));
         ghProp.unwrapBufferField().changeValue(pcModifyFields_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setNewRecord(final character _pcMode_1)
   {
      character pcMode_1 = TypeFactory.initInput(_pcMode_1);
      
      return function("setNewRecord", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NewRecord"));
         ghProp.unwrapBufferField().changeValue(pcMode_1);
         NamedEventManager.publish("UpdateActive", targetProcedure(), "I", new Object[]
         {
            isNotEqual(pcMode_1, "NO")
         });
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setObjectMode(final character _pcObjectMode_1)
   {
      character pcObjectMode_1 = TypeFactory.initInput(_pcObjectMode_1);
      
      return function("setObjectMode", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMode"));
         ghProp.unwrapBufferField().changeValue(pcObjectMode_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setObjectParent(final handle _phParent_1)
   {
      handle phParent_1 = TypeFactory.initInput(_phParent_1);
      /*------------------------------------------------------------------------------
        Purpose:  Assigns a handle value to the ObjectParent property representing
                  the parent Progress container widget handle for the 
                  visualization object. 
         Params:  phParent AS HANDLE -- The handle of the parent object
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("setObjectParent", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            if ((matchesList("DIALOG-BOX,FRAME", phParent_1.unwrapType().getResourceType())).booleanValue())
            {
               hContainer.unwrapWidget().setFrameHandle(phParent_1);
            }
            else
            {
               hContainer.unwrapWidget().setParentHandle(phParent_1);
            }
            
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPrintPreviewActive(final logical _lPreviewActive_1)
   {
      logical lPreviewActive_1 = TypeFactory.initInput(_lPreviewActive_1);
      
      return function("setPrintPreviewActive", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PrintPreviewActive"));
         ghProp.unwrapBufferField().changeValue(lPreviewActive_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRowIdent(final character _pcRowIdent_1)
   {
      character pcRowIdent_1 = TypeFactory.initInput(_pcRowIdent_1);
      
      return function("setRowIdent", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowIdent"));
         ghProp.unwrapBufferField().changeValue(pcRowIdent_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setSaveSource(final logical _plSave_1)
   {
      logical plSave_1 = TypeFactory.initInput(_plSave_1);
      
      return function("setSaveSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SaveSource"));
         ghProp.unwrapBufferField().changeValue(plSave_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setTableIosource(final handle _phObject_2)
   {
      handle phObject_2 = TypeFactory.initInput(_phObject_2);
      
      return function("setTableIOSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("TableIOSource"));
         ghProp.unwrapBufferField().changeValue(phObject_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setTableIosourceEvents(final character _pcEvents_4)
   {
      character pcEvents_4 = TypeFactory.initInput(_pcEvents_4);
      
      return function("setTableIOSourceEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("TableIOSourceEvents"));
         ghProp.unwrapBufferField().changeValue(pcEvents_4);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setToolbarSource(final character _pcTarget_1)
   {
      character pcTarget_1 = TypeFactory.initInput(_pcTarget_1);
      
      return function("setToolbarSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ToolbarSource"));
         ghProp.unwrapBufferField().changeValue(pcTarget_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setToolbarSourceEvents(final character _pcEvents_4)
   {
      character pcEvents_4 = TypeFactory.initInput(_pcEvents_4);
      
      return function("setToolbarSourceEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ToolbarSourceEvents"));
         ghProp.unwrapBufferField().changeValue(pcEvents_4);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setUpdateTarget(final character _pcObject_2)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      
      return function("setUpdateTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         ghProp.unwrapBufferField().changeValue(pcObject_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setUpdateTargetNames(final character _pcTargetNames_1)
   {
      character pcTargetNames_1 = TypeFactory.initInput(_pcTargetNames_1);
      
      return function("setUpdateTargetNames", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTargetNames"));
         ghProp.unwrapBufferField().changeValue(pcTargetNames_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setWindowTitleField(final character _cWindowTitleField_1)
   {
      character cWindowTitleField_1 = TypeFactory.initInput(_cWindowTitleField_1);
      
      return function("setWindowTitleField", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowTitleField"));
         ghProp.unwrapBufferField().changeValue(cWindowTitleField_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character showDataMessages()
   {
      /*------------------------------------------------------------------------------
        Purpose:   Returns the name of the field (if any) from the first
                   error message, to allow the caller to use it to position the 
                   cursor.
         Params:   <none>.   
         Notes:    Invokes fetchMessages() to retrieve all Data-related messages
                   (normally database update-related error messages), and
                   displays them in a alert-box of type error.
                   This function expects to receive back a single string 
                   from fetchMessages with one or more messages delimited by CHR(3),
                   and within each message the message text, Fieldname (or blank) +
                   a Tablename (or blank), delimited by CHR(4) if present.
      ------------------------------------------------------------------------------*/
      character cMessages = TypeFactory.character();
      integer iMsg = TypeFactory.integer();
      integer iMsgCnt = TypeFactory.integer();
      character cMessage = TypeFactory.character();
      character cFirstField = TypeFactory.character();
      character cField = TypeFactory.character();
      character cTable = TypeFactory.character();
      character cText = TypeFactory.character("");
      
      return function("showDataMessages", character.class, new Block((Body) () -> 
      {
         cMessages.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
         iMsgCnt.assign(numEntries(cMessages, chr(3)));
         
         ToClause toClause10 = new ToClause(iMsg, 1, iMsgCnt);
         
         doTo("loopLabel19", toClause10, new Block((Body) () -> 
         {
            cMessage.assign(entry(iMsg, cMessages, chr(3)));
            cField.assign(_isGreaterThan(numEntries(cMessage, chr(4)), 1) ? entry(2, cMessage, chr(4)) : new character(""));
            cTable.assign(_isGreaterThan(numEntries(cMessage, chr(4)), 2) ? entry(3, cMessage, chr(4)) : new character(""));
            cText.assign(concat(cText, (_isNotEqual(cField, "") ? ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 10) : new character("")), cField, "   ", (_isNotEqual(cTable, "") ? ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 11) : new character("")), cTable, (_or(isNotEqual(cField, ""), () -> isNotEqual(cTable, "")) ? new character("\n") : new character("")), "  ", entry(1, cMessage, chr(4)), "\n"));
            
            /* Return the field name from the first error message so the caller can
                   use it to position the cursor. */
            if (_isEqual(iMsg, 1))
            {
               cFirstField.assign(cField);
            }
         }));
         
         /* END DO iMsg */
         if (_isNotEqual(cText, ""))
         {
            messageBox(cText, ALERT_ERROR, BTN_OK, (String) null);
         }
         
         returnNormal(cFirstField);
      }));
   }
}
