/*--------------------------------------------------------------------------
    File        : Smart.java
    Purpose     : General Super Procedure for New ADM applications

    Syntax      : adm2/smart.p

    Modified    : July 31, 2000 Version 9.1B
------------------------------------------------------------------------*/

package com.goldencode.hotel.common.adm2;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo._temp.*;
import com.goldencode.hotel.ui.common.adm2.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.util.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/adm2/smart.p).
 */
public class Smart
{
   Admlink_1_1.Buf admlink = SharedVariableManager.addTempTable("admlink", Admlink_1_1.Buf.class, "admlink", "ADMLink", false);

   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*          This .p file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Tell smrtattr.i that this is the Super Procedure */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartexclcustom.i
       Purpose     : Defines EXCLUDE-xxx preprocessor variables to exclude
                     functions or internal procedures in the super procedure
                     where it is referenced.
       Syntax      : {src/adm2/custom/smartexclcustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in src/adm2/smart.p
     ------------------------------------------------------------------------*/   
   /* Define and initialize variables for properties shared by all objects. */   
   character scPassThroughLinks = TypeFactory.character("Data;multiple,Update;single,Filter;single,OutMessage;single,Navigation;single,Commit;single");

   character gcDataMessages = TypeFactory.character("");

   /* _UIB-CODE-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Procedure
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: CODE-ONLY COMPILE
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Procedure ASSIGN
            HEIGHT             = 12.05
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ************************* Included-Libraries *********************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   SmartDisplayLinksDialogFrame displayLinksDialogFrameFrame = null;

   character radioSort = TypeFactory.character("Type");

   QueryWrapper query0 = null;

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/adm2/smart.p).
    */
   public void execute()
   {
      externalProcedure(Smart.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         RecordBuffer.openScope(admlink);
         
         /* _UIB-CODE-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 14.86
                  WIDTH              = 57.2.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Include the file which defines prototypes for all of the super
              procedure's entry points. Also, start or attach to the super procedure.
              Skip start-super-proc if we *are* the super procedure. 
              And skip including the prototypes if we are *any* super procedure. */
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         cType.assign("SUPER");
         returnNormal(cType);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     Adds a link between two objects by setting property values <br>
    *              in each.<br>
    * Parameters:  INPUT phSource AS HANDLE  source procedure handle, <br>
    *              INPUT pcLink   AS CHARACTER   link name, <br>
    *              INPUT phTarget AS HANDLE  target procedure handle<br>
    * Notes:       If the link is not in the SupportedLinks list for either object,<br>
    *              then the link name will be treated as a single <br>
    *              subscription in the "Target" for an event in the "Source".
    */
   public void addLink(final handle _phSource, final character _pcLink_4, final handle _phTarget)
   {
      handle phSource = TypeFactory.initInput(_phSource);
      character pcLink_4 = TypeFactory.initInput(_pcLink_4);
      handle phTarget = TypeFactory.initInput(_phTarget);
      integer iEntry = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cTargets = TypeFactory.character();
      character cSources = TypeFactory.character();
      handle hTarget = TypeFactory.handle();
      character cType = TypeFactory.character();
      character cNumTargs = TypeFactory.character();
      integer iLink = TypeFactory.integer();
      handle hSrcContainer = TypeFactory.handle();
      handle hTrgContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* A container link is not a true link, so simplify logic and skip pass-thru 
              logic to improve performance (only measurable with very many objects..) */
         if (_isEqual(pcLink_4, "Container"))
         {
            ghProp.assign(handle.fromString(entry(1, phTarget.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            ghProp.unwrapBufferField().changeValue(phSource);
            /* {get Prop var [handle]} */
            cTargets.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getContainerTarget", phSource));
            /* This works also if cTargets = ? */
            cTargets.assign(concat((_isGreaterThan(cTargets, "") ? concat(cTargets, ",") : new character("")), valueOf(phTarget)));
            /* {set Prop value [handle]} */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setContainerTarget", phSource, "I", cTargets);
         }
         else
         {
            /* For a "PageN" link, where the name of the link as passed to addLink is
                   "PAGE" plus a page number, add that as a '|'-delimited string to the
                   PageNTarget property in the Source (the Container). Don't do anything
                   in the Target because PageNSource would always be the ContainerSource. */
            if (_and(begins(pcLink_4, "PAGE"), () -> isNotEqual(pcLink_4, "PAGE")))
            {
 /* It's "PageN" */
               ControlFlowOps.invokeWithMode("modifyListProperty", "IIII", phSource, new character("ADD"), new character("PageNTarget"), concat(valueOf(phTarget), "|", substring(pcLink_4, 5)));
            }
            else
            {
               loopLabel0:
               for (iLink.assign(1); _isLessThanOrEqual(iLink, numEntries(scPassThroughLinks)); iLink.increment())
               {
                  /* passthrough links are stored as link;single/multiple */
                  if (_isEqual(entry(1, entry(iLink, scPassThroughLinks), ";"), pcLink_4))
                  {
                     cNumTargs.assign(entry(2, entry(iLink, scPassThroughLinks), ";"));
                  }
               }
               
               /* END DO iLink */
               if (_isNotEqual(cNumTargs, ""))
               {
                  ghProp.assign(handle.fromString(entry(1, phSource.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
                  cType.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isNotEqual(cType, ""))
                  {
                     ErrorManager.silentErrorEnable();
                     /* First, if my Source has a Source of its own for the same link type,
                                  then change my Source to that one. Leave the existing link in place,
                                  IF the link type supports multiple targets. */
                     hObject.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", pcLink_4, "Source"), phSource));
                     ErrorManager.silentErrorDisable();
                     
                     if ((hObject.isValid()).booleanValue())
                     {
                        ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                        hSrcContainer.assign(ghProp.unwrapBufferField().value());
                        ghProp.assign(handle.fromString(entry(1, phTarget.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                        hTrgContainer.assign(ghProp.unwrapBufferField().value());
                        
                        if (_or(isEqual(hSrcContainer, phSource), () -> isEqual(hTrgContainer, phSource)))
                        {
                           if (_isEqual(cNumTargs, "single"))
                           {
                              /* Link supports only one target; so don't keep the "intermediate"
                                                link that goes to the container. */
                              ControlFlowOps.invokeWithMode("removeLink", "III", hObject, pcLink_4, phSource);
                           }
                           
                           /* set up to modify the new link in any case. */
                           phSource.assign(hObject);
                        }
                     }
                  }
                  ghProp.assign(handle.fromString(entry(1, phTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
                  cType.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isNotEqual(cType, ""))
                  {
                     ErrorManager.silentErrorEnable();
                     /* If my target has target(s) of the same link type, then I want to
                                  remove it/them and add a new link to my Source. */
                     cTargets.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", pcLink_4, "Target"), phTarget));
                     ErrorManager.silentErrorDisable();
                     
                     if (_and(notUnknown(cTargets), () -> isNotEqual(cTargets, "")))
                     {
                        IntegerExpression resExpr0 = new IntegerExpression()
                        {
                           public integer execute()
                           {
                              return numEntries(cTargets);
                           }
                        };
                        ToClause toClause0 = new ToClause(iEntry, 1, resExpr0);
                        
                        doTo("loopLabel1", toClause0, new Block((Body) () -> 
                        {
                           /* if there are any */
                           hTarget.assign(handle.fromString(entry(iEntry, cTargets)));
                           ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                           ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                           hTrgContainer.assign(ghProp.unwrapBufferField().value());
                           ghProp.assign(handle.fromString(entry(1, phSource.unwrapADMData().getADMData(), chr(1))));
                           ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                           hSrcContainer.assign(ghProp.unwrapBufferField().value());
                           
                           if (_or(isEqual(hTrgContainer, phTarget), () -> isEqual(hSrcContainer, phTarget)))
                           {
                              ControlFlowOps.invokeWithMode("removeLink", "III", phTarget, pcLink_4, hTarget);
                              ControlFlowOps.invokeWithMode("addLink", "III", phSource, pcLink_4, hTarget);
                           }
                        }));
                        
                        /* END DO iEntry */
                        /* if this link type supports multiple Targets, then go ahead
                                       and add the link to the container in case it;s wanted;
                                       otherwise just return, */
                        if (_isEqual(cNumTargs, "single"))
                        {
                           returnNormal();
                        }
                     }
                  }
               }
 /* we found a pass-through link */;
               ghProp.assign(handle.fromString(entry(1, phSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("SupportedLinks"));
               cSources.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, phTarget.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("SupportedLinks"));
               cTargets.assign(ghProp.unwrapBufferField().value());
               
               if (_and(and(isNotEqual(pcLink_4, "Container"), () -> not(begins(pcLink_4, "Page"))), () -> and(isEqual(lookup(concat(pcLink_4, "-Source"), cSources), 0), () -> isEqual(lookup(concat(pcLink_4, "-Target"), cTargets), 0))))
               {
                  NamedEventManager.subscribe(phTarget, pcLink_4, phSource);
                  /* Because there are no "Source" and "Target" properties for
                                these "dynamic" links, we need to store the handles where
                                the linkHandles function will be able to get at them later,
                                if needed. */
                  ControlFlowOps.invokeInWithMode("modifyUserLinks", phSource, "III", new character("ADD"), concat(pcLink_4, "-Target"), phTarget);
                  ControlFlowOps.invokeInWithMode("modifyUserLinks", phTarget, "III", new character("ADD"), concat(pcLink_4, "-Source"), phSource);
                  returnNormal();
               }
               
               /* END DO for non-Supported Link */
               /* All the remaining code is for Supported Links. */
               /* Whether we found a pass-through or not, continue with the current link */
               /* NOTE: This will fail w/o error if the property isn't defined.*/
               /* Although standard SmartLinks permit a single Source and multiple
                        Targets, check to see whether this link does. A single Source or
                        Target is stored as a handle, multiple Sources or Targets as a
                        list in Character form. */
               if (_isEqual(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "propertyType", phTarget, "I", concat(pcLink_4, "Source")), "CHARACTER"))
               {
                  ControlFlowOps.invokeWithMode("modifyListProperty", "IIII", phTarget, new character("ADD"), concat(pcLink_4, "Source"), valueOf(phSource));
               }
               else
               {
                  if (_isUnknown(ControlFlowOps.invokeDynamicFunctionIn(concat("get", pcLink_4, "Source"), phTarget)))
                  {
                     ErrorManager.silentErrorEnable();
                     ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", pcLink_4, "Source"), phTarget, "I", phSource);
                     ErrorManager.silentErrorDisable();
                  }
                  else
                  {
                     /* {fnarg <func-name> <arg> [handle] */ 
                     showmessage(new character(substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 79), phTarget.unwrapFile().getFileName(), pcLink_4)));
                     returnNormal();
                  }
               }
               
               /* END ELSE DO (if Not CHARACTER) */
               if (_isEqual(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "propertyType", phSource, "I", concat(pcLink_4, "Target")), "CHARACTER"))
               {
                  ControlFlowOps.invokeWithMode("modifyListProperty", "IIII", phSource, new character("ADD"), concat(pcLink_4, "Target"), valueOf(phTarget));
               }
               else
               {
                  if (_isUnknown(ControlFlowOps.invokeDynamicFunctionIn(concat("get", pcLink_4, "Target"), phSource)))
                  {
                     ErrorManager.silentErrorEnable();
                     ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", pcLink_4, "Target"), phSource, "I", phTarget);
                     ErrorManager.silentErrorDisable();
                  }
                  else
                  {
                     /* {fnarg <func-name> <arg> [handle] */ 
                     showmessage(new character(substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 80), phSource.unwrapFile().getFileName(), pcLink_4)));
                     returnNormal();
                  }
               }
            }
         }
         /* pcLink <> 'Container' */
         /* SUBSCRIBE to all the appropriate events on each side of the link. 
              First SUBSCRIBE the target to all the events it says it wants
              from its source. */
         ControlFlowOps.invokeInWithMode("linkStateHandler", phTarget, "III", new character("Add"), phSource, concat(pcLink_4, "Source"));
         /* Then SUBSCRIBE the source to all the events (if any) that it wants
              from its target. */
         ControlFlowOps.invokeInWithMode("linkStateHandler", phSource, "III", new character("Add"), phTarget, concat(pcLink_4, "Target"));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Inserts the message text into a data message log along with its<br>
    *           Field, and Table if known.<br>
    *  Params:  INPUT pcText AS CHARACTER  Text of the message; <br>
    *           INPUT pcField AS CHARACTER   the field name for which the message<br>
    *              occurred, if it was related to a specific field;<br>
    *           INPUT pcTable AS CHARACTER   the database table for which the <br>
    *              message occurred, if it was related to an update to a database <br>
    *              table.<br>
    *   Notes:  If pcText is unknown (?), that signals <br>
    *             that this function should retrieve messages from the <br>
    *             error-status handle.
    */
   public void addMessage(final character _pcText, final character _pcField, final character _pcTable)
   {
      character pcText = TypeFactory.initInput(_pcText);
      character pcField = TypeFactory.initInput(_pcField);
      character pcTable = TypeFactory.initInput(_pcTable);
      integer iMsg = TypeFactory.integer();
      integer iMsgCnt = TypeFactory.integer();
      character cMessage = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* If one or more "raw" messages were passed (i.e., they are already in
              the delimited formatted created below), then these were returned from
              an AppServer object or other remote object. Just append them to any local
              messages. */
         if (_and(notUnknown(pcText), () -> isNotEqual(indexOf(pcText, chr(4)), 0)))
         {
            gcDataMessages.assign(concat(gcDataMessages, (_isNotEqual(gcDataMessages, "") ? chr(3) : new character("")), pcText));
         }
         else
         {
            /* If there's no message passed, this means that a Progress ERROR-STATUS
                   was detected, so we add a row for each of those messages. */
            iMsgCnt.assign(_isUnknown(pcText) ? ErrorManager.numErrors() : new integer(1));
            
            loopLabel2:
            for (iMsg.assign(1); _isLessThanOrEqual(iMsg, iMsgCnt); iMsg.increment())
            {
               if (_isUnknown(pcText))
               {
                  /* When logging ERROR-STATUS messages, remove any which directly 
                           reference the BUFFER-FIELD attribute; these errors are side-effects
                           of other assignment errors which should be reported to the user
                           instead. */
                  cMessage.assign(ErrorManager.getErrorText(iMsg));
                  
                  if (_isNotEqual(indexOf(cMessage, "BUFFER-FIELD"), 0))
                  {
                     continue loopLabel2;
                  }
               }
               gcDataMessages.assign(concat(gcDataMessages, (_isNotEqual(gcDataMessages, "") ? chr(3) : new character("")), (_isUnknown(pcText) ? cMessage : pcText), chr(4), (_isUnknown(pcField) ? new character("") : pcField), chr(4), (_isUnknown(pcTable) ? new character("") : pcTable)));
            }
         }
         /* END ELSE DO */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Changes the tab order of SmartObjects<br>
    * Parameters:  INPUT phObject AS HANDLE  handle of the smart object<br>
    *              INPUT phAnchor AS HANDLE  handle of either another smartobject <br>
    *                procedure or a widget-handle of the object that will <br>
    *                anchor the smartobject<br>
    *              INPUT pcPosition AS CHARACTER  <br>
    *                "After" if smartobject is moved-after the anchor<br>
    *                "Before" if smartobject is moved-before anchor<br>
    * <p>
    * Notes:       adjustTabOrder calls are generated by the AppBuilder in <br>
    *              adm-create-objects
    */
   public void adjustTabOrder(final handle _phObject_5, final handle _phAnchor, final character _pcPosition)
   {
      handle phObject_5 = TypeFactory.initInput(_phObject_5);
      handle phAnchor = TypeFactory.initInput(_phAnchor);
      character pcPosition = TypeFactory.initInput(_pcPosition);
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, phObject_5.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hContainer.isValid()))
         {
            returnNormal("ADM-ERROR");
         }
         
         /* If phAnchor is smart-object procedure handle, get its object-handle */
         if (_isEqual(phAnchor.unwrapType().getResourceType(), "PROCEDURE"))
         {
            ghProp.assign(handle.fromString(entry(1, phAnchor.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
            phAnchor.assign(ghProp.unwrapBufferField().value());
            
            if (_not(phAnchor.isValid()))
            {
               returnNormal("ADM-ERROR");
            }
         }
         
         /* Check that the two handle have the same parent */
         if (_isNotEqual(hContainer.unwrapWidget().getParentHandle(), phAnchor.unwrapWidget().getParentHandle()))
         {
            returnNormal("ADM-ERROR");
         }
         
         if (_isEqual(pcPosition, "BEFORE"))
         {
            hContainer.unwrapWidget().moveBeforeTabItem(phAnchor);
         }
         else
         {
            hContainer.unwrapWidget().moveAfterTab(phAnchor);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Applies "ENTRY" to the first enabled and visible object <br>
    *              in the default frame (unless pcField is specified), <br>
    *              or in the first child which is a Frame.<br>
    * Parameters:  INPUT pcField AS CHARACTER  optional fieldname; if specified,<br>
    *              (if this parameter is not blank or unknown), then<br>
    *              the frame field of that name will be positioned to. <br>
    *            - sets focus into viewer properly when container launched and we <br>
    *              do an apply entry.
    */
   public void applyEntry(final character _pcField)
   {
      character pcField = TypeFactory.initInput(_pcField);
      handle hContainer = TypeFactory.handle();
      handle hWidget_1 = TypeFactory.handle();
      handle hWidget2 = TypeFactory.handle();
      /* Astra2 */
      handle hWidget3 = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Astra2 */
         if (_isUnknown(pcField))
         {
            pcField.assign("");
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            loopLabel3:
            while (_isEqual(hContainer.unwrapType().getResourceType(), "WINDOW"))
            {
               hContainer.assign(hContainer.unwrapTree().firstChild());
            }
            
            hWidget_1.assign(hContainer.unwrapIterableResource().currentIteration());
            hWidget_1.assign(hWidget_1.unwrapWidget().getFirstTabItem());
            
            loopLabel4:
            while ((hWidget_1.isValid()).booleanValue())
            {
               if (_and(and(and(not(or(begins(hWidget_1.unwrap().name(), "Folder"), () -> begins(hWidget_1.unwrap().name(), "Panel"))), () -> hWidget_1.unwrapSensitive().isSensitive()), () -> hWidget_1.unwrapWidget().isVisible()), () -> or(isEqual(pcField, ""), () -> isEqual(hWidget_1.unwrap().name(), pcField))))
               {
                  loopLabel5:
                  while (_and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "WINDOW")))
                  {
                     hContainer.assign(hContainer.unwrapWidget().getParentHandle());
                  }
                  
                  if (_isEqual(hContainer.unwrapType().getResourceType(), "WINDOW"))
                  {
                     setCurrentWindow(hContainer);
                  }
                  
                  hWidget2.setUnknown();
                  hWidget3.setUnknown();
                  
                  if (_isEqual(hWidget_1.unwrapType().getResourceType(), "FRAME"))
                  {
                     ErrorManager.silentErrorEnable();
                     hWidget2.assign(hWidget_1.unwrapTree().firstChild());
                     ErrorManager.silentErrorDisable();
                     
                     if (_and(and(hWidget2.isValid(), () -> HandleOps.canQuery(hWidget2, "type")), () -> isEqual(hWidget2.unwrapType().getResourceType(), "FIELD-GROUP")))
                     {
                        ErrorManager.silentErrorEnable();
                        hWidget2.assign(hWidget2.unwrapWidget().getFirstTabItem());
                        ErrorManager.silentErrorDisable();
                     }
                     
                     if (_and(and(and(and(hWidget2.isValid(), () -> HandleOps.canQuery(hWidget2, "type")), () -> isEqual(hWidget2.unwrapType().getResourceType(), "FRAME")), () -> hWidget2.unwrapSensitive().isSensitive()), () -> hWidget2.unwrapWidget().isVisible()))
                     {
                        ErrorManager.silentErrorEnable();
                        /* SDF */
                        hWidget3.assign(hWidget2.unwrapTree().firstChild());
                        ErrorManager.silentErrorDisable();
                        
                        if (_and(and(hWidget3.isValid(), () -> HandleOps.canQuery(hWidget3, "type")), () -> isEqual(hWidget3.unwrapType().getResourceType(), "FIELD-GROUP")))
                        {
                           ErrorManager.silentErrorEnable();
                           hWidget3.assign(hWidget3.unwrapWidget().getFirstTabItem());
                           ErrorManager.silentErrorDisable();
                        }
                     }
                     
                     loopLabel6:
                     while (_and(hWidget3.isValid(), () -> not(and(hWidget3.unwrapSensitive().isSensitive(), () -> hWidget3.unwrapWidget().isVisible()))))
                     {
                        hWidget3.assign(hWidget3.unwrapWidget().getNextTabItem());
                     }
                     
                     loopLabel7:
                     while (_and(hWidget2.isValid(), () -> or(not(and(hWidget2.unwrapSensitive().isSensitive(), () -> hWidget2.unwrapWidget().isVisible())), () -> isEqual(hWidget2.unwrapType().getResourceType(), "frame"))))
                     {
                        hWidget2.assign(hWidget2.unwrapWidget().getNextTabItem());
                     }
                  }
                  
                  if ((hWidget3.isValid()).booleanValue())
                  {
                     apply(hWidget3, "ENTRY");
                  }
                  else
                  {
                     if ((hWidget2.isValid()).booleanValue())
                     {
                        apply(hWidget2, "ENTRY");
                     }
                     else
                     {
                        apply(hWidget_1, "ENTRY");
                     }
                  }
                  returnNormal();
               }
               else
               {
                  hWidget_1.assign(hWidget_1.unwrapWidget().getNextTabItem());
               }
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Sets the cursor on all windows and on any dialog box frames <br>
    *           that are currently on the screen.   <br>
    * Parameters: INPUT pcCursor AS CHARACTER  name of cursor to use.  <br>
    *               This should be either "WAIT" or "".
    */
   public void changeCursor(final character _pcCursor)
   {
      character pcCursor = TypeFactory.initInput(_pcCursor);
      
      internalProcedure(new Block((Body) () -> 
      {
         LogicalTerminal.setWaitState(_isEqual(pcCursor, "WAIT") ? new character("GENERAL") : new character(""));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Default action for SmartObject-specific initialization of<br>
    *              ActiveX Controls. Runs adm-create-controls, an AppBuilder-<br>
    *              generated procedure.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       A localization of this behavior should be placed in a procedure<br>
    *              called createControls in the SmartObject. The V8-style name<br>
    *              adm-create-controls for the standard behavior is maintained<br>
    *              in order to allow a localization in the same procedure file.
    */
   public void createControls()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         ControlFlowOps.invokeIn("adm-create-controls", targetProcedure());
         ErrorManager.silentErrorDisable();
         returnNormal();
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void destroyObject()
   {
      logical lCancel = TypeFactory.logical();
      logical lUseRepos = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("confirmExit", targetProcedure(), "U", new Object[]
         {
            lCancel
         });
         
         if ((lCancel).booleanValue())
         {
            /* Main window block will check ERROR-STATUS */
            returnError("ADM-ERROR");
         }
 /* Any message has already been displayed. */;
         
         /* END DO IF lCancel */
         ControlFlowOps.invokeWithMode("returnFocus", "I", targetProcedure());
         /* Hide objects where applicable before destroying contents.  */
         ControlFlowOps.invokeIn("hideObject", targetProcedure());
         NamedEventManager.publish("destroyObject", targetProcedure());
         /* Destroy descendents */
         /* If we close a subwindow in character mode, we need to explicitly
              re-view its parent. */
         ControlFlowOps.invokeIn("removeAllLinks", targetProcedure());
         /* {get Prop var [handle]} */ 
         lUseRepos.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUseRepository", targetProcedure()));
         
         /* clone the repos admprops into a static one in the static object's 
              widget-pool so it lives to be referenced after super in destroyObject
              overrides */
         if ((lUseRepos).booleanValue())
         {
            ErrorManager.silentErrorEnable();
            ControlFlowOps.invokeIn("adm-clone-props", targetProcedure());
            ErrorManager.silentErrorDisable();
            ErrorManager.setError(new logical(false));
         }
         
         ControlFlowOps.invokeIn("disable_UI", targetProcedure());
         returnNormal();
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void displayLinks()
   {
      internalProcedure(new Block((Pre) () -> 
      {
         displayLinksDialogFrameFrame = GenericFrame.createFrame(SmartDisplayLinksDialogFrame.class, "displayLinks-dialog-frame");
         /* Query definitions                                */
         query0 = new QueryWrapper("BROWSE-1", true);
      }, 
      (Body) () -> 
      {
         query0.addBuffer(admlink, true);
         displayLinksDialogFrameFrame.openScope();
         
         FrameElement[] elementList0 = new FrameElement[]
         {
            new Element(new FieldReference(admlink, "linktype"), displayLinksDialogFrameFrame.widgetBrowse1LinktypeColumn()),
            new HeaderElement(() -> toLowerCase(admlink.getLinksource().unwrapFile().getFileName()), displayLinksDialogFrameFrame.widgetBrowse1Expr12Column()),
            new HeaderElement(() -> toLowerCase(admlink.getLinktarget().unwrapFile().getFileName()), displayLinksDialogFrameFrame.widgetBrowse1Expr13Column())
         };
         /* Browse definitions                                */
         displayLinksDialogFrameFrame.widgetBrowse1().registerQuery(query0, elementList0);
         
         registerTrigger(new EventList("VALUE-CHANGED", displayLinksDialogFrameFrame.widgetRadioSort()), Smart.this, new Trigger((Body) () -> 
         {
            displayLinksDialogFrameFrame.assignScreenValue(new Element(radioSort, displayLinksDialogFrameFrame.widgetRadioSort()));
            query0.assign(new PresortQuery().initialize(admlink, ((String) null), null, "admlink.id asc"));
            query0.addSortCriterion(((CharacterExpr) () -> _isEqual(radioSort, "Type") ? admlink.getLinktype() : _isEqual(radioSort, "Source") ? admlink.getLinksource().unwrapFile().getFileName() : admlink.getLinktarget().unwrapFile().getFileName()));
            query0.open();
         }));
         
         FrameElement[] elementList1 = new FrameElement[]
         {
            new WidgetElement(displayLinksDialogFrameFrame.widgetRadioSort()),
            new WidgetElement(displayLinksDialogFrameFrame.widgetBrowse1()),
            new WidgetElement(displayLinksDialogFrameFrame.widgetBtnOk())
         };
         
         displayLinksDialogFrameFrame.enable(elementList1);
         
         admlink.deleteAll();
         ControlFlowOps.invokeWithMode("oneObjectLinks", "I", targetProcedure());
         query0.assign(new PresortQuery().initialize(admlink, ((String) null), null, "admlink.id asc"));
         query0.addSortCriterion(((CharacterExpr) () -> _isEqual(radioSort, "Type") ? admlink.getLinktype() : _isEqual(radioSort, "Source") ? admlink.getLinksource().unwrapFile().getFileName() : admlink.getLinktarget().unwrapFile().getFileName()));
         query0.open();
         
         LogicalTerminal.waitFor(displayLinksDialogFrameFrame, new EventList("GO", displayLinksDialogFrameFrame.asWidget()));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:    Runs the dialog to get runtime property settings<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Generally run by the AppBuilder in design mode.
    */
   public void editInstanceProperties()
   {
      character cDialog = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PropertyDialog"));
         cDialog.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         ControlFlowOps.invokeWithMode((cDialog).toStringMessage(), "I", targetProcedure());
         ErrorManager.silentErrorDisable();
         
         if ((ErrorManager.isError()).booleanValue())
         {
            /* {fnarg <func-name> <arg> [handle] */ 
            showmessage(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 81));
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose: Passes an exit request to its container    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:  The convention is that the standard routine always<br>
    *     passes an exit request to its CONTAINER-SOURCE. The container <br>
    *     that is actually able to initiate the exit should define<br>
    *     a local version andnot* call the standard one.    <br>
    *     That local "exitObject" is built into the SmartWindow template.
    */
   public void exitObject()
   {
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("exitObject", targetProcedure());
         /* NOTE: MUST go to Container-Source */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Hides the current object.<br>
    * Parameters:  none<br>
    * Notes:       "Hide" is a logical concept here; non-visual objects may also be<br>
    *              "hidden", meaning that they are not currently active; this may<br>
    *              affect whether code in some subscribe procedures is executed.
    */
   public void hideObject()
   {
      handle hContainer = TypeFactory.handle();
      character cType = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setObjectHidden", targetProcedure(), "I", true);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("containerType"));
         cType.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            hContainer.unwrapWidget().setHidden(new logical(true));
         }
         
         if (_isNotEqual(cType, ""))
         {
            /* We don't need to physically hide the SmartObjects in this Container -
                   they will disappear when it is hidden - but we need to tell them that
                   they are part of a hidden Container so that they can set links
                   and other states dependent on HIDDEN accordingly. */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignLinkProperty", targetProcedure(), "III", "Container-Target", "ContainerHidden", "yes");
         }
         
         /* For those objects which want to "deactivate" a link when an object is
              hidden, we tell them that this object is 'inactive'. We also set the
              ObjectActive property to hold onto the state for future inquiries. */
         NamedEventManager.publish("LinkState", targetProcedure(), "I", new Object[]
         {
            "inactive"
         });
         returnNormal();
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void initializeObject()
   {
      handle hContainer = TypeFactory.handle();
      logical lInitialized = TypeFactory.logical();
      logical lHideOnInit = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         
         if ((lInitialized).booleanValue())
         {
            returnNormal("ADM-ERROR");
         }
         
         ErrorManager.silentErrorEnable();
         /* Just get out if already initialized. */
         /* Initialize any OCX's in the SmartObjects. */
         ControlFlowOps.invokeIn("createControls", targetProcedure());
         ErrorManager.silentErrorDisable();
         ErrorManager.silentErrorEnable();
         ControlFlowOps.invokeIn("control_load", targetProcedure());
         ErrorManager.silentErrorDisable();
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         ghProp.unwrapBufferField().changeValue(new logical(true));
         
         if (_not(hContainer.isValid()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnInit"));
            lHideOnInit.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lHideOnInit))
            {
               ControlFlowOps.invokeIn("viewObject", targetProcedure());
            }
            else
            {
               NamedEventManager.publish("LinkState", targetProcedure(), "I", new Object[]
               {
                  "inactive"
               });
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *   Purpose: Handler for the LinkState event, also used by addlink and removeLink,           <br>
    *            Subscribes/unsubscribes to the &lt;link&gt;events in the object   <br>
    * Parameter: pcState  - 'Add'      - activate newly added links by subscribing to <br>
    *                                    the &lt;Link&gt;Events of the passed object.<br>
    *                     - 'Active'   - activate links by subscribing to the<br>
    *                                    &lt;Link&gt;Events of the passed object.<br>
    *                     - 'Remove'   - deactivate newly removed links by <br>
    *                                    unsubscribing to the &lt;Link&gt;Events of the <br>
    *                                    passed object.                   <br>
    *                     - 'Inactive' - deactivate links by unsubscribing to the<br>
    *                                    &lt;Link&gt;Events of the passed object.                   <br>
    *            phObject - Object to subscribe/unsubscribe to.                         <br>
    *            pcLink   - Full link name pointing to the passed object.  <br>
    *                       DataSource or Data-source (both forms supported) <br>
    *    Notes: The name -handler attempts to indicate that this is an event-handler <br>
    *           that not should be called directly outside of the intended events, but<br>
    *           rather be actively used as an event to ensure that properties that<br>
    *           are link dependant are set/removed.  <br>
    *         - It's crucial that the subscribtion only happens once so we check <br>
    *           ObjectActive to ensure that the inactive/active unsubscribe/subscribe<br>
    *           only is performed when the state is changed:<br>
    *            updateLinkState(State)  <br>
    *              publish linkState (state) &gt; receiver <br>
    *              Here.. &lt; run linkStateHandler in source(target). <br>
    *              {set ObjectActive ..}<br>
    *         - Since this may be called for several objects/links the ObjectActive <br>
    *           property has to be managed outside of this.
    */
   public void linkStateHandler(final character _pcState_1, final handle _phObject_5, final character _pcLink_4)
   {
      character pcState_1 = TypeFactory.initInput(_pcState_1);
      handle phObject_5 = TypeFactory.initInput(_phObject_5);
      character pcLink_4 = TypeFactory.initInput(_pcLink_4);
      character cEvents = TypeFactory.character();
      integer iEvent = TypeFactory.integer();
      character cLinkedObject = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         pcLink_4.assign(replaceAll(pcLink_4, "-", ""));
         cEvents.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", pcLink_4, "Events"), targetProcedure()));
         cLinkedObject.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", pcLink_4), targetProcedure()));
         ErrorManager.silentErrorDisable();
         
         if ((ErrorManager.isError()).booleanValue())
         {
            returnNormal("adm-error");
         }
         
         /* ?? */
         switch (StringHelper.safeTrimTrailing((pcState_1).toStringMessage()).toUpperCase())
         {
            case "REMOVE":
               {
                  /* 'Remove' is only allowed if the get<link> is  pointing to the object */
                  if (_not(matchesList(cLinkedObject, valueOf(phObject_5))))
                  {
                     returnNormal();
                  }
               }
               break;
            case "ADD":
               {
                  if (_not(matchesList(cLinkedObject, valueOf(phObject_5))))
                  {
                     returnNormal();
                  }
               }
               break;
            case "ACTIVE":
               {
                  if (_not(matchesList(cLinkedObject, valueOf(phObject_5))))
                  {
                     returnNormal();
                  }
                  
                  if (_not(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", targetProcedure(), "II", pcLink_4, phObject_5))))
                  {
                     returnNormal();
                  }
                  
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "modifyInactiveLinks", targetProcedure(), "III", "REMOVE", pcLink_4, phObject_5);
               }
               break;
            case "INACTIVE":
               {
                  if (_not(matchesList(cLinkedObject, valueOf(phObject_5))))
                  {
                     returnNormal();
                  }
                  
                  if ((new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", targetProcedure(), "II", pcLink_4, phObject_5))).booleanValue())
                  {
                     returnNormal();
                  }
                  
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "modifyInactiveLinks", targetProcedure(), "III", "ADD", pcLink_4, phObject_5);
               }
               break;
         }
         
         if ((phObject_5.isValid()).booleanValue())
         {
            loopLabel8:
            for (iEvent.assign(1); _isLessThanOrEqual(iEvent, numEntries(cEvents)); iEvent.increment())
            {
               /* Never activate/deactivate linkstate */
               if (_or(isNotEqual(entry(iEvent, cEvents), "LinkState"), () -> matchesList("REMOVE,ADD", pcState_1)))
               {
                  if ((matchesList("ACTIVE,ADD", pcState_1)).booleanValue())
                  {
                     NamedEventManager.subscribe(targetProcedure(), entry(iEvent, cEvents), phObject_5);
                  }
                  
                  if ((matchesList("INACTIVE,REMOVE", pcState_1)).booleanValue())
                  {
                     NamedEventManager.unsubscribe(targetProcedure(), entry(iEvent, cEvents), phObject_5);
                  }
               }
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Allows values to be added or deleted from any object property<br>
    *              which is a comma-separated list (SupportedLinks, etc.)<br>
    * Parameters:  INPUT phCaller AS HANDLE  handle of the object whose <br>
    *                property is being changed<br>
    *              INPUT pcMode AS CHARACTER  'ADD' or 'REMOVE'<br>
    *              INPUT pcListName AS CHARACTER  name of the property<br>
    *              INPUT pcListvalue AS CHARACTER  the value to add or remove<br>
    * Notes:       This is the ADM2 equivalent of what was modify-list-attribute
    */
   public void modifyListProperty(final handle _phCaller, final character _pcMode_2, final character _pcListName, final character _pcListValue)
   {
      handle phCaller = TypeFactory.initInput(_phCaller);
      character pcMode_2 = TypeFactory.initInput(_pcMode_2);
      character pcListName = TypeFactory.initInput(_pcListName);
      character pcListValue = TypeFactory.initInput(_pcListValue);
      logical lAddingValue = TypeFactory.logical();
      character cValueList = TypeFactory.character();
      integer iValue = TypeFactory.integer();
      logical ok = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_isEqual(pcMode_2, "ADD"))
         {
            lAddingValue.assign(true);
         }
         else
         {
            if (_isEqual(pcMode_2, "REMOVE"))
            {
               lAddingValue.assign(false);
            }
            else
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               showmessage(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 82));
               returnError();
            }
         }
         ErrorManager.silentErrorEnable();
         cValueList.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", trim(pcListName)), phCaller));
         ErrorManager.silentErrorDisable();
         
         if (_isUnknown(cValueList))
         {
            /* If the property isn't defined we have to initialize it with the added values first.*/
            if ((lAddingValue).booleanValue())
            {
               ErrorManager.silentErrorEnable();
               ok.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", pcListName), phCaller, "I", pcListValue));
               ErrorManager.silentErrorDisable();
            }
            
            /* NO-ERROR clause is added in case the property doesn't exist */
            returnNormal();
         }
         iValue.assign(lookup(pcListValue, cValueList));
         
         /* Removing a value that's not there or adding a value that *is* there: */
         if (_or(and(isEqual(iValue, 0), not(lAddingValue)), () -> and(isNotEqual(iValue, 0), lAddingValue)))
         {
            returnNormal();
         }
         else
         {
            if ((lAddingValue).booleanValue())
            {
                /* New item is added to the list */cValueList.assign(concat(cValueList, (_isNotEqual(cValueList, "") ? new character(",") : new character("")), pcListValue));
            }
            else
            {
               cValueList.assign(concat(",", cValueList, ","));
               cValueList.assign(replaceAll(cValueList, concat(",", entry(plus(iValue, 1), cValueList), ","), ","));
               cValueList.assign(substring(cValueList, 2, minus(length(cValueList), 2), "CHARACTER"));
            }
 /* Removing a value */;
         }
         /* Reset the attribute value. */
         ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", pcListName), phCaller, "I", cValueList);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Maintains a delimited list of user-defined links (that is, <br>
    *              links which are not in the SupportedLinks list for an object),<br>
    *              and the handle(s) of the object(s) at the other end of the <br>
    *              links.<br>
    * Parameters:  INPUT pcMod AS CHARACTER  'ADD' or 'REMOVE';<br>
    *              INPUT pcLinkName AS CHARACTER  link name including -Source or<br>
    *              -Target;<br>
    *              INPUT phObject AS HANDLE  procedure handle of the object at the<br>
    *              other end of the link.<br>
    * Notes:       Run from addLink and removeLink; used primarily by <br>
    *              the linkHandles function.<br>
    *              The list is the third entry in ADM-DATA, delimited by CHR(1).<br>
    *              Each entry in the list consists of a link name followed by<br>
    *              CHR(4) followed by a comma-separated list of one or<br>
    *              more handles. The list entries are delimited by CHR(3).
    */
   public void modifyUserLinks(final character _pcMod, final character _pcLinkName, final handle _phObject_5)
   {
      character pcMod = TypeFactory.initInput(_pcMod);
      character pcLinkName = TypeFactory.initInput(_pcLinkName);
      handle phObject_5 = TypeFactory.initInput(_phObject_5);
      character cLinkList = TypeFactory.character();
      integer iLink = TypeFactory.integer();
      character cLinkEntry = TypeFactory.character("");
      character cLinkName = TypeFactory.character();
      character cHandles = TypeFactory.character();
      character cNewEntry = TypeFactory.character("");
      
      internalProcedure(new Block((Body) () -> 
      {
         cLinkList.assign(entry(3, targetProcedure().unwrapADMData().getADMData(), chr(1)));
         
         loopLabel9:
         for (iLink.assign(1); _isLessThanOrEqual(iLink, numEntries(cLinkList, chr(3))); iLink.increment())
         {
            cLinkEntry.assign(entry(iLink, cLinkList, chr(3)));
            cLinkName.assign(entry(1, cLinkEntry, chr(4)));
            
            if (_isEqual(cLinkName, pcLinkName))
            {
               cHandles.assign(entry(2, cLinkEntry, chr(4)));
               
               if (_isEqual(pcMod, "ADD"))
               {
                  /* If this object is already there, just exit. */
                  if (_isNotEqual(lookup(valueOf(phObject_5), cHandles), 0))
                  {
                     returnNormal();
                  }
                  
                  cHandles.assign(concat(cHandles, (_isNotEqual(cHandles, "") ? new character(",") : new character("")), valueOf(phObject_5)));
                  cNewEntry.assign(concat(pcLinkName, chr(4), cHandles));
                  break loopLabel9;
               }
               else
               {
                  if (_isEqual(pcMod, "REMOVE"))
                  {
                     /* If this object is *not* already there, just exit. */
                     if (_isEqual(lookup(valueOf(phObject_5), cHandles), 0))
                     {
                        returnNormal();
                     }
                     
                     cHandles.assign(replaceAll(concat(",", cHandles, ","), concat(",", valueOf(phObject_5), ","), ","));
                     cHandles.assign(substring(cHandles, 2, minus(length(cHandles), 2)));
                     cNewEntry.assign(concat(pcLinkName, chr(4), cHandles));
                  }
               }
            }
            else
            {
               cLinkEntry.assign("");
            }
         }
         
         /* END DO iLink */
         if (_isEqual(cLinkEntry, ""))
         {
            if (_isEqual(pcMod, "ADD"))
            {
               cNewEntry.assign(concat(pcLinkName, chr(4), valueOf(phObject_5)));
            }
            else
            {
               returnNormal();
            }
         }
 /* Not there yet; create it for Add */;
         
         /* END DO IF cLinkEntry = "" */
         if (_isEqual(cLinkEntry, ""))
         {
             /* Just add it to the end */targetProcedure().unwrapADMData().setADMData(concat(targetProcedure().unwrapADMData().getADMData(), (_isNotEqual(cLinkList, "") ? chr(3) : new character("")), cNewEntry));
         }
         else
         {
            targetProcedure().unwrapADMData().setADMData(replaceAll(targetProcedure().unwrapADMData().getADMData(), cLinkEntry, cNewEntry));
         }
         
         returnNormal();
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void oneObjectLinks(final handle _hObject)
   {
      handle hObject = UndoableFactory.initInput(_hObject);
      character cSupported = UndoableFactory.character();
      integer iLink = UndoableFactory.integer();
      character cLink = UndoableFactory.character();
      character cType = UndoableFactory.character();
      character cTargets = UndoableFactory.character();
      integer iTarget = UndoableFactory.integer();
      character cContainer = UndoableFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SupportedLinks"));
         cSupported.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorDisable();
         ErrorManager.silentErrorEnable();
         ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
         cContainer.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorDisable();
         
         if (_isNotEqual(cContainer, ""))
         {
            cSupported.assign(concat(cSupported, ",Container-Source"));
         }
         
         IntegerExpression resExpr1 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cSupported);
            }
         };
         ToClause toClause1 = new ToClause(iLink, 1, resExpr1);
         
         doTo("loopLabel10", toClause1, new Block((Body) () -> 
         {
            cLink.assign(entry(iLink, cSupported));
            
            if (_isNotEqual(indexOf(cLink, "Source"), 0))
            {
               cType.assign(substring(cLink, 1, minus(indexOf(cLink, "-"), 1)));
               ErrorManager.silentErrorEnable();
               cTargets.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", cType, "Target"), hObject));
               ErrorManager.silentErrorDisable();
               
               IntegerExpression resExpr2 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cTargets);
                  }
               };
               ToClause toClause2 = new ToClause(iTarget, 1, resExpr2);
               
               doTo("loopLabel11", toClause2, new Block((Body) () -> 
               {
                  admlink.create();
                  RecordBuffer.startBatch();
                  admlink.setLinktype(cType);
                  admlink.setLinksource(hObject);
                  admlink.setLinktarget(handle.fromString(entry(iTarget, cTargets)));
                  RecordBuffer.endBatch();
                  
                  if (_isEqual(cLink, "Container-Source"))
                  {
 /* recurse on contained objects. */
                     ControlFlowOps.invokeWithMode("oneObjectLinks", "I", admlink.getLinktarget());
                  }
               }));
            }
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Removes all links as part of destroying a procedure.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Run automatically as part of destroyObject
    */
   public void removeAllLinks()
   {
      character cSupportedLinks = TypeFactory.character();
      integer iLink = TypeFactory.integer();
      integer iPage = TypeFactory.integer();
      character cLink = TypeFactory.character();
      character cLinkType = TypeFactory.character();
      integer iHyphen = TypeFactory.integer();
      integer iObject = TypeFactory.integer();
      character cDirection = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      character cObjects = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
         iPage.assign(ghProp.unwrapBufferField().value());
         
         if (_isNotEqual(iPage, 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hObject.assign(ghProp.unwrapBufferField().value());
            
            if ((hObject.isValid()).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("removePageNTarget", hObject, "II", targetProcedure(), iPage);
            }
         }
         /* END DO IF not Page 0 */
         /* remove user-defined links too */
         ControlFlowOps.invokeIn("removeUserLinks", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SupportedLinks"));
         cSupportedLinks.assign(ghProp.unwrapBufferField().value());
         /* Add standard links which aren't on SupportedLinks to the list. */
         cSupportedLinks.assign(concat(cSupportedLinks, (_isNotEqual(cSupportedLinks, "") ? new character(",") : new character("")), "Container-Source,Container-Target,Page-Source,Page-Target"));
         
         IntegerExpression resExpr3 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cSupportedLinks);
            }
         };
         ToClause toClause3 = new ToClause(iLink, 1, resExpr3);
         
         doTo("loopLabel12", toClause3, new Block((Body) () -> 
         {
            cLink.assign(trim(entry(iLink, cSupportedLinks)));
            iHyphen.assign(lastIndexOf(entry(iLink, cSupportedLinks), "-"));
            cLinkType.assign(substring(cLink, 1, minus(iHyphen, 1)));
            /* Base link type */
            cDirection.assign(substring(cLink, plus(iHyphen, 1)));
            
            /* Source or Target */
            if (_isEqual(cDirection, "TARGET"))
            {
               ErrorManager.silentErrorEnable();
               /* Note: Can't use {get} for variable properties.*/
               cObjects.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", cLinkType, "Source"), targetProcedure()));
               ErrorManager.silentErrorDisable();
               
               if (_notUnknown(cObjects))
               {
                  IntegerExpression resExpr4 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cObjects);
                     }
                  };
                  ToClause toClause4 = new ToClause(iObject, 1, resExpr4);
                  
                  doTo("loopLabel13", toClause4, new Block((Body) () -> 
                  {
                     /* May be multiple sources. */
                     hObject.assign(handle.fromString(entry(iObject, cObjects)));
                     
                     if ((hObject.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeInWithMode("removeLink", targetProcedure(), "III", hObject, cLinkType, targetProcedure());
                     }
                  }));
               }
            }
 /* This object is the Target */            else
            {
               ErrorManager.silentErrorEnable();
               /* This object is the Source */
               cObjects.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", cLinkType, "Target"), targetProcedure()));
               ErrorManager.silentErrorDisable();
               
               if (_notUnknown(cObjects))
               {
                  IntegerExpression resExpr5 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cObjects);
                     }
                  };
                  ToClause toClause5 = new ToClause(iObject, 1, resExpr5);
                  
                  doTo("loopLabel14", toClause5, new Block((Body) () -> 
                  {
                     /* May be multiple targets. */
                     hObject.assign(handle.fromString(entry(iObject, cObjects)));
                     
                     if ((hObject.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeInWithMode("removeLink", targetProcedure(), "III", targetProcedure(), cLinkType, hObject);
                     }
                  }));
               }
 /* Might be unknown if no prop function. */;
            }
         }));
         
         /* END Processing for SupportedLinks */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose:     Removes a specific link between two objects.<br>
    * Parameters:  INPUT phSource AS HANDLE  source procedure handle,<br>
    *              INPUT pcLink   AS CHARACTER  link type name, <br>
    *              INPUT phTarget AS HANDLE  link target object handle
    */
   public void removeLink(final handle _phSource, final character _pcLink_4, final handle _phTarget)
   {
      handle phSource = TypeFactory.initInput(_phSource);
      character pcLink_4 = TypeFactory.initInput(_pcLink_4);
      handle phTarget = TypeFactory.initInput(_phTarget);
      character cSources = TypeFactory.character();
      character cTargets = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, phSource.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SupportedLinks"));
         cSources.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, phTarget.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SupportedLinks"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         if (_and(and(isNotEqual(pcLink_4, "Container"), () -> not(begins(pcLink_4, "Page"))), () -> and(isEqual(lookup(concat(pcLink_4, "-Source"), cSources), 0), () -> isEqual(lookup(concat(pcLink_4, "-Target"), cTargets), 0))))
         {
            NamedEventManager.unsubscribe(phTarget, pcLink_4, phSource);
            /* Because there are no "Source" and "Target" properties for
                        these "dynamic" links, we need to store the handles where
                        the linkHandles function will be able to get at them later,
                        if needed. */
            ControlFlowOps.invokeInWithMode("modifyUserLinks", phSource, "III", new character("REMOVE"), concat(pcLink_4, "-Target"), phTarget);
            ControlFlowOps.invokeInWithMode("modifyUserLinks", phTarget, "III", new character("REMOVE"), concat(pcLink_4, "-Source"), phSource);
            returnNormal();
         }
         
         /* END DO for non-Supported Link */
         /* The remaining code is for standard SupportedLinks. */
         /* UNSUBSCRIBE to all the appropriate events on each side of the old link. 
              First UNSUBSCRIBE the target. */
         ControlFlowOps.invokeInWithMode("linkStateHandler", phTarget, "III", new character("Remove"), phSource, concat(pcLink_4, "Source"));
         /*  UNSUBSCRIBE the source. */
         ControlFlowOps.invokeInWithMode("linkStateHandler", phSource, "III", new character("Remove"), phTarget, concat(pcLink_4, "Target"));
         
         /* We must be prepared for the Source or Target link to be a list 
              of more than one object. */
         if (_isEqual(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "propertyType", phTarget, "I", concat(pcLink_4, "Source")), "CHARACTER"))
         {
            ControlFlowOps.invokeWithMode("modifyListProperty", "IIII", phTarget, new character("REMOVE"), concat(pcLink_4, "Source"), valueOf(phSource));
         }
         else
         {
            ErrorManager.silentErrorEnable();
            ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", pcLink_4, "Source"), phTarget, "I", new unknown());
            ErrorManager.silentErrorDisable();
         }
         
         /* Remove the Source  -- don't complain if it's not there. */
         if (_isEqual(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "propertyType", phSource, "I", concat(pcLink_4, "Target")), "CHARACTER"))
         {
            ControlFlowOps.invokeWithMode("modifyListProperty", "IIII", phSource, new character("REMOVE"), concat(pcLink_4, "Target"), valueOf(phTarget));
         }
         else
         {
            ErrorManager.silentErrorEnable();
            ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", pcLink_4, "Target"), phSource, "I", new unknown());
            ErrorManager.silentErrorDisable();
         }
         
         /* Remove the Target  -- don't complain if it's not there. */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Remove all user-defined links. This routine will normally be called <br>
    *           when an object is deleted. Not only do we want to delete it's links<br>
    *           but we need to delete the links to it that other objects have.<br>
    *           So, for instance, if user links for the deleted object has a link <br>
    *           such as <br>
    *           "Mylink-target,&lt;handlex&gt;"<br>
    *           then we need to delete a corresponding link "mylink-source,handley" <br>
    *           in the object identified by 'handlex'. Note: in this example, <br>
    *           'handley' is the object that is being deleted.<br>
    *           <br>
    *              <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void removeUserLinks()
   {
      character clinklist = TypeFactory.character();
      integer ilink = TypeFactory.integer();
      integer iHandle = TypeFactory.integer();
      character clinkentry = TypeFactory.character();
      character clinkname = TypeFactory.character();
      character chandles = TypeFactory.character();
      handle hObj = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* get the User-defined links list from adm-data */
         clinklist.assign(entry(3, targetProcedure().unwrapADMData().getADMData(), chr(1)));
         
         loopLabel15:
         for (ilink.assign(1); _isLessThanOrEqual(ilink, numEntries(clinklist, chr(3))); ilink.increment())
         {
            clinkentry.assign(entry(ilink, clinklist, chr(3)));
            clinkname.assign(entry(1, clinkentry, chr(4)));
            chandles.assign(entry(2, clinkentry, chr(4)));
            
            /* if the link is "mylink-target" for the current object, then
                 * we need to delete "mylink-source" in the other object (and 
                 * vice-versa). So we make the substitution here.
                 */
            if (_isNotEqual(lastIndexOf(clinkname, "-Target"), 0))
            {
               clinkname.assign(replaceAll(clinkname, "-Target", "-Source"));
            }
            else
            {
               if (_isNotEqual(lastIndexOf(clinkname, "-Source"), 0))
               {
                  clinkname.assign(replaceAll(clinkname, "-Source", "-Target"));
               }
            }
            
            IntegerExpression resExpr6 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(chandles, ",");
               }
            };
            ToClause toClause6 = new ToClause(iHandle, 1, resExpr6);
            
            doTo("loopLabel16", toClause6, new Block((Body) () -> 
            {
               hObj.assign(handle.fromString(entry(iHandle, chandles, ",")));
               
               if ((hObj.isValid()).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("modifyUserLinks", hObj, "III", new character("Remove"), clinkname, targetProcedure());
               }
            }));
         }
         
         clinklist.assign(targetProcedure().unwrapADMData().getADMData());
         clinklist.replaceEntry(3, chr(1), "");
         targetProcedure().unwrapADMData().setADMData(clinklist);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void repositionObject(final decimal _pdRow, final decimal _pdCol)
   {
      decimal pdRow = TypeFactory.initInput(_pdRow);
      decimal pdCol = TypeFactory.initInput(_pdCol);
      handle hParent = TypeFactory.handle();
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            if (_isEqual(hContainer.unwrapType().getResourceType(), "WINDOW"))
            {
               if (_isEqual(pdRow, 0))
               {
                  pdRow.assign(divide(minus(LogicalTerminal.getHeightChars(), hContainer.unwrapSizeable().getHeightChars()), 2));
               }
               
               if (_isEqual(pdCol, 0))
               {
                  pdCol.assign(divide(minus(LogicalTerminal.getWidthChars(), hContainer.unwrapSizeable().getWidthChars()), 2));
               }
            }
            else
            {
               if (_isEqual(hContainer.unwrapType().getResourceType(), "DIALOG-BOX"))
               {
                  hParent.assign(hContainer.unwrapWidget().getParentHandle());
                  
                  if (_isEqual(pdRow, 0))
                  {
                     pdRow.assign(minus(divide(minus(LogicalTerminal.getHeightChars(), hContainer.unwrapSizeable().getHeightChars()), 2), hParent.unwrapWidget().getRow()));
                  }
                  
                  if (_isEqual(pdCol, 0))
                  {
                     pdCol.assign(minus(divide(minus(LogicalTerminal.getWidthChars(), hContainer.unwrapSizeable().getWidthChars()), 2), hParent.unwrapWidget().getColumn()));
                  }
               }
            }
            
            /* If the row or column wound up being between 0 and 1 after the 
                     calculation, change it, because otherwise Progress will complain. */
            if (_and(isGreaterThanOrEqual(pdRow, 0), () -> isLessThan(pdRow, 1)))
            {
               pdRow.assign(1);
            }
            
            if (_and(isGreaterThanOrEqual(pdCol, 0), () -> isLessThan(pdCol, 1)))
            {
               pdCol.assign(1);
            }
            
            ErrorManager.silentErrorEnable();
            hContainer.unwrapWidget().setRow(pdRow);
            hContainer.unwrapWidget().setColumn(pdCol);
            ErrorManager.silentErrorDisable();
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     returns focus to the containing window<br>
    * Parameters:  hTarget - a handle to the target procedure object<br>
    * Notes:
    */
   public void returnFocus(final handle _hTarget)
   {
      handle hTarget = TypeFactory.initInput(_hTarget);
      character cUibmode = TypeFactory.character();
      handle hCntSrc = TypeFactory.handle();
      handle hCntWidget = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
         cUibmode.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hCntWidget.assign(ghProp.unwrapBufferField().value());
         
         /* This object's widget container */
         if (_and(and(isNotEqual(cUibmode, "DESIGN"), () -> hCntWidget.isValid()), () -> isEqual(hCntWidget.unwrapType().getResourceType(), "WINDOW")))
         {
            ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hCntSrc.assign(ghProp.unwrapBufferField().value());
            
            /* Container Source's procedure handle */
            if ((hCntSrc.isValid()).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, hCntSrc.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
               hCntWidget.assign(ghProp.unwrapBufferField().value());
            }
            
            if ((hCntWidget.isValid()).booleanValue())
            {
               apply(hCntWidget, "ENTRY");
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Astra 2 override for showMessage function to use Astra 2 message<br>
    *              handling routines.<br>
    *              Displays (using a simple MESSAGE statement by default)<br>
    *              either a literal message string, or a message number which<br>
    *              is returned by the messageNumber function.<br>
    * Parameters: INPUT pcMessage AS CHARACTER  <br>
    *             - Either a literal message string <br>
    *             - Or a message number in character form. <br>
    *              <br>
    *              A message number can be followed by a comma delimited list<br>
    *              with maximum 10 entries:<br>
    *              <br>
    *              The LAST entry (2 - 10) is:               <br>
    *              1) The word "Question" or "YesNo", in which case the message is <br>
    *                 displayed with YES-NO buttons and the answer is returned.<br>
    *              <br>
    *              2) The word "YesNoCancel", in which case the message is displayed<br>
    *                 with YES-NO-CANCEL buttons and the answer is returned.<br>
    *                 <br>
    *              Optional entries from 2 to 10: <br>
    *                 Each entry will be placed into the numeric message<br>
    *                 in place of the the string of form &n, where n is an integer <br>
    *                 between 1 and 9, inclusive (Entry 2 will replace &1 etc)         <br>
    *                 <br>
    *   Returns:   LOGICAL: true/false if the Question option is used,<br>
    *                       true/false/unknown if the YesNoCancel option is used <br>
    *                       else true.<br>
    * Notes:       This function can be overridden to use a mechanism other than<br>
    *              the MESSAGE statement to display messages, and still use the<br>
    *              messageNumber function to map message numbers to translatable text.<br>
    *              Note that this is different from addMessage, fetchMessages, etc.,<br>
    *              which log messages in a temp-table for later retrieval.
    */
   public void showMessageProcedure(final character _pcMessage_1, final logical plAnswer)
   {
      character pcMessage_1 = TypeFactory.initInput(_pcMessage_1);
      integer iMessage = TypeFactory.integer();
      character cMessage = TypeFactory.character();
      character cMessageType = TypeFactory.character();
      character[] cMsg = TypeFactory.characterExtent(9);
      integer iNumParam = TypeFactory.integer();
      logical lAnswer = TypeFactory.logical();
      character cAnswer = UndoableFactory.character();
      character cButtonPressed = UndoableFactory.character();
      handle hContainerSource = TypeFactory.handle();
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(plAnswer);
      }, 
      (Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hContainerSource.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorEnable();
         iMessage.assign(new integer(entry(1, pcMessage_1)));
         ErrorManager.silentErrorDisable();
         
         /* was a number passed? */
         if ((ErrorManager.isError()).booleanValue())
         {
            messageBox(pcMessage_1, ALERT_INFO, BTN_OK, (String) null);
         }
         else
         {
            cMessage.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", iMessage));
            iNumParam.assign(numEntries(pcMessage_1));
            cMessageType.assign(entry(iNumParam, pcMessage_1));
            assignSingle(cMsg, 1, _isGreaterThan(iNumParam, 1) ? entry(2, pcMessage_1) : new character(""));
            assignSingle(cMsg, 2, _isGreaterThan(iNumParam, 2) ? entry(3, pcMessage_1) : new character(""));
            assignSingle(cMsg, 3, _isGreaterThan(iNumParam, 3) ? entry(4, pcMessage_1) : new character(""));
            assignSingle(cMsg, 4, _isGreaterThan(iNumParam, 4) ? entry(5, pcMessage_1) : new character(""));
            assignSingle(cMsg, 5, _isGreaterThan(iNumParam, 5) ? entry(6, pcMessage_1) : new character(""));
            assignSingle(cMsg, 6, _isGreaterThan(iNumParam, 6) ? entry(7, pcMessage_1) : new character(""));
            assignSingle(cMsg, 7, _isGreaterThan(iNumParam, 7) ? entry(8, pcMessage_1) : new character(""));
            assignSingle(cMsg, 8, _isGreaterThan(iNumParam, 8) ? entry(9, pcMessage_1) : new character(""));
            assignSingle(cMsg, 9, _isGreaterThan(iNumParam, 9) ? entry(10, pcMessage_1) : new character(""));
            cMessage.assign(substitute(cMessage, subscript(cMsg, 1), subscript(cMsg, 2), subscript(cMsg, 3), subscript(cMsg, 4), subscript(cMsg, 5), subscript(cMsg, 6), subscript(cMsg, 7), subscript(cMsg, 8), subscript(cMsg, 9)));
            
            /* Yes -- get the msg */
            switch (StringHelper.safeTrimTrailing((cMessageType).toStringMessage()).toUpperCase())
            {
               case "QUESTION":
               case "YESNO":
                  {
                     if (_and(and(not(new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "IsDialogBoxParent", targetProcedure(), "I", hContainer))), () -> not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFunctionInCallStack", targetProcedure())))), () -> gshSessionManager.isValid()))
                     {
                        ErrorManager.silentErrorEnable();
                        ControlFlowOps.invokeInWithMode("askQuestion", gshSessionManager, "IIIIIIIUO", cMessage, new character("Yes,No"), new character("YES"), new character("NO"), new character("ADM2 Message"), new character(""), new character(""), cAnswer, cButtonPressed /* pcButtonPressed   */);
                        ErrorManager.silentErrorDisable();
                        
                        switch (StringHelper.safeTrimTrailing((cButtonPressed).toStringMessage()).toUpperCase())
                        {
                           case "YES":
                              {
                                 lAnswer.assign(true);
                              }
                              break;
                           case "NO":
                              {
                                 lAnswer.assign(false);
                              }
                              break;
                        }
                     }
                     else
                     {
                        messageBox(cMessage, false, new AccessorWrapper(lAnswer), ALERT_QUESTION, BTN_YES_NO, (String) null);
                     }
                     plAnswer.assign(lAnswer);
                     returnNormal();
                  }
               case "OKCANCEL":
                  {
                     if (_and(and(not(new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "IsDialogBoxParent", targetProcedure(), "I", hContainer))), () -> not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFunctionInCallStack", targetProcedure())))), () -> gshSessionManager.isValid()))
                     {
                        ErrorManager.silentErrorEnable();
                        ControlFlowOps.invokeInWithMode("askQuestion", gshSessionManager, "IIIIIIIUO", cMessage, new character("Ok,Cancel"), new character("YES"), new character("NO"), new character("ADM2 Message"), new character(""), new character(""), cAnswer, cButtonPressed /* pcButtonPressed   */);
                        ErrorManager.silentErrorDisable();
                        
                        switch (StringHelper.safeTrimTrailing((cButtonPressed).toStringMessage()).toUpperCase())
                        {
                           case "YES":
                              {
                                 lAnswer.assign(true);
                              }
                              break;
                           case "NO":
                              {
                                 lAnswer.assign(false);
                              }
                              break;
                        }
                     }
                     else
                     {
                        messageBox(cMessage, false, new AccessorWrapper(lAnswer), ALERT_QUESTION, BTN_OK_CANCEL, (String) null);
                     }
                     plAnswer.assign(lAnswer);
                     returnNormal();
                  }
               case "YESNOCANCEL":
                  {
                     if (_and(and(not(new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "IsDialogBoxParent", targetProcedure(), "I", hContainer))), () -> not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFunctionInCallStack", targetProcedure())))), () -> gshSessionManager.isValid()))
                     {
                        ControlFlowOps.invokeInWithMode("askQuestion", gshSessionManager, "IIIIIIIUO", cMessage, new character("Yes,No,Cancel"), new character("CANCEL"), new character("Cancel"), new character("ADM2 Message"), new character(""), new character(""), cAnswer, cButtonPressed /* pcButtonPressed   */);
                        
                        switch (StringHelper.safeTrimTrailing((cButtonPressed).toStringMessage()).toUpperCase())
                        {
                           case "YES":
                              {
                                 lAnswer.assign(true);
                              }
                              break;
                           case "NO":
                              {
                                 lAnswer.assign(false);
                              }
                              break;
                           case "CANCEL":
                              {
                                 lAnswer.setUnknown();
                              }
                              break;
                        }
                     }
                     else
                     {
                        messageBox(cMessage, false, new AccessorWrapper(lAnswer), ALERT_QUESTION, BTN_YES_NO_CANCEL, (String) null);
                     }
                     plAnswer.assign(lAnswer);
                     returnNormal();
                  }
               default:
                  {
                     if (_and(and(not(new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "IsDialogBoxParent", targetProcedure(), "I", hContainer))), () -> not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFunctionInCallStack", targetProcedure())))), () -> gshSessionManager.isValid()))
                     {
                        ControlFlowOps.invokeInWithMode("showMessages", gshSessionManager, "IIIIIIIIO", cMessage, new character("INF"), new character("OK"), new character("OK"), new character(""), new character("ADM2 Message"), new logical(true), hContainerSource, cButtonPressed);
                     }
 /* pcButtonPressed */                     else
                     {
                        messageBox(cMessage, ALERT_INFO, BTN_OK, (String) null);
                     }
                  }
                  break;
            }
         }
         /* END ELSE IF numeric message */
         plAnswer.assign(true);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void toggleData(final logical _plEnabled)
   {
      logical plEnabled = TypeFactory.initInput(_plEnabled);
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLinksEnabled"));
         ghProp.unwrapBufferField().changeValue(plEnabled);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Views the current object.<br>
    *  Params:     &lt;none&gt;<br>
    *   Notes:     "Viewing" in the ADM is a logical concept which can be applied<br>
    *              to all objects regardless of whether they have a visualization;<br>
    *              that is why this procedure is found in smart.p. When an<br>
    *              object is "viewed" its links are typically activated; when<br>
    *              "hidden" they are sometimes deactivated, depending on the link<br>
    *              type. If an object has an actual visualization, the version of<br>
    *              viewObject in visual.p will view it.
    */
   public void viewObject()
   {
      character cContainer = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("containerType"));
         cContainer.assign(ghProp.unwrapBufferField().value());
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setObjectHidden", targetProcedure(), "I", false);
         
         if (_isNotEqual(cContainer, ""))
         {
            /* We don't need to physically view the SmartObjects in this Container -
                   they will reappear when it is viewed - but we need to tell them that
                   they are part of a viewed Container so that they can set links
                   and other states dependent on HIDDEN accordingly. */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignLinkProperty", targetProcedure(), "III", "Container-Target", "ContainerHidden", "no");
         }
         
         /* For those objects which want to "activate" a link when an object is
              viewed, we tell them that this object is 'active'. We also set the
              ObjectActive property to hold onto the state for future inquiries. */
         NamedEventManager.publish("LinkState", targetProcedure(), "I", new Object[]
         {
            "active"
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            hContainer.unwrapWidget().setHidden(new logical(false));
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public logical anyMessage()
   {
      return function("anyMessage", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Returns a flag indicating whether there is any message in the log.
            Params:  <none>
           Returns:  LOGICAL: true if there are messages in the log, else false.
         ------------------------------------------------------------------------------*/
         returnNormal(isNotEqual(gcDataMessages, ""));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignLinkProperty(final character _pcLink_4, final character _pcPropName_5, final character _pcPropValue_2)
   {
      character pcLink_4 = TypeFactory.initInput(_pcLink_4);
      character pcPropName_5 = TypeFactory.initInput(_pcPropName_5);
      character pcPropValue_2 = TypeFactory.initInput(_pcPropValue_2);
      /*------------------------------------------------------------------------------
        Purpose:     Sets a property value in an object at the other end of 
                     a specified link, relative to TARGET-PROCEDURE.
        Parameters:  INPUT pcLink AS CHARACTER -- Link Type, 
                     INPUT pcPropName AS CHARACTER -- Property Name, 
                     INPUT pcPropValue AS CHARACTER -- Property Value.
           Returns:  LOGICAL: true if "set" operation succeeds, else false.
        Notes:       ADM2 Version of set-link-attribute. Note that only one property
                     name and value is allowed, as opposed to the "attribute list"
                     format of V8. If the property function is not there or invalid
                     somehow, or if any of the "set"s fails, return false.
      ------------------------------------------------------------------------------*/
      character cObjects = TypeFactory.character();
      logical lReturn = TypeFactory.logical(true);
      logical lSuccess = TypeFactory.logical();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      
      return function("assignLinkProperty", logical.class, new Block((Body) () -> 
      {
         cObjects.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "linkHandles", targetProcedure(), "I", pcLink_4));
         
         if (_notUnknown(cObjects))
         {
            IntegerExpression resExpr7 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cObjects);
               }
            };
            ToClause toClause7 = new ToClause(iObject, 1, resExpr7);
            
            doTo("loopLabel17", toClause7, new Block((Body) () -> 
            {
               ErrorManager.silentErrorEnable();
               hObject.assign(handle.fromString(entry(iObject, cObjects)));
               lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", pcPropName_5), hObject, "I", pcPropValue_2));
               ErrorManager.silentErrorDisable();
               
               if (_not(lSuccess))
               {
                  lReturn.assign(false);
               }
            }));
         }
         returnNormal(lReturn);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical changeLinkState(final character _pcState_1, final character _pcLink_4, final handle _phObject_5)
   {
      character pcState_1 = TypeFactory.initInput(_pcState_1);
      character pcLink_4 = TypeFactory.initInput(_pcLink_4);
      handle phObject_5 = TypeFactory.initInput(_phObject_5);
      /*------------------------------------------------------------------------------
        Purpose: Subscribe to the link events in the passed object  
      Parameter: pcState - 'Active'  - activate links by subscribing to the
                                      <Link>Events of the passed object
                           'Inactive' - deactivate links by unsubscribing to the
                                      <Link>Events of the passed object
                 pcLink - full link name to a linked object.  
                          DataSource or Data-source (both forms supported) 
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      integer iEvent = TypeFactory.integer();
      
      return function("changeLinkState", logical.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         pcLink_4.assign(replaceAll(pcLink_4, "-", ""));
         cEvents.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", pcLink_4, "Events"), targetProcedure()));
         ErrorManager.silentErrorDisable();
         
         if (_and(isEqual(ErrorManager.isError(), false), () -> phObject_5.isValid()))
         {
            loopLabel18:
            for (iEvent.assign(1); _isLessThanOrEqual(iEvent, numEntries(cEvents)); iEvent.increment())
            {
               if (_isEqual(pcState_1, "ACTIVE"))
               {
                  NamedEventManager.subscribe(targetProcedure(), entry(iEvent, cEvents), phObject_5);
               }
               
               if (_isEqual(pcState_1, "INACTIVE"))
               {
                  NamedEventManager.unsubscribe(targetProcedure(), entry(iEvent, cEvents), phObject_5);
               }
            }
            
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character deleteEntry(final integer _piEntry_1, final character _pcString_1, final character _pcDelim_1)
   {
      integer piEntry_1 = TypeFactory.initInput(_piEntry_1);
      character pcString_1 = TypeFactory.initInput(_pcString_1);
      character pcDelim_1 = TypeFactory.initInput(_pcDelim_1);
      /*------------------------------------------------------------------------------
        Purpose:  Delete entry piEntry from pcString.
        Returns:  Returns the new string without the specified entry.
          
      ------------------------------------------------------------------------------*/
      integer iNumEnt = TypeFactory.integer();
      character cUnique = TypeFactory.character("@");
      
      return function("deleteEntry", character.class, new Block((Body) () -> 
      {
         /* if delimiter is not specified then use comma as default */
         if (_or(isEqual(pcDelim_1, ""), () -> isUnknown(pcDelim_1)))
         {
            pcDelim_1.assign(",");
         }
         
         /* determine a unique string to replace the entry we want to delete then
          * we can easily delete it and the appropriate delimiters from pcString.
          * First, if the character used to build the unique string is the delimiter 
          * then use another character altogether to build the unique string.
          */
         if (_isEqual(pcDelim_1, cUnique))
         {
            cUnique.assign("$");
         }
         
         loopLabel19:
         while (_isGreaterThan(indexOf(pcString_1, cUnique), 0))
         {
            cUnique.assign(concat(cUnique, substring(cUnique, 1, 1)));
         }
         
         /* replace the entry-to-delete with unique string */
         /* then delete it and appropriate delimiters      */
         pcString_1.replaceEntry(piEntry_1, pcDelim_1, cUnique);
         iNumEnt.assign(numEntries(pcString_1, pcDelim_1));
         
         if (_and(isEqual(iNumEnt, 1), () -> isEqual(piEntry_1, 1)))
         {
            pcString_1.assign("");
         }
         else
         {
            pcString_1.assign(replaceAll(pcString_1, _isEqual(piEntry_1, iNumEnt) ? concat(pcDelim_1, cUnique) /* last entry*/ : _isEqual(piEntry_1, 1) ? concat(cUnique, pcDelim_1) /* first entry*/ : concat(cUnique, pcDelim_1), ""));
         }
         
         returnNormal(pcString_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical deleteProperties()
   {
      /*------------------------------------------------------------------------------
        Purpose: Delete the property tt record   
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hPropTable = TypeFactory.handle();
      
      return function("deleteProperties", logical.class, new Block((Body) () -> 
      {
         hPropTable.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         
         if (_and(hPropTable.isValid(), () -> isNotEqual(hPropTable.unwrap().name(), "ADMProps")))
         {
            hPropTable.unwrapBuffer().findFirst(concat("WHERE Target = WIDGET-HANDLE(", character.quoter(targetProcedure()), ") "));
            hPropTable.unwrapBuffer().deleteRecord();
         }
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fetchMessages()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a delimited list of all messages in their "raw" form. 
                  The message log is cleared.
         Params:  <none>
        Returns:  CHARACTER: specially-delimited message text string
          Notes:  The message list is delimited by CHR(3); within each message, the
                  Message Text, the Field (if any), and the Table (if any) are delimited
                  by CHR(4). Use the similar function reviewMessages to read messages
                  without deleting them.
      ------------------------------------------------------------------------------*/
      character cMessages = TypeFactory.character("");
      
      return function("fetchMessages", character.class, new Block((Body) () -> 
      {
         cMessages.assign(gcDataMessages);
         gcDataMessages.assign("");
         returnNormal(cMessages);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fixQueryString(final character _pcQueryString_2)
   {
      character pcQueryString_2 = TypeFactory.initInput(_pcQueryString_2);
      integer iPosn = TypeFactory.integer();
      character cBefore = TypeFactory.character();
      character cAfter = TypeFactory.character();
      
      return function("fixQueryString", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose: To check for comma decimal places in query string and replace with
                    full stops to resolve issues when running with European numeric
                    formats selected.
             Notes: Whereever a query prepare is being used, this procedure should first
                    be called to resolve any issues in the query string, such as decimal
                    formatting.
                    The main issues arise when the query string contains stringed decimal
                    values.
         ------------------------------------------------------------------------------*/
         if (_isEqual(NumberType.getNumericDecimalPoint(), "."))
         {
            returnNormal(pcQueryString_2);
         }
         
         iPosn.assign(indexOf(pcQueryString_2, NumberType.getNumericDecimalPoint()));
         
         LogicalOp whileClause0 = () -> and(isNotEqual(iPosn, 0), () -> notUnknown(iPosn));
         
         repeatWhile("commaLoop", whileClause0, new Block((Body) () -> 
         {
            cBefore.assign("");
            cAfter.assign("");
            
            if (_isGreaterThan(iPosn, 1))
            {
               cBefore.assign(substring(pcQueryString_2, minus(iPosn, 1), 1));
            }
            
            if (_isLessThan(iPosn, length(pcQueryString_2)))
            {
               cAfter.assign(substring(pcQueryString_2, plus(iPosn, 1), 1));
            }
            
            if (_and(and(and(isGreaterThanOrEqual(cBefore, "0"), () -> isLessThanOrEqual(cBefore, "9")), () -> isGreaterThanOrEqual(cAfter, "0")), () -> isLessThanOrEqual(cAfter, "9")))
            {
               /* See if it is not quoted and thus needs to be changed */
               if (_isEqual(ControlFlowOps.invokeDynamicFunctionWithMode(logical.class, "isObjQuoted", "II", pcQueryString_2, iPosn), false))
               {
                  pcQueryString_2.replace(".", iPosn, 1);
               }
            }
            iPosn.assign(indexOf(pcQueryString_2, NumberType.getNumericDecimalPoint(), plus(iPosn, 1)));
         }));
         
         /* comma loop */
         returnNormal(pcQueryString_2);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getChildDataKey()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cChildDataKey_1 = TypeFactory.character();
      
      return function("getChildDataKey", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ChildDataKey"));
         cChildDataKey_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cChildDataKey_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getClassName()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Repository class name
          Notes:
      ------------------------------------------------------------------------------*/
      character cClassName = TypeFactory.character();
      
      return function("getClassName", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ClassName"));
         cClassName.assign(ghProp.unwrapBufferField().value());
         returnNormal(cClassName);
      }));
   }

   /** getClassName */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getContainerHandle()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the widget handle of this object's Window or 
                  Frame container. 
         Returns: HANDLE
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("getContainerHandle", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         returnNormal(hContainer);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getContainerHidden()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a flag indicating whether this object's *parent* container
                  is hidden.
         Returns: LOGICAL
         Params:  <none>
      ------------------------------------------------------------------------------*/
      logical lHidden = TypeFactory.logical();
      
      return function("getContainerHidden", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHidden"));
         lHidden.assign(ghProp.unwrapBufferField().value());
         returnNormal(lHidden);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getContainerSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the handle of this object's ContainerSource, if any.
         Params:  <none>
        Returns:  HANDLE
      ------------------------------------------------------------------------------*/
      handle hSource = TypeFactory.handle();
      
      return function("getContainerSource", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(hSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainerSourceEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a comma-separated list of the events this object 
                  wants to subscribe to in its ContainerSource
         Params:  <none>
        Returns:  CHARACTER
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getContainerSourceEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSourceEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainerType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of Container which this SmartObject is --
                  blank if the object is not a container, otherwise "WINDOW" for
                  a SmartWindow , "FRAME" for a SmartFrame.
         Params:  <none>
        Returns:  CHARACTER
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getContainerType", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
         cType.assign(ghProp.unwrapBufferField().value());
         returnNormal(cType);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getDataLinksEnabled()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lDataLinksEnabled_1 = TypeFactory.logical();
      
      return function("getDataLinksEnabled", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLinksEnabled"));
         lDataLinksEnabled_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(lDataLinksEnabled_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getDataSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the object's data source, if any.
         Params:  <none>
        Returns:  HANDLE
          Notes: There si no xp preprosessor in order to allow design-time override  
      ------------------------------------------------------------------------------*/
      handle hDataSource = TypeFactory.handle();
      
      return function("getDataSource", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSource"));
         hDataSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(hDataSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDataSourceEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a comma-separated list of the events this object 
                  wants to subscribe to in its DataSource.
         Params:  <none>
        Returns:  CHARACTER
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getDataSourceEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDataSourceNames()
   {
      /*------------------------------------------------------------------------------
       Purpose:  Returns the ObjectName of the Data Object that sends data to this
                 visual object. This would be set if the data-Source is an SBO
                 or other Container with DataObjects.
        Params:  <none>
         Notes: Used by both visual objects and SDOs.
                See the SBOs addDataTarget for more details on how this is set.  
      ------------------------------------------------------------------------------*/
      character cSourceNames = TypeFactory.character();
      
      return function("getDataSourceNames", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
         cSourceNames.assign(ghProp.unwrapBufferField().value());
         returnNormal(cSourceNames);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDataTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Data Target (in CHARACTER form, because it may be
                  a comma-separated list). 
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cTarget = TypeFactory.character();
      
      return function("getDataTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cTarget.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTarget);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDataTargetEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:     Returns the list of events this object subscribes to in its
                     DataTarget.
        Parameters:  
        Notes:        
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getDataTargetEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTargetEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getDbaware()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a flag indicating whether this object is dependent
                  on being connected to a database or not, to allow some code
                  to execute two different ways (for DataObjects, e.g.).
          Params: <none>
         Returns: LOGICAL
      ------------------------------------------------------------------------------*/
      logical lAware_1 = TypeFactory.logical();
      
      return function("getDBAware", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DBAware"));
         lAware_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(lAware_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDesignDataObject()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns the design time SDO for objects that needs SDO data,
                 but cannot be linked.
          Notes:  
      ------------------------------------------------------------------------------*/
      character cDataObject = TypeFactory.character();
      
      return function("getDesignDataObject", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DesignDataObject"));
         cDataObject.assign(ghProp.unwrapBufferField().value());
         returnNormal(cDataObject);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getDynamicObject()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lTemp_1 = TypeFactory.logical();
      
      return function("getDynamicObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicObject"));
         lTemp_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(lTemp_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getHideOnInit()
   {
      /*------------------------------------------------------------------------------
        Purpose: Return the logical flag that indicates whether to visualize 
                 at initialization.
          Notes: Also used for non visual object in order to publish LinkState 
                 correctly for activation and deactivation of links.   
                 Defaults to no, set to yes from the container when it runs initPages 
                 to initialize non visible pages 
      ------------------------------------------------------------------------------*/
      logical lHideOnInit = TypeFactory.logical();
      
      return function("getHideOnInit", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnInit"));
         lHideOnInit.assign(ghProp.unwrapBufferField().value());
         returnNormal(lHideOnInit);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getInactiveLinks()
   {
      /*------------------------------------------------------------------------------
         Purpose: Stores inactive links 
         Notes:   Stored as a comma-separated paired list where the second entry of 
                  each pair is a semi-colon separated list of object handles 
              -   modifyInactiveLinks should be used to maintain thje property. 
              -   isLinklnactive should be used to check if an actual link is 
                  inactive                  
      ------------------------------------------------------------------------------*/
      character cInactiveLinks = TypeFactory.character();
      
      return function("getInactiveLinks", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InactiveLinks"));
         cInactiveLinks.assign(ghProp.unwrapBufferField().value());
         returnNormal(cInactiveLinks);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public decimal getInstanceId()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Repository manager's unique identifier of this instance  
          Notes:  
      ------------------------------------------------------------------------------*/
      decimal dId = TypeFactory.decimal();
      
      return function("getInstanceId", decimal.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceId"));
         dId.assign(ghProp.unwrapBufferField().value());
         returnNormal(dId);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getInstanceProperties()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the ADM Instance Properties of the SmartObject --
                  a list of those properties which can be set at design time to
                  be initialized as part of SmO startup.
         Params:  <none>
        Returns:  CHARACTER
      ------------------------------------------------------------------------------*/
      character cProps = TypeFactory.character();
      
      return function("getInstanceProperties", character.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceProperties"));
         cProps.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorDisable();
         returnNormal(cProps);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getLabel()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns the LABEL defined for the selection   
          Notes: - "?" specifies that the logicalObjectName is to be used
                 - Blank specifies NO-LABEL   
      ------------------------------------------------------------------------------*/
      character cLabel = TypeFactory.character();
      
      return function("getLabel", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Label"));
         cLabel.assign(ghProp.unwrapBufferField().value());
         
         if (_isUnknown(cLabel))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            cLabel.assign(ghProp.unwrapBufferField().value());
            
            if (_or(isEqual(cLabel, ""), () -> isUnknown(cLabel)))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
               cLabel.assign(ghProp.unwrapBufferField().value());
            }
            /* {get Prop var [handle]} */ 
            
            /* store default for future requests */
            if (_and(isNotEqual(cLabel, ""), () -> notUnknown(cLabel)))
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setLabel", targetProcedure(), "I", cLabel);
            }
         }
         returnNormal(cLabel);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getLayoutPosition()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
              Notes:
      ------------------------------------------------------------------------------*/
      character cLayoutPosition = TypeFactory.character();
      
      return function("getLayoutPosition", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LayoutPosition"));
         cLayoutPosition.assign(ghProp.unwrapBufferField().value());
         returnNormal(cLayoutPosition);
      }));
   }

   /** get LayoutPosition */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getLogicalObjectName()
   {
      /*------------------------------------------------------------------------------
        Purpose: Return the logical object (Repository object name)  
          Notes:  This is the unique name of the object master in the repository 
      ------------------------------------------------------------------------------*/
      character cLogicalObject = TypeFactory.character();
      
      return function("getLogicalObjectName", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
         cLogicalObject.assign(ghProp.unwrapBufferField().value());
         returnNormal(cLogicalObject);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getLogicalVersion()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cVersion_2 = TypeFactory.character();
      
      return function("getLogicalVersion", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalVersion"));
         cVersion_2.assign(ghProp.unwrapBufferField().value());
         returnNormal(cVersion_2);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getObjectHidden()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a flag indicating whether the current object is hidden.
                  Note that "Hidden" is a logical concept in the ADM. 
                  A non-visual object can be "hidden" to indicate that it is 
                  not currently active in some way, because it is a 
                  Container-Target of some visual object that is hidden.
         Params:  <none>
        Returns:  LOGICAL
      ------------------------------------------------------------------------------*/
      logical lHidden = TypeFactory.logical();
      logical lContainerHidden = TypeFactory.logical();
      
      return function("getObjectHidden", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHidden"));
         lContainerHidden.assign(ghProp.unwrapBufferField().value());
         
         if ((lContainerHidden).booleanValue())
         {
            returnNormal(true);
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectHidden"));
            lHidden.assign(ghProp.unwrapBufferField().value());
            returnNormal(lHidden);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getObjectInitialized()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a flag indicating whether this object has been initialized.
         Params:  <none>
        Returns:  LOGICAL
      ------------------------------------------------------------------------------*/
      logical lInitted = TypeFactory.logical();
      
      return function("getObjectInitialized", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitted.assign(ghProp.unwrapBufferField().value());
         returnNormal(lInitted);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getObjectName()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the name of the object, which can be the filename
                  or some other designation meaningful to the repository and
                  other objects. 
         Returns: CHARACTER
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cName_1 = TypeFactory.character();
      
      return function("getObjectName", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
         cName_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cName_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public integer getObjectPage()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the logical page on which this object has been placed.
         Params:  <none>
        Returns:  INTEGER
      ------------------------------------------------------------------------------*/
      integer iPage = TypeFactory.integer();
      
      return function("getObjectPage", integer.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
         iPage.assign(ghProp.unwrapBufferField().value());
         returnNormal(iPage);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getObjectParent()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the widget handle of this object's Window or Frame parent,
                  that is, the handle of the visual container of its CONTAINER-SOURCE.
         Params:  <none>
        Returns:  HANDLE
          Notes:  Compare to ContainerHandle, which is the handle of *this* object's 
                  Frame or Window if it has one.
      ---------------------------------------------------------------------------*/
      handle hObject = TypeFactory.handle();
      
      return function("getObjectParent", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hObject.assign(ghProp.unwrapBufferField().value());
         
         if ((hObject.isValid()).booleanValue())
         {
            if (_and(HandleOps.canQuery(hObject, "FRAME"), () -> hObject.unwrapWidget().getFrameHandle().isValid()))
            {
               returnNormal(hObject.unwrapWidget().getFrameHandle());
            }
            else
            {
               if ((hObject.unwrapWidget().getParentHandle().isValid()).booleanValue())
               {
                  returnNormal(hObject.unwrapWidget().getParentHandle());
               }
               else
               {
                  returnNormal(new handle());
               }
            }
         }
         else
         {
            returnNormal(new handle());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getObjectVersion()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the ADM version of the SmartObject
         Params:  <none>
        Returns:  CHARACTER
          Notes:  For Progress Version 9 objects, this will return "ADM2.0" or higher.
      ------------------------------------------------------------------------------*/
      character cVersion_2 = TypeFactory.character();
      
      return function("getObjectVersion", character.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectVersion"));
         cVersion_2.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorDisable();
         returnNormal(cVersion_2);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getParentDataKey()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cParentDataKey_1 = TypeFactory.character();
      
      return function("getParentDataKey", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ParentDataKey"));
         cParentDataKey_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cParentDataKey_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPassThroughLinks()
   {
      return function("getPassThroughLinks", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Returns the list of which link types are considered candidates
                     for creating "pass-through" links.
            Params:  <none>
           Returns:  CHARACTER
             Notes:  This property value is stored once in smart.p for all SmartObjects.
         ------------------------------------------------------------------------------*/
         returnNormal(scPassThroughLinks);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPhysicalObjectName()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cTemp_1 = TypeFactory.character();
      
      return function("getPhysicalObjectName", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalObjectName"));
         cTemp_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTemp_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPhysicalVersion()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cVersion_2 = TypeFactory.character();
      
      return function("getPhysicalVersion", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalVersion"));
         cVersion_2.assign(ghProp.unwrapBufferField().value());
         returnNormal(cVersion_2);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPropertyDialog()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the name of the dialog procedure that sets 
                  InstanceProperties.
         Params:  <none>
        Returns:  CHARACTER
          Notes:  This property is usually used only internally, but must be callable
                  from the AppBuilder to determine whether to enable the 
                  InstanceProperties menu item.
      ------------------------------------------------------------------------------*/
      character cDialog = TypeFactory.character();
      
      return function("getPropertyDialog", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PropertyDialog"));
         cDialog.assign(ghProp.unwrapBufferField().value());
         returnNormal(cDialog);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getQueryObject()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns a flag indicating whether this object queries data.
          Notes: The data class and sbo class are both considered to be a QueryObject. 
      Note date: 2002/02/14       
      ------------------------------------------------------------------------------*/
      logical lQuery = TypeFactory.logical();
      
      return function("getQueryObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
         lQuery.assign(ghProp.unwrapBufferField().value());
         returnNormal(lQuery);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getRenderingProcedure()
   {
      /*------------------------------------------------------------------------------
        Purpose: Return the rendering procedure
          Notes: 
      ------------------------------------------------------------------------------*/
      character cRenderingProcedure = TypeFactory.character();
      
      return function("getRenderingProcedure", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RenderingProcedure"));
         cRenderingProcedure.assign(ghProp.unwrapBufferField().value());
         returnNormal(cRenderingProcedure);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getRunAttribute()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cRunAttribute_1 = TypeFactory.character();
      
      return function("getRunAttribute", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RunAttribute"));
         cRunAttribute_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cRunAttribute_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getSuperProcedure()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
              Notes:
      ------------------------------------------------------------------------------*/
      character cSuperProcedure = TypeFactory.character();
      
      return function("getSuperProcedure", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SuperProcedure"));
         cSuperProcedure.assign(ghProp.unwrapBufferField().value());
         returnNormal(cSuperProcedure);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getSuperProcedureHandle()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
              Notes:
      ------------------------------------------------------------------------------*/
      character cProcedureHandle = TypeFactory.character();
      
      return function("getSuperProcedureHandle", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SuperProcedureHandle"));
         cProcedureHandle.assign(ghProp.unwrapBufferField().value());
         returnNormal(cProcedureHandle);
      }));
   }

   /** getSuperProcedureHandle */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getSuperProcedureMode()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
              Notes:
      ------------------------------------------------------------------------------*/
      character cProcedureMode = TypeFactory.character();
      
      return function("getSuperProcedureMode", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SuperProcedureMode"));
         cProcedureMode.assign(ghProp.unwrapBufferField().value());
         returnNormal(cProcedureMode);
      }));
   }

   /** getSuperProcedureMode */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getSupportedLinks()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a list of the SmartObject links supported by this object.
         Params:  <none>
        Returns: CHARACTER
      ------------------------------------------------------------------------------*/
      character cLinks = TypeFactory.character();
      
      return function("getSupportedLinks", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SupportedLinks"));
         cLinks.assign(ghProp.unwrapBufferField().value());
         returnNormal(cLinks);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getThinRenderingProcedure()
   {
      /*------------------------------------------------------------------------------
        Purpose: Return the thin rendering procedure
          Notes: 
      ------------------------------------------------------------------------------*/
      character cThinRenderingProcedure = TypeFactory.character();
      
      return function("getThinRenderingProcedure", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ThinRenderingProcedure"));
         cThinRenderingProcedure.assign(ghProp.unwrapBufferField().value());
         returnNormal(cThinRenderingProcedure);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getTranslatableProperties()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a list of translatable properties for the object.
         Params:  <none>
        Returns:  CHARACTER
      ------------------------------------------------------------------------------*/
      character cProps = TypeFactory.character();
      
      return function("getTranslatableProperties", character.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("TranslatableProperties"));
         cProps.assign(ghProp.unwrapBufferField().value());
         ErrorManager.silentErrorDisable();
         returnNormal(cProps);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getUibmode()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the UIB Mode property to indicate whether this object is
                  in Design mode in the AppBuilder.
         Params:  <none>
        Returns:  CHARACTER
          Notes:  This will return blank if the object is not in design mode,
                  that is, not running in an AppBuilder design window. It will
                  return "Design" if in design mode, or "Design-Child" if it is
                  contained in another SmartObject which is in design mode
                  (such as a SmartFrame). It will return ? if the object is not
                  a SmartObject (does not have a valid handle in ADM-DATA).
      ------------------------------------------------------------------------------*/
      character cMode = TypeFactory.character(null);
      
      return function("getUIBMode", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
         cMode.assign(ghProp.unwrapBufferField().value());
         returnNormal(cMode);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getUseRepository()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lRepos = TypeFactory.logical();
      
      return function("getUseRepository", logical.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         /* icf session manager will have this in a super procedure of the session */
         lRepos.assign(ControlFlowOps.invokeDynamicFunctionIn("isICFRunning", thisProcedure()));
         ErrorManager.silentErrorDisable();
         /* Return no if unknown !*/
         returnNormal(isEqual(lRepos, true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getUserProperty(final character _pcPropName_5)
   {
      character pcPropName_5 = TypeFactory.initInput(_pcPropName_5);
      /*------------------------------------------------------------------------------
        Purpose:  Retrieves the value of a dynamically-defined property.
         Params:  pcPropName AS CHARACTER
        Returns:  CHARACTER: property value in character form
          Notes:  Dynamically-defined properties are currently stored in a list 
                  in the ADM-DATA procedure attribute, delimited by CHR(3), 
                  with CHR(4) between property name and value. However, 
                  it should not be necessary for developers to be aware of the s
                  pecific storage mechanism for dynamically-defined properties, 
                  which could be subject to change in the future. 
      ------------------------------------------------------------------------------*/
      character cProps = TypeFactory.character();
      character cPropVal = TypeFactory.character();
      integer iEntry = TypeFactory.integer();
      
      return function("getUserProperty", character.class, new Block((Body) () -> 
      {
         cProps.assign(entry(2, targetProcedure().unwrapADMData().getADMData(), chr(1)));
         
         loopLabel20:
         for (iEntry.assign(1); _isLessThanOrEqual(iEntry, numEntries(cProps, chr(3))); iEntry.increment())
         {
            cPropVal.assign(entry(iEntry, cProps, chr(3)));
            
            if (_isEqual(entry(1, cPropVal, chr(4)), pcPropName_5))
            {
               returnNormal(entry(2, cPropVal, chr(4)));
            }
         }
         
         /* END DO iEntry */
         returnNormal(new character());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical instanceOf(final character _pcObjectType_1)
   {
      character pcObjectType_1 = TypeFactory.initInput(_pcObjectType_1);
      /*------------------------------------------------------------------------------
        Purpose: Resolve if this is an instance Of a particular class/object type 
          Notes: For Dynamics this does include the inheritance hierarchy 
       ------------------------------------------------------------------------------*/
      character cClassName = TypeFactory.character();
      
      return function("instanceOf", logical.class, new Block((Body) () -> 
      {
         if (_and(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUseRepository", targetProcedure())), () -> gshRepositoryManager.isValid()))
         {
            /* {get Prop var [handle]} */ 
            cClassName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getClassName", targetProcedure()));
            /* Using ClassIsA is more robust because IsA() depends on this
                       object being in the object cache. In addition, ClassIsA() will
                       attempt to cache the class if it is not already cached, something
                       that IsA() cannot do.
                     */
            returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode("ClassIsA", gshRepositoryManager, "II", cClassName, pcObjectType_1));
         }
         
         /* Using the Repository */
         /* Current workaround to ensure that this can replace all direct use of 
              * objecttype is to compare with the object type */
         returnNormal(isEqual(pcObjectType_1, ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectType", targetProcedure())) /* {fn <func-name> [handle] */);
      }));
   }

   /** instanceOf */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public character instancePropertyList(final character _pcPropList_3)
   {
      character pcPropList_3 = TypeFactory.initInput(_pcPropList_3);
      /*------------------------------------------------------------------------------
        Purpose:  Returns a list of the values of the names of the object's 
                  InstanceProperties, that is those properties which can be set 
                  to initial values in design mode.
                  These can be set in the AppBuilder to determine the object 
                  instance's behavior at runtime.
          Params: INPUT pcPropList AS CHARACTER -- optional list of properties wanted. 
                  The default (when this parameter is blank) is all the InstanceProps;
                  other valid options are "*", for all properties, or a list of 
                  specific properties wanted. 
         Returns: CHARACTER: delimited list of property name/value pairs with CHR(3)
                  between pairs and CHR(4) between name and value.
      ------------------------------------------------------------------------------*/
      character cInstanceProperties = TypeFactory.character();
      integer iNumProps = TypeFactory.integer();
      integer iEntry = TypeFactory.integer();
      integer iProc = TypeFactory.integer();
      character cProcs = TypeFactory.character();
      handle hProc = TypeFactory.handle();
      character cPropValues = TypeFactory.character("");
      character cProperty = TypeFactory.character();
      character cSignature = TypeFactory.character();
      character cEntries = TypeFactory.character();
      logical lTranslate = TypeFactory.logical(false);
      character cTranslatable = TypeFactory.character();
      character cValue = TypeFactory.character();
      
      return function("instancePropertyList", character.class, new Block((Body) () -> 
      {
         if (_isEqual(pcPropList_3, "ADM-TRANSLATABLE-FORMAT"))
         {
            lTranslate.assign(true);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("TranslatableProperties"));
            cTranslatable.assign(ghProp.unwrapBufferField().value());
            pcPropList_3.assign("");
         }
         
         if (_or(isEqual(pcPropList_3, ""), () -> isUnknown(pcPropList_3)))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceProperties"));
            cInstanceProperties.assign(ghProp.unwrapBufferField().value());
         }
         else
         {
            if (_isEqual(pcPropList_3, "*"))
            {
               /* For now at least we define properties as being identified by a
                      function that begins "get" without a following hyphen and which takes
                      no arguments. We build a list of all of those properties, looking
                      in the object itself and in all its super procedures. */
               cProcs.assign(concat(valueOf(targetProcedure()), ",", targetProcedure().unwrapCommonProcedure().superProcedures()));
               
               loopLabel21:
               for (iProc.assign(1); _isLessThanOrEqual(iProc, numEntries(cProcs)); iProc.increment())
               {
                  hProc.assign(handle.fromString(entry(iProc, cProcs)));
                  
                  if ((hProc.isValid()).booleanValue())
                  {
                     cEntries.assign(hProc.unwrapProcedure().internalEntries());
                     iNumProps.assign(numEntries(cEntries));
                     
                     loopLabel22:
                     for (iEntry.assign(1); _isLessThanOrEqual(iEntry, iNumProps); iEntry.increment())
                     {
                        cProperty.assign(entry(iEntry, cEntries));
                        
                        /* If there's a get property and it's not already in our list... */
                        if (_and(and(begins(cProperty, "get"), () -> isNotEqual(substring(cProperty, 4, 1), "-")), () -> isEqual(lookup(substring(cProperty, 4), cInstanceProperties), 0)))
                        {
                           cSignature.assign(hProc.unwrapProcedure().getSignature(cProperty));
                           
                           if (_and(and(isEqual(entry(1, cSignature), "FUNCTION"), () -> isEqual(numEntries(cSignature) /* It's a function... */, 3)), () -> isEqual(entry(3, cSignature) /* Null 3rd entry means no args */, "")))
                           {
                              cInstanceProperties.assign(concat(cInstanceProperties, (_isNotEqual(cInstanceProperties, "") ? new character(",") : new character("")), substring(cProperty, 4)));
                           }
                        }
                     }
                  }
               }
               
               /* END DO iProc */
               /* Now add any ad hoc properties which have been defined. */
               cEntries.assign(entry(2, targetProcedure().unwrapADMData().getADMData(), chr(1)));
               
               loopLabel23:
               for (iEntry.assign(1); _isLessThanOrEqual(iEntry, numEntries(cEntries, chr(3))); iEntry.increment())
               {
                  cInstanceProperties.assign(concat(cInstanceProperties, (_isNotEqual(cInstanceProperties, "") ? new character(",") : new character("")), entry(1, entry(iEntry, cEntries, chr(3)), chr(4))));
               }
            }
            else
            {
               cInstanceProperties.assign(pcPropList_3);
            }
         }
         /* {get Prop var [handle]} */ 
         
         /* Give them the ones they asked for. */
         if ((lTranslate).booleanValue())
         {
            cPropValues.assign("'");
         }
         
         /* In quotes if xlatable */
         iNumProps.assign(numEntries(cInstanceProperties));
         
         if (_and(lTranslate, () -> isEqual(iNumProps, 0)))
         {
             /* If no properties at all, */cPropValues.assign("''");
         }
         
         ToClause toClause8 = new ToClause(iEntry, 1, iNumProps);
         
         doTo("loopLabel24", toClause8, new Block((Body) () -> 
         {
            cProperty.assign(entry(iEntry, cInstanceProperties));
            
            /* We better avoid calling asHandle if unbound as this actually will
                   do a bind ..*/
            if (_and(isEqual(cProperty, "AsHandle"), () -> not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsBound", targetProcedure())))))
            {
               cValue.assign("");
            }
            else
            {
               ErrorManager.silentErrorEnable();
               cValue.assign(valueOf(ControlFlowOps.invokeDynamicFunctionIn(concat("get", cProperty), targetProcedure())));
               ErrorManager.silentErrorDisable();
            }
            
            if (_isUnknown(cValue))
            {
                /* This is an ad hoc user property. */cValue /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "getUserProperty", targetProcedure(), "I", cProperty));
            }
            
            if (_isUnknown(cValue))
            {
               cValue.assign("");
            }
            
            if ((lTranslate).booleanValue())
            {
               cPropValues.assign(concat(cPropValues, (_isNotEqual(cPropValues, "'") ? chr(3) : new character("")), cProperty, chr(4)));
               
               if (_isNotEqual(lookup(cProperty, cTranslatable), 0))
               {
                  cPropValues.assign(concat(cPropValues, "':U + '", cValue, "'"));
                  
                  if (_isNotEqual(iEntry, iNumProps))
                  {
                     cPropValues.assign(concat(cPropValues, " + '"));
                  }
               }
               else
               {
                  cPropValues.assign(concat(cPropValues, cValue));
               }
            }
 /* Return the special form with :Us */            else
            {
               cPropValues.assign(concat(cPropValues, (_isNotEqual(cPropValues, "") ? chr(3) : new character("")), cProperty, chr(4), cValue));
            }
         }));
         
         /* If this is the last property and the user wants the translatable format
              and this last property was not translatable, then put ':U at the end. */
         if (_and(lTranslate, () -> isEqual(lookup(cProperty, cTranslatable), 0)))
         {
            cPropValues.assign(concat(cPropValues, "':U"));
         }
         
         returnNormal(cPropValues);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical isDialogBoxParent(final handle _hWidget_1)
   {
      handle hWidget_1 = TypeFactory.initInput(_hWidget_1);
      
      return function("isDialogBoxParent", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose: TRUE if any parent widget of 'hWidget' is a DIALOG-BOX
             Notes:  
         ------------------------------------------------------------------------------*/
         if ((hWidget_1.isValid()).booleanValue())
         {
            if (_isEqual(hWidget_1.unwrapType().getResourceType(), "DIALOG-BOX"))
            {
               returnNormal(true);
            }
            else
            {
               if ((HandleOps.canQuery(hWidget_1, "PARENT")).booleanValue())
               {
                  returnNormal(isDialogBoxParent(hWidget_1.unwrapWidget().getParentHandle()));
               }
               else
               {
                  returnNormal(false);
               }
            }
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical isFunctionInCallStack()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns TRUE if there is a Function in the call stack. 
          Notes:  
      ------------------------------------------------------------------------------*/
      character cSuperList = TypeFactory.character();
      character cSuperNameList = TypeFactory.character();
      integer iVar = TypeFactory.integer((long) 1);
      character cName_1 = TypeFactory.character();
      character cIpName = TypeFactory.character();
      handle hProcedure = TypeFactory.handle();
      integer iIdx = TypeFactory.integer();
      
      return function("isFunctionInCallStack", logical.class, new Block((Body) () -> 
      {
         /* create a list of session procedures and their names */
         hProcedure.assign(ProcedureManager.firstProcedure());
         
         LogicalOp whileClause1 = () -> hProcedure.isValid();
         
         repeatWhile("loopLabel25", whileClause1, new Block((Body) () -> 
         {
            if (_isEqual(hProcedure.unwrapType().getResourceType(), "PROCEDURE"))
            {
               cSuperList.assign(concat(cSuperList, (_isGreaterThan(cSuperList, "") ? new character(",") : new character("")), valueOf(hProcedure)));
               cSuperNameList.assign(concat(cSuperNameList, (_isGreaterThan(cSuperNameList, "") ? new character(",") : new character("")), hProcedure.unwrapFile().getFileName()));
            }
            
            hProcedure.assign(hProcedure.unwrap().getNextSibling());
         }));
         
         repeat("loopLabel26", new Block((Body) () -> 
         {
            iVar.assign(plus(iVar, 1));
             /* do not include THIS function */cName_1.assign(EnvironmentOps.getSourceName(iVar));
            hProcedure.setUnknown();
            
            if (_or(isUnknown(cName_1), () -> isEqual(cName_1, "")) /* 20030306-008, iz9204 */ )
            {
 /* end of stack */
               leave("loopLabel26");
            }
            
            if (_isEqual(numEntries(cName_1, " "), 1))
            {
               next("loopLabel26");
            }
            
            cIpName.assign(entry(1, cName_1, " "));
            cName_1.assign(entry(2, cName_1, " "));
            iIdx.assign(lookup(cName_1, cSuperNameList));
            
            if (_isGreaterThan(iIdx, 0))
            {
               hProcedure.assign(handle.fromString(entry(iIdx, cSuperList)));
            }
            
            if ((hProcedure.isValid()).booleanValue())
            {
               if (_isEqual(entry(1, hProcedure.unwrapProcedure().getSignature(cIpName)), "FUNCTION"))
               {
                  returnNormal(true);
               }
            }
         }));
         
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical isLinkInactive(final character _pcLinkType_2, final handle _phObject_5)
   {
      character pcLinkType_2 = TypeFactory.initInput(_pcLinkType_2);
      handle phObject_5 = TypeFactory.initInput(_phObject_5);
      /*------------------------------------------------------------------------------
         Purpose: Check if a particular link is inactivate  
      Parameters:
          pcLinkType - LinkType  f.ex 'DataSource'.        
          phObject   - Object in other end of link     
                     - ? - if object does not matter  
                           may be used with links that only supports one object 
                           or cases where one only need to know if any link is 
                           inactive (or all links are active).    
           Notes: Whenever possible pass in the object as single links may change 
                  to multiple links.    
               -  The inactivelinks property is maintained by the modifyInactiveLinks
                  function. 
      ------------------------------------------------------------------------------*/
      integer iPos = TypeFactory.integer();
      character cLinks = TypeFactory.character();
      character cHandles = TypeFactory.character();
      
      return function("isLinkInactive", logical.class, new Block((Body) () -> 
      {
         /* Ignore ANY dashes in linkname  */
         pcLinkType_2.assign(replaceAll(pcLinkType_2, "-", ""));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InactiveLinks"));
         cLinks.assign(ghProp.unwrapBufferField().value());
         iPos.assign(lookup(pcLinkType_2, cLinks));
         
         if (_and(isGreaterThan(iPos, 0), () -> notUnknown(phObject_5)))
         {
            cHandles.assign(entry(plus(iPos, 1), cLinks));
            returnNormal(isGreaterThan(lookup(valueOf(phObject_5), cHandles, ";"), 0));
         }
         else
         {
            returnNormal(isGreaterThan(iPos, 0));
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical isObjQuoted(final character _pcQueryString_2, final integer _piPosition_1)
   {
      character pcQueryString_2 = TypeFactory.initInput(_pcQueryString_2);
      integer piPosition_1 = TypeFactory.initInput(_piPosition_1);
      /*------------------------------------------------------------------------------
        Purpose: Looks at the object number in the query string and determines whether
                 or not it is wrapped in quotes
      
          Notes: This is needed when running the application in European format. If an
                 object number is in quotes and we are in European mode / format, the
                 object number must remain with a comma in the quotes, i.e. '12345678,02'
                 to convert properly to a decimal. If it is not quoted however, then
                 the comma must be replaced by a '.', i.e. ...obj = 12345678,02, FIRST ...
                 must be replaced with ...obj = 12345678.02, FIRST ... to ensure that
                 the query resolves properly. The replace will be done by 'fixQueryString',
                 which calls this function to establish whether or not to replace the object
                 number's decimal seperator based on whether it is quoted or not
      ------------------------------------------------------------------------------*/
      character cAllowedCharacters = TypeFactory.character();
      character cCharacter = TypeFactory.character();
      logical lQuotedInFront = TypeFactory.logical();
      logical lQuotedBehind = TypeFactory.logical();
      logical lObjQuoted = TypeFactory.logical();
      logical lFinished = TypeFactory.logical();
      integer iCounter = TypeFactory.integer();
      
      return function("isObjQuoted", logical.class, new Block((Body) () -> 
      {
         cAllowedCharacters.assign(concat("1234567890 '\"", chr(10), chr(13)));
         lQuotedInFront.assign(false);
         lQuotedBehind.assign(false);
         lObjQuoted.assign(false);
         
         /* Read forward through the string */
         if (_isGreaterThanOrEqual(length(pcQueryString_2), piPosition_1))
         {
            lFinished.assign(false);
            iCounter.assign(piPosition_1);
            
            loopLabel27:
            while (_isEqual(lFinished, false))
            {
               iCounter.assign(plus(iCounter, 1));
               cCharacter.assign(substring(pcQueryString_2, iCounter, 1));
               
               if (_and(isNotEqual(indexOf(cAllowedCharacters, cCharacter), 0), () -> or(isEqual(cCharacter, "'"), () -> isEqual(cCharacter, "\""))))
               {
                  lQuotedBehind.assign(true);
                  lFinished.assign(true);
               }
               
               if (_isGreaterThanOrEqual(iCounter, length(pcQueryString_2)))
               {
                  lFinished.assign(true);
               }
            }
         }
         
         /* Read backward through the string */
         if (_isGreaterThan(piPosition_1, 1))
         {
            lFinished.assign(false);
            iCounter.assign(piPosition_1);
            
            loopLabel28:
            while (_isEqual(lFinished, false))
            {
               iCounter.assign(minus(iCounter, 1));
               cCharacter.assign(substring(pcQueryString_2, iCounter, 1));
               
               if (_and(isNotEqual(indexOf(cAllowedCharacters, cCharacter), 0), () -> or(isEqual(cCharacter, "'"), () -> isEqual(cCharacter, "\""))))
               {
                  lQuotedInFront.assign(true);
                  lFinished.assign(true);
               }
               
               if (_isLessThanOrEqual(iCounter, 1))
               {
                  lFinished.assign(true);
               }
            }
         }
         
         if (_and(lQuotedInFront, lQuotedBehind))
         {
            lObjQuoted.assign(true);
         }
         
         returnNormal(lObjQuoted);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character linkHandles(final character _pcLink_4)
   {
      character pcLink_4 = TypeFactory.initInput(_pcLink_4);
      /*------------------------------------------------------------------------------
        Purpose:  Takes a link name and returns a list of handles of objects at
                  the other end of that link, relative to the TARGET-PROCEDURE.
         Params:  pcLink AS CHARACTER -- Link name (including "-SOURCE" or "-TARGET")
        Returns:  CHARACTER: comma-separated list of handles 
          Notes:  ADM2 version of get-link-handle IN V8. NOTE: If the link type
                  does not exist in the object "" will be returned, not ?.
      ------------------------------------------------------------------------------*/
      character cObjects = TypeFactory.character();
      character cLinkList = TypeFactory.character();
      integer iEntry = TypeFactory.integer();
      character cLinkEntry = TypeFactory.character();
      
      return function("linkHandles", character.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         cObjects.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", trim(concat(substring(pcLink_4, 1, minus(lastIndexOf(pcLink_4, "-"), 1)), substring(pcLink_4, plus(lastIndexOf(pcLink_4, "-"), 1))))), targetProcedure()));
         ErrorManager.silentErrorDisable();
         
         if (_isUnknown(cObjects))
         {
            /* Unknown means this is not a standard SupportedLink; so get the
                   handle from ADM-DATA (see modifyUserLinks for format). */
            cObjects.assign("");
            /* Init to blank in case it's not found here. */
            cLinkList.assign(entry(3, targetProcedure().unwrapADMData().getADMData(), chr(1)));
            
            loopLabel29:
            for (iEntry.assign(1); _isLessThanOrEqual(iEntry, numEntries(cLinkList, chr(3))); iEntry.increment())
            {
               cLinkEntry.assign(entry(iEntry, cLinkList, chr(3)));
               
               if (_isEqual(entry(1, cLinkEntry, chr(4)), pcLink_4))
               {
                  cObjects.assign(entry(2, cLinkEntry, chr(4)));
                  break loopLabel29;
               }
            }
         }
         /* END DO IF ? */
         returnNormal(cObjects);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character linkProperty(final character _pcLink_4, final character _pcPropName_5)
   {
      character pcLink_4 = TypeFactory.initInput(_pcLink_4);
      character pcPropName_5 = TypeFactory.initInput(_pcPropName_5);
      /*------------------------------------------------------------------------------
        Purpose:  Returns the value of the requested property in the object at the
                  other end of the specified link, relative to TARGET-PROCEDURE.
         Params:  INPUT pcLink     AS CHARACTER -- Link name,
                  INPUT pcPropName AS CHARACTER -- Property name.
        Returns:  CHARACTER: property value in character form
          Notes:  ADM2 Version of request-attribute in V8. The value is returned in
                  character format. If there is not exactly one object at the other
                  end of the link, or that object is no longer there,
                  the unknown value is returned.
      ------------------------------------------------------------------------------*/
      character cObject = TypeFactory.character();
      character cValue = TypeFactory.character();
      
      return function("linkProperty", character.class, new Block((Body) () -> 
      {
         cObject.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", trim(concat(substring(pcLink_4, 1, minus(lastIndexOf(pcLink_4, "-"), 1)), substring(pcLink_4, plus(lastIndexOf(pcLink_4, "-"), 1))))), targetProcedure()));
         
         if (_and(notUnknown(cObject), () -> isEqual(numEntries(cObject), 1)))
         {
            ErrorManager.silentErrorEnable();
            cValue.assign(valueOf(ControlFlowOps.invokeDynamicFunctionIn(concat("get", pcPropName_5), handle.fromString(cObject))));
            ErrorManager.silentErrorDisable();
            returnNormal(cValue);
         }
         else
         {
            returnNormal(new character());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character mappedEntry(final character _pcEntry_1, final character _pcList_1, final logical _plFirst_1, final character _pcDelimiter_1)
   {
      character pcEntry_1 = TypeFactory.initInput(_pcEntry_1);
      character pcList_1 = TypeFactory.initInput(_pcList_1);
      logical plFirst_1 = TypeFactory.initInput(_plFirst_1);
      character pcDelimiter_1 = TypeFactory.initInput(_pcDelimiter_1);
      /*------------------------------------------------------------------------------
        Purpose: Return the 'other' entry in a separated list of paired entries.
                 This is required to ensure that the lookup does not find a matching
                 entry in the wrong part of the pair.  
                    
      Parameters:  INPUT pcEntry    - entry to lookup.  
                   INPUT pcList     - comma separated list with paired entries. 
                   INPUT plFirst    - TRUE  - lookup first and RETURN second.
                                      FALSE - lookup second and RETURN first.
                   INPUT pcDelmiter - Delimiter of pcList               
          Notes: Used to find mapped RowObject or database column in assignList.  
                 In other cases, such as the ObjectMapping property of SBOs, an
                 entry may occur more than once in the list, in which case a list
                 of matching values is returned, using the same delimiter as the list.
              -  Returns ? if no entry is found          
      ------------------------------------------------------------------------------*/
      integer iLookUp = TypeFactory.integer();
      character cList = TypeFactory.character();
      character cValues = TypeFactory.character();
      
      return function("mappedEntry", character.class, new Block((Body) () -> 
      {
         cValues.setUnknown();
          /* Set to ? to identify not found (Blank may be found) */cList.assign(pcList_1);
         
         loopLabel30:
         while (true)
         {
            iLookUp.assign(lookup(pcEntry_1, cList, pcDelimiter_1));
            
            /* The entry is no longer in the list or not at all, so return any values 
                   we have found in earlier passes; if none found unknown will be returned.*/
            if (_or(isEqual(iLookUp, 0), () -> isUnknown(iLookUp)))
            {
               returnNormal(cValues);
            }
            
            /* If this is the correct half of the pair add the other part from the
                   original list to the list of values to return. */
            if (_isEqual(modulo(iLookUp, 2), ((plFirst_1).booleanValue() ? new integer(1) : new integer(0))))
            {
               cValues.assign(concat((_notUnknown(cValues) ? concat(cValues, pcDelimiter_1) : new character("")), entry((plFirst_1).booleanValue() ? plus(iLookUp, 1) : minus(iLookUp, 1), pcList_1, pcDelimiter_1)));
            }
            
            /* We remove this entry (right or wrong) from the work list to be able 
                   to lookup the next. (Setting it to blank if we are looking for blank
                   will cause an endless loop so we set it to '?' in that case )*/
            cList.replaceEntry(iLookUp, pcDelimiter_1, _isNotEqual(pcEntry_1, "") ? new character("") : new character("?"));
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character mergeLists(final character _pcList1_1, final character _pcList2_1, final character _pcDlm1_1, final character _pcDlm2_1, final character _pcNewDlm_1)
   {
      character pcList1_1 = TypeFactory.initInput(_pcList1_1);
      character pcList2_1 = TypeFactory.initInput(_pcList2_1);
      character pcDlm1_1 = TypeFactory.initInput(_pcDlm1_1);
      character pcDlm2_1 = TypeFactory.initInput(_pcDlm2_1);
      character pcNewDlm_1 = TypeFactory.initInput(_pcNewDlm_1);
      /*------------------------------------------------------------------------------
        Purpose: Return a paired list of two lists 
          Notes: The main reason that this exists is performance, it is approx 
                 50% faster to merge without a loop.  
      ------------------------------------------------------------------------------*/
      integer iNumEntries = TypeFactory.integer();
      character cMergeList = TypeFactory.character();
      integer iNum = TypeFactory.integer();
      
      return function("mergeLists", character.class, new Block((Body) () -> 
      {
         pcDlm1_1.assign(_isEqual(pcDlm1_1, "") ? new character(" ") : _notUnknown(pcDlm1_1) ? pcDlm1_1 : new character(","));
         pcDlm2_1.assign(_isEqual(pcDlm2_1, "") ? new character(" ") : _notUnknown(pcDlm2_1) ? pcDlm2_1 : new character(","));
         pcNewDlm_1.assign(_isEqual(pcNewDlm_1, "") ? new character(" ") : _notUnknown(pcNewDlm_1) ? pcNewDlm_1 : new character(","));
         iNumEntries.assign(numEntries(pcList1_1, pcDlm1_1));
         cMergeList.assign(replaceAll(pcList1_1, pcDlm1_1, pcNewDlm_1));
         
         if (_isGreaterThanOrEqual(iNumEntries, 1))
         {
            cMergeList.replaceEntry(minus(multiply(1, 2), 1), pcNewDlm_1, concat(entry(1, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(1, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 2))
         {
            cMergeList.replaceEntry(minus(multiply(2, 2), 1), pcNewDlm_1, concat(entry(2, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(2, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 3))
         {
            cMergeList.replaceEntry(minus(multiply(3, 2), 1), pcNewDlm_1, concat(entry(3, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(3, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 4))
         {
            cMergeList.replaceEntry(minus(multiply(4, 2), 1), pcNewDlm_1, concat(entry(4, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(4, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 5))
         {
            cMergeList.replaceEntry(minus(multiply(5, 2), 1), pcNewDlm_1, concat(entry(5, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(5, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 6))
         {
            cMergeList.replaceEntry(minus(multiply(6, 2), 1), pcNewDlm_1, concat(entry(6, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(6, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 7))
         {
            cMergeList.replaceEntry(minus(multiply(7, 2), 1), pcNewDlm_1, concat(entry(7, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(7, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 8))
         {
            cMergeList.replaceEntry(minus(multiply(8, 2), 1), pcNewDlm_1, concat(entry(8, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(8, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 9))
         {
            cMergeList.replaceEntry(minus(multiply(9, 2), 1), pcNewDlm_1, concat(entry(9, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(9, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 10))
         {
            cMergeList.replaceEntry(minus(multiply(10, 2), 1), pcNewDlm_1, concat(entry(10, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(10, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 11))
         {
            cMergeList.replaceEntry(minus(multiply(11, 2), 1), pcNewDlm_1, concat(entry(11, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(11, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 12))
         {
            cMergeList.replaceEntry(minus(multiply(12, 2), 1), pcNewDlm_1, concat(entry(12, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(12, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 13))
         {
            cMergeList.replaceEntry(minus(multiply(13, 2), 1), pcNewDlm_1, concat(entry(13, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(13, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 14))
         {
            cMergeList.replaceEntry(minus(multiply(14, 2), 1), pcNewDlm_1, concat(entry(14, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(14, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 15))
         {
            cMergeList.replaceEntry(minus(multiply(15, 2), 1), pcNewDlm_1, concat(entry(15, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(15, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 16))
         {
            cMergeList.replaceEntry(minus(multiply(16, 2), 1), pcNewDlm_1, concat(entry(16, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(16, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 17))
         {
            cMergeList.replaceEntry(minus(multiply(17, 2), 1), pcNewDlm_1, concat(entry(17, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(17, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 18))
         {
            cMergeList.replaceEntry(minus(multiply(18, 2), 1), pcNewDlm_1, concat(entry(18, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(18, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 19))
         {
            cMergeList.replaceEntry(minus(multiply(19, 2), 1), pcNewDlm_1, concat(entry(19, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(19, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 20))
         {
            cMergeList.replaceEntry(minus(multiply(20, 2), 1), pcNewDlm_1, concat(entry(20, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(20, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 21))
         {
            cMergeList.replaceEntry(minus(multiply(21, 2), 1), pcNewDlm_1, concat(entry(21, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(21, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 22))
         {
            cMergeList.replaceEntry(minus(multiply(22, 2), 1), pcNewDlm_1, concat(entry(22, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(22, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 23))
         {
            cMergeList.replaceEntry(minus(multiply(23, 2), 1), pcNewDlm_1, concat(entry(23, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(23, pcList2_1, pcDlm2_1)));
         }
         
         if (_isGreaterThanOrEqual(iNumEntries, 24))
         {
            cMergeList.replaceEntry(minus(multiply(24, 2), 1), pcNewDlm_1, concat(entry(24, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(24, pcList2_1, pcDlm2_1)));
         }
         
         loopLabel31:
         for (iNum.assign(25); _isLessThanOrEqual(iNum, iNumEntries); iNum.increment())
         {
            cMergeList.replaceEntry(minus(multiply(iNum, 2), 1), pcNewDlm_1, concat(entry(iNum, pcList1_1, pcDlm1_1), pcNewDlm_1, entry(iNum, pcList2_1, pcDlm2_1)));
         }
         
         returnNormal(cMergeList);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character messageNumber(final integer _piMessage_1)
   {
      integer piMessage_1 = TypeFactory.initInput(_piMessage_1);
      /*------------------------------------------------------------------------------
        Purpose:  Returns a message text given a message number. Allows these
                  these messages to be translated and kept track of in one place
                  (src/adm2/admmsgs.i)
         Params:  INPUT piMessage AS INTEGER
        Returns:  CHARACTER: message text
      ------------------------------------------------------------------------------*/
      /*********************************************************************
      * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
      * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
      * below.  All Rights Reserved.                                       *
      *                                                                    *
      * The Initial Developer of the Original Code is PSC.  The Original   *
      * Code is Progress IDE code released to open source December 1, 2000.*
      *                                                                    *
      * The contents of this file are subject to the Possenet Public       *
      * License Version 1.0 (the "License"); you may not use this file     *
      * except in compliance with the License.  A copy of the License is   *
      * available as of the date of this notice at                         *
      * http://www.possenet.org/license.html                               *
      *                                                                    *
      * Software distributed under the License is distributed on an "AS IS"*
      * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
      * should refer to the License for the specific language governing    *
      * rights and limitations under the License.                          *
      *                                                                    *
      * Contributors:                                                      *
      *                                                                    *
      *********************************************************************/
      /* admmsgs.i -- include file with translatable ADM messages (and others
         which need to be modifiable without changing ADM source procedures). */
      character[] cAdmmessages = TypeFactory.characterExtent(91, "You must select a single row for deletion.", "Current values must be saved or cancelled before Add or Copy.", "", "Current values must be saved or cancelled before Commit.", "Query Prepare in initProps failed.", "You must complete or cancel the update before leaving the current row.", "Current record has been changed. Do you wish to save those changes?", "Field(s) &1 have been changed by another user. Your change has been rejected.", "Unable to locate the r-code for &1. Executing its source file.", "Field:  ", "Table:  ", "You must complete the current update operation.", "You must complete the current add operation.", "You must complete the current copy operation.", "Update cancelled.", "", "", "This database record does not exist or is locked by another user.", "", "", "exit", "continue", "Attempt to delete record failed.", "", "The JMS broker is unavailable.", "The message could not be sent because a valid JMS session is not available.", "The XML message could not be routed. It has no 'xmlns' attribute or DTD reference.", "The XML message could not be routed. '&1' has no matching internal reference.", "&1 was not found with &2.", "", "commit", "", "The business logic procedure &1 was not found.", "", "", "Action error: ", "undo", "", "", "&1 could not find class action '&2'", "", "", "", "", "Query Prepare in Browser failed.", "", "", "", "The copy of Crystal reports dataobject &1 details failed.", "", "", "No data to print", "Column name &1 not found in the SmartDataObject.", "Column &1 may not be updated.", "", "Excel not installed or running version prior to Office 97", "No data to export to &1", "Function &1 called with wrong mode &2", "", "Function &1 not defined.", "Property &1 not defined in &2", "No UpdateTarget present for Add operation.", "No UpdateTarget present for Copy operation.", "No UpdateTarget present for Delete operation.", "No UpdateTarget present for Save operation.", "", "Message could not be sent for the following reason:", "TransferRows does not support mode &1 when appending.", "&1 should only be called on the client half of an &2", "", "Unknown Object Name '&1' passed to &1", "Property &1 not defined.", "No Record Available. Table IO operations not supported on One-to-Zero relations.", "", "", "", "", "&1: List of items is too large.", "SmartObject &1 does not support multiple &2 Sources.", "SmartObject &1 does not support multiple &2 Targets.", "Property Dialog not defined or did not execute successfully.", "Add/Remove flag not recognized in modify-list-attribute call.", "The specified node key &1 already exists. You must specify a unique node.", "The specified parent node key &1 does not exist.", "You cannot search for a blank key value.", "Unknown Data Source Specified (&1)", "", "SmartObject &1 with Version &2 cannot be run by the ADM2.2 support code." /* 88 */);
      
      return function("messageNumber", character.class, new Block((Body) () -> 
      {
         assignSingle(cAdmmessages, 3, concat("Current values have not been saved.", chr(10), chr(10), "Do you wish to save current values before you &1?"));
         assignSingle(cAdmmessages, 16, concat("It is necessary to commit (or undo) current changes", chr(10), "before trying to reposition to a record that is not", chr(10), "in the current batch of records."));
         assignSingle(cAdmmessages, 17, concat("It is necessary to commit (or undo) current changes", chr(10), "before fetching another batch of records."));
         assignSingle(cAdmmessages, 19, concat("Field(s) &1 is not available in the data object.", chr(10), "The initialization of &2 could not be completed.", chr(10), "You should exit or cancel."));
         assignSingle(cAdmmessages, 20, concat("Current changes have not been committed.", chr(10), chr(10), "Do you wish to commit changes before you &1?"));
         assignSingle(cAdmmessages, 24, concat("It is necessary to commit (or undo) current changes", chr(10), "before refreshing the current row."));
         assignSingle(cAdmmessages, 30, "Unknown or ambiguous buffer reference '&1'. Could not add expression to query.&2");
         assignSingle(cAdmmessages, 32, concat("Current values have not been saved.", chr(10), chr(10), "Confirm undo of both unsaved and uncommitted changes?"));
         assignSingle(cAdmmessages, 34, concat("Do you wish to delete the current record?", chr(10)));
         assignSingle(cAdmmessages, 35, "(extracted records = &1) (max. records = &2)");
         assignSingle(cAdmmessages, 38, concat("Cannot create class action '&1'.", chr(10), "It already exists as an instance action."));
         assignSingle(cAdmmessages, 39, concat("Cannot create instance action '&1'.", chr(10), "It already exists as a class action."));
         assignSingle(cAdmmessages, 41, concat("&1 called unbindserver with a blank input parameter.", chr(10), "This is currently not supported."));
         assignSingle(cAdmmessages, 42, concat("Not enough information to find a row in object: &1", chr(10), "Ensure that there are nodes mapped to the object's KeyFields"));
         assignSingle(cAdmmessages, 43, "Could not find data source object");
         assignSingle(cAdmmessages, 44, concat("Function 'storeNodeValue()' did not find data source information.for object '&1' when trying to store value for column '&2'", chr(10), "This should have been created in 'startDataRow()' if the object is", "properly mapped to one of the column's parent nodes in the XML Mapping."));
         assignSingle(cAdmmessages, 46, "SmartDataObject '&1' is part of SmartBusinessObject '&2' that has no AppServer partition defined and is running locally without proper database connection(s).");
         assignSingle(cAdmmessages, 47, "SmartDataObject has no AppServer partition defined and is running locally without proper database connection(s).");
         assignSingle(cAdmmessages, 48, "Crystal reports dataobject &1 is not set up. Please contact your system administrator.");
         assignSingle(cAdmmessages, 50, "Crystal reports landscape template &1 is not set up. Please contact your system administrator.");
         assignSingle(cAdmmessages, 51, "Crystal reports portrait template &1 is not set up. Please contact your system administrator.");
         assignSingle(cAdmmessages, 55, "<not in use>");
         assignSingle(cAdmmessages, 59, "Unable to Re-Open Query as a Folder Window is Active. Please close the Folder Window first.");
         assignSingle(cAdmmessages, 66, "No UpdateTarget present for Add/Copy operation.");
         assignSingle(cAdmmessages, 70, "SmartBusinessObject has no AppServer partition defined and is running locally without proper database connection(s).");
         assignSingle(cAdmmessages, 74, concat("Unable to update column '&1'.", chr(10), "Object '&2' is either not available or not updatable"));
         assignSingle(cAdmmessages, 75, concat("Unable to find an appropriate data-source for object '&1'", chr(10), "All columns must exist in the SmartBusinessObject's contained objects."));
         assignSingle(cAdmmessages, 76, concat("Unable to find an appropriate data-source for object '&1'", chr(10), "All columns must exist in &2 the SmartBusinessObject's contained objects."));
         assignSingle(cAdmmessages, 77, concat("The SmartBusinessObject &1 cannot update &2 together. Either make sure that only fields from the SmartDataObject Update Target are enabled or if these objects have a one-to-one relationship and should be updated together, specify that the Data Target is to be updated from the Data Source in the SmartDataObject's Instance Properties.", chr(10), chr(10), " The enabled fields and the update link will be disabled for now."));
         assignSingle(cAdmmessages, 87, concat("Could not launch extract program  '&1' on AppServer.", chr(10), "Error returned from launch program: &2."));
         assignSingle(cAdmmessages, 90, concat("About to transfer selected data into Excel.", chr(10), chr(10), "This may take a long time if the data set is large and has not been filtered.", chr(10), "You may specify the maximum records to return for large data sets.", chr(10)));
         assignSingle(cAdmmessages, 91, concat("About to transfer selected data into a Report Preview Window", chr(10), chr(10), "This may take a long time if the data set is large and has not been filtered.", chr(10), "You may specify the maximum records to return for large data sets.", chr(10), chr(10), "NOTE : The report will only display the fields that do not exceed the maximum width of the report layout.", chr(10)));
         /* Defines the array cADMMessages */
         returnNormal(subscript(cAdmmessages, piMessage_1));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical modifyInactiveLinks(final character _pcMode_2, final character _pcLinkType_2, final handle _phObject_5)
   {
      character pcMode_2 = TypeFactory.initInput(_pcMode_2);
      character pcLinkType_2 = TypeFactory.initInput(_pcLinkType_2);
      handle phObject_5 = TypeFactory.initInput(_phObject_5);
      /*------------------------------------------------------------------------------
        Purpose: Modify the internal InactiveLinks property that is used to keep track
                 of inactivelinks for the object.    
       Parameters:
           pcMode  - 'ADD'    - add to list  
                   - 'REMOVE' - Remove from list        
           pcLinkType - LinkType  f.ex 'DataSource'.        
           phObject   - Object in other end of link     
          Notes: The property is stored as a comma-separated paired list where the
                 second entry of each pair is a semi-colon separated list of object
                 handles 
              -  The isLinklnactive should be used to check if an actual link is 
                 inactive                 
      ------------------------------------------------------------------------------*/
      character cLinks = TypeFactory.character();
      integer iPos = TypeFactory.integer();
      character cHandles = TypeFactory.character();
      integer iHandle = TypeFactory.integer();
      character cD1 = TypeFactory.character(",");
      character cD2 = TypeFactory.character(";");
      
      return function("modifyInactiveLinks", logical.class, new Block((Body) () -> 
      {
         /* Ignore ANY dashes in linkname  */
         pcLinkType_2.assign(replaceAll(pcLinkType_2, "-", ""));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InactiveLinks"));
         cLinks.assign(ghProp.unwrapBufferField().value());
         iPos.assign(lookup(pcLinkType_2, cLinks));
         
         if (_isEqual(pcMode_2, "ADD"))
         {
            if (_isEqual(iPos, 0))
            {
               cLinks.assign(concat(cLinks, (_isEqual(cLinks, "") ? new character("") : cD1), pcLinkType_2, cD1, valueOf(phObject_5)));
            }
            else
            {
               cHandles.assign(entry(plus(iPos, 1), cLinks));
               cHandles.assign(concat(cHandles, (_isEqual(cHandles, "") ? new character("") : cD2), valueOf(phObject_5)));
               cLinks.replaceEntry(plus(iPos, 1), cHandles);
            }
         }
         else
         {
            if (_and(isEqual(pcMode_2, "REMOVE"), () -> isGreaterThan(iPos, 0)))
            {
               cHandles.assign(entry(plus(iPos, 1), cLinks));
               
               if (_or(isEqual(numEntries(cHandles, cD2), 1), () -> isUnknown(phObject_5)))
               {
                  cLinks.replaceEntry(iPos, "");
                  cLinks.replaceEntry(plus(iPos, 1), "");
                  cLinks.assign(trim(replaceAll(concat(cD1, cLinks, cD1), concat(cD1, cD1), cD1), cD1));
               }
               else
               {
                  iHandle.assign(lookup(valueOf(phObject_5), cHandles, cD2));
                  
                  if (_isGreaterThan(iHandle, 0))
                  {
                     cHandles.replaceEntry(iHandle, cD2, "");
                     cHandles.assign(trim(replaceAll(concat(cD2, cHandles, cD2), concat(cD2, cD2), cD2), cD2));
                  }
                  
                  cLinks.replaceEntry(plus(iPos, 1), cHandles);
               }
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InactiveLinks"));
         ghProp.unwrapBufferField().changeValue(cLinks);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character propertyType(final character _pcPropName_5)
   {
      character pcPropName_5 = TypeFactory.initInput(_pcPropName_5);
      /*------------------------------------------------------------------------------
        Purpose:  Locates the "set" property function for the specified property name
                  either locally or in a SUPER procedure, and returns its datatype.
         Params:  INPUT pcPropName AS CHARACTER -- Property name
        Returns:  CHARACTER: datatype of the property
      ------------------------------------------------------------------------------*/
      handle hProc = TypeFactory.handle();
      integer i = TypeFactory.integer();
      character cSetProp = TypeFactory.character();
      character cSupers = TypeFactory.character();
      character cSignature = TypeFactory.character();
      handle hSuper = TypeFactory.handle();
      
      return function("propertyType", character.class, new Block((Body) () -> 
      {
         cSetProp.assign(concat("set", pcPropName_5));
         
         if (_isNotEqual(lookup(cSetProp, targetProcedure().unwrapProcedure().internalEntries()), 0))
         {
            hProc.assign(targetProcedure());
         }
         else
         {
            cSupers.assign(targetProcedure().unwrapCommonProcedure().superProcedures());
            
            loopLabel32:
            for (i.assign(numEntries(cSupers)); _isGreaterThanOrEqual(i, 1); i.decrement())
            {
               hSuper.assign(handle.fromString(entry(i, cSupers)));
               
               if (_isNotEqual(lookup(cSetProp, hSuper.unwrapProcedure().internalEntries()), 0))
               {
                  hProc.assign(hSuper);
                  break loopLabel32;
               }
            }
         }
         
         /* END ELSE DO IF not found in the object's entries list. */
         if ((hProc.isValid()).booleanValue())
         {
            /* Signature should be "FUNCTION,LOGICAL, INPUT <param> <type>" */
            cSignature.assign(hProc.unwrapProcedure().getSignature(cSetProp));
            
            if (_or(or(isNotEqual(numEntries(cSignature), 3), () -> isNotEqual(entry(1, cSignature), "FUNCTION")), () -> isNotEqual(entry(2, cSignature), "LOGICAL")))
            {
               returnNormal(new character());
            }
            else
            {
               cSignature.assign(entry(3, cSignature));
               
               if (_or(isNotEqual(numEntries(cSignature, " "), 3), () -> isNotEqual(entry(1, cSignature, " "), "INPUT")))
               {
                  returnNormal(new character());
               }
               else
               {
                  returnNormal(entry(3, cSignature, " "));
               }
            }
         }
         else
         {
            returnNormal(new character());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character reviewMessages()
   {
      return function("reviewMessages", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Returns a delimited list of all messages, without removing
                     them from the log. 
            Params:  <none>
           Returns:  CHARACTER: The message list is delimited by CHR(3); within each 
                     message, the message text, the Field (if any), and the Table 
                     (if any) are delimited by CHR(4). 
             Notes:  Use the similar function fetchMessages to read messages
                     and delete them from the log, which is the norm.
         ------------------------------------------------------------------------------*/
         returnNormal(gcDataMessages);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setChildDataKey(final character _cChildDataKey_1)
   {
      character cChildDataKey_1 = TypeFactory.initInput(_cChildDataKey_1);
      
      return function("setChildDataKey", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ChildDataKey"));
         ghProp.unwrapBufferField().changeValue(cChildDataKey_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setClassName(final character _pcClassName_1)
   {
      character pcClassName_1 = TypeFactory.initInput(_pcClassName_1);
      
      return function("setClassName", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ClassName"));
         ghProp.unwrapBufferField().changeValue(pcClassName_1);
         returnNormal(true);
      }));
   }

   /** setClassName */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainerHidden(final logical _plHidden_2)
   {
      logical plHidden_2 = TypeFactory.initInput(_plHidden_2);
      
      return function("setContainerHidden", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHidden"));
         ghProp.unwrapBufferField().changeValue(plHidden_2);
         /* {set ObjectHidden plHidden}. */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainerSource(final handle _phObject_5)
   {
      handle phObject_5 = TypeFactory.initInput(_phObject_5);
      
      return function("setContainerSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         ghProp.unwrapBufferField().changeValue(phObject_5);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainerSourceEvents(final character _pcEvents_2)
   {
      character pcEvents_2 = TypeFactory.initInput(_pcEvents_2);
      
      return function("setContainerSourceEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSourceEvents"));
         ghProp.unwrapBufferField().changeValue(pcEvents_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDataLinksEnabled(final logical _lDataLinksEnabled_1)
   {
      logical lDataLinksEnabled_1 = TypeFactory.initInput(_lDataLinksEnabled_1);
      
      return function("setDataLinksEnabled", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLinksEnabled"));
         ghProp.unwrapBufferField().changeValue(lDataLinksEnabled_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDataSource(final handle _phObject_5)
   {
      handle phObject_5 = TypeFactory.initInput(_phObject_5);
      
      return function("setDataSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSource"));
         ghProp.unwrapBufferField().changeValue(phObject_5);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDataSourceEvents(final character _pcEventsList_1)
   {
      character pcEventsList_1 = TypeFactory.initInput(_pcEventsList_1);
      
      return function("setDataSourceEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceEvents"));
         ghProp.unwrapBufferField().changeValue(pcEventsList_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDataSourceNames(final character _pcSourceNames_1)
   {
      character pcSourceNames_1 = TypeFactory.initInput(_pcSourceNames_1);
      
      return function("setDataSourceNames", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
         ghProp.unwrapBufferField().changeValue(pcSourceNames_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDataTarget(final character _pcTarget_1)
   {
      character pcTarget_1 = TypeFactory.initInput(_pcTarget_1);
      
      return function("setDataTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         ghProp.unwrapBufferField().changeValue(pcTarget_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDataTargetEvents(final character _pcEvents_2)
   {
      character pcEvents_2 = TypeFactory.initInput(_pcEvents_2);
      
      return function("setDataTargetEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTargetEvents"));
         ghProp.unwrapBufferField().changeValue(pcEvents_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDbaware(final logical _lAware_1)
   {
      logical lAware_1 = TypeFactory.initInput(_lAware_1);
      
      return function("setDBAware", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DBAware"));
         ghProp.unwrapBufferField().changeValue(lAware_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDesignDataObject(final character _pcDataObject_1)
   {
      character pcDataObject_1 = TypeFactory.initInput(_pcDataObject_1);
      
      return function("setDesignDataObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DesignDataObject"));
         ghProp.unwrapBufferField().changeValue(pcDataObject_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDynamicObject(final logical _lTemp_1)
   {
      logical lTemp_1 = TypeFactory.initInput(_lTemp_1);
      
      return function("setDynamicObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicObject"));
         ghProp.unwrapBufferField().changeValue(lTemp_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setHideOnInit(final logical _plHideOnInit_1)
   {
      logical plHideOnInit_1 = TypeFactory.initInput(_plHideOnInit_1);
      
      return function("setHideOnInit", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnInit"));
         ghProp.unwrapBufferField().changeValue(plHideOnInit_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setInactiveLinks(final character _pcInactiveLinks_1)
   {
      character pcInactiveLinks_1 = TypeFactory.initInput(_pcInactiveLinks_1);
      
      return function("setInactiveLinks", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InactiveLinks"));
         ghProp.unwrapBufferField().changeValue(pcInactiveLinks_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setInstanceId(final decimal _pdInstanceId_1)
   {
      decimal pdInstanceId_1 = TypeFactory.initInput(_pdInstanceId_1);
      
      return function("setInstanceId", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceId"));
         ghProp.unwrapBufferField().changeValue(pdInstanceId_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setInstanceProperties(final character _pcPropList_3)
   {
      character pcPropList_3 = TypeFactory.initInput(_pcPropList_3);
      
      return function("setInstanceProperties", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceProperties"));
         ghProp.unwrapBufferField().changeValue(pcPropList_3);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setLabel(final character _pcLabel_1)
   {
      character pcLabel_1 = TypeFactory.initInput(_pcLabel_1);
      
      return function("setLabel", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Label"));
         ghProp.unwrapBufferField().changeValue(pcLabel_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setLayoutPosition(final character _pcLayoutPosition_1)
   {
      character pcLayoutPosition_1 = TypeFactory.initInput(_pcLayoutPosition_1);
      
      return function("setLayoutPosition", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LayoutPosition"));
         ghProp.unwrapBufferField().changeValue(pcLayoutPosition_1);
         returnNormal(true);
      }));
   }

   /** setLayoutPosition */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setLogicalObjectName(final character _cName_1)
   {
      character cName_1 = TypeFactory.initInput(_cName_1);
      
      return function("setLogicalObjectName", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
         ghProp.unwrapBufferField().changeValue(cName_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setLogicalVersion(final character _cVersion_2)
   {
      character cVersion_2 = TypeFactory.initInput(_cVersion_2);
      
      return function("setLogicalVersion", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalVersion"));
         ghProp.unwrapBufferField().changeValue(cVersion_2);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectVersion"));
         ghProp.unwrapBufferField().changeValue(cVersion_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setObjectHidden(final logical _plHidden_2)
   {
      logical plHidden_2 = TypeFactory.initInput(_plHidden_2);
      
      return function("setObjectHidden", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectHidden"));
         ghProp.unwrapBufferField().changeValue(plHidden_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setObjectName(final character _pcName_2)
   {
      character pcName_2 = TypeFactory.initInput(_pcName_2);
      
      return function("setObjectName", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
         ghProp.unwrapBufferField().changeValue(pcName_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setObjectParent(final handle _phParent_1)
   {
      handle phParent_1 = TypeFactory.initInput(_phParent_1);
      /*------------------------------------------------------------------------------
        Purpose:  Sets the property ObjectParent, the widget handle of this
                  SmartObject's Container-Source's Frame or Window.
         Params:  INPUT phParent AS HANDLE -- Frame or Window handle.
        Returns:  LOGICAL: true if assign succeeds; false if parent handle param or
                  ContainerHandle property is not a valid handle.
      ------------------------------------------------------------------------------*/
      handle hObject = TypeFactory.handle();
      
      return function("setObjectParent", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hObject.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hObject.isValid(), () -> phParent_1.isValid()))
         {
            if ((matchesList("DIALOG-BOX,FRAME", phParent_1.unwrapType().getResourceType())).booleanValue())
            {
               if ((HandleOps.canSet(hObject, "FRAME")).booleanValue())
               {
                  hObject.unwrapWidget().setFrameHandle(phParent_1);
               }
            }
            else
            {
               hObject.unwrapWidget().setParentHandle(phParent_1);
            }
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setObjectVersion(final character _cObjectVersion_1)
   {
      character cObjectVersion_1 = TypeFactory.initInput(_cObjectVersion_1);
      
      return function("setObjectVersion", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectVersion"));
         ghProp.unwrapBufferField().changeValue(cObjectVersion_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setParentDataKey(final character _cParentDataKey_1)
   {
      character cParentDataKey_1 = TypeFactory.initInput(_cParentDataKey_1);
      
      return function("setParentDataKey", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ParentDataKey"));
         ghProp.unwrapBufferField().changeValue(cParentDataKey_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPassThroughLinks(final character _pcLinks_1)
   {
      character pcLinks_1 = TypeFactory.initInput(_pcLinks_1);
      
      return function("setPassThroughLinks", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose: Sets the variable which stores links which can be passed through 
            Params: pcLinks AS CHARACTER -- comma-separated list of links.
                    Each link actually consists of <linkname>;single/multiple,
                    where single means only one target is supported, so the original
                    link to the container should be deleted when the links are combined.
           Returns: LOGICAL (true)
             Notes: This property is shared by all objects. Because it is a list,
                    it should normally be modified using modifyListProperty.
         ------------------------------------------------------------------------------*/
         scPassThroughLinks.assign(pcLinks_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPhysicalObjectName(final character _cTemp_1)
   {
      character cTemp_1 = TypeFactory.initInput(_cTemp_1);
      
      return function("setPhysicalObjectName", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalObjectName"));
         ghProp.unwrapBufferField().changeValue(cTemp_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPhysicalVersion(final character _cVersion_2)
   {
      character cVersion_2 = TypeFactory.initInput(_cVersion_2);
      
      return function("setPhysicalVersion", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalVersion"));
         ghProp.unwrapBufferField().changeValue(cVersion_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRenderingProcedure(final character _cProcedure_2)
   {
      character cProcedure_2 = TypeFactory.initInput(_cProcedure_2);
      
      return function("setRenderingProcedure", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RenderingProcedure"));
         ghProp.unwrapBufferField().changeValue(cProcedure_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRunAttribute(final character _cRunAttribute_1)
   {
      character cRunAttribute_1 = TypeFactory.initInput(_cRunAttribute_1);
      
      return function("setRunAttribute", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RunAttribute"));
         ghProp.unwrapBufferField().changeValue(cRunAttribute_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setSuperProcedure(final character _pcSuperProcedure_1)
   {
      character pcSuperProcedure_1 = TypeFactory.initInput(_pcSuperProcedure_1);
      
      return function("setSuperProcedure", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SuperProcedure"));
         ghProp.unwrapBufferField().changeValue(pcSuperProcedure_1);
         returnNormal(true);
      }));
   }

   /** setSuperProcedure */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setSuperProcedureHandle(final character _pcProcedureHandle_1)
   {
      character pcProcedureHandle_1 = TypeFactory.initInput(_pcProcedureHandle_1);
      
      return function("setSuperProcedureHandle", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SuperProcedureHandle"));
         ghProp.unwrapBufferField().changeValue(pcProcedureHandle_1);
         returnNormal(true);
      }));
   }

   /** setSuperProcedureHandle */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setSuperProcedureMode(final character _pcProcedureMode_1)
   {
      character pcProcedureMode_1 = TypeFactory.initInput(_pcProcedureMode_1);
      
      return function("setSuperProcedureMode", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SuperProcedureMode"));
         ghProp.unwrapBufferField().changeValue(pcProcedureMode_1);
         returnNormal(true);
      }));
   }

   /** setSuperProcedureMode */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setSupportedLinks(final character _pcLinkList_1)
   {
      character pcLinkList_1 = TypeFactory.initInput(_pcLinkList_1);
      
      return function("setSupportedLinks", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Modifies the list of SupportedLinks. 
            Params:  pcLinkList AS CHARACTER -- comma-separated list of links.
           Returns:  LOGICAL (true)
             Notes:  Because this is a comma-separated list, it should normally be
                     invoked indirectly, through modifyListProperty.
         ------------------------------------------------------------------------------*/
         if (_isEqual(pcLinkList_1, ""))
         {
            returnNormal(false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SupportedLinks"));
         ghProp.unwrapBufferField().changeValue(pcLinkList_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setThinRenderingProcedure(final character _cProcedure_2)
   {
      character cProcedure_2 = TypeFactory.initInput(_cProcedure_2);
      
      return function("setThinRenderingProcedure", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ThinRenderingProcedure"));
         ghProp.unwrapBufferField().changeValue(cProcedure_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setTranslatableProperties(final character _pcPropList_3)
   {
      character pcPropList_3 = TypeFactory.initInput(_pcPropList_3);
      
      return function("setTranslatableProperties", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("TranslatableProperties"));
         ghProp.unwrapBufferField().changeValue(pcPropList_3);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setUibmode(final character _pcMode_2)
   {
      character pcMode_2 = TypeFactory.initInput(_pcMode_2);
      
      return function("setUIBMode", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Sets the UIBMode property of the object.
            Params:  INPUT pcMode AS CHARACTER -- blank or "Design" are normal values.
           Returns:  LOGICAL (true)
             Notes:  In addition to setting the property, this property function
                     runs an AppBuilder procedure which sets up the object for use
                     in a design window, making it Movable, etc.
                     For performance reasons, UIBMode has been made an xp property.  
                     If you need to set it, make sure this function is invoked explicitly.
                     Don't {set UIBMode...}
         ------------------------------------------------------------------------------*/
         if (_isEqual(pcMode_2, "Design"))
         {
            /* Make the object editable in the UIB */
            ControlFlowOps.invokeWithMode("adeuib/_uibmode.p", "I", targetProcedure());
            /* Set UIBMode in all children of this object.  Note that they *
                   * in turn will set UIBMode in their children and so on...     */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignLinkProperty", targetProcedure(), "III", "Container-Target", "UIBMode", "Design-Child");
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
         ghProp.unwrapBufferField().changeValue(pcMode_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setUserProperty(final character _pcPropName_5, final character _pcPropValue_2)
   {
      character pcPropName_5 = TypeFactory.initInput(_pcPropName_5);
      character pcPropValue_2 = TypeFactory.initInput(_pcPropValue_2);
      /*------------------------------------------------------------------------------
        Purpose:  Assigns a value to a dynamically-defined property,
                  allocating a slot for the property if it doesn't exist yet.
         Params:  INPUT pcPropName AS CHARACTER, 
                  INPUT pcPropValue AS CHARACTER
        Returns:  LOGICAL (true)
      ------------------------------------------------------------------------------*/
      character cOldProps = TypeFactory.character();
      character cNewProps = TypeFactory.character();
      integer iIndex = TypeFactory.integer();
      integer iNext = TypeFactory.integer();
      
      return function("setUserProperty", logical.class, new Block((Body) () -> 
      {
         /* These ad hoc properties are stored in the second entry in the
              object's ADM-DATA attribute, as a string delimited by CHR(3)
              between property/value pairs and CHR(4) between the property name
              and its value. */
         /* Changed to delimit name/value with CHR(4). */
         if (_isUnknown(pcPropValue_2))
         {
             /* Don't allow unknown value. */pcPropValue_2.assign("");
         }
         
         cOldProps.assign(entry(2, targetProcedure().unwrapADMData().getADMData(), chr(1)));
         iIndex.assign(indexOf(concat(chr(3), cOldProps), concat(chr(3), pcPropName_5, chr(4))));
         
         if (_isEqual(iIndex, 0))
         {
             /* Property wasn't defined yet. */cNewProps.assign(concat(cOldProps, (_isNotEqual(cOldProps, "") ? chr(3) : new character("")), pcPropName_5, chr(4), pcPropValue_2));
         }
         else
         {
            iIndex.assign(plus(iIndex, length(pcPropName_5)));
            /* End of current prop name */
            /* iNext is the position of delimiter before the next property. */
            iNext.assign(indexOf(substring(cOldProps, plus(iIndex, 1)), chr(3)));
            /* Substitute the new value for the old one, and then add back
                          any other property values if there were any. */
            cNewProps.assign(concat(substring(cOldProps, 1, iIndex), pcPropValue_2, (_isNotEqual(iNext, 0) ? substring(cOldProps, plus(iIndex, iNext)) : new character(""))));
         }
         
         /* END DO IF iIndex NE 0 */
         targetProcedure().unwrapADMData().setADMData(concat(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1)), chr(1), cNewProps, chr(1), entry(3, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         /* entry 3 is user links */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical showmessage(final character _pcMessage_1)
   {
      character pcMessage_1 = TypeFactory.initInput(_pcMessage_1);
      /*------------------------------------------------------------------------------
        Purpose:     Displays (using a simple MESSAGE statement by default)
                     either a literal message string, or a message number which
                     is returned by the messageNumber function.
        Parameters: INPUT pcMessage AS CHARACTER -- 
                    - Either a literal message string 
                    - Or a message number in character form. 
                     
                     A message number can be followed by a comma delimited list
                     with maximum 10 entries:
                     
                     The LAST entry (2 - 10) is:               
                     1) The word "Question" or "YesNo", in which case the message is 
                        displayed with YES-NO buttons and the answer is returned.
                     
                     2) The word "YesNoCancel", in which case the message is displayed
                        with YES-NO-CANCEL buttons and the answer is returned.
                        
                     Optional entries from 2 to 10: 
                        Each entry will be placed into the numeric message
                        in place of the the string of form &n, where n is an integer 
                        between 1 and 9, inclusive (Entry 2 will replace &1 etc)         
                        
          Returns:   LOGICAL: true/false if the Question option is used,
                              true/false/unknown if the YesNoCancel option is used 
                              else true.
        Notes:       This function can be overridden to use a mechanism other than
                     the MESSAGE statement to display messages, and still use the
                     messageNumber function to map message numbers to translatable text.
                     Note that this is different from addMessage, fetchMessages, etc.,
                     which log messages in a temp-table for later retrieval.
      ------------------------------------------------------------------------------*/
      integer iMessage = TypeFactory.integer();
      character cMessage = TypeFactory.character();
      character cMessageType = TypeFactory.character();
      character[] cMsg = TypeFactory.characterExtent(9);
      integer iNumParam = TypeFactory.integer();
      logical lAnswer = TypeFactory.logical();
      
      return function("showmessage", logical.class, new Block((Body) () -> 
      {
         ErrorManager.silentErrorEnable();
         iMessage.assign(new integer(entry(1, pcMessage_1)));
         ErrorManager.silentErrorDisable();
         
         /* was a number passed? */
         if ((ErrorManager.isError()).booleanValue())
         {
            messageBox(pcMessage_1, ALERT_INFO, BTN_OK, (String) null);
         }
         else
         {
            cMessage.assign(messageNumber(iMessage));
            iNumParam.assign(numEntries(pcMessage_1));
            cMessageType.assign(entry(iNumParam, pcMessage_1));
            assignSingle(cMsg, 1, _isGreaterThan(iNumParam, 1) ? entry(2, pcMessage_1) : new character(""));
            assignSingle(cMsg, 2, _isGreaterThan(iNumParam, 2) ? entry(3, pcMessage_1) : new character(""));
            assignSingle(cMsg, 3, _isGreaterThan(iNumParam, 3) ? entry(4, pcMessage_1) : new character(""));
            assignSingle(cMsg, 4, _isGreaterThan(iNumParam, 4) ? entry(5, pcMessage_1) : new character(""));
            assignSingle(cMsg, 5, _isGreaterThan(iNumParam, 5) ? entry(6, pcMessage_1) : new character(""));
            assignSingle(cMsg, 6, _isGreaterThan(iNumParam, 6) ? entry(7, pcMessage_1) : new character(""));
            assignSingle(cMsg, 7, _isGreaterThan(iNumParam, 7) ? entry(8, pcMessage_1) : new character(""));
            assignSingle(cMsg, 8, _isGreaterThan(iNumParam, 8) ? entry(9, pcMessage_1) : new character(""));
            assignSingle(cMsg, 9, _isGreaterThan(iNumParam, 9) ? entry(10, pcMessage_1) : new character(""));
            cMessage.assign(substitute(cMessage, subscript(cMsg, 1), subscript(cMsg, 2), subscript(cMsg, 3), subscript(cMsg, 4), subscript(cMsg, 5), subscript(cMsg, 6), subscript(cMsg, 7), subscript(cMsg, 8), subscript(cMsg, 9)));
            
            /* Yes -- get the msg */
            switch (StringHelper.safeTrimTrailing((cMessageType).toStringMessage()).toUpperCase())
            {
               case "QUESTION":
               case "YESNO":
                  {
                     messageBox(cMessage, false, new AccessorWrapper(lAnswer), ALERT_QUESTION, BTN_YES_NO, (String) null);
                     returnNormal(lAnswer);
                  }
               case "OKCANCEL":
                  {
                     messageBox(cMessage, false, new AccessorWrapper(lAnswer), ALERT_QUESTION, BTN_OK_CANCEL, (String) null);
                     returnNormal(lAnswer);
                  }
               case "YESNOCANCEL":
                  {
                     messageBox(cMessage, false, new AccessorWrapper(lAnswer), ALERT_QUESTION, BTN_YES_NO_CANCEL, (String) null);
                     returnNormal(lAnswer);
                  }
               default:
                  {
                     messageBox(cMessage, ALERT_INFO, BTN_OK, (String) null);
                  }
                  break;
            }
         }
         /* END ELSE IF numeric message */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character signature(final character _pcName_2)
   {
      character pcName_2 = TypeFactory.initInput(_pcName_2);
      /*------------------------------------------------------------------------------
        Purpose: Returns the signature of the named function or internal procedure,
                 in the format returned by the Progress GET-SIGNATURE method.  
         Params: INPUT pcName AS CHARACTER -- function or procedure name.
        Returns: CHARACTER: signature in Progress GET-SIGNATURE format.
          Notes: This function is needed because the routine may be located in
                 a SUPER procedure, so we need to search SUPER-PROCEDURES if needed.
      ------------------------------------------------------------------------------*/
      integer iEntry = TypeFactory.integer();
      character cSuperProcs = TypeFactory.character();
      handle hSuper = TypeFactory.handle();
      
      return function("Signature", character.class, new Block((Body) () -> 
      {
         if (_isNotEqual(lookup(pcName_2, targetProcedure().unwrapProcedure().internalEntries()), 0))
         {
            returnNormal(targetProcedure().unwrapProcedure().getSignature(pcName_2));
         }
         else
         {
            cSuperProcs.assign(targetProcedure().unwrapCommonProcedure().superProcedures());
            
            loopLabel33:
            for (iEntry.assign(1); _isLessThanOrEqual(iEntry, numEntries(cSuperProcs)); iEntry.increment())
            {
               hSuper.assign(handle.fromString(entry(iEntry, cSuperProcs)));
               
               if (_and(hSuper.isValid(), () -> isNotEqual(lookup(pcName_2, hSuper.unwrapProcedure().internalEntries()), 0)))
               {
                  returnNormal(hSuper.unwrapProcedure().getSignature(pcName_2));
               }
            }
         }
         returnNormal("");
      }));
   }
}
